package jp.takayuki.swt.dnd;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;

/**
 * PNGf[^TransferłB
 * @author Takayuki Shoji
 */
public class PNGTransfer extends ByteArrayTransfer {

	/** typeIds */
	private static final int[] typeIds = { registerType("PNG"), //$NON-NLS-1$
			registerType("image/png") }; //$NON-NLS-1$

	/** typeNames */
	private static final String[] typeNames = { "PNG", "image/png" }; //$NON-NLS-1$ //$NON-NLS-2$

	/** VOgCX^X */
	private static final PNGTransfer instance = new PNGTransfer();

	protected int[] getTypeIds() {
		return typeIds;
	}

	protected String[] getTypeNames() {
		return typeNames;
	}

	/**
	 * CX^X擾܂B
	 * @return CX^X
	 */
	public static PNGTransfer getInstance() {
		return instance;
	}

	/**
	 * {@inheritDoc}
	 * <p>
	 * ߂lImageData
	 * @see org.eclipse.swt.dnd.ByteArrayTransfer#nativeToJava(org.eclipse.swt.dnd.TransferData)
	 */
	public Object nativeToJava(TransferData transferData) {
		byte[] bytes = (byte[]) super.nativeToJava(transferData);
		if (bytes == null) {
			return null;
		}
		ByteArrayInputStream in = new ByteArrayInputStream(bytes);
		ImageLoader loader = new ImageLoader();
		ImageData[] data = loader.load(in);
		return data[0];
	}

	/**
	 * {@inheritDoc}
	 * <p>
	 * objecť^ImageDataB
	 * 
	 * @see org.eclipse.swt.dnd.ByteArrayTransfer#javaToNative(java.lang.Object, org.eclipse.swt.dnd.TransferData)
	 */
	public void javaToNative(Object object, TransferData transferData) {
		ImageData data = (ImageData) object;
		ImageLoader loader = new ImageLoader();
		loader.data = new ImageData[] { data };
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		loader.save(os, SWT.IMAGE_PNG);
		super.javaToNative(os.toByteArray(), transferData);
	}
}
