package jp.takayuki.swt.dnd;

import jp.takayuki.tools.Tool;

import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.TransferData;

/**
 * vCx[gf[^TransferłB
 * <p>
 * AvP[VɕێIuWFNg̃nbVlInteger^œo͂܂B
 * Nbv{[hɂbig endian32bitƂĊi[܂B
 * 
 * @author Takayuki Shoji
 */
public class PrivateDataTransfer extends ByteArrayTransfer {
	/** typeIds */
	private static final int[] typeIds = { registerType("application/x-petaclone-internal") }; //$NON-NLS-1$

	/** typeNames */
	private static final String[] typeNames = { "application/x-petaclone-internal" }; //$NON-NLS-1$ 

	/** VOgCX^X */
	private static final PrivateDataTransfer instance = new PrivateDataTransfer();

	protected int[] getTypeIds() {
		return typeIds;
	}

	protected String[] getTypeNames() {
		return typeNames;
	}

	/**
	 * CX^X擾܂B
	 * @return CX^X
	 */
	public static PrivateDataTransfer getInstance() {
		return instance;
	}

	protected void javaToNative(Object object, TransferData transferData) {
		Integer hash = (Integer) object;
		byte[] bytes = new byte[4];
		Tool.writeInt32BigEndian(bytes, 0, hash.intValue());
		super.javaToNative(bytes, transferData);
	}

	protected Object nativeToJava(TransferData transferData) {
		byte[] bytes = (byte[]) super.nativeToJava(transferData);
		if (bytes != null && bytes.length == 4) {
			return new Integer(Tool.byteToIntBigEndian(bytes, 0));
		}
		return null;
	}
}
