package jp.takayuki.swt.undo;

import java.util.ArrayList;
import java.util.List;

/**
 * StyledTextUndoR}h
 * 
 * @author Takayuki Shoji
 */
public class TextUndoCommand {
	/** ŏIύX */
	public long time = System.currentTimeMillis();

	/** }[W\Ȃtrue */
	public boolean mergeable = true;

	/** ҏW̊Jn */
	public int offset;

	/** ҏW̕ */
	public String inserted = ""; //$NON-NLS-1$

	/** ҏWO̕ */
	public String replaced = ""; //$NON-NLS-1$

	/** ҏW̃̕X^C */
	public List insertedObjects;

	/** ҏWÕ̕X^C */
	public List replacedObjects;

	public String toString() {
		StringBuffer sb = new StringBuffer("TextUndoCommand{"); //$NON-NLS-1$
		sb.append("time=").append(time); //$NON-NLS-1$
		sb.append(", mergeable=").append(mergeable); //$NON-NLS-1$
		sb.append(", offset=").append(offset); //$NON-NLS-1$
		sb.append(", inserted=").append(inserted); //$NON-NLS-1$
		sb.append(", replaced=").append(replaced); //$NON-NLS-1$
		listToString(sb, "insertedObjects", insertedObjects); //$NON-NLS-1$
		listToString(sb, "replacedObjects", replacedObjects); //$NON-NLS-1$
		sb.append('}');
		return sb.toString();
	}

	/**
	 * Xg𕶎񉻂܂B
	 * @param sb o͐
	 * @param name ϐ
	 * @param list Xg
	 */
	private void listToString(StringBuffer sb, String name, List list) {
		sb.append(", ").append(name).append("={"); //$NON-NLS-1$ //$NON-NLS-2$
		if (list != null) {
			for (int i = 0; i < list.size(); i++) {
				sb.append(list.get(i)).append(","); //$NON-NLS-1$
			}
		} else {
			sb.append("null"); //$NON-NLS-1$
		}
		sb.append('}');
	}

	/**
	 * @param obj ҏWÕ̕X^C
	 */
	public void addInsertedObject(Object obj) {
		if (insertedObjects == null) {
			insertedObjects = new ArrayList();
		}
		insertedObjects.add(obj);
	}

	/**
	 * FIXME UndopAttachment́AdataImageDataApositionplatformIndexێ悤ɂBUndôƂɋCt邱ƁB
	 * @param obj ҏW̃̕X^C
	 */
	public void addReplacedObject(Object obj) {
		if (replacedObjects == null) {
			replacedObjects = new ArrayList();
		}
		replacedObjects.add(obj);
	}

	/**
	 * UndoCommand}[W܂B
	 * @param undo }[W݂UndoCommand
	 * @return }[Włꍇtrue
	 */
	public boolean merge(TextUndoCommand undo) {
		if (!mergeable) {
			return false;
		}
		if (time + (20 * 1000) < System.currentTimeMillis()) {
			// 莞Ԍo
			mergeable = false;
			return false;
		}

		if (offset + inserted.length() == undo.offset
				&& undo.replaced.length() == 0 && inserted.length() > 0) {
			// Pȕǉ
			// O񂪍폜(inserted.length()==0)}[WȂ
			inserted += undo.inserted;
			if (undo.insertedObjects != null && !undo.insertedObjects.isEmpty()) {
				if (insertedObjects == null) {
					insertedObjects = undo.insertedObjects;
				} else {
					insertedObjects.addAll(undo.insertedObjects);
				}
			}
			time = System.currentTimeMillis();
			return true;
		}
		mergeable = false;
		return false;
	}

	/**
	 * @return hashCode()IntegerŃbvĕԂ܂B
	 */
	public Integer hashCodeAsInteger() {
		return new Integer(super.hashCode());
	}
}