package jp.takayuki.swt.util;

import java.util.ArrayList;
import java.util.List;

import jp.takayuki.swt.dnd.DibTransfer;
import jp.takayuki.swt.dnd.PNGTransfer;

import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.ImageTransfer;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.MenuListener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

/**
 * Nbv{[h̃f[^ɉăj[ڂenabled𐧌䂷郁j[Xi[
 * 
 * @author Takayuki Shoji
 */
public class ClipboardMenuItemEnabler implements MenuListener {

	/** widget.datãL[(MenuItem) */
	private static final String DATA_KEY_ITEM = "ClipboardMenuItem.MenuItem"; //$NON-NLS-1$

	/** widget.datãL[(Transfer[]) */
	private static final String DATA_KEY_TYPE = "ClipboardMenuItem.Transfer"; //$NON-NLS-1$

	/** singleton instance */
	private static final ClipboardMenuItemEnabler instance = new ClipboardMenuItemEnabler();

	/** Transfer̔z: TextTransfer */
	public static Transfer[] PURE_TEXT = new Transfer[] { TextTransfer
			.getInstance() };

	/** Transfer̔z: TextTransfer, FileTransfer */
	public static Transfer[] TEXT = new Transfer[] {
			TextTransfer.getInstance(), FileTransfer.getInstance() };

	/** Transfer̔z: PNGTransfer, ImageTransfer, DibTransfer */
	public static Transfer[] IMAGE = new Transfer[] {
			PNGTransfer.getInstance(), ImageTransfer.getInstance(),
			DibTransfer.getInstance() };

	/** Transfer̔z: FileTransfer */
	public static final Transfer[] FILE = new Transfer[] { FileTransfer
			.getInstance() };

	/** Transfer̔z: Ytł */
	public static final Transfer[] ATTACHMENT = new Transfer[] {
			FileTransfer.getInstance(), TextTransfer.getInstance(),
			PNGTransfer.getInstance(), ImageTransfer.getInstance(),
			DibTransfer.getInstance() };

	/**
	 * j[ڂNbv{[hɊ܂܂lɉenabled𐧌䂷悤ɓo^܂B
	 * 
	 * @param menuItem enabled𐧌䂷郁j[
	 * @param supportedTypes Nbv{[hɊi[ĂƂɃj[ڂgp\ɂTransfer
	 */
	public static void register(MenuItem menuItem, Transfer[] supportedTypes) {
		Menu menu = menuItem.getParent();
		List items = (List) menu.getData(DATA_KEY_ITEM);
		List types = (List) menu.getData(DATA_KEY_TYPE);
		if (items == null) {
			items = new ArrayList();
			types = new ArrayList();
			menu.setData(DATA_KEY_ITEM, items);
			menu.setData(DATA_KEY_TYPE, types);
			menu.addMenuListener(instance);
		}
		items.add(menuItem);
		types.add(supportedTypes);
	}

	public void menuShown(MenuEvent ev) {
		Menu menu = (Menu) ev.widget;
		List items = (List) menu.getData(DATA_KEY_ITEM);
		List types = (List) menu.getData(DATA_KEY_TYPE);
		if (items == null) {
			return;
		}
		Clipboard clip = new Clipboard(menu.getDisplay());
		try {
			TransferData[] trs = clip.getAvailableTypes();
			for (int i = 0; i < items.size(); i++) {
				MenuItem menuItem = (MenuItem) items.get(i);
				Transfer[] transfer = (Transfer[]) types.get(i);
				boolean enabled = false;
				transfer: for (int j = 0; j < transfer.length; j++) {
					for (int c = 0; c < trs.length; c++) {
						if (transfer[j].isSupportedType(trs[c])) {
							enabled = true;
							break transfer;
						} else if (transfer[j] instanceof ImageTransfer) {
							// isSupportedTypelԂȂꍇ̃tH[
							// https://bugs.eclipse.org/bugs/show_bug.cgi?id=250246
							if (clip.getContents(transfer[j]) != null) {
								enabled = true;
								break transfer;
							}
						}
					}
				}
				menuItem.setEnabled(enabled);
			}
		} finally {
			clip.dispose();
		}
	}

	public void menuHidden(MenuEvent ev) {
		Menu menu = (Menu) ev.widget;
		List items = (List) menu.getData(DATA_KEY_ITEM);
		SWTMenuUtils.setEnabled(items, true);
	}
}
