package jp.takayuki.swt.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Widget;

/**
 * \bhĂяoɕϊCxgXi[B
 * <p>
 * TuNXăCxgnhƂȂ郁\bh`܂B
 * Cxgnh\bh͗B̈ƂSelectionEvent
 * 󂯎悤ɒ`Ȃ΂܂B
 * <p>
 * Cxgnh\bh͌O𓊂Ă͂܂B
 * Oꂽꍇ́AsOɂȂ܂B
 * <p>
 * Cxg̔Widgetƃ\bh\bhregistergp
 * ֘At܂B
 * <p>
 * Cxg邲ƂɃtNVgpă\bh
 * 邽߁AZԂɘAĔCxg̏ɂ͌Ă܂B
 * 
 * @author Takayuki Shoji
 */
public abstract class ListenerDelegate extends SelectionAdapter {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(ListenerDelegate.class);

	/**
	 * widget.datãL[
	 */
	public static final String DATA_KEY = "Delegate"; //$NON-NLS-1$

	/**
	 * ̌^
	 */
	private static final Class[] PARAMETER_TYPE = new Class[] { SelectionEvent.class };

	/**
	 * p̔z
	 */
	private final Object[] argument = new Object[1];

	/**
	 * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public final void widgetSelected(SelectionEvent event) {

		String methodName = (String) event.widget.getData(DATA_KEY);

		if (methodName == null) {
			logger.fatal("Widget doesn't have delegate method name." //$NON-NLS-1$
					+ event.widget);
			return;
		}
		try {
			Method method = this.getClass().getMethod(methodName,
					PARAMETER_TYPE);

			// TuNXŒ`ł낤\bhĂяo
			argument[0] = event;
			method.invoke(this, argument);

		} catch (SecurityException e) {
			handleException(e);
		} catch (NoSuchMethodException e) {
			handleException(e);
		} catch (IllegalArgumentException e) {
			handleException(e);
		} catch (IllegalAccessException e) {
			handleException(e);
		} catch (InvocationTargetException e) {
			handleException(e);
		}
	}

	/**
	 * Cxgnh\bhŗOꍇɌĂяo܂B
	 * <p>
	 * <ul>
	 * <li>SecurityException
	 * <li>NoSuchMethodException
	 * <li>IllegalArgumentException
	 * <li>IllegalAccessException
	 * <li>InvocationTargetException
	 * </ul>
	 * @param e O
	 */
	protected abstract void handleException(Exception e);

	/**
	 * Cxgɑ΂ČĂяo\bho^܂B
	 * <p>
	 * CxgXi[͕ʓro^Ȃ΂܂B
	 * 
	 * @param widget EBWFbg
	 * @param methodName \bh
	 */
	public void register(Widget widget, String methodName) {
		widget.setData(DATA_KEY, methodName);
	}

	/**
	 * SelectionListenerƂẴCX^Xǉ܂B
	 * Ώۂ̃Rg[ɑ΂ă\bhݒ肵܂B
	 * 
	 * @param button {^
	 * @param methodName \bh
	 */
	public void registerAndAddListener(Button button, String methodName) {
		button.setData(DATA_KEY, methodName);
		button.addSelectionListener(this);
	}

	/**
	 * SelectionListenerƂẴCX^Xǉ܂B
	 * Ώۂ̃Rg[ɑ΂ă\bhݒ肵܂B
	 * 
	 * @param item j[ACe
	 * @param methodName \bh
	 */
	public void registerAndAddListener(MenuItem item, String methodName) {
		item.setData(DATA_KEY, methodName);
		item.addSelectionListener(this);
	}

	/**
	 * SelectionListenerƂẴCX^Xǉ܂B
	 * Ώۂ̃Rg[ɑ΂ă\bhݒ肵܂B
	 * 
	 * @param table e[u
	 * @param methodName \bh
	 */
	public void registerAndAddListener(Table table, String methodName) {
		table.setData(DATA_KEY, methodName);
		table.addSelectionListener(this);
	}
}
