package jp.takayuki.swt.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.MenuListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

/**
 * eLXg{bNX̑IԂɉăj[ڂenabled𐧌䂷郁j[Xi[
 * 
 * @author Takayuki Shoji
 */
public class TextSelectionMenuItemEnabler implements MenuListener {

	/** widget.datãL[(MenuItem) */
	private static final String DATA_KEY_ITEM = "TextSelectionMenuItem.MenuItem"; //$NON-NLS-1$

	/** singleton instance */
	private static final TextSelectionMenuItemEnabler instance = new TextSelectionMenuItemEnabler();

	/**
	 * j[ڂeLXg{bNX̑IԂɉenabled𐧌䂷悤ɓo^܂B
	 * @param text eLXg{bNX
	 * @param menuItem enabled𐧌䂷郁j[
	 */
	public static void register(StyledText text, MenuItem menuItem) {
		Menu menu = menuItem.getParent();
		Map map = (Map) menu.getData(DATA_KEY_ITEM);
		if (map == null) {
			map = new HashMap();
			menu.setData(DATA_KEY_ITEM, map);
			menu.addMenuListener(instance);
		}
		List menuItems = (List) map.get(text);
		if (menuItems == null) {
			menuItems = new ArrayList();
			map.put(text, menuItems);
		}
		menuItems.add(menuItem);
	}

	public void menuShown(MenuEvent ev) {
		Menu menu = (Menu) ev.widget;
		Map map = (Map) menu.getData(DATA_KEY_ITEM);
		if (map == null) {
			return;
		}
		for (Iterator itr = map.entrySet().iterator(); itr.hasNext();) {
			Entry entry = (Entry) itr.next();
			StyledText text = (StyledText) entry.getKey();
			Point range = text.getSelectionRange();
			boolean enabled = range.y > 0;
			List menuItems = (List) entry.getValue();
			SWTMenuUtils.setEnabled(menuItems, enabled);
		}
	}

	public void menuHidden(MenuEvent ev) {
		Menu menu = (Menu) ev.widget;
		Map map = (Map) menu.getData(DATA_KEY_ITEM);
		if (map == null) {
			return;
		}
		for (Iterator itr = map.values().iterator(); itr.hasNext();) {
			List menuItems = (List) itr.next();
			SWTMenuUtils.setEnabled(menuItems, true);
		}
	}
}
