package jp.takayuki.swt.widgets;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Event;

/**
 * LabeledIconTrayɕ\ACeB
 * ACRƃ{^̏Ԃ̂ŕ`ƃTCYvZ͎Oōs({EBWFbg)
 * <br>dispose()̂LabeledIconTray.remove()gƁB
 * @author Takayuki Shoji
 */
public class LabeledIconItem extends Canvas {
	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(LabeledIconItem.class);
	/**
	 * {^
	 */
	public final static int BUTTON = 0;

	/**
	 * ACR
	 */
	public final static int ICON = 1;

	/** ftHgeLXg */
	private final static String defaultText = "(n/a)"; //$NON-NLS-1$

	/** _IȐeEBWFbgBڂtray.getComposite() */
	private LabeledIconTray tray;

	/** eEBWFbgł̔ԍ */
	private int number;

	/** {^̏ԂȂtrue */
	private boolean isButton;

	/** IĂȂtrue(ACRACê) */
	private boolean isSelected;

	/** tH[JXĂȂtrue(`Ŏgp) */
	private boolean isFocused;

	/** }EX{^̏Ń_EĂȂtrue */
	private boolean withinRect;

	/** }EX_EȂtrue */
	private boolean mouseDown;

	/** xp̃eLXg */
	private String text;

	/** ACR */
	private Image image;

	/** progresso[\Ȃtrue */
	private boolean progress;

	/** progress100%̒l */
	private long progressAll;

	/** progresš݂̒l */
	private long progressDone;

	/**
	 * vOXo[܂B
	 */
	public void clearProgress() {
		if (!this.progress)
			return;
		this.progress = false;
		redraw();
	}

	/**
	 * vOXo[ɐis󋵂ݒ肵܂B
	 * @param all Ŝ̒l
	 * @param done l
	 */
	public void setProgress(long all, long done) {
		this.progress = true;
		this.progressAll = all;
		this.progressDone = done;
		redraw();
	}

	/**
	 * RXgN^
	 * @param tray gC
	 * @param style SWT.PUSH, SWT.NONE
	 */
	public LabeledIconItem(LabeledIconTray tray, int style) {
		this(tray, style, tray.getItemCount());
	}

	/**
	 * RXgN^
	 * @param tray gC
	 * @param style SWT.PUSH, SWT.NONE
	 * @param index }ʒu
	 */
	public LabeledIconItem(LabeledIconTray tray, int style, int index) {
		super(tray.getComposite(), style);
		this.tray = tray;
		// ftHg̔wi
		setBackground(getDisplay().getSystemColor(SWT.COLOR_LIST_BACKGROUND));

		// Xi[
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent event) {
				LabeledIconItem.this.paintControl(event);
			}
		});
		MouseAction mouseListener = new MouseAction();
		addMouseListener(mouseListener);
		addMouseMoveListener(mouseListener);

		// tH[JXĎp
		if (LabeledIconTray.DEBUG) {
			addFocusListener(new FocusAdapter() {
				public void focusGained(FocusEvent event) {
					logger.debug("item focus gained"); //$NON-NLS-1$
				}

				public void focusLost(FocusEvent arg0) {
					logger.debug("item focus lost"); //$NON-NLS-1$
				}
			});
		}

		// X^Cݒ
		if ((style & SWT.PUSH) != 0)
			isButton = true;

		tray.addItem(this, index);
	}

	/**
	 * `B
	 * (1,1)ɉ摜`A5sNZăx`
	 * @param e Cxg
	 */
	void paintControl(PaintEvent e) {
		if (isDisposed()) {
			return;
		}
		//GC gc = e.gc;
		if (isButton) {
			drawButton(e);
		} else {
			drawIcon(e);
		}
	}

	/**
	 * {^ACe̕`
	 * @param e Cxg
	 */
	private void drawButton(PaintEvent e) {
		GC gc = e.gc;
		int imgWidth = 0, imgHeight = 0, textWidth = 0, textHeight = 0;
		// 𑪂
		if (image != null) {
			Rectangle imgRect = image.getBounds();
			imgHeight = imgRect.height;
			imgWidth = imgRect.width;
		}
		String tmpText = text;
		{
			if (tmpText == null) {
				tmpText = defaultText;
			}
			Point textExtent = gc.stringExtent(text);
			textWidth = textExtent.x;
			textHeight = textExtent.y;
		}
		// 摜̈ʒu
		int imgX = 2;
		int imgY = 2 + ((textHeight + 4) > imgHeight ? (textHeight + 4 - imgHeight) / 2
				: 0);
		// eLXg̈ʒu
		int textX = 2 + imgWidth + 2;
		int textY = 2 + (imgHeight > (textHeight + 4) ? (imgHeight - textHeight + 4) / 2
				: 0) + 2;
		// ̈
		int width = imgWidth + textWidth + 4 + 6;
		int height = Math.max(imgHeight, textHeight + 4) + 6;
		//logger.debug("_`̈ " + width + "," + height);
		// tH[JX{^
		if (isFocused == false && mouseDown == false) {
			// wi
			gc.setBackground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_BACKGROUND));
			gc.fillRectangle(0, 0, width, height);
			// ËÂe
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_DARK_SHADOW));
			gc.drawLine(0, height - 1, width - 1, height - 1);
			gc.drawLine(width - 1, 0, width - 1, height - 1);
			// E̖邢e
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_NORMAL_SHADOW));
			gc.drawLine(1, height - 2, width - 2, height - 2);
			gc.drawLine(width - 2, 1, width - 2, height - 3);
			// nCCg
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW));
			gc.drawLine(0, 0, 0, height - 2);
			gc.drawLine(1, 0, width - 2, 0);
			// 摜
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_FOREGROUND));
			if (image != null) {
				gc.drawImage(image, imgX, imgY);
			}
			// eLXg
			//gc.drawString(tmpText, textX, textY);
			if (getEnabled()) {
				gc.drawString(tmpText, textX, textY);
			} else {
				gc.setForeground(getDisplay().getSystemColor(
						SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW));
				gc.drawString(tmpText, textX + 1, textY + 1, true);
				gc.setForeground(getDisplay().getSystemColor(
						SWT.COLOR_WIDGET_NORMAL_SHADOW));
				gc.drawString(tmpText, textX, textY, true);
			}
			// vOXo[
			if (progress) {
				drawProgress(gc, imgX, 3, imgWidth, Math.max(imgHeight,
						textHeight + 4) - 2);
			}
		}
		// tH[JXĂւ񂾃{^
		else if (isFocused == true && mouseDown == true && withinRect == true) {
			// ʒuEɂ炷
			imgX++;
			imgY++;
			textX++;
			textY++;
			// wi
			gc.setBackground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_BACKGROUND));
			gc.fillRectangle(0, 0, width, height);
			// O̘g
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_BORDER));
			gc.drawRectangle(0, 0, width - 1, height - 1);
			// VhE
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_NORMAL_SHADOW));
			gc.drawRectangle(1, 1, width - 3, height - 3);
			// 摜ƃeLXg
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_FOREGROUND));
			if (image != null) {
				gc.drawImage(image, imgX, imgY);
			}
			gc.drawString(tmpText, textX, textY);
			// tH[JX̓_
			gc.drawFocus(textX - 2, textY - 2, textWidth + 4, textHeight + 4);
		}
		// tH[JXꂽ{^(isFocused == true)
		else {
			// wi
			gc.setBackground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_BACKGROUND));
			gc.fillRectangle(0, 0, width, height);
			// O̘g
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_BORDER));
			gc.drawRectangle(0, 0, width - 1, height - 1);
			// VhE
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_NORMAL_SHADOW));
			gc.drawLine(2, height - 2, width - 2, height - 2);
			gc.drawLine(width - 2, 2, width - 2, height - 2);
			// nCCg
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW));
			gc.drawLine(1, 1, 1, height - 2);
			gc.drawLine(2, 1, width - 2, 1);
			// 摜
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_FOREGROUND));
			if (image != null) {
				gc.drawImage(image, imgX, imgY);
			}
			// eLXg
			if (getEnabled()) {
				gc.drawString(tmpText, textX, textY);
			} else {
				gc.setForeground(getDisplay().getSystemColor(
						SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW));
				gc.drawString(tmpText, textX + 1, textY + 1, true);
				gc.setForeground(getDisplay().getSystemColor(
						SWT.COLOR_WIDGET_NORMAL_SHADOW));
				gc.drawString(tmpText, textX, textY, true);
			}
			// tH[JX̓_
			gc.drawFocus(textX - 2, textY - 2, textWidth + 4, textHeight + 4);
			// vOXo[
			if (progress) {
				drawProgress(gc, imgX, 3, imgWidth, Math.max(imgHeight,
						textHeight + 4) - 2);
			}
		}
	}

	/**
	 * vOXo[̕`
	 * @param gc OtBbNReLXg
	 * @param imgX
	 * @param areaY 摜܂̓eLXgYW̏ق
	 * @param imgWidth
	 * @param areaHeight 摜܂̓eLXg+4̑傫ق
	 */
	private void drawProgress(GC gc, int imgX, int areaY, int imgWidth,
			int areaHeight) {
		// vOXo[̈ʒu
		int x = imgX + Math.max(imgWidth - 5 - 1, 0);
		// (ϕ`悷sNZ)
		int done;
		if (progressAll != 0) {
			done = (int) Math.min(
					progressDone * (areaHeight - 1) / progressAll,
					areaHeight - 1);
		} else {
			done = 0;
		}

		//logger.debug("areaHeight: " + areaHeight);
		//logger.debug("progressAll: " + progressAll);
		//logger.debug("progressDone: " + progressDone);
		//logger.debug("done: " + done);

		// g̕`
		gc.setForeground(getDisplay().getSystemColor(
				SWT.COLOR_WIDGET_FOREGROUND));
		gc.drawLine(x, areaY, x, areaY + areaHeight - 1);
		gc.drawLine(x + 4, areaY, x + 4, areaY + areaHeight - 1);
		gc.drawLine(x + 1, areaY + areaHeight - 1, x + 3, areaY + areaHeight
				- 1);
		// ̕`
		gc
				.setBackground(getDisplay().getSystemColor(
						SWT.COLOR_LIST_BACKGROUND));
		gc.fillRectangle(x + 1, areaY, 3, areaHeight - 1 - done);
		// ̕`
		//gc.setBackground(getDisplay().getSystemColor(SWT.COLOR_GREEN));
		Color color = new Color(getDisplay(), 191, 191, 255);
		gc.setBackground(color);
		gc.fillRectangle(x + 1, areaY + areaHeight - 1 - done, 3, done);
		color.dispose();
	}

	/**
	 * ACRACe̕`
	 * @param e Cxg
	 */
	private void drawIcon(PaintEvent e) {
		GC gc = e.gc;
		int imgWidth = 0, imgHeight = 0, textWidth = 0, textHeight = 0;
		// 𑪂
		if (image != null) {
			Rectangle imgRect = image.getBounds();
			imgHeight = imgRect.height;
			imgWidth = imgRect.width;
		}
		String tmpText = text;
		{
			if (tmpText == null) {
				tmpText = defaultText;
			}
			Point textExtent = gc.stringExtent(tmpText);
			textWidth = textExtent.x;
			textHeight = textExtent.y;
		}
		// 摜̈ʒu
		int imgX = 3;
		int imgY = 3 + ((textHeight + 4) > imgHeight ? (textHeight + 4 - imgHeight) / 2
				: 0);
		// eLXg̈ʒu
		int textX = 3 + imgWidth + 2;
		int textY = 3 + (imgHeight > (textHeight + 4) ? (imgHeight - textHeight + 4) / 2
				: 0) + 2;
		// ACR̕`: IԂɂĕςAtH[JX
		// IԂɂĐFς
		if (isSelected) {
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_LIST_SELECTION_TEXT));
			gc.setBackground(getDisplay().getSystemColor(
					SWT.COLOR_LIST_SELECTION));
			// IԂ̓hԂ
			gc.fillRectangle(textX - 2, textY - 2, textWidth + 4,
					textHeight + 4);
		} else {
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_LIST_FOREGROUND));
			gc.setBackground(getDisplay().getSystemColor(
					SWT.COLOR_LIST_BACKGROUND));
		}
		// `
		//		logger.debug("̈TCY " + e.width + ", " + e.height);
		//		logger.debug(
		//			"`ʒu " + imgX + ", " + imgY + ", " + textX + ", " + textY);
		if (image != null) {
			gc.drawImage(image, imgX, imgY);
		}
		if (!getEnabled()) {
			gc.setForeground(getDisplay().getSystemColor(
					SWT.COLOR_WIDGET_LIGHT_SHADOW));
		}
		gc.drawString(tmpText, textX, textY);

		// tH[JX̕`
		if (isFocused) {
			//			logger.debug(
			//				"tH[JX̕`ʒu "
			//					+ (textX - 2)
			//					+ ", "
			//					+ (textY - 2)
			//					+ ", "
			//					+ (textWidth + 4)
			//					+ ", "
			//					+ (textHeight + 4));
			gc.drawFocus(textX - 2, textY - 2, textWidth + 4, textHeight + 4);
		}
		// vOXo[
		if (progress) {
			drawProgress(gc, imgX, 3, imgWidth, Math.max(imgHeight,
					textHeight + 4) - 2);
		}
	}

	/**
	 * TCY̌vZBăCAEg炷߂ɃACR
	 * {^̓TCYꏏɂB
	 * @param wHint
	 * @param hHint
	 * @param changed
	 */
	public Point computeSize(int wHint, int hHint, boolean changed) {
		int imgWidth = 0, imgHeight = 0, textWidth = 0, textHeight = 0;
		// 𑪂
		if (image != null) {
			Rectangle imgRect = image.getBounds();
			imgHeight = imgRect.height;
			imgWidth = imgRect.width;
		}
		String tmpText = text;
		{
			if (tmpText == null) {
				tmpText = defaultText;
			}
			GC gc = new GC(this);
			Point textExtent = gc.stringExtent(tmpText);
			gc.dispose();
			textWidth = textExtent.x;
			textHeight = textExtent.y;
		}
		int width = imgWidth + textWidth + 4 + 6;
		int height = Math.max(imgHeight, textHeight + 4) + 6;
		// qgɏ]
		if (wHint != SWT.DEFAULT)
			width = wHint;
		if (hHint != SWT.DEFAULT)
			height = hHint;
		return new Point(width, height);
	}

	/**
	 * ACR̃TCY
	 */
	/*
	 private Point computeIconSize(int wHint, int hHint) {
	 int imgWidth = 0, imgHeight = 0, textWidth = 0, textHeight = 0;
	 // 𑪂
	 if (image != null) {
	 Rectangle imgRect = image.getBounds();
	 imgHeight = imgRect.height;
	 imgWidth = imgRect.width;
	 }
	 String tmpText = text;
	 {
	 if (tmpText == null) {
	 tmpText = defaultText;
	 }
	 GC gc = new GC(this);
	 Point textExtent = gc.stringExtent(tmpText);
	 gc.dispose();
	 textWidth = textExtent.x;
	 textHeight = textExtent.y;
	 }
	 int width = textWidth + imgWidth + 4;
	 int height = Math.max(imgHeight, textHeight + 4);
	 // qgɏ]
	 if (wHint != SWT.DEFAULT)
	 width = wHint + 4;
	 if (hHint != SWT.DEFAULT)
	 height = hHint + 4;
	 //		logger.debug(
	 //			"ACRTCY"
	 //				+ getText()
	 //				+ " "
	 //				+ wHint
	 //				+ ", "
	 //				+ hHint
	 //				+ ", "
	 //				+ width
	 //				+ ", "
	 //				+ height);
	 return new Point(width, height);
	 }
	 */
	/**
	 * {^̃TCY
	 */
	/*
	 private Point computeButtonSize(int wHint, int hHint) {
	 int imgWidth = 0, imgHeight = 0, textWidth = 0, textHeight = 0;
	 // 𑪂
	 if (image != null) {
	 Rectangle imgRect = image.getBounds();
	 imgHeight = imgRect.height;
	 imgWidth = imgRect.width;
	 }
	 String tmpText = text;
	 {
	 if (tmpText == null) {
	 tmpText = defaultText;
	 }
	 GC gc = new GC(this);
	 Point textExtent = gc.stringExtent(text);
	 gc.dispose();
	 textWidth = textExtent.x;
	 textHeight = textExtent.y;
	 }
	 int width = (imgWidth + textWidth + 2 + 2) + 4;
	 int height = Math.max(imgHeight, textHeight + 2 + 2) + 4;
	 // qgɏ]
	 if (wHint != SWT.DEFAULT)
	 width = wHint + 4;
	 if (hHint != SWT.DEFAULT)
	 height = hHint + 4;
	 // ]𑫂
	 return new Point(width, height);
	 }
	 */
	/**
	 * ݒ肳Ă摜Ԃ
	 * @return ImageIuWFNg
	 */
	public Image getImage() {
		return image;
	}

	/**
	 * ݒ肳ĂeLXgԂ
	 * @return eLXg
	 */
	public String getText() {
		return text;
	}

	/**
	 * ACRݒ肷Bĕ`悷B
	 * @param image ݒ肷Image
	 */
	public void setImage(Image image) {
		if (this.image == image) {
			return;
		}
		this.image = image;
		// ăCAEg
		tray.doLayout();
	}

	/**
	 * eLXgݒ肷Bĕ`悷B
	 * @param string ݒ肷eLXg
	 */
	public void setText(String string) {
		if ((string == null && text == null) || string != null
				&& string.equals(text)) {
			return;
		}
		text = string;
		// ăCAEg
		tray.doLayout();
	}

	/**
	 * ACRȂIԂɂB<br>
	 * ĕ`: Ȃ
	 * @param selection IꍇtrueAIɂfalse
	 */
	void setSelection(boolean selection) {
		if (!isButton && getEnabled()) {
			isSelected = selection;
		}
	}

	/**
	 * IԂ擾
	 * @return IĂꍇtrue
	 */
	boolean getSelection() {
		return isSelected;
	}

	/**
	 * tH[JXݒ肷<br>
	 * ĕ`: Ȃ
	 * @param focus tH[JXȂtrue
	 */
	void setFocus(boolean focus) {
		isFocused = focus;
	}

	/**
	 * tH[JXݒ肷邩Ԃ(}EXŃNbNƌĂяo)B<br>
	 * @return tH[JX͂Ȃ̂ŏfalseԂ
	 */
	public boolean setFocus() {
		if (LabeledIconTray.DEBUG)
			logger.debug("setFocus"); //$NON-NLS-1$
		return false;
	}

	/**
	 * Ԃݒ肷B
	 * @param status LabeledIconItem.BUTTON, LabeledIconItem.ICON
	 */
	public void setStatus(int status) {
		if (status == BUTTON) {
			isButton = true;
			isSelected = false;
		} else if (status == ICON) {
			isButton = false;
			mouseDown = false;
		}
		redraw();
		// TCY𓯂ɂ̂ōăCAEg͕svɂȂB
	}

	/**
	 * Ԃ擾
	 * @return LabeledIconItem.BUTTON, LabeledIconItem.ICON
	 */
	public int getStatus() {
		return isButton ? BUTTON : ICON;
	}

	/**
	 * @return ACe̔ԍԂ܂B
	 */
	int getNumber() {
		return number;
	}

	/**
	 * @param i
	 */
	void setNumber(int i) {
		number = i;
	}

	/**
	 * }EXCxg
	 */
	private class MouseAction implements MouseListener, MouseMoveListener {
		/** ACë̗ */
		private Rectangle rect;

		/** }EX{^_ECxgnh */
		public void mouseDown(MouseEvent event) {
			if (isButton && event.button == 1) {
				// gbLOJn
				// : \̈Ɋ܂܂Ă
				rect = LabeledIconItem.this.getBounds();
				withinRect = true;
				mouseDown = true;
				if (LabeledIconTray.DEBUG) {
					logger.debug("tracking:start " //$NON-NLS-1$
							+ eventToString(event));
				}
				tray.onMouseDownAtButtonItem(event);
				if (LabeledIconTray.DEBUG) {
					logger.debug("tracking:start2 " //$NON-NLS-1$
							+ eventToString(event));
				}
				redraw();
			} else {
				// {^̍NbNȊOׂ͂Ă
				if (LabeledIconTray.DEBUG) {
					logger.debug("item MouseDown event " //$NON-NLS-1$
							+ eventToString(event));
				}

				tray.onMouseDownAtItem(event);
				// ACe̎OhbO
				if (event.button == 1) {
					rect = LabeledIconItem.this.getBounds();
					withinRect = true;
					mouseDown = true;
				}
			}
		}

		public void mouseUp(MouseEvent event) {
			if (!isButton) {
				if (LabeledIconTray.DEBUG)
					logger.debug("MouseUpCxg " + eventToString(event)); //$NON-NLS-1$
				tray.onMouseUpAtIconItem(event);
				return;
			}
			// ͈͓ȂselectionCxg
			if (event.button == 1) {
				mouseDown = false;
				if (withinRect) {
					if (LabeledIconTray.DEBUG)
						logger.debug("SelectionCxg " + eventToString(event)); //$NON-NLS-1$
					tray.onClickAtButtonItem(event);
					redraw();
				}
			}
		}

		public void mouseMove(MouseEvent event) {
			//logger.debug("Move " + eventToString(event));
			if (!mouseDown) {
				return;
			}
			if (withinRect == false
					&& rect.contains(event.x + rect.x, event.y + rect.y)) {
				withinRect = true;
				if (LabeledIconTray.DEBUG)
					logger.debug("Move() " + eventToString(event)); //$NON-NLS-1$
				redraw();
			} else if (withinRect
					&& !rect.contains(event.x + rect.x, event.y + rect.y)) {
				withinRect = false;
				if (LabeledIconTray.DEBUG)
					logger.debug("Move(O) " + eventToString(event)); //$NON-NLS-1$
				redraw();
			}
			if (!isButton
					&& (event.stateMask & (SWT.BUTTON1 | SWT.BUTTON2 | SWT.BUTTON3)) != 0) {
				// hbOCxgʒm
				Event e = new Event();
				e.button = event.button;
				e.data = null;
				e.display = event.display;
				e.stateMask = event.stateMask;
				e.time = event.time;
				e.widget = event.widget;
				e.x = event.x;
				e.y = event.y;
				tray.notifyListeners(SWT.DragDetect, e);
			}
		}

		public void mouseDoubleClick(MouseEvent event) {
			if (isButton) {
				return;
			}
			// _uNbNʒm
			if (LabeledIconTray.DEBUG)
				logger.debug("_uNbN " + eventToString(event)); //$NON-NLS-1$
			tray.onDoubleClickAtIconItem(event);
		}

		/**
		 * Cxg̕
		 * @param e Cxg
		 * @return Cxg̕\
		 */
		String eventToString(MouseEvent e) {
			StringBuffer sb = new StringBuffer();
			sb.append("time: ").append(e.time); //$NON-NLS-1$
			sb.append(", button: ").append(e.button); //$NON-NLS-1$
			sb.append(", stateMask: ").append(e.stateMask); //$NON-NLS-1$
			sb.append(", x: ").append(e.x); //$NON-NLS-1$
			sb.append(", y: ").append(e.y); //$NON-NLS-1$
			return sb.toString();
		}
	}

	/**
	 * 
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("number: ").append(number); //$NON-NLS-1$
		sb.append(", isButton: ").append(isButton); //$NON-NLS-1$
		sb.append(", isSelected: ").append(isSelected); //$NON-NLS-1$
		sb.append(", isFocused: ").append(isFocused); //$NON-NLS-1$
		sb.append(", withinRect: ").append(withinRect); //$NON-NLS-1$
		sb.append(", mouseDown: ").append(mouseDown); //$NON-NLS-1$
		sb.append(", text: ").append(text); //$NON-NLS-1$
		sb.append(", image: ").append(image); //$NON-NLS-1$
		return sb.toString();
	}
}
