package jp.takayuki.swt.widgets;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

/**
 * EBhËړ
 * 
 * @author Takayuki Shoji
 */
public class SWTWindowTransition implements Runnable {

	/** JnW */
	private int x1;

	/** JnW */
	private int y1;

	/** ڕWXW */
	private int x2;

	/** ڕWYW */
	private int y2;

	/** Jn */
	private long startTime;

	/** ڍs */
	private long totalTime;

	/** ŏIIȓx */
	private int targetAlpha;

	/** ΏۂShell */
	private Shell shell;

	///** (eXgp) */
	//private int count;

	/**
	 * RXgN^
	 * @param shell ΏۂShell
	 * @param x2 ڕWXW
	 * @param y2 ڕWYW
	 * @param totalTime ړ
	 * @param targetAlpha ŏIIȓx
	 */
	public SWTWindowTransition(Shell shell, int x2, int y2, long totalTime,
			int targetAlpha) {
		this.shell = shell;
		this.x2 = x2;
		this.y2 = y2;
		this.totalTime = totalTime;
		this.targetAlpha = targetAlpha;
		Point location = shell.getLocation();
		x1 = location.x;
		y1 = location.y;
	}

	public void run() {
		if (shell.isDisposed()) {
			return;
		}
		if (startTime == 0) {
			startTime = System.currentTimeMillis();
		}
		long elapsed = System.currentTimeMillis() - startTime;
		if (elapsed > totalTime) {
			shell.setLocation(x2, y2);
			shell.setAlpha(targetAlpha);
			//System.out.println(count);
			return;
		}
		double ratio = Math.sin(((double) elapsed / (double) totalTime)
				* (Math.PI / 2d));
		int x3 = (int) (x1 + ((x2 - x1) * ratio));
		int y3 = (int) (y1 + ((y2 - y1) * ratio));
		shell.setAlpha((int) (111 + ratio * (targetAlpha - 111)));
		shell.setLocation(x3, y3);

		//count++;

		// ̐xZȂ
		Display.getDefault().timerExec(10, this);
	}
}
