package jp.takayuki.tools;

import java.io.File;

import petaclone.swt.SWTMainWindow;

/**
 * AvP[VzufBNg̎񋟂܂B
 * @author Takayuki Shoji
 */
public abstract class AbstractPathResolver implements PathResolver {

	/**
	 * {@inheritDoc}
	 * @return G[ꍇnullԂ܂B
	 * @see PathResolver#getProgramDirectory()
	 */
	public File getProgramDirectory() {
		File p = Tool.getProgramDirectory(SWTMainWindow.class);
		while (p != null) {
			String name = p.getName().toUpperCase();
			if (name.contains("PETACLONE")) { //$NON-NLS-1$
				//TODO AvP[V
				// AvP[V܂ރtH_
				return p;
			} else if (name.equalsIgnoreCase("Applications") //$NON-NLS-1$
					|| name.startsWith("PROGRAM FILES")) { //$NON-NLS-1$
				// ƃtH_ɓĂȂ
				return null;
			}
			p = p.getParentFile();
		}
		return null;
	}

	/**
	 * ݂̃VXevpeB[ java.home st@C̃pX𐄑܂B
	 * 
	 * @return Java̎st@C̃pX
	 */
	public String getJavaPath() {
		String home = System.getProperty("java.home"); //$NON-NLS-1$
		File f = new File(home, "bin" + File.separatorChar + "java"); //$NON-NLS-1$ //$NON-NLS-2$
		return f.getAbsolutePath();
	}

}
