package jp.takayuki.tools;

import java.util.Arrays;

/**
 * ƕɊւNXłB
 * 
 * @author Takayuki Shoji
 */
public class CharCode {

	/** sR[h̒ */
	private static final int LEN_EOL = System.getProperty("line.separator") //$NON-NLS-1$
			.length();

	/**
	 * ubNړ̃ItZbgԂ܂B
	 * 
	 * @param lineText ݂̍s̃eLXg
	 * @param offset J[\̃ItZbg
	 * @param lineOffset s̃ItZbg
	 * @return newOffset
	 */
	public static int getMovementOffsetForward(String lineText, int offset,
			int lineOffset) {

		if (lineOffset + lineText.length() == offset) {
			// Ō̏ꍇCfbNX𒴂邪Ȃ
			return lineText.length() + lineOffset + LEN_EOL;
		}

		char first = lineText.charAt(offset - lineOffset);
		int type = getType(first);
		int block = getCodeGroup(first);
		//System.out.println(first);	

		// Jnm肳
		if (block == KanaModifier) {
			// ɕTɍs
			int j = offset - lineOffset - 1;
			for (; j >= 0; j--) {
				char c = lineText.charAt(j);
				int b = getCodeGroup(c);
				if (b == KanaModifier) {
					continue;
				}
				// ㏑
				// J^JiƂЂ炪Ȃ݂̂O[v
				int t = getType(c);
				if ((b == Hiragana || b == Katakana)
						&& t == Character.OTHER_LETTER) {
					type = t;
					block = b;
				}
				break;
			}
			//// s܂ŒȂǂꍇ
			//if (j == -1) {
			//	type = getType(first);
			//	block = getUnicodeBlock(first);
			//}
		}
		//else {
		//	type = getType(first);
		//	block = getUnicodeBlock(first);
		//}
		//System.out.println("Jn: block=" + block + ", type=" + type);

		int i = offset - lineOffset + 1;
		for (; i < lineText.length(); i++) {
			char c = lineText.charAt(i);
			int b = getCodeGroup(c);
			int t = getType(c);//tmp
			//System.out.println(": block=" + b + ", type=" + t + ", " + c);
			switch (b) {
			case KanaModifier:
				if ((block == Hiragana || block == Katakana)
						&& type == Character.OTHER_LETTER) {
					continue;
				}
				break;

			default:
				t = getType(c);
				if (type == t && block == b) {
					continue;
				}
				break;
			}
			if (isGroup(type, block, c)) {
				continue;
			}
			break;
		}
		return lineOffset + i;

	}

	/**
	 * ubNړ̃ItZbgԂ܂B
	 * 
	 * @param lineText ݂̍s̃eLXg
	 * @param offset J[\̃ItZbg
	 * @param lineOffset s̃ItZbg
	 * @return newOffset
	 */
	public static int getMovementOffsetBackward(String lineText, int offset,
			int lineOffset) {
		if (offset == 0) {
			return 0;
		} else if (offset == lineOffset) {
			return offset - LEN_EOL;
		}

		char first = lineText.charAt(offset - lineOffset - 1);
		int type = getType(first);
		int block = getCodeGroup(first);
		int i = offset - lineOffset - 1;
		i_loop: for (; i >= 0; i--) {
			char c = lineText.charAt(i);
			int b = getCodeGroup(c);
			if (block == KanaModifier) {
				if (b == KanaModifier) {
					continue;
				}
				int t = getType(c);
				if ((b == Hiragana || b == Katakana)
						&& t == Character.OTHER_LETTER) {
					type = t;
					block = b;
				} else {
					// ƃO[vȂ
					return lineOffset + i + 1;
				}
				continue;
			}

			if (b == KanaModifier) {
				// ɒTĉCĂ邩m肳
				int j = i - 1;
				for (; j >= 0; j--) {
					char jc = lineText.charAt(j);
					int jcb = getCodeGroup(jc);
					if (jcb == KanaModifier) {
						continue;
					}
					if (isGroup(type, block, jc)) {
						i = j;
						continue i_loop;
					}
					return lineOffset + i + 1;
				}
				// sɒȂǂꍇ
				return lineOffset + i + 1;
			}
			if (!isGroup(type, block, c)) {
				break;
			}
		}
		return lineOffset + i + 1;
	}

	/**
	 * O[v\ȕ킩ǂ𔻒肵܂B
	 * @param type Jnʒu̕
	 * @param block JnʒuUnicodeBlock
	 * @param c ݂̕
	 * @return O[v\ȏꍇtrue
	 */
	private static boolean isGroup(int type, int block, int c) {
		int type2 = getType(c);
		int block2 = getCodeGroup(c);

		if (type == type2 && block == block2) {
			return true;
		}

		if (block == Hiragana || block == Katakana) {
			return block2 == KanaModifier;
		}
		return false;
	}

	/**
	 * Ԃ܂B
	 * @param c 
	 * @return 
	 */
	public static int getType(int c) {

		// ʂ̕̕␳
		switch (c) {
		case '\u3005': // X CJK_SYMBOLS_AND_PUNCTUATION MODIFIER_LETTER
		case '\u30fd': // R KATAKANA MODIFIER_LETTER
		case '\u30fe': // S KATAKANA MODIFIER_LETTER
		case '\u309d': // T HIRAGANA MODIFIER_LETTER
		case '\u309e': // U HIRAGANA MODIFIER_LETTER
			return Character.OTHER_LETTER;
		}

		int type = Character.getType(c);
		switch (type) {
		case Character.LOWERCASE_LETTER:
		case Character.UPPERCASE_LETTER:
		case Character.TITLECASE_LETTER:
			// 啶Ə
			return Character.OTHER_LETTER;
		}
		return type;

	}

	/**
	 * UnicodeBlock擾܂B
	 * ̕ɂ͗OKp܂B
	 * 
	 * @param c char
	 * @return UnicodeBlock
	 */
	public static int getCodeGroup(int c) {

		// ʂ̕
		switch (c) {
		case '\u3005': // X CJK_SYMBOLS_AND_PUNCTUATION MODIFIER_LETTER
		case '\u3006': // Y CJK_SYMBOLS_AND_PUNCTUATION OTHER_LETTER
			return CJKUnifiedIdeographs; // ʂ̊

		case '\u30a0': // _unCt KATAKANA DASH_PUNCTUATION
		case '\u30fb': //  KATAKANA OTHER_PUNCTUATION
			return CJKSymbolsandPunctuation;

		case '\u3031': // PJԂ
		case '\u3032': // PJԂ
		case '\u3033': // PJԂ^
		case '\u3034': // PJԂ^J
		case '\u3035': // PJԂ_
		case '\u303c': // ܂
		case '\u3099': // _(UnicodeŗL)
		case '\u309a': // _(UnicodeŗL)
		case '\u309b': // _
		case '\u309c': // _
		case '\u30fc': // 
			return KanaModifier;
		default:
			break;
		}

		// ubNƕύX
		int block = getUnicodeBlock(c);
		switch (block) {
		case KatakanaPhoneticExtensions:
			return Katakana;
		case CJKRadicalsSupplement:
		case CJKUnifiedIdeographsExtensionA:
		case CJKUnifiedIdeographsExtensionB:
		case CJKUnifiedIdeographsExtensionC:
		case CJKUnifiedIdeographsExtensionD:
		case CJKUnifiedIdeographs:
		case CJKCompatibilityIdeographs:
		case CJKCompatibilityIdeographsSupplement:
			return CJKUnifiedIdeographs;
		default:
			return block;
		}
	}

	/**
	 * UnicodeubN擾܂B
	 * 
	 * @param codePoint R[h|Cg
	 * @return CfbNX
	 */
	public static int getUnicodeBlock(int codePoint) {
		int index = Arrays.binarySearch(blocks, codePoint);
		if (index < 0) {
			return -index - 2;
		}
		return index;
	}

	/**
	 * http://www.unicode.org/Public/UNIDATA/Blocks.txt
	 */
	public static final int[] blocks = { //
	//
			0, // [0] 0000..007F; Basic Latin
			128, // [1] 0080..00FF; Latin-1 Supplement
			256, // [2] 0100..017F; Latin Extended-A
			384, // [3] 0180..024F; Latin Extended-B
			592, // [4] 0250..02AF; IPA Extensions
			688, // [5] 02B0..02FF; Spacing Modifier Letters
			768, // [6] 0300..036F; Combining Diacritical Marks
			880, // [7] 0370..03FF; Greek and Coptic
			1024, // [8] 0400..04FF; Cyrillic
			1280, // [9] 0500..052F; Cyrillic Supplement
			1328, // [10] 0530..058F; Armenian
			1424, // [11] 0590..05FF; Hebrew
			1536, // [12] 0600..06FF; Arabic
			1792, // [13] 0700..074F; Syriac
			1872, // [14] 0750..077F; Arabic Supplement
			1920, // [15] 0780..07BF; Thaana
			1984, // [16] 07C0..07FF; NKo
			2048, // [17] 0800..083F; Samaritan
			2112, // [18] 0840..085F; Mandaic
			2144, // [19] 
			2208, // [20] 08A0..08FF; Arabic Extended-A
			2304, // [21] 0900..097F; Devanagari
			2432, // [22] 0980..09FF; Bengali
			2560, // [23] 0A00..0A7F; Gurmukhi
			2688, // [24] 0A80..0AFF; Gujarati
			2816, // [25] 0B00..0B7F; Oriya
			2944, // [26] 0B80..0BFF; Tamil
			3072, // [27] 0C00..0C7F; Telugu
			3200, // [28] 0C80..0CFF; Kannada
			3328, // [29] 0D00..0D7F; Malayalam
			3456, // [30] 0D80..0DFF; Sinhala
			3584, // [31] 0E00..0E7F; Thai
			3712, // [32] 0E80..0EFF; Lao
			3840, // [33] 0F00..0FFF; Tibetan
			4096, // [34] 1000..109F; Myanmar
			4256, // [35] 10A0..10FF; Georgian
			4352, // [36] 1100..11FF; Hangul Jamo
			4608, // [37] 1200..137F; Ethiopic
			4992, // [38] 1380..139F; Ethiopic Supplement
			5024, // [39] 13A0..13FF; Cherokee
			5120, // [40] 1400..167F; Unified Canadian Aboriginal Syllabics
			5760, // [41] 1680..169F; Ogham
			5792, // [42] 16A0..16FF; Runic
			5888, // [43] 1700..171F; Tagalog
			5920, // [44] 1720..173F; Hanunoo
			5952, // [45] 1740..175F; Buhid
			5984, // [46] 1760..177F; Tagbanwa
			6016, // [47] 1780..17FF; Khmer
			6144, // [48] 1800..18AF; Mongolian
			6320, // [49] 18B0..18FF; Unified Canadian Aboriginal Syllabics Extended
			6400, // [50] 1900..194F; Limbu
			6480, // [51] 1950..197F; Tai Le
			6528, // [52] 1980..19DF; New Tai Lue
			6624, // [53] 19E0..19FF; Khmer Symbols
			6656, // [54] 1A00..1A1F; Buginese
			6688, // [55] 1A20..1AAF; Tai Tham
			6832, // [56] 
			6912, // [57] 1B00..1B7F; Balinese
			7040, // [58] 1B80..1BBF; Sundanese
			7104, // [59] 1BC0..1BFF; Batak
			7168, // [60] 1C00..1C4F; Lepcha
			7248, // [61] 1C50..1C7F; Ol Chiki
			7296, // [62] 
			7360, // [63] 1CC0..1CCF; Sundanese Supplement
			7376, // [64] 1CD0..1CFF; Vedic Extensions
			7424, // [65] 1D00..1D7F; Phonetic Extensions
			7552, // [66] 1D80..1DBF; Phonetic Extensions Supplement
			7616, // [67] 1DC0..1DFF; Combining Diacritical Marks Supplement
			7680, // [68] 1E00..1EFF; Latin Extended Additional
			7936, // [69] 1F00..1FFF; Greek Extended
			8192, // [70] 2000..206F; General Punctuation
			8304, // [71] 2070..209F; Superscripts and Subscripts
			8352, // [72] 20A0..20CF; Currency Symbols
			8400, // [73] 20D0..20FF; Combining Diacritical Marks for Symbols
			8448, // [74] 2100..214F; Letterlike Symbols
			8528, // [75] 2150..218F; Number Forms
			8592, // [76] 2190..21FF; Arrows
			8704, // [77] 2200..22FF; Mathematical Operators
			8960, // [78] 2300..23FF; Miscellaneous Technical
			9216, // [79] 2400..243F; Control Pictures
			9280, // [80] 2440..245F; Optical Character Recognition
			9312, // [81] 2460..24FF; Enclosed Alphanumerics
			9472, // [82] 2500..257F; Box Drawing
			9600, // [83] 2580..259F; Block Elements
			9632, // [84] 25A0..25FF; Geometric Shapes
			9728, // [85] 2600..26FF; Miscellaneous Symbols
			9984, // [86] 2700..27BF; Dingbats
			10176, // [87] 27C0..27EF; Miscellaneous Mathematical Symbols-A
			10224, // [88] 27F0..27FF; Supplemental Arrows-A
			10240, // [89] 2800..28FF; Braille Patterns
			10496, // [90] 2900..297F; Supplemental Arrows-B
			10624, // [91] 2980..29FF; Miscellaneous Mathematical Symbols-B
			10752, // [92] 2A00..2AFF; Supplemental Mathematical Operators
			11008, // [93] 2B00..2BFF; Miscellaneous Symbols and Arrows
			11264, // [94] 2C00..2C5F; Glagolitic
			11360, // [95] 2C60..2C7F; Latin Extended-C
			11392, // [96] 2C80..2CFF; Coptic
			11520, // [97] 2D00..2D2F; Georgian Supplement
			11568, // [98] 2D30..2D7F; Tifinagh
			11648, // [99] 2D80..2DDF; Ethiopic Extended
			11744, // [100] 2DE0..2DFF; Cyrillic Extended-A
			11776, // [101] 2E00..2E7F; Supplemental Punctuation
			11904, // [102] 2E80..2EFF; CJK Radicals Supplement
			12032, // [103] 2F00..2FDF; Kangxi Radicals
			12256, // [104] 
			12272, // [105] 2FF0..2FFF; Ideographic Description Characters
			12288, // [106] 3000..303F; CJK Symbols and Punctuation
			12352, // [107] 3040..309F; Hiragana
			12448, // [108] 30A0..30FF; Katakana
			12544, // [109] 3100..312F; Bopomofo
			12592, // [110] 3130..318F; Hangul Compatibility Jamo
			12688, // [111] 3190..319F; Kanbun
			12704, // [112] 31A0..31BF; Bopomofo Extended
			12736, // [113] 31C0..31EF; CJK Strokes
			12784, // [114] 31F0..31FF; Katakana Phonetic Extensions
			12800, // [115] 3200..32FF; Enclosed CJK Letters and Months
			13056, // [116] 3300..33FF; CJK Compatibility
			13312, // [117] 3400..4DBF; CJK Unified Ideographs Extension A
			19904, // [118] 4DC0..4DFF; Yijing Hexagram Symbols
			19968, // [119] 4E00..9FFF; CJK Unified Ideographs
			40960, // [120] A000..A48F; Yi Syllables
			42128, // [121] A490..A4CF; Yi Radicals
			42192, // [122] A4D0..A4FF; Lisu
			42240, // [123] A500..A63F; Vai
			42560, // [124] A640..A69F; Cyrillic Extended-B
			42656, // [125] A6A0..A6FF; Bamum
			42752, // [126] A700..A71F; Modifier Tone Letters
			42784, // [127] A720..A7FF; Latin Extended-D
			43008, // [128] A800..A82F; Syloti Nagri
			43056, // [129] A830..A83F; Common Indic Number Forms
			43072, // [130] A840..A87F; Phags-pa
			43136, // [131] A880..A8DF; Saurashtra
			43232, // [132] A8E0..A8FF; Devanagari Extended
			43264, // [133] A900..A92F; Kayah Li
			43312, // [134] A930..A95F; Rejang
			43360, // [135] A960..A97F; Hangul Jamo Extended-A
			43392, // [136] A980..A9DF; Javanese
			43488, // [137] 
			43520, // [138] AA00..AA5F; Cham
			43616, // [139] AA60..AA7F; Myanmar Extended-A
			43648, // [140] AA80..AADF; Tai Viet
			43744, // [141] AAE0..AAFF; Meetei Mayek Extensions
			43776, // [142] AB00..AB2F; Ethiopic Extended-A
			43824, // [143] 
			43968, // [144] ABC0..ABFF; Meetei Mayek
			44032, // [145] AC00..D7AF; Hangul Syllables
			55216, // [146] D7B0..D7FF; Hangul Jamo Extended-B
			55296, // [147] D800..DB7F; High Surrogates
			56192, // [148] DB80..DBFF; High Private Use Surrogates
			56320, // [149] DC00..DFFF; Low Surrogates
			57344, // [150] E000..F8FF; Private Use Area
			63744, // [151] F900..FAFF; CJK Compatibility Ideographs
			64256, // [152] FB00..FB4F; Alphabetic Presentation Forms
			64336, // [153] FB50..FDFF; Arabic Presentation Forms-A
			65024, // [154] FE00..FE0F; Variation Selectors
			65040, // [155] FE10..FE1F; Vertical Forms
			65056, // [156] FE20..FE2F; Combining Half Marks
			65072, // [157] FE30..FE4F; CJK Compatibility Forms
			65104, // [158] FE50..FE6F; Small Form Variants
			65136, // [159] FE70..FEFF; Arabic Presentation Forms-B
			65280, // [160] FF00..FFEF; Halfwidth and Fullwidth Forms
			65520, // [161] FFF0..FFFF; Specials
			65536, // [162] 10000..1007F; Linear B Syllabary
			65664, // [163] 10080..100FF; Linear B Ideograms
			65792, // [164] 10100..1013F; Aegean Numbers
			65856, // [165] 10140..1018F; Ancient Greek Numbers
			65936, // [166] 10190..101CF; Ancient Symbols
			66000, // [167] 101D0..101FF; Phaistos Disc
			66048, // [168] 
			66176, // [169] 10280..1029F; Lycian
			66208, // [170] 102A0..102DF; Carian
			66272, // [171] 
			66304, // [172] 10300..1032F; Old Italic
			66352, // [173] 10330..1034F; Gothic
			66384, // [174] 
			66432, // [175] 10380..1039F; Ugaritic
			66464, // [176] 103A0..103DF; Old Persian
			66528, // [177] 
			66560, // [178] 10400..1044F; Deseret
			66640, // [179] 10450..1047F; Shavian
			66688, // [180] 10480..104AF; Osmanya
			66736, // [181] 
			67584, // [182] 10800..1083F; Cypriot Syllabary
			67648, // [183] 10840..1085F; Imperial Aramaic
			67680, // [184] 
			67840, // [185] 10900..1091F; Phoenician
			67872, // [186] 10920..1093F; Lydian
			67904, // [187] 
			67968, // [188] 10980..1099F; Meroitic Hieroglyphs
			68000, // [189] 109A0..109FF; Meroitic Cursive
			68096, // [190] 10A00..10A5F; Kharoshthi
			68192, // [191] 10A60..10A7F; Old South Arabian
			68224, // [192] 
			68352, // [193] 10B00..10B3F; Avestan
			68416, // [194] 10B40..10B5F; Inscriptional Parthian
			68448, // [195] 10B60..10B7F; Inscriptional Pahlavi
			68480, // [196] 
			68608, // [197] 10C00..10C4F; Old Turkic
			68688, // [198] 
			69216, // [199] 10E60..10E7F; Rumi Numeral Symbols
			69248, // [200] 
			69632, // [201] 11000..1107F; Brahmi
			69760, // [202] 11080..110CF; Kaithi
			69840, // [203] 110D0..110FF; Sora Sompeng
			69888, // [204] 11100..1114F; Chakma
			69968, // [205] 
			70016, // [206] 11180..111DF; Sharada
			70112, // [207] 
			71296, // [208] 11680..116CF; Takri
			71376, // [209] 
			73728, // [210] 12000..123FF; Cuneiform
			74752, // [211] 12400..1247F; Cuneiform Numbers and Punctuation
			74880, // [212] 
			77824, // [213] 13000..1342F; Egyptian Hieroglyphs
			78896, // [214] 
			92160, // [215] 16800..16A3F; Bamum Supplement
			92736, // [216] 
			93952, // [217] 16F00..16F9F; Miao
			94112, // [218] 
			110592, // [219] 1B000..1B0FF; Kana Supplement
			110848, // [220] 
			118784, // [221] 1D000..1D0FF; Byzantine Musical Symbols
			119040, // [222] 1D100..1D1FF; Musical Symbols
			119296, // [223] 1D200..1D24F; Ancient Greek Musical Notation
			119376, // [224] 
			119552, // [225] 1D300..1D35F; Tai Xuan Jing Symbols
			119648, // [226] 1D360..1D37F; Counting Rod Numerals
			119680, // [227] 
			119808, // [228] 1D400..1D7FF; Mathematical Alphanumeric Symbols
			120832, // [229] 
			126464, // [230] 1EE00..1EEFF; Arabic Mathematical Alphabetic Symbols
			126720, // [231] 
			126976, // [232] 1F000..1F02F; Mahjong Tiles
			127024, // [233] 1F030..1F09F; Domino Tiles
			127136, // [234] 1F0A0..1F0FF; Playing Cards
			127232, // [235] 1F100..1F1FF; Enclosed Alphanumeric Supplement
			127488, // [236] 1F200..1F2FF; Enclosed Ideographic Supplement
			127744, // [237] 1F300..1F5FF; Miscellaneous Symbols And Pictographs
			128512, // [238] 1F600..1F64F; Emoticons
			128592, // [239] 
			128640, // [240] 1F680..1F6FF; Transport And Map Symbols
			128768, // [241] 1F700..1F77F; Alchemical Symbols
			128896, // [242] 
			131072, // [243] 20000..2A6DF; CJK Unified Ideographs Extension B
			173792, // [244] 
			173824, // [245] 2A700..2B73F; CJK Unified Ideographs Extension C
			177984, // [246] 2B740..2B81F; CJK Unified Ideographs Extension D
			178208, // [247] 
			194560, // [248] 2F800..2FA1F; CJK Compatibility Ideographs Supplement
			195104, // [249] 
			917504, // [250] E0000..E007F; Tags
			917632, // [251] 
			917760, // [252] E0100..E01EF; Variation Selectors Supplement
			918000, // [253] 
			983040, // [254] F0000..FFFFF; Supplementary Private Use Area-A
			1048576, // [255] 100000..10FFFF; Supplementary Private Use Area-B
			1114112 // undefined
	};

	/** ȏC */
	public static final int KanaModifier = -1;

	/***/
	public static final int BasicLatin = 0;

	/***/
	public static final int Latin1Supplement = 1;

	/***/
	public static final int LatinExtendedA = 2;

	/***/
	public static final int LatinExtendedB = 3;

	/***/
	public static final int IPAExtensions = 4;

	/***/
	public static final int SpacingModifierLetters = 5;

	/***/
	public static final int CombiningDiacriticalMarks = 6;

	/***/
	public static final int GreekandCoptic = 7;

	/***/
	public static final int Cyrillic = 8;

	/***/
	public static final int CyrillicSupplement = 9;

	/***/
	public static final int Armenian = 10;

	/***/
	public static final int Hebrew = 11;

	/***/
	public static final int Arabic = 12;

	/***/
	public static final int Syriac = 13;

	/***/
	public static final int ArabicSupplement = 14;

	/***/
	public static final int Thaana = 15;

	/***/
	public static final int NKo = 16;

	/***/
	public static final int Samaritan = 17;

	/***/
	public static final int Mandaic = 18;

	/***/
	public static final int ArabicExtendedA = 20;

	/***/
	public static final int Devanagari = 21;

	/***/
	public static final int Bengali = 22;

	/***/
	public static final int Gurmukhi = 23;

	/***/
	public static final int Gujarati = 24;

	/***/
	public static final int Oriya = 25;

	/***/
	public static final int Tamil = 26;

	/***/
	public static final int Telugu = 27;

	/***/
	public static final int Kannada = 28;

	/***/
	public static final int Malayalam = 29;

	/***/
	public static final int Sinhala = 30;

	/***/
	public static final int Thai = 31;

	/***/
	public static final int Lao = 32;

	/***/
	public static final int Tibetan = 33;

	/***/
	public static final int Myanmar = 34;

	/***/
	public static final int Georgian = 35;

	/***/
	public static final int HangulJamo = 36;

	/***/
	public static final int Ethiopic = 37;

	/***/
	public static final int EthiopicSupplement = 38;

	/***/
	public static final int Cherokee = 39;

	/***/
	public static final int UnifiedCanadianAboriginalSyllabics = 40;

	/***/
	public static final int Ogham = 41;

	/***/
	public static final int Runic = 42;

	/***/
	public static final int Tagalog = 43;

	/***/
	public static final int Hanunoo = 44;

	/***/
	public static final int Buhid = 45;

	/***/
	public static final int Tagbanwa = 46;

	/***/
	public static final int Khmer = 47;

	/***/
	public static final int Mongolian = 48;

	/***/
	public static final int UnifiedCanadianAboriginalSyllabicsExtended = 49;

	/***/
	public static final int Limbu = 50;

	/***/
	public static final int TaiLe = 51;

	/***/
	public static final int NewTaiLue = 52;

	/***/
	public static final int KhmerSymbols = 53;

	/***/
	public static final int Buginese = 54;

	/***/
	public static final int TaiTham = 55;

	/***/
	public static final int Balinese = 57;

	/***/
	public static final int Sundanese = 58;

	/***/
	public static final int Batak = 59;

	/***/
	public static final int Lepcha = 60;

	/***/
	public static final int OlChiki = 61;

	/***/
	public static final int SundaneseSupplement = 63;

	/***/
	public static final int VedicExtensions = 64;

	/***/
	public static final int PhoneticExtensions = 65;

	/***/
	public static final int PhoneticExtensionsSupplement = 66;

	/***/
	public static final int CombiningDiacriticalMarksSupplement = 67;

	/***/
	public static final int LatinExtendedAdditional = 68;

	/***/
	public static final int GreekExtended = 69;

	/***/
	public static final int GeneralPunctuation = 70;

	/***/
	public static final int SuperscriptsandSubscripts = 71;

	/***/
	public static final int CurrencySymbols = 72;

	/***/
	public static final int CombiningDiacriticalMarksforSymbols = 73;

	/***/
	public static final int LetterlikeSymbols = 74;

	/***/
	public static final int NumberForms = 75;

	/***/
	public static final int Arrows = 76;

	/***/
	public static final int MathematicalOperators = 77;

	/***/
	public static final int MiscellaneousTechnical = 78;

	/***/
	public static final int ControlPictures = 79;

	/***/
	public static final int OpticalCharacterRecognition = 80;

	/***/
	public static final int EnclosedAlphanumerics = 81;

	/***/
	public static final int BoxDrawing = 82;

	/***/
	public static final int BlockElements = 83;

	/***/
	public static final int GeometricShapes = 84;

	/***/
	public static final int MiscellaneousSymbols = 85;

	/***/
	public static final int Dingbats = 86;

	/***/
	public static final int MiscellaneousMathematicalSymbolsA = 87;

	/***/
	public static final int SupplementalArrowsA = 88;

	/***/
	public static final int BraillePatterns = 89;

	/***/
	public static final int SupplementalArrowsB = 90;

	/***/
	public static final int MiscellaneousMathematicalSymbolsB = 91;

	/***/
	public static final int SupplementalMathematicalOperators = 92;

	/***/
	public static final int MiscellaneousSymbolsandArrows = 93;

	/***/
	public static final int Glagolitic = 94;

	/***/
	public static final int LatinExtendedC = 95;

	/***/
	public static final int Coptic = 96;

	/***/
	public static final int GeorgianSupplement = 97;

	/***/
	public static final int Tifinagh = 98;

	/***/
	public static final int EthiopicExtended = 99;

	/***/
	public static final int CyrillicExtendedA = 100;

	/***/
	public static final int SupplementalPunctuation = 101;

	/***/
	public static final int CJKRadicalsSupplement = 102;

	/***/
	public static final int KangxiRadicals = 103;

	/***/
	public static final int IdeographicDescriptionCharacters = 105;

	/***/
	public static final int CJKSymbolsandPunctuation = 106;

	/***/
	public static final int Hiragana = 107;

	/***/
	public static final int Katakana = 108;

	/***/
	public static final int Bopomofo = 109;

	/***/
	public static final int HangulCompatibilityJamo = 110;

	/***/
	public static final int Kanbun = 111;

	/***/
	public static final int BopomofoExtended = 112;

	/***/
	public static final int CJKStrokes = 113;

	/***/
	public static final int KatakanaPhoneticExtensions = 114;

	/***/
	public static final int EnclosedCJKLettersandMonths = 115;

	/***/
	public static final int CJKCompatibility = 116;

	/***/
	public static final int CJKUnifiedIdeographsExtensionA = 117;

	/***/
	public static final int YijingHexagramSymbols = 118;

	/***/
	public static final int CJKUnifiedIdeographs = 119;

	/***/
	public static final int YiSyllables = 120;

	/***/
	public static final int YiRadicals = 121;

	/***/
	public static final int Lisu = 122;

	/***/
	public static final int Vai = 123;

	/***/
	public static final int CyrillicExtendedB = 124;

	/***/
	public static final int Bamum = 125;

	/***/
	public static final int ModifierToneLetters = 126;

	/***/
	public static final int LatinExtendedD = 127;

	/***/
	public static final int SylotiNagri = 128;

	/***/
	public static final int CommonIndicNumberForms = 129;

	/***/
	public static final int Phagspa = 130;

	/***/
	public static final int Saurashtra = 131;

	/***/
	public static final int DevanagariExtended = 132;

	/***/
	public static final int KayahLi = 133;

	/***/
	public static final int Rejang = 134;

	/***/
	public static final int HangulJamoExtendedA = 135;

	/***/
	public static final int Javanese = 136;

	/***/
	public static final int Cham = 138;

	/***/
	public static final int MyanmarExtendedA = 139;

	/***/
	public static final int TaiViet = 140;

	/***/
	public static final int MeeteiMayekExtensions = 141;

	/***/
	public static final int EthiopicExtendedA = 142;

	/***/
	public static final int MeeteiMayek = 144;

	/***/
	public static final int HangulSyllables = 145;

	/***/
	public static final int HangulJamoExtendedB = 146;

	/***/
	public static final int HighSurrogates = 147;

	/***/
	public static final int HighPrivateUseSurrogates = 148;

	/***/
	public static final int LowSurrogates = 149;

	/***/
	public static final int PrivateUseArea = 150;

	/***/
	public static final int CJKCompatibilityIdeographs = 151;

	/***/
	public static final int AlphabeticPresentationForms = 152;

	/***/
	public static final int ArabicPresentationFormsA = 153;

	/***/
	public static final int VariationSelectors = 154;

	/***/
	public static final int VerticalForms = 155;

	/***/
	public static final int CombiningHalfMarks = 156;

	/***/
	public static final int CJKCompatibilityForms = 157;

	/***/
	public static final int SmallFormVariants = 158;

	/***/
	public static final int ArabicPresentationFormsB = 159;

	/***/
	public static final int HalfwidthandFullwidthForms = 160;

	/***/
	public static final int Specials = 161;

	/***/
	public static final int LinearBSyllabary = 162;

	/***/
	public static final int LinearBIdeograms = 163;

	/***/
	public static final int AegeanNumbers = 164;

	/***/
	public static final int AncientGreekNumbers = 165;

	/***/
	public static final int AncientSymbols = 166;

	/***/
	public static final int PhaistosDisc = 167;

	/***/
	public static final int Lycian = 169;

	/***/
	public static final int Carian = 170;

	/***/
	public static final int OldItalic = 172;

	/***/
	public static final int Gothic = 173;

	/***/
	public static final int Ugaritic = 175;

	/***/
	public static final int OldPersian = 176;

	/***/
	public static final int Deseret = 178;

	/***/
	public static final int Shavian = 179;

	/***/
	public static final int Osmanya = 180;

	/***/
	public static final int CypriotSyllabary = 182;

	/***/
	public static final int ImperialAramaic = 183;

	/***/
	public static final int Phoenician = 185;

	/***/
	public static final int Lydian = 186;

	/***/
	public static final int MeroiticHieroglyphs = 188;

	/***/
	public static final int MeroiticCursive = 189;

	/***/
	public static final int Kharoshthi = 190;

	/***/
	public static final int OldSouthArabian = 191;

	/***/
	public static final int Avestan = 193;

	/***/
	public static final int InscriptionalParthian = 194;

	/***/
	public static final int InscriptionalPahlavi = 195;

	/***/
	public static final int OldTurkic = 197;

	/***/
	public static final int RumiNumeralSymbols = 199;

	/***/
	public static final int Brahmi = 201;

	/***/
	public static final int Kaithi = 202;

	/***/
	public static final int SoraSompeng = 203;

	/***/
	public static final int Chakma = 204;

	/***/
	public static final int Sharada = 206;

	/***/
	public static final int Takri = 208;

	/***/
	public static final int Cuneiform = 210;

	/***/
	public static final int CuneiformNumbersandPunctuation = 211;

	/***/
	public static final int EgyptianHieroglyphs = 213;

	/***/
	public static final int BamumSupplement = 215;

	/***/
	public static final int Miao = 217;

	/***/
	public static final int KanaSupplement = 219;

	/***/
	public static final int ByzantineMusicalSymbols = 221;

	/***/
	public static final int MusicalSymbols = 222;

	/***/
	public static final int AncientGreekMusicalNotation = 223;

	/***/
	public static final int TaiXuanJingSymbols = 225;

	/***/
	public static final int CountingRodNumerals = 226;

	/***/
	public static final int MathematicalAlphanumericSymbols = 228;

	/***/
	public static final int ArabicMathematicalAlphabeticSymbols = 230;

	/***/
	public static final int MahjongTiles = 232;

	/***/
	public static final int DominoTiles = 233;

	/***/
	public static final int PlayingCards = 234;

	/***/
	public static final int EnclosedAlphanumericSupplement = 235;

	/***/
	public static final int EnclosedIdeographicSupplement = 236;

	/***/
	public static final int MiscellaneousSymbolsAndPictographs = 237;

	/***/
	public static final int Emoticons = 238;

	/***/
	public static final int TransportAndMapSymbols = 240;

	/***/
	public static final int AlchemicalSymbols = 241;

	/***/
	public static final int CJKUnifiedIdeographsExtensionB = 243;

	/***/
	public static final int CJKUnifiedIdeographsExtensionC = 245;

	/***/
	public static final int CJKUnifiedIdeographsExtensionD = 246;

	/***/
	public static final int CJKCompatibilityIdeographsSupplement = 248;

	/***/
	public static final int Tags = 250;

	/***/
	public static final int VariationSelectorsSupplement = 252;

	/***/
	public static final int SupplementaryPrivateUseAreaA = 254;

	/***/
	public static final int SupplementaryPrivateUseAreaB = 255;

}
