package jp.takayuki.tools;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import petaclone.AppPreferences;
import extcmd.Restart;

/**
 * ċNƍXVs܂B
 * @author Takayuki Shoji
 */
public class GtkRestartHelper extends AbstractRestartHelper {

	/**
	 * @param pref ݒ
	 */
	public GtkRestartHelper(AppPreferences pref) {
		super(pref);
	}

	public void update(File updateFile) throws IOException {

		// J̏ꍇ͍XVȂ
		checkDevelopmentEnvironment();

		PathResolver pathResolver = pref.getPolicy().getPathResolver();

		deleteRestartLog();

		Map envp = new HashMap(System.getenv());
		envp.put(Restart.LOG, logFile.getAbsolutePath());
		envp.put(Restart.WATCH_FILE, createLockFile());
		envp.put(Restart.NEW_FILE, updateFile.getAbsolutePath());
		File installDir = pathResolver.getProgramDirectory();
		if (installDir == null) {
			throw new IOException("Failed to get program directory."); //$NON-NLS-1$
		}
		envp.put(Restart.APP_FOLDER_NAME, "petaclone"); //$NON-NLS-1$
		envp.put(Restart.INSTALL_DIR, installDir);
		envp.put(Restart.BASE_DIR, Tool.getCurrentDirectory());
		String[] cmdSet = pathResolver.getExecutable();
		if (cmdSet == null) {
			throw new IOException("Failed to get restart command."); //$NON-NLS-1$
		}
		for (int i = 0; i < cmdSet.length; i++) {
			envp.put(Restart.RESTART + i, cmdSet[i]);
		}

		/*
		 * 쐬[W
		 * gksudo -k "/bin/echo \"red blue\""
		 */
		List args = new ArrayList();
		args.add(pathResolver.getJavaPath());
		args.add("-cp"); //$NON-NLS-1$
		args.add(updateDir.getAbsolutePath());
		args.add(Restart.class.getName());
		args.add(Restart.CMD_PRIVILEGE_UPDATE);

		// 
		List privilege = elevateCommandPrivilege(args);
		for (int i = 0; i < privilege.size(); i++) {
			envp.put(Restart.PRIVILEGE + i, privilege.get(i));
		}

		List args2 = getUpdateCommand(pathResolver);

		// s
		writeRestartClass();
		execute(args2, envp);
	}

	/**
	 * R}hŎsł悤ɂ܂B
	 * @param args R}h
	 * @return Ŏsł悤ɂR}h
	 */
	private List elevateCommandPrivilege(List args) {
		List result = new ArrayList();

		result.add("gksudo"); //$NON-NLS-1$
		result.add("-k"); //$NON-NLS-1$
		result.add("-g"); //$NON-NLS-1$
		result.add("-d"); //$NON-NLS-1$
		//TODO K؂ȃbZ[W\
		//result.add("-m"); //$NON-NLS-1$
		//result.add("Installing Petaclone."); //$NON-NLS-1$

		// eɈptƐɓ삵Ȃ
		StringBuffer buf = new StringBuffer();
		//Tool.escapeDoubleQuotation2(buf, (String) args.get(0));
		buf.append((String) args.get(0));
		for (int i = 1; i < args.size(); i++) {
			buf.append(' ');
			//Tool.escapeDoubleQuotation2(buf, (String) args.get(i));
			buf.append((String) args.get(i));
		}
		result.add(buf.toString());

		return result;
	}

}
