package jp.takayuki.tools;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * \[Xoh̃bp[B
 * <p>
 * L[ȂꍇɗO𓊂܂B
 * 
 * @author Takayuki Shoji
 */
public class MessageMap {

	/**
	 * ̈
	 */
	private static final Object[] EMPTY = {};

	/**
	 * P[ɑΉ郊\[Xoh
	 */
	private final ResourceBundle bndl;

	/**
	 * RXgN^B
	 * 
	 * @param name x[X 
	 * @param bndl \[Xoh
	 */
	public MessageMap(ResourceBundle bndl) {
		this.bndl = bndl;
	}

	/**
	 * NXɑΉ郁bZ[W}bv擾܂B
	 * 
	 * @param clazz NX
	 * @return bZ[W}bv
	 */
	public static MessageMap getMessageMap(Class clazz) {
		return getMessageMap(clazz.getName());
	}

	/**
	 * "messages"x[Xɂ\[Xoh擾܂B
	 * 
	 * @return MessageMap
	 */
	public static MessageMap getMessageMap() {
		return getMessageMap("messages"); //$NON-NLS-1$
	}

	/**
	 * x[Xƌ݂̃P[ɑΉ郊\[Xoh擾MessageMapɕϊĕԂ܂B
	 * 
	 * @param name x[X
	 * @return MessageMap
	 */
	public static MessageMap getMessageMap(final String name) {
		try {
			ResourceBundle bundle = ResourceBundle.getBundle(name);
			return new MessageMap(bundle);
		} catch (MissingResourceException e) {
			return new MessageMap(null) {
				public String get(String key, Object[] args) {
					return "Resource \"" //$NON-NLS-1$
							+ name + "\" not found."; //$NON-NLS-1$
				}
			};
		}
	}

	/**
	 * L[ɑΉ̃bZ[W擾܂B
	 * 
	 * @param key L[
	 * @return bZ[W
	 */
	public String get(String key) {
		return get(key, EMPTY);
	}

	/**
	 * L[ɑΉt̃bZ[W擾܂B
	 * 
	 * @param key L[
	 * @param args bZ[W
	 * @return bZ[WBL[݂Ȃꍇ̓L[ԂB
	 */
	public String get(String key, Object[] args) {
		String val;
		try {
			val = bndl.getString(key);
		} catch (MissingResourceException e) {
			return "\"" + key + "\" not found."; //$NON-NLS-1$ //$NON-NLS-2$
		}
		if (args == EMPTY) {
			// bZ[Wꍇ̓v[Xz_̂܂܏o͂邽߁A
			// ̗LŔfĂ悢B
			return val;
		}
		try {
			return MessageFormat.format(val, args);
		} catch (IllegalArgumentException e) {
			return "Illegal format:" + val; //$NON-NLS-1$
		}
	}

	/**
	 * L[ɑΉt̃bZ[W1ڂɎw肵؂蕶ŋ؂ĔzŎ擾܂B
	 * @param key L[
	 * @return bZ[W̔z
	 */
	public String[] getArray(String key) {
		String v = get(key);
		if (v != null) {
			return Tool.split(v.substring(1), v.charAt(0), -1);
		}
		return new String[0];
	}
}
