package petaclone;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import jp.takayuki.logging.Logger;

import com.melloware.jintellitype.HotkeyListener;
import com.melloware.jintellitype.JIntellitype;

/**
 * zbgL[CxgEventBrokerɓn܂B
 * 
 * @author Takayuki Shoji
 */
public class HotkeyEventBridge implements HotkeyListener {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(HotkeyEventBridge.class);

	/**
	 * EventBroker
	 */
	private EventBroker broker;

	/**
	 * ID𐶐JE^
	 */
	private int count;

	/**
	 * Cxg}bv
	 * <p>
	 * L[: Integer ID<br>
	 * l: String Cxg
	 */
	private Map eventMap = new HashMap();

	/**
	 * JIntellitypẽCX^X
	 */
	private JIntellitype jit;

	/**
	 * RXgN^
	 * 
	 * @param broker EventBroker
	 * @throws ApplicationException JIntellitype̐ŗOꍇ
	 */
	public HotkeyEventBridge(EventBroker broker) throws ApplicationException {
		this.broker = broker;
		try {
			jit = JIntellitype.getInstance();
			jit.addHotKeyListener(this);
		} catch (RuntimeException e) {
			throw new ApplicationException(
					"Exception occurred while generating JIntellitype.", e); //$NON-NLS-1$
		}
	}

	/**
	 * HotkeyCxg󂯎\bhłB
	 * 
	 * @see com.melloware.jintellitype.HotkeyListener#onHotKey(int)
	 */
	public void onHotKey(int identifier) {

		String eventName = (String) eventMap.get(new Integer(identifier));

		if (logger.isInfoEnabled())
			logger.info("Hotkey event:" + eventName + "(" + identifier + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$

		broker.notifyEvent(eventName, null);
	}

	/**
	 * zbgL[o^܂B
	 * <p>
	 * 0͖̕܂B
	 * 
	 * @param eventName Cxg
	 * @param key L[Rrl[VBCL[CTRL, SHIFT, ALT, WINŎw肵A+ŌB
	 * @throws ApplicationException 
	 */
	public void addHotkey(String eventName, String key)
			throws ApplicationException {

		if (key == null || key.length() == 0 || key.equals("+")) { //$NON-NLS-1$
			/*
			 * "+"ŕۑoOA̒l
			 * G[Ƃ݂ȂȂ悤ɂB
			 */
			return;
		}

		count++;

		try {
			jit.registerHotKey(count, key);
			eventMap.put(new Integer(count), eventName);
		} catch (IllegalArgumentException e) {
			throw new ApplicationException("Invalid key asignment.", e); //$NON-NLS-1$
		}
	}

	/**
	 * zbgL[̓o^܂B
	 * 
	 * @param eventName Cxg
	 */
	public void removeHotkey(String eventName) {
		Integer id = (Integer) eventMap.get(eventName);
		jit.unregisterHotKey(id.intValue());
		eventMap.remove(id);
	}

	/**
	 * ׂẴzbgL[̓o^܂B
	 */
	public void removeAllHotkeys() {
		Iterator itr = eventMap.keySet().iterator();
		while (itr.hasNext()) {
			Integer id = (Integer) itr.next();
			jit.unregisterHotKey(id.intValue());
			itr.remove();
		}
	}

	/**
	 * \[X܂B
	 * <p>
	 * vZX̏IɕKĂяoKv܂B
	 */
	public void dispose() {
		jit.cleanUp();
	}
}
