package petaclone;

import java.io.File;
import java.io.IOException;

import jp.takayuki.logging.Logger;
import jp.takayuki.tools.Tool;

/**
 * ݒƃp[^ɊÂăR}hs邽߂̃NXłB
 * @author Takayuki Shoji
 */
public class ToolExecutor {

	/**
	 * log
	 */
	private static final Logger logger = Logger.getLogger(ToolExecutor.class);

	/**
	 * AvP[Vݒ
	 */
	private final AppPreferences pref;

	/**
	 * RXgN^
	 * @param pref AvP[Vݒ
	 */
	public ToolExecutor(AppPreferences pref) {
		this.pref = pref;
	}

	/**
	 * t@CJs܂B
	 * @param propertyPrefix vpeB̃vtBbNX
	 * @param file Ώۂ̃t@C܂̓tH_B
	 */
	public void openFile(String propertyPrefix, File file) {
		String execPath = pref.getToolCommand(propertyPrefix);
		if (execPath == null || execPath.length() == 0) {
			logger.warn("Executable file not specified."); //$NON-NLS-1$
			return;
		}
		String param = pref.getToolParameter(propertyPrefix);
		File dir = pref.getToolWorkingFolderAsFile(propertyPrefix);

		StringBuffer sb = new StringBuffer();
		Tool.quoteExecPath(sb, execPath);
		sb.append(' ');
		for (int i = 0; i < param.length(); i++) {
			char c = param.charAt(i);
			switch (c) {
			case '%':
				i++;
				if (i < param.length()) {
					c = param.charAt(i);
					switch (c) {
					case '%':
						sb.append('%');
						break;
					case 'f':
						if (file != null) {
							sb.append(file.getAbsolutePath());
						}
						break;
					case 'd':
						if (file != null) {
							File parent = file.getParentFile();
							if (parent != null) {
								sb.append(parent.getAbsolutePath());
							}
						}
						break;
					default:
						break;
					}
				}
				break;

			default:
				sb.append(c);
				break;
			}
		}

		String command = sb.toString();
		try {
			logger.info(command);
			Process p = Runtime.getRuntime().exec(command, null, dir);
			p.waitFor();
		} catch (IOException e) {
			logger.error("Failed to execute:" + command, e); //$NON-NLS-1$
		} catch (InterruptedException e) {
			logger.error("Failed to execute:" + command, e); //$NON-NLS-1$
		}
	}

}
