package petaclone.denki;

import java.net.InetSocketAddress;
import java.text.DecimalFormat;

import jp.takayuki.tools.Tool;

/**
 * dCgpʂƃpPbg
 * @author Takayuki Shoji
 */
public class DenkiUsage {
	/** R}h(pPbgp) */
	String command;

	/** d͉Ж(pPbgp) */
	String epco;

	/** MAhX(pPbgp) */
	InetSocketAddress sourceAddress;

	/** waitM(pPbgp) */
	long wait;

	/** (HH:mm) */
	String updateTime = ""; //$NON-NLS-1$

	/** őd͋(kW) */
	int peekSupply;

	/** (HH:mm) */
	String time = ""; //$NON-NLS-1$

	/** d͏(kW) */
	int demand;

	/** G[tO */
	boolean error;

	/**
	 * @return 
	 */
	DenkiUsage duplicate() {
		DenkiUsage dup = new DenkiUsage();
		dup.updateTime = updateTime;
		dup.peekSupply = peekSupply;
		dup.time = time;
		dup.demand = demand;
		return dup;
	}

	/**
	 * @return gp
	 */
	double getUsageRate() {
		if (peekSupply == 0) {
			return 0d;
		}
		return (((double) demand) / ((double) peekSupply)) * 100d;
	}

	/**
	 * gptH[}bg܂B
	 * @param rate gp
	 * @return tH[}bgςݕ
	 */
	static String formatRate(double rate) {
		return new DecimalFormat("0.00").format(rate); //$NON-NLS-1$
	}

	/**
	 * gptH[}bg܂B
	 * @param rate gp
	 * @return tH[}bgςݕ
	 */
	static String formatRateShort(double rate) {
		return new DecimalFormat("00").format(rate); //$NON-NLS-1$
	}

	/**
	 * pPbg͂܂B
	 * @param packetStr pPbgf[^
	 * @return Ȃf[^̏ꍇfalse
	 */
	boolean parsePacket(String packetStr) {
		String[] fields = Tool.split(packetStr, ","); //$NON-NLS-1$
		if (fields.length < 6) {
			return false;
		}
		try {
			command = fields[0];
			epco = fields[1];
			updateTime = fields[2];
			peekSupply = Integer.parseInt(fields[3]);
			time = fields[4];
			demand = Integer.parseInt(fields[5]);
		} catch (NumberFormatException e) {
			return false;
		}
		if (peekSupply < 0 || demand < 0) {
			return false;
		}
		return true;
	}

	/**
	 * pPbgp̕擾܂B
	 * @param com R}h
	 * @param company d͉ЂID
	 * @return pPbgp̕
	 */
	synchronized String toPacket(String com) {
		return com + ',' + epco + ',' + updateTime + ',' + peekSupply + ','
				+ time + ',' + demand;
	}

	public String toString() {
		return "DenkiUsage{" + "updateTime=" + updateTime + ", peek=" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				+ peekSupply + ", time=" + time + ", demand=" + demand + "}"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	}
}
