package petaclone.swt;

import jp.takayuki.swt.util.ListenerDelegate;
import jp.takayuki.swt.util.SWTMenuUtils;
import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Text;

/**
 * ̃[eBeBB
 * 
 * @author Takayuki Shoji
 */
public class FindUtils {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap msg = MessageMap.getMessageMap();

	/**
	 * ύXo郊Xi[
	 */
	private static final class ModificationDetector implements ModifyListener {

		/**
		 * C^[tF[X
		 */
		private final Findable findable;

		/**
		 * ͂ꂽeLXg{bNX
		 */
		private final Text text;

		/**
		 * Ō̃Cxg̔
		 */
		private long lastModified;

		/**
		 * RXgN^
		 * @param findable C^[tF[X
		 * @param text ͂ꂽeLXg{bNX
		 */
		ModificationDetector(Findable findable, Text text) {
			this.findable = findable;
			this.text = text;
		}

		public void modifyText(ModifyEvent e) {
			this.lastModified = System.currentTimeMillis();

			Display display = Display.getDefault();
			display.timerExec(350, new LazyTask(lastModified));
		}

		/**
		 * x^XN
		 * 
		 * @author Takayuki Shoji
		 */
		private final class LazyTask implements Runnable {

			/**
			 * Cxg̔
			 */
			private final long createdTime;

			/**
			 * RXgN^
			 * 
			 * @param createdTime Cxg̔
			 */
			public LazyTask(long createdTime) {
				this.createdTime = createdTime;
			}

			public void run() {
				if (lastModified != createdTime) {
					// ύXđ̒x^XNsĂ
					return;
				}
				if (!text.isDisposed()) {
					String search = text.getText();
					findable.findItem(search, 0, false);
				}
			}
		}

	}

	/**
	 * eLXg{bNX\z܂B
	 * 
	 * @param parent eLXg{bNXzueEBWFbg
	 * @param target e[u
	 * @param actions CxgXi[
	 * @param createButton I{^𐶐ꍇtrue
	 * @param findable ̂߂̃C^[tF[X
	 * @return eLXg{bNX
	 */
	public static Text createSearchBox(Composite parent,
			ListenerDelegate actions, boolean createButton,
			final Findable findable) {
		Label label = new Label(parent, SWT.HORIZONTAL);
		label.setText(msg.get("FindUtils.find.label")); //$NON-NLS-1$

		Text text = new Text(parent, SWT.BORDER | SWT.SEARCH | SWT.CANCEL);

		GridData gd = new GridData();
		gd.horizontalAlignment = SWT.FILL;
		gd.grabExcessHorizontalSpace = true;
		gd.verticalAlignment = SWT.CENTER;
		text.setLayoutData(gd);

		text.addModifyListener(new ModificationDetector(findable, text));

		if (createButton) {
			Button button = new Button(parent, SWT.PUSH);
			button.setText(msg.get("FindUtils.select.label")); //$NON-NLS-1$
			actions.registerAndAddListener(button, "doSelectAllMatchedItems"); //$NON-NLS-1$
		}
		return text;
	}

	/**
	 * AÕj[ACeǉ܂B
	 * 
	 * @param menuEdit ҏWj[
	 * @param actions CxgXi[
	 */
	public static void createMenu(Menu menuEdit, ListenerDelegate actions) {
		SWTMenuUtils.addMenuItem(menuEdit, //
				msg.get("FindUtils.findNext.label"), //$NON-NLS-1$
				"F3", SWT.F3, null, //$NON-NLS-1$
				actions, "doFindNext"); //$NON-NLS-1$

		SWTMenuUtils.addMenuItem(menuEdit, //
				msg.get("FindUtils.findPrevious.label"), //$NON-NLS-1$
				"Shift+F3",// //$NON-NLS-1$
				SWT.MOD2 | SWT.F3, null, actions, "doFindPrevious"); //$NON-NLS-1$
	}
}
