package petaclone.swt;

import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import petaclone.AppPreferences;
import petaclone.MessengerFacade;
import petaclone.RuntimeProperties;

/**
 * sݒʒm[hƒʒm郁bZ[W̐ݒ_CAOB
 * Jn{^NbNƕsݒʒm[hɂȂA_CAO
 * ʏ탂[hɂǂB
 * @author Takayuki Shoji
 */
public class SWTAbsenceDialog {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** MessengerFacade */
	private MessengerFacade facade;

	/** ݒ */
	private AppPreferences pref;

	/** _CAOShell */
	private Shell shell;

	/**
	 * RXgN^B
	 * @param parent eshel
	 * @param facade MessengerFacade
	 * @param pref ݒ
	 * @param absence ŏs݂ɂ
	 */
	public SWTAbsenceDialog(Shell parent, MessengerFacade facade,
			AppPreferences pref, boolean absence) {

		this.facade = facade;
		this.pref = pref;
		this.shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		init(absence);
	}

	/**
	 * EBWFbg̏ƃEBhẼI[vB
	 * @param absence Nɕs݃[hɂꍇtrue
	 */
	private void init(boolean absence) {

		// N[YXi[
		shell.addShellListener(new ShellClosed());

		// CAEg
		GridLayout gridLayout = new GridLayout();
		shell.setLayout(gridLayout);

		// bZ[W
		Label label = new Label(shell, SWT.NULL);
		label.setText(mm.get("SWTAbsenceDialog.instruction.label")); //$NON-NLS-1$

		// eLXg{bNX
		Text textBox = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.V_SCROLL);
		textBox.setText(pref.getAbsenceMessage());
		GridData data = new GridData();
		data.widthHint = 200;
		data.heightHint = 200;
		textBox.setLayoutData(data);

		// Jn{^
		Button button = new Button(shell, SWT.PUSH);
		button.setText(mm.get("SWTAbsenceDialog.start.label")); //$NON-NLS-1$
		data = new GridData();
		data.horizontalAlignment = SWT.CENTER;
		button.setLayoutData(data);

		// Jn{^̃Xi[
		ButtonStartAbsence bsa = new ButtonStartAbsence(textBox, button);
		button.addSelectionListener(bsa);

		// Nɕs
		if (absence) {
			bsa.widgetSelected(null);
		}

		shell.pack();
		shell.open();
	}

	/**
	 * SelectionAdapter:Jn{^Bsݒʒm[hɈڍsB
	 * eLXg{bNXҏWsA{^Isɂ܂B
	 */
	private class ButtonStartAbsence extends SelectionAdapter {
		/** sݒʒm̃eLXg{bNX */
		private Text textBox;

		/** Jn{^ */
		private Button button;

		/**
		 * RXgN^
		 * @param textBox eLXg{bNX
		 * @param button {^
		 */
		public ButtonStartAbsence(Text textBox, Button button) {
			this.textBox = textBox;
			this.button = button;
		}

		public void widgetSelected(SelectionEvent e) {

			// eLXg{bNXA{^gps\ɂ
			textBox.setEditable(false);
			button.setEnabled(false);

			// ʒmۑ
			String message = textBox.getText();
			pref.setAbsenceMessage(message);

			// sݒʒm[hɂ
			RuntimeProperties rp = pref.getRuntime();
			rp.setAbsenceMessage(message);
			rp.setPresence(RuntimeProperties.PRESENCE_ABSENCE);

			// bZW[ɒʒm
			facade.sendAbsenceMode(true);
		}
	}

	/**
	 * Xi
	 */
	private class ShellClosed extends ShellAdapter {
		public void shellClosed(ShellEvent event) {
			// sݒʒm[h
			RuntimeProperties rp = pref.getRuntime();
			rp.setPresence(RuntimeProperties.PRESENCE_NORMAL);

			// bZW[ɒʒm
			facade.sendAbsenceMode(false);
		}
	}
}
