package petaclone.swt;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Properties;

import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.InetAddressUtils;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.PropertiesUtils;
import jp.takayuki.tools.Tool;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Text;

import petaclone.AppPreferences;
import petaclone.CollectableControl;
import petaclone.ControlChecker;
import petaclone.ControlCreator;
import petaclone.LaunchConfiguration;

/**
 * CollectableControlNXQ
 * @author Takayuki Shoji
 */
public class SWTControlCreator implements ControlCreator {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * eEBWFbg
	 */
	private Composite parent;

	/**
	 * vpeB[
	 */
	private Properties prop;

	/**
	 * qg
	 */
	private int widthHint = SWT.DEFAULT;

	/**
	 * Rg[̃Xg<br>
	 * l: CollectableControl
	 */
	private ArrayList controls = new ArrayList();

	/**
	 * RXgN^
	 * @param properties vpeB
	 */
	SWTControlCreator(Properties properties) {
		this.prop = properties;
	}

	/**
	 * vpeB[lۑ܂B
	 */
	void saveProperties() {
		Iterator itr = controls.iterator();
		while (itr.hasNext()) {
			CollectableControl control = (CollectableControl) itr.next();
			control.saveProperty();
		}
	}

	/**
	 * Rg[`FbNĕۑł邩mF܂B
	 * @return
	 * 		`FbNɃpXȂŏ̃Rg[Ԃ܂B
	 * 		`FbNɃpXꍇnullԂ܂B
	 */
	CollectableControl checkProperties() {
		Iterator itr = controls.iterator();
		while (itr.hasNext()) {
			CollectableControl control = (CollectableControl) itr.next();
			if (!control.checkValue()) {
				return control;
			}
		}
		return null;
	}

	/**
	 * 삷Propertiesw肵܂B
	 * @param prop vpeB
	 */
	void setProperties(Properties prop) {
		this.prop = prop;
	}

	/**
	 * eEBWFbg؂ւ܂B
	 * @param parent eEBWFbg
	 */
	void setParent(Composite parent) {
		this.parent = parent;
	}

	/**
	 * Rg[[X܂B<br>
	 * PropertiesEBWFbg̔j𔺂A
	 * 2ʈȏɂ킽đ삷ꍇ(EBU[hȂ)
	 * saveProperties()̌ɎgpăRg[̃Xg܂B
	 */
	void releaseControls() {
		this.controls = new ArrayList();
	}

	/**
	 * ̃qg^܂B
	 * @param widthHint qgƂȂ鉡
	 */
	void setWidthHint(int widthHint) {
		this.widthHint = widthHint;
	}

	/**
	 * CAEgf[^𐶐܂B
	 * @param colspan Xp2̃CAEgf[^
	 * @param fill ɂςɍL郌CAEgf[^
	 * @return GridData
	 */
	private GridData createLayoutData(boolean colspan, boolean fill) {
		GridData data = new GridData();
		if (colspan) {
			data.horizontalSpan = 2;
		}
		if (fill) {
			data.horizontalAlignment = SWT.FILL;
			data.grabExcessHorizontalSpace = true;
		}
		return data;
	}

	/**
	 * eEBWFbg肵܂B
	 * 
	 * @param snapToGrid ObhɑꍇtrueAl߂ŕׂꍇfalseB
	 * @return eEBWFbg
	 */
	private Composite determineParent(boolean snapToGrid) {

		if (snapToGrid) {
			return parent;
		}

		Composite myParent = new Composite(parent, SWT.NONE);
		myParent.setLayoutData(createLayoutData(true, false));

		RowLayout layout = new RowLayout(SWT.HORIZONTAL);
		layout.marginBottom = 0;
		layout.marginTop = 0;
		layout.marginLeft = 0;
		layout.marginRight = 0;
		layout.marginHeight = 0;
		layout.marginWidth = 0;
		layout.center = true;
		myParent.setLayout(layout);
		return myParent;
	}

	/**
	 * `FbN{bNXB
	 * `FbNĂȂԂ"0"AȊO`FbNꂽԂƂĈ܂B
	 * 2lȂ̂Œl̃`FbN͍s܂B
	 */
	private class CheckBox implements CollectableControl {
		/** vpeB[ */
		String property;

		/** `FbN{bNX̃{^Rg[ */
		Button checkBox;

		/**
		 * RXgN^
		 * @param property vpeB
		 * @param label x
		 * @param defaultValue `FbN{bNX̏
		 */
		CheckBox(String property, String label, boolean defaultValue) {
			this.property = property;
			// 
			checkBox = new Button(parent, SWT.CHECK);
			checkBox.setText(label);

			// I
			boolean value = PropertiesUtils.getBoolean(prop, property,
					defaultValue);
			checkBox.setSelection(value);

			// CAEg
			checkBox.setLayoutData(createLayoutData(true, false));
		}

		/**
		 * trueԂ܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * `FbNĂȂԂ"0"Ƃĕۑ܂B
		 */
		public void saveProperty() {
			PropertiesUtils.setBoolean(prop, property, checkBox.getSelection());
		}

		/**
		 * `FbN͍s܂B
		 */
		public void setChecker(ControlChecker checker) {
			// `FbN̕KvȂ
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			checkBox.forceFocus();
		}

		/**
		 * c[`bvݒ肵܂B
		 */
		public void setToolTipText(String text) {
			checkBox.setToolTipText(text);
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * WI{^B
	 * IlȂ̂Œl̃`FbN͍s܂B
	 */
	private class Radio implements CollectableControl {
		/** vpeB̃L[ */
		private String property;

		/** vpeB̒l */
		private String[] propertyValues;

		/** WI{^EBWFbg */
		private Button[] radio;

		/** O[v(c[`bv̐ݒɎg) */
		private Group group;

		/**
		 * RXgN^
		 * @param property vpeB[
		 * @param label x
		 * @param values \l
		 * @param propertyValues vpeB[l
		 * @param defaultValue ftHgl
		 */
		Radio(String property, String label, String[] values,
				String[] propertyValues, String defaultValue) {
			this.property = property;
			this.propertyValues = propertyValues;
			// 
			group = new Group(parent, SWT.SHADOW_ETCHED_IN);
			group.setText(label);
			group.setLayoutData(createLayoutData(true, false));
			group.setLayout(new FillLayout(SWT.VERTICAL));

			// ݂̒l擾
			String selectedValue = prop.getProperty(property, defaultValue);

			radio = new Button[values.length];
			//boolean selected = false;
			for (int i = 0; i < values.length; i++) {
				radio[i] = new Button(group, SWT.RADIO);
				radio[i].setText(values[i]);
				// I
				if (selectedValue != null
						&& propertyValues[i].equals(selectedValue)) {
					radio[i].setSelection(true);
					//selected = true;
				}
			}
		}

		/**
		 * trueԂ܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * vpeB[lۑ܂B
		 */
		public void saveProperty() {
			int selected = getSelection();
			if (selected == -1) {
				return;
			}
			prop.setProperty(property, this.propertyValues[selected]);
		}

		/**
		 * `FbN͍s܂B
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			int selected = getSelection();
			if (selected == -1) {
				radio[0].forceFocus();
			} else {
				radio[selected].forceFocus();
			}
		}

		/**
		 * c[`bveLXgݒ肵܂B
		 */
		public void setToolTipText(String text) {
			group.setToolTipText(text);
		}

		/**
		 * IĂԍԂ܂B<br>
		 * IĂȂꍇ-1Ԃ܂B
		 * @return IĂԍ
		 */
		private int getSelection() {
			for (int i = 0; i < radio.length; i++) {
				if (radio[i].getSelection()) {
					return i;
				}
			}
			return -1;
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * R{{bNX
	 */
	private class ComboBox implements CollectableControl {
		/** vpeB̃L[ */
		private String property;

		/** vpeB̒l */
		private String[] propertyValues;

		/** R{EBWFbg */
		private Combo combo;

		/** x */
		private Label label;

		/**
		 * RXgN^
		 * @param property vpeB[
		 * @param label x
		 * @param values \l
		 * @param propertyValues vpeB[l
		 * @param defaultValue ftHgl
		 * @param snapToGrid ObhɑꍇtrueAl߂ŕׂꍇfalseB
		 */
		ComboBox(String property, String label, String[] values,
				String[] propertyValues, String defaultValue, boolean snapToGrid) {
			this.property = property;
			this.propertyValues = propertyValues;

			Composite myParent = determineParent(snapToGrid);
			this.label = new Label(myParent, SWT.NONE);
			this.label.setText(label);
			// R{
			combo = new Combo(myParent, SWT.READ_ONLY);
			// ݂̒l擾
			String selectedValue = prop.getProperty(property, defaultValue);
			for (int i = 0; i < values.length; i++) {
				combo.add(values[i]);
				// I
				if (selectedValue != null
						&& selectedValue.equals(propertyValues[i])) {
					combo.select(i);
				}
			}
		}

		/**
		 * IlȂ̂ŏtrueԂ܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * vpeB[lۑ܂B
		 */
		public void saveProperty() {
			int index = combo.getSelectionIndex();
			if (index == -1) {
				return;
			}
			prop.setProperty(property, this.propertyValues[index]);
		}

		/**
		 * `FbN͍s܂B
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			this.combo.forceFocus();
		}

		/**
		 * c[`bvݒ肵܂B
		 */
		public void setToolTipText(String text) {
			label.setToolTipText(text);
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * eLXg
	 */
	private class TextBox implements CollectableControl {
		/** vpeB[ */
		String property;

		/** eLXgEBWFbg */
		Text text;

		/** x(c[`bvݒp) */
		Label label;

		/** `FbJ[ */
		ControlChecker checker;

		/**
		 * RXgN^
		 * @param property vpeB
		 * @param label x
		 * @param defaultText ftHgl
		 * @param compact ɕׂꍇtrueAcɕׂꍇfalseB
		 */
		TextBox(String property, String label, String defaultText,
				boolean compact) {
			this.property = property;
			// 
			this.label = new Label(parent, SWT.NONE);
			this.label.setText(label);
			if (compact) {
				//
			} else {
				this.label.setLayoutData(createLayoutData(true, false));
			}
			// eLXg
			text = new Text(parent, SWT.BORDER | SWT.SINGLE);
			text.setText(prop.getProperty(property, defaultText));
			text.setLayoutData(createLayoutData(!compact, true));
		}

		/**
		 * checkerĂяoē͒l`FbN܂B
		 */
		public boolean checkValue() {
			if (checker == null) {
				return true;
			}
			// `FbJ[̌Ăяo
			return checker.checkValue(text.getText());
		}

		/**
		 * vpeBۑ܂B
		 * checkergetFrequency()Ɋւ炸A
		 * vpeB[l`FbNKv͂܂B
		 */
		public void saveProperty() {
			prop.setProperty(property, text.getText());
		}

		/**
		 * `FbJ[ݒ肵܂B
		 * K؂ȃCxgɉcheckerĂяoA͂𐧌܂B
		 */
		public void setChecker(ControlChecker checker) {
			if (checker == null) {
				return;
			}
			this.checker = checker;
			if (checker.getFrequency() != ControlChecker.CHECK_EVERY) {
				return;
			}
			// CxgXi[o^
			this.text.addVerifyListener(new VerifyListener() {
				public void verifyText(VerifyEvent event) {
					// Back Space or Delete
					if (event.keyCode == 8 || event.keyCode == 127) {
						return;
					}
					event.doit = TextBox.this.checker
							.checkType(event.character);
					if (event.doit == false) {
						return;
					}
					// ͌̕쐬
					Text box = TextBox.this.text;
					StringBuffer cur = new StringBuffer(box.getText());
					Point selection = box.getSelection();
					cur.delete(selection.x, selection.y);
					cur.insert(selection.x, event.character);
					event.doit = TextBox.this.checker.checkValue(cur.toString());
				}
			});
		}

		/**
		 * tH[JX܂B
		 * checkValue()falseꍇȂǂɌĂяo܂B
		 */
		public void setFocus() {
			text.forceFocus();
		}

		/**
		 * c[`bvݒ肵܂B
		 */
		public void setToolTipText(String text) {
			label.setToolTipText(text);
		}

		/**
		 * RԂ܂B
		 * checkergpĂȂƂNullPointerExceptionX[܂B
		 */
		public String getReason() {
			return checker.getReason();
		}
	}

	/**
	 * Spinner
	 */
	private class SpinnerBox implements CollectableControl {
		/**
		 * Spinner
		 */
		private Spinner spinner;

		/**
		 * vpeB
		 */
		private String property;

		/**
		 * x
		 */
		private Label label;

		/**
		 * RXgN^
		 * @param property vpeB[
		 * @param label x
		 * @param defaultValue ftHgl
		 * @param snapToGrid ObhɑꍇtrueAl߂ŕׂꍇfalseB
		 * @param min ŏl
		 * @param max ől
		 * @param increment 
		 */
		public SpinnerBox(String property, String label, int defaultValue,
				boolean snapToGrid, int min, int max, int increment) {

			this.property = property;

			Composite myParent = determineParent(snapToGrid);
			this.label = new Label(myParent, SWT.NONE);
			this.label.setText(label);
			spinner = new Spinner(myParent, SWT.BORDER);
			spinner.setMinimum(min);
			spinner.setMaximum(max);
			spinner.setIncrement(increment);

			int value = PropertiesUtils.getInt(prop, property, defaultValue);
			spinner.setSelection(value);
		}

		/**
		 * ͒l͏ɐ
		 */
		public boolean checkValue() {
			return true;
		}

		public String getReason() {
			return ""; //$NON-NLS-1$
		}

		public void saveProperty() {
			String val = Integer.toString(spinner.getSelection());
			prop.setProperty(property, val);
		}

		public void setChecker(ControlChecker checker) {
			// T|[gȂ
		}

		public void setFocus() {
			spinner.setFocus();
		}

		public void setToolTipText(String text) {
			label.setToolTipText(text);
		}
	}

	/**
	 * pX[hύX{^ƃpX[hύX_CAO
	 */
	private class PasswordBox extends SelectionAdapter implements
			CollectableControl {

		/** vpeB */
		private String property;

		/** {^ */
		private Button button;

		/** _CAO */
		private SWTPasswordChangeDialog dialog;

		/**
		 * RXgN^
		 * @param property vpeB[
		 * @param buttonLabel {^̃x
		 * @param dialogTitle pX[hύX_CAÕ^Cg
		 */
		public PasswordBox(String property, String buttonLabel,
				String dialogTitle) {

			this.property = property;

			// {^
			button = new Button(parent, SWT.PUSH);
			button.setText(buttonLabel);
			button.setLayoutData(createLayoutData(true, false));

			dialog = new SWTPasswordChangeDialog(parent.getShell(), dialogTitle);
			String storedPassword = prop.getProperty(this.property, ""); //$NON-NLS-1$
			this.dialog.setPassword(storedPassword);

			button.addSelectionListener(this);
		}

		/**
		 * {^NbNꂽƂ̏
		 */
		public void widgetSelected(SelectionEvent e) {
			this.dialog.open();
		}

		/**
		 * vpeBۑ܂B
		 */
		public void saveProperty() {
			String storedPassword = dialog.getPassword();
			prop.setProperty(property, storedPassword);
		}

		/**
		 * `FbN܂
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * true
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * `FbNȂ̂null
		 */
		public String getReason() {
			return null;
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			button.forceFocus();
		}

		/**
		 * c[`bvɕ\镶ݒ肵܂B
		 */
		public void setToolTipText(String text) {
			button.setToolTipText(text);
		}
	}

	/**
	 * t@CI_CAOуfBNgI_CAO
	 */
	private class FileDirectorySelector extends SelectionAdapter implements
			CollectableControl {

		/** vpeB[l */
		private String property;

		/** eLXg{bNX */
		private Text fileText;

		/** x(c[`bvݒp) */
		private Label labelText;

		/** I{^(tH[JXp) */
		private Button button;

		/** t@C_CAÔƂtrue */
		private final boolean file;

		/** pX */
		private final String initialPath;

		/** tB^(t@C_CAÔ) */
		private final String[] filterNames;

		/** gqtB^(t@C_CAÔ) */
		private final String[] filterExtentions;

		/**
		 * RXgN^
		 * @param property vpeB
		 * @param label x
		 * @param defaultValue ftHgl
		 * @param initialPath pX
		 * @param editable eLXg{bNXҏW\ɂꍇtrueB
		 * @param file t@CI_CAÔƂtrueAfBNgI_CAÔƂfalseB
		 * @param filterNames tB^(t@C_CAÔ)
		 * @param filterExtentions gqtB^(t@C_CAÔ)
		 * @param message bZ[W(fBNg_CAÔ)
		 */
		FileDirectorySelector(String property, String label,
				String defaultValue, String initialPath, boolean editable,
				boolean file, String[] filterNames, String[] filterExtentions) {

			this.property = property;
			this.initialPath = initialPath;
			this.file = file;
			this.filterNames = filterNames;
			this.filterExtentions = filterExtentions;

			// x
			labelText = new Label(parent, SWT.NONE);
			labelText.setText(label);
			labelText.setLayoutData(createLayoutData(true, false));

			// eLXg{bNXƃ{^
			Composite composite = new Composite(parent, SWT.NONE);
			GridData compositeData = createLayoutData(true, true);
			// eꍇɐeEBWFbg̕LȂ悤Ɏw
			compositeData.widthHint = 100;
			composite.setLayoutData(compositeData);

			GridLayout layout = new GridLayout();
			layout.marginHeight = 0;
			layout.numColumns = 2;
			composite.setLayout(layout);

			// eLXg{bNX
			fileText = new Text(composite, SWT.SINGLE | SWT.BORDER);
			fileText.setText(prop.getProperty(property, defaultValue));
			fileText.setLayoutData(createLayoutData(false, true));
			fileText.setEditable(editable);

			// {^
			button = new Button(composite, SWT.PUSH);
			button.setText(mm.get("SWTControlCreator.select")); //$NON-NLS-1$
			button.addSelectionListener(this);
		}

		/**
		 * trueԂ܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * vpeB[ۑ܂B
		 */
		public void saveProperty() {
			prop.setProperty(property, fileText.getText());
		}

		/**
		 * `FbN܂B
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			button.forceFocus();
		}

		/**
		 * c[`bvݒ肵܂B
		 */
		public void setToolTipText(String text) {
			labelText.setToolTipText(text);
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}

		public void widgetSelected(SelectionEvent e) {

			String result;
			if (file) {
				FileDialog dialog = new FileDialog(parent.getShell(), SWT.OPEN
						| SWT.SHEET);
				if (this.initialPath != null) {
					dialog.setFilterPath(this.initialPath);
				}
				if (this.filterNames != null) {
					dialog.setFilterNames(this.filterNames);
				}
				if (this.filterExtentions != null) {
					dialog.setFilterExtensions(this.filterExtentions);
				}
				result = dialog.open();

			} else {
				DirectoryDialog dialog = new DirectoryDialog(parent.getShell());

				String text = fileText.getText();
				if (text != null && text.length() > 0) {
					dialog.setFilterPath(text);
				} else if (initialPath != null) {
					dialog.setFilterPath(initialPath);
				}

				dialog.setMessage(labelText.getText());
				result = dialog.open();
			}
			if (result != null) {
				fileText.setText(result);
			}
		}
	}

	/**
	 * ͕⏕{^teLXg{bNX
	 */
	private class AssistedTextBox extends SelectionAdapter implements
			CollectableControl {

		/** vpeB[l */
		private String property;

		/** eLXg{bNX */
		private Text text;

		/**
		 * ͕⏕p̃{^
		 */
		private Button button;

		/**
		 * x
		 */
		private Label label;

		/**
		 * ̓`FbNp
		 */
		private ControlChecker checker;

		/**
		 * RXgN^
		 * 
		 * @param property vpeB
		 * @param labelText x̃eLXg
		 * @param defaultValue ftHgl
		 * @param menuData |bvAbvj[̃x̃eLXgƑ}eLXg̔z
		 */
		public AssistedTextBox(String property, String labelText,
				String defaultValue, String[][] menuData) {

			this.property = property;

			// x
			label = new Label(parent, SWT.NONE);
			label.setText(labelText);
			label.setLayoutData(createLayoutData(true, false));

			// eLXg{bNXƃ{^
			Composite composite = new Composite(parent, SWT.NONE);
			GridData compositeData = createLayoutData(true, true);
			// eꍇɐeEBWFbg̕LȂ悤Ɏw
			compositeData.widthHint = 100;
			composite.setLayoutData(compositeData);

			GridLayout layout = new GridLayout();
			layout.marginHeight = 0;
			layout.numColumns = 2;
			composite.setLayout(layout);

			// eLXg{bNX
			text = new Text(composite, SWT.SINGLE | SWT.BORDER);
			text.setText(prop.getProperty(property, defaultValue));
			text.setLayoutData(createLayoutData(false, true));

			// {^
			button = new Button(composite, SWT.PUSH);
			button.setText(">"); //$NON-NLS-1$
			if (menuData != null) {
				final Menu menu = new Menu(button);
				button.setMenu(menu);
				button.addSelectionListener(this);

				for (int i = 0; i < menuData.length; i++) {
					MenuItem item = new MenuItem(menu, SWT.PUSH);
					item.setText(menuData[i][0]);
					item.addSelectionListener(this);
					item.setData("Text", menuData[i][1]); //$NON-NLS-1$
				}
			}

		}

		public void widgetSelected(SelectionEvent event) {
			if (event.widget == button) {
				// j[̕\
				SWTUtils.showButtonPopupMenu(event);

			} else {
				// j[ڂ̏
				String str = (String) event.widget.getData("Text"); //$NON-NLS-1$
				text.insert(str);
			}
		}

		public void saveProperty() {
			prop.setProperty(property, text.getText());
		}

		public void setChecker(ControlChecker checker) {
			this.checker = checker;
		}

		//TODO TextBoxRs[R[h
		public boolean checkValue() {
			if (checker == null) {
				return true;
			}
			// `FbJ[̌Ăяo
			return checker.checkValue(text.getText());
		}

		public String getReason() {
			return checker.getReason();
		}

		public void setFocus() {
			text.forceFocus();
		}

		public void setToolTipText(String text) {
			label.setToolTipText(text);
		}
	}

	/**
	 * x<br>
	 * Ȃǂɗp郉x𐶐܂B
	 * vpeB[Ȃǂ͂܂B
	 */
	private class LabelText implements CollectableControl {

		/**
		 * RXgN^
		 * @param text x̕
		 */
		LabelText(String text) {
			Label label = new Label(parent, SWT.NONE | SWT.WRAP);
			label.setText(text);
			GridData data = createLayoutData(true, true);
			if (widthHint != SWT.DEFAULT) {
				data.widthHint = widthHint;
			}

			label.setLayoutData(data);
		}

		/**
		 * true
		 */
		public boolean checkValue() {
			return true;
		}

		public void saveProperty() {
			//
		}

		public void setChecker(ControlChecker checker) {
			//
		}

		public void setFocus() {
			//
		}

		public void setToolTipText(String text) {
			//
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * Zp[^()
	 */
	private class Separator implements CollectableControl {
		/**
		 * RXgN^
		 */
		Separator() {
			Label label = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL);
			label.setLayoutData(createLayoutData(true, true));
		}

		/**
		 * true
		 */
		public boolean checkValue() {
			return true;
		}

		public void saveProperty() {
			//
		}

		public void setChecker(ControlChecker checker) {
			//
		}

		public void setFocus() {
			//
		}

		public void setToolTipText(String text) {
			//
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * u[hLXg(C^[tF[Xɂ͒`Ȃ)<br>
	 * AvP[VݒpƋNݒp(WI{^t)2ނ𐶐
	 */
	private class BroadcastGroup implements CollectableControl {
		/** WI{^̃vpeB[ */
		private String radioProperty;

		/** AhXXg̃vpeB[ */
		private String listProperty;

		/** ͗ */
		private Text textBroadcast;

		/** Xg */
		private List list;

		/** WI{^ */
		private Button[] buttons;

		/** Limited broadcast̃`FbN{bNX */
		private Button limitedBrCheckBox;

		/** Directed broadcast̃`FbN{bNX */
		private Button directedBrCheckBox;

		/** E{^ */
		private Button toList;

		/** {^ */
		private Button toText;

		/**
		 * |[gԍ̓͂
		 */
		private boolean allowPort;

		/**
		 * Limited broadcast̃vpeB
		 */
		private final String limitedBrProperty;

		/**
		 * Directed broadcast̃vpeB
		 */
		private final String directedBrProperty;

		/**
		 * RXgN^(AvP[Vݒp)
		 * @param listProperty Xg{bNX̃vpeB
		 * @param limitedBrProperty Limited broadcast̃vpeB
		 * @param directedBrProperty Directed broadcast̃vpeB
		 */
		BroadcastGroup(String listProperty, String limitedBrProperty,
				String directedBrProperty) {
			this.listProperty = listProperty;
			this.limitedBrProperty = limitedBrProperty;
			this.directedBrProperty = directedBrProperty;
			initWidgets();
		}

		/**
		 * RXgN^(Nݒp)
		 * @param radioProperty WI{^̃vpeB
		 * @param listProperty Xg{bNX̃vpeB
		 * @param allowPort |[gԍ̓͂ꍇtrue
		 * @param limitedBrProperty Limited broadcast̃vpeB
		 * @param directedBrProperty Directed broadcast̃vpeB
		 */
		BroadcastGroup(String radioProperty, String listProperty,
				boolean allowPort, String limitedBrProperty,
				String directedBrProperty) {
			this.listProperty = listProperty;
			this.radioProperty = radioProperty;
			this.allowPort = allowPort;
			this.limitedBrProperty = limitedBrProperty;
			this.directedBrProperty = directedBrProperty;
			initWidgets();
		}

		/**
		 * EBWFbg̐
		 */
		private void initWidgets() {
			// O[v
			Group addrGroup = new Group(parent, SWT.SHADOW_ETCHED_IN);
			addrGroup.setText(mm.get("SWTControlCreator.ba.broadcastAddress")); //$NON-NLS-1$
			GridData addrGroupData = new GridData(
					GridData.HORIZONTAL_ALIGN_FILL | GridData.GRAB_HORIZONTAL);
			addrGroupData.horizontalSpan = 2;
			addrGroup.setLayoutData(addrGroupData);

			GridLayout addrLayout = new GridLayout();
			addrLayout.numColumns = 3;
			addrGroup.setLayout(addrLayout);

			// Nݒp
			if (radioProperty != null) {
				// WI{^
				buttons = new Button[2];
				buttons[0] = new Button(addrGroup, SWT.RADIO);
				buttons[0].setText(mm
						.get("SWTControlCreator.ba.useApplicationSetting")); //$NON-NLS-1$

				buttons[1] = new Button(addrGroup, SWT.RADIO);
				buttons[1].setText(mm.get("SWTControlCreator.ba.specifyBelow")); //$NON-NLS-1$

				// CAEgf[^
				for (int i = 0; i < buttons.length; i++) {
					horizontalSpan3(buttons[i]);
				}
				// WI{^̏Ԃ̐ݒ͑̃Rg[𐶐ōs
			}

			// `FbN{bNX
			limitedBrCheckBox = new Button(addrGroup, SWT.CHECK);
			limitedBrCheckBox.setText(mm
					.get("SWTControlCreator.ba.limitedBroadcast")); //$NON-NLS-1$
			limitedBrCheckBox.setSelection(PropertiesUtils.getBoolean(prop,
					limitedBrProperty, true));
			horizontalSpan3(limitedBrCheckBox);

			directedBrCheckBox = new Button(addrGroup, SWT.CHECK);
			directedBrCheckBox.setText(mm
					.get("SWTControlCreator.ba.directedBroadcast")); //$NON-NLS-1$
			directedBrCheckBox.setSelection(PropertiesUtils.getBoolean(prop,
					directedBrProperty, false));
			horizontalSpan3(directedBrCheckBox);

			// eLXg{bNX
			this.textBroadcast = new Text(addrGroup, SWT.SINGLE | SWT.BORDER);
			GridData textData = new GridData(GridData.FILL_HORIZONTAL
					| GridData.GRAB_HORIZONTAL
					| GridData.HORIZONTAL_ALIGN_BEGINNING);
			textBroadcast.setLayoutData(textData);
			// E(Xgɒǉ)
			toList = new Button(addrGroup, SWT.PUSH);
			toList.setText(">"); //$NON-NLS-1$
			toList.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent arg0) {
					String input = textBroadcast.getText();
					if (input.length() == 0) {
						return;
					}
					if (allowPort) {
						if (InetAddressUtils.toInetSocketAddress(input, 0) == null) {
							showError();
							return;
						}
					} else {
						try {
							InetAddress.getByName(input);
						} catch (UnknownHostException e) {
							showError();
							return;
						}
					}

					list.add(input);
					textBroadcast.setText(""); //$NON-NLS-1$
					textBroadcast.setFocus();
				}

				/**
				 * G[bZ[W\܂B
				 */
				private void showError() {
					String msg = mm
							.get("SWTControlCreator.ba.couldNotConvertToIPAddress"); //$NON-NLS-1$
					SWTUtils.showError(parent.getShell(), msg);
					textBroadcast.setFocus();
				}
			});

			// Xg
			this.list = new List(addrGroup, SWT.SINGLE | SWT.V_SCROLL
					| SWT.BORDER);
			GridData listData = new GridData();
			listData.verticalSpan = 3;
			//listData.widthHint = 100;
			listData.heightHint = list.getItemHeight() * 6;
			listData.grabExcessHorizontalSpace = true;
			listData.horizontalAlignment = SWT.FILL;
			listData.verticalAlignment = SWT.FILL;
			this.list.setLayoutData(listData);
			// Xg̒g
			String broadcast = prop.getProperty(listProperty, ""); //$NON-NLS-1$
			String[] addrs = Tool.split(broadcast, ',', 0);
			for (int i = 0; i < addrs.length; i++) {
				if (addrs[i].length() == 0
						|| addrs[i].equals("255.255.255.255")) { //$NON-NLS-1$
					continue;
				}
				list.add(addrs[i]);
			}

			// F192.168.1.255
			Label example = new Label(addrGroup, SWT.NONE);
			example.setText(mm.get("SWTControlCreator.ba.example")); //$NON-NLS-1$

			// (Xg폜AҏW\)
			toText = new Button(addrGroup, SWT.PUSH);
			toText.setText("<"); //$NON-NLS-1$
			toText.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent arg0) {
					int index = list.getSelectionIndex();
					if (index < 0) {
						return;
					}
					String item = list.getItem(index);
					list.remove(index);
					textBroadcast.setText(item);
					textBroadcast.setFocus();
				}
			});

			// 
			Label explanation = new Label(addrGroup, SWT.WRAP);
			explanation.setText(mm.get("SWTControlCreator.ba.explanation")); //$NON-NLS-1$
			GridData explanationData = new GridData();
			explanationData.widthHint = 90;
			explanation.setLayoutData(explanationData);

			// WI{^ƂXi[o^
			if (radioProperty != null) {
				// WI{^̏
				if (!PropertiesUtils.getBoolean(prop,
						LaunchConfiguration.USE_DEFAULT_BROADCAST, true)) {
					buttons[1].setSelection(true);
				} else {
					// Av̐ݒg
					buttons[0].setSelection(true);
					setEnable(false);
				}
				// Xi[o^
				ButtonSelected listener = new ButtonSelected();
				buttons[0].addListener(SWT.Selection, listener);
				buttons[1].addListener(SWT.Selection, listener);
				//System.out.println("WI{^: " + buttons[1].getSelection());
			}
		}

		/**
		 * horizontalSpan = 3 GridData𐶐܂B
		 * @param ctrl Rg[
		 */
		private void horizontalSpan3(Control ctrl) {
			GridData data = new GridData();
			data.horizontalSpan = 3;
			ctrl.setLayoutData(data);
		}

		/**
		 * WI{^̃Xi[
		 */
		private class ButtonSelected implements Listener {
			public void handleEvent(Event event) {
				//System.out.println("WI{^: " + buttons[1].getSelection());
				setEnable(buttons[1].getSelection());
			}
		}

		/**
		 * enablȅԂς܂B
		 * @param enable Lɂꍇtrue
		 */
		private void setEnable(boolean enable) {
			textBroadcast.setEnabled(enable);
			list.setEnabled(enable);
			toList.setEnabled(enable);
			toText.setEnabled(enable);
			limitedBrCheckBox.setEnabled(enable);
			directedBrCheckBox.setEnabled(enable);
		}

		/**
		 * Ƀ`FbN̂trueԂ܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * vpeBۑ܂B
		 */
		public void saveProperty() {
			// WI{^
			if (radioProperty != null) {
				if (buttons[0].getSelection()) {
					prop.setProperty(radioProperty, "1"); //$NON-NLS-1$
				} else {
					prop.setProperty(radioProperty, "0"); //$NON-NLS-1$
				}
			}
			// limited, directed broadcast
			PropertiesUtils.setBoolean(prop, limitedBrProperty,
					limitedBrCheckBox.getSelection());
			PropertiesUtils.setBoolean(prop, directedBrProperty,
					directedBrCheckBox.getSelection());

			// Xg
			StringBuffer sb = new StringBuffer();
			for (int i = 0; i < list.getItemCount(); i++) {
				sb.append(list.getItem(i));
				if (i + 1 < list.getItemCount()) {
					sb.append(","); //$NON-NLS-1$
				}
			}
			prop.setProperty(listProperty, sb.toString());
		}

		/**
		 * ׂēŃ`FbN܂B
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			// WI{^
			if (radioProperty != null && buttons[0].getSelection()) {
				buttons[0].forceFocus();
				return;
			}
			// eLXg{bNX
			textBroadcast.forceFocus();
		}

		/**
		 * c[`bv͎gp܂B
		 */
		public void setToolTipText(String text) {
			//
		}

		/** `FbNȂ̂null */
		public String getReason() {
			return null;
		}
	}

	/**
	 * bZ[WEBhẺƍݒ肷EBWFbg
	 */
	private class Square implements CollectableControl {
		/** ̃vpeB[ */
		private String widthProperty;

		/** ̃vpeB[ */
		private String heightProperty;

		/** ̃eLXg{bNX */
		private Spinner widthSpinner;

		/** ̃eLXg{bNX */
		private Spinner heightSpinner;

		/**
		 * RXgN^
		 * @param widthProperty ̃vpeB
		 * @param widthDefault ̃ftHgl
		 * @param heightProperty ̃vpeB
		 * @param heightDefault ̃ftHgl
		 * @param label x
		 */
		Square(String widthProperty, int widthDefault, String heightProperty,
				int heightDefault, String label) {
			this.widthProperty = widthProperty;
			this.heightProperty = heightProperty;
			// 
			Group group = new Group(parent, SWT.SHADOW_ETCHED_IN);
			group.setLayoutData(createLayoutData(true, false));
			group.setText(label);
			GridLayout layout = new GridLayout();
			layout.numColumns = 4;
			group.setLayout(layout);

			/*
			 * }`fBXvCɊւẮA
			 * bZ[WEBhEJƂ
			 * ΏۃfBXvCɉTCY̐sB
			 */
			Rectangle rect = Display.getDefault().getClientArea();

			// 
			widthSpinner = createSpinner(group,
					mm.get("SWTControlCreator.square.width")); //$NON-NLS-1$
			widthSpinner.setMinimum(0);
			widthSpinner.setMaximum(rect.width);
			widthSpinner.setIncrement(50);
			widthSpinner.setSelection(widthDefault);

			// 
			heightSpinner = createSpinner(group,
					mm.get("SWTControlCreator.square.height")); //$NON-NLS-1$
			heightSpinner.setMinimum(0);
			heightSpinner.setMaximum(rect.height);
			heightSpinner.setIncrement(50);
			heightSpinner.setSelection(heightDefault);
		}

		/**
		 * Spinner𐶐܂B
		 * @param parent eEBWFbg
		 * @param label x
		 * @return Spinner
		 */
		private Spinner createSpinner(Composite parent, String label) {
			Label aLabel = new Label(parent, SWT.NONE);
			aLabel.setText(label);

			Spinner spin = new Spinner(parent, SWT.BORDER);

			GridData data = new GridData(GridData.FILL_HORIZONTAL);
			data.widthHint = 50;

			spin.setLayoutData(data);
			return spin;
		}

		/**
		 * l͈̔͂`FbN܂B
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * RԂ܂B
		 */
		public String getReason() {
			return ""; //$NON-NLS-1$
		}

		/**
		 * vpeB[ۑ܂B
		 */
		public void saveProperty() {
			prop.setProperty(widthProperty,
					Integer.toString(widthSpinner.getSelection()));
			prop.setProperty(heightProperty,
					Integer.toString(heightSpinner.getSelection()));
		}

		/**
		 * `FbN͓ōs܂B
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			widthSpinner.forceFocus();
		}

		/**
		 * c[`bv͎gp܂B
		 */
		public void setToolTipText(String text) {
			//
		}
	}

	/**
	 * tHgI_CAO
	 */
	private class FontSelector extends SelectionAdapter implements
			CollectableControl {

		/**
		 * tHg̃vpeB
		 */
		private String fontNameProperty;

		/**
		 * tHgTCỸvpeB
		 */
		private String fontSizeProperty;

		/**
		 * tHgX^C̃vpeB
		 */
		private String fontStyleProperty;

		/**
		 * tHg̃P[
		 */
		private String fontLocaleProerty;

		/**
		 * ItHgf[^
		 */
		private FontData fontData;

		/**
		 * tHg\郉x
		 */
		private Label fontInfo;

		/**
		 * RXgN^
		 * @param propertyPrefix vpeB̃vtBbNX
		 * @param label x
		 */
		public FontSelector(String propertyPrefix, String label) {
			fontNameProperty = propertyPrefix + ".name"; //$NON-NLS-1$
			fontSizeProperty = propertyPrefix + ".size"; //$NON-NLS-1$
			fontStyleProperty = propertyPrefix + ".style"; //$NON-NLS-1$
			fontLocaleProerty = propertyPrefix + ".locale"; //$NON-NLS-1$

			restoreFontData();
			createWidgets(label);
		}

		/**
		 * EBWFbg̐
		 * @param labelText x
		 */
		private void createWidgets(String labelText) {
			Label label = new Label(parent, SWT.NONE);
			label.setText(labelText);

			Composite composite = new Composite(parent, SWT.NONE);
			GridData gridData = new GridData();
			gridData.grabExcessHorizontalSpace = true;
			gridData.horizontalAlignment = GridData.HORIZONTAL_ALIGN_FILL;
			composite.setLayoutData(gridData);

			GridLayout layout = new GridLayout(2, false);
			//layout.horizontalSpacing = 0;
			layout.verticalSpacing = 0;
			layout.marginTop = 0;
			layout.marginBottom = 0;
			layout.marginLeft = 0;
			layout.marginRight = 0;
			layout.marginHeight = 0;
			layout.marginWidth = 0;
			composite.setLayout(layout);

			Button b = new Button(composite, SWT.PUSH);
			b.setText(mm.get("SWTControlCreator.font.select")); //$NON-NLS-1$

			b.addSelectionListener(this);

			fontInfo = new Label(composite, SWT.NONE);
			updateFontInfo();
		}

		public void widgetSelected(SelectionEvent e) {
			FontDialog dialog = new FontDialog(parent.getShell());
			if (fontData != null) {
				dialog.setFontList(new FontData[] { fontData });
			}
			FontData data = dialog.open();
			if (data == null) {
				return;
			}
			fontData = data;
			// \̍XV
			updateFontInfo();
		}

		/**
		 * ItHg̏XV܂B
		 */
		private void updateFontInfo() {
			if (fontData == null) {
				fontInfo.setText(mm.get("SWTControlCreator.font.default")); //$NON-NLS-1$
				return;
			}

			String info = fontData.getName() + ", " + fontData.getHeight() //$NON-NLS-1$
					+ "pt"; //$NON-NLS-1$
			fontInfo.setText(info);
			fontInfo.getParent().pack();
		}

		/**
		 * tHgf[^̕
		 */
		private void restoreFontData() {
			String name = prop.getProperty(fontNameProperty);
			int size = PropertiesUtils.getInt(prop, fontSizeProperty, 9);
			int style = PropertiesUtils.getInt(prop, fontStyleProperty, 0);
			String locale = prop.getProperty(fontLocaleProerty);
			if (name != null && name.length() > 0) {
				fontData = new FontData(name, size, style);
				fontData.setLocale(locale);
			}
		}

		/**
		 * ɐ
		 */
		public boolean checkValue() {
			return true;
		}

		/**
		 * ɐ̂ŉԂȂ
		 */
		public String getReason() {
			return ""; //$NON-NLS-1$
		}

		/**
		 * vpeBɕۑ܂B
		 */
		public void saveProperty() {
			if (fontData == null) {
				prop.remove(fontNameProperty);
				prop.remove(fontSizeProperty);
				prop.remove(fontStyleProperty);
				prop.remove(fontLocaleProerty);
			} else {
				prop.setProperty(fontNameProperty, fontData.getName());
				prop.setProperty(fontSizeProperty,
						Integer.toString(fontData.getHeight()));
				prop.setProperty(fontStyleProperty,
						Integer.toString(fontData.getStyle()));
				prop.setProperty(fontLocaleProerty, fontData.getLocale());
			}
		}

		/**
		 * `FbNȂ
		 */
		public void setChecker(ControlChecker checker) {
			//
		}

		/**
		 * tH[JX܂B
		 */
		public void setFocus() {
			//
		}

		/**
		 * c[`bveLXgݒ肵܂B
		 */
		public void setToolTipText(String text) {
			//
		}

	}

	/**
	 * V[gJbgL[ݒ肷邽߂̃EBWFbg
	 */
	private class KeyCombinationSelector implements CollectableControl {

		/**
		 * vpeB
		 */
		private final String property;

		/**
		 * CL[
		 */
		private Combo combo;

		/**
		 * L[
		 */
		private Text text;

		/**
		 * G[̗R
		 */
		private String reason;

		/**
		 * tH[JXΏۂ̃Rg[
		 */
		private Control control;

		/**
		 * RXgN^
		 * 
		 * @param property vpeB
		 * @param defaultValue ftHgl
		 * @param labelText ږ
		 */
		public KeyCombinationSelector(String property, String defaultValue,
				String labelText) {
			this.property = property;

			String value = prop.getProperty(property, defaultValue);
			int index = value.lastIndexOf('+');

			String modifier = ""; //$NON-NLS-1$
			String key = ""; //$NON-NLS-1$
			if (index != -1) {
				modifier = value.substring(0, index);
				modifier = modifier.replaceAll("\\+", " + "); //$NON-NLS-1$ //$NON-NLS-2$
				key = value.substring(index + 1);
			}

			Composite composite = new Composite(parent, SWT.NONE);
			composite.setLayoutData(createLayoutData(true, true));

			GridLayout layout = new GridLayout();
			layout.numColumns = 4;

			composite.setLayout(layout);

			Label label = new Label(composite, SWT.NONE);
			label.setText(labelText);
			label.setLayoutData(createLayoutData(false, true));

			combo = new Combo(composite, SWT.READ_ONLY);
			combo.add(""); //$NON-NLS-1$
			combo.add("Ctrl"); //$NON-NLS-1$
			combo.add("Shift"); //$NON-NLS-1$
			combo.add("Alt"); //$NON-NLS-1$
			combo.add("Win"); //$NON-NLS-1$
			combo.add("Ctrl + Shift"); //$NON-NLS-1$
			combo.add("Ctrl + Alt"); //$NON-NLS-1$
			combo.add("Ctrl + Win"); //$NON-NLS-1$
			combo.add("Shift + Alt"); //$NON-NLS-1$
			combo.add("Shift + Win"); //$NON-NLS-1$
			combo.add("Alt + Win"); //$NON-NLS-1$
			combo.add("Ctrl + Shift + Alt"); //$NON-NLS-1$
			combo.add("Ctrl + Shift + Win"); //$NON-NLS-1$
			combo.add("Ctrl + Alt + Win"); //$NON-NLS-1$
			combo.add("Shift + Alt + Win"); //$NON-NLS-1$
			combo.add("Ctrl + Shift + Alt + Win"); //$NON-NLS-1$

			int size = combo.getItemCount();
			for (int i = 0; i < size; i++) {
				String v = combo.getItem(i);
				if (v.equals(modifier)) {
					combo.select(i);
					break;
				}
			}

			Label plus = new Label(composite, SWT.NONE);
			plus.setText(" + "); //$NON-NLS-1$

			text = new Text(composite, SWT.BORDER);
			text.setText(key);
			text.setTextLimit(4);

			GridData data = new GridData(50, SWT.DEFAULT);
			text.setLayoutData(data);

			control = combo;
		}

		/**
		 * ͂`FbN܂B
		 */
		public boolean checkValue() {
			String modifier = combo.getText();
			String key = text.getText();

			if (modifier.length() != 0 && key.length() == 0) {
				// L[̐ݒ肪Kv
				reason = mm.get("SWTControlCreator.hotkey.needKey"); //$NON-NLS-1$
				control = text;
				return false;
			}

			if (modifier.length() == 0 && key.length() != 0) {
				// CL[̐ݒ肪Kv
				reason = mm.get("SWTControlCreator.hotkey.needModifierKey"); //$NON-NLS-1$
				control = combo;
				return false;
			}

			if (key.startsWith("0x") && key.length() == 4) { //$NON-NLS-1$
				try {
					Integer.parseInt(key.substring(2), 16);
				} catch (NumberFormatException e) {
					reason = mm.get("SWTControlCreator.hotkey.invalidValue.1"); //$NON-NLS-1$
					control = text;
					return false;
				}
			} else if (key.length() > 1) {
				reason = mm.get("SWTControlCreator.hotkey.invalidValue.2"); //$NON-NLS-1$
				control = text;
				return false;
			} else if (key.length() == 1) {
				char c = key.charAt(0);
				if (!('0' <= c && c <= '9') && !('A' <= c && c <= 'Z')) {
					reason = mm.get("SWTControlCreator.hotkey.invalidValue.3"); //$NON-NLS-1$
					control = text;
					return false;
				}
			}

			return true;
		}

		public String getReason() {
			return reason;
		}

		public void saveProperty() {
			String modifier = combo.getText();
			modifier = modifier.replaceAll(" ", ""); //$NON-NLS-1$ //$NON-NLS-2$

			String key = text.getText();

			if (key == null || key.length() == 0) {
				prop.remove(property);
			} else {
				prop.setProperty(property, modifier + "+" + key); //$NON-NLS-1$
			}
		}

		public void setChecker(ControlChecker checker) {
			//
		}

		public void setFocus() {
			this.control.forceFocus();
		}

		public void setToolTipText(String text) {
			//
		}

	}

	/**
	 * Oc[̏ݒ肷_CAO\܂B
	 */
	private class ToolConfigurator extends SelectionAdapter implements
			CollectableControl {

		/** vpeB̃vtBbNX */
		private final String propertyPrefix;

		/** ږу_CAÕ^Cg */
		private String labelText;

		/** ̃f[^ێɎgp */
		private Properties toolConfigProp;

		/** ҏW{^ */
		private Button button;

		/** |bvAbvj[̃f[^ */
		private final String[][] menuData;

		/**
		 * RXgN^
		 * @param proprtyPrefix vpeB̃vtBbNX
		 * @param execPathDefault st@C̃pX̃ftHgl
		 * @param paramDefault R}hC̃ftHgl
		 * @param workingDirDefault ƃtH_̃ftHgl
		 * @param labelText x
		 * @param menuData |bvAbvj[̃f[^
		 */
		public ToolConfigurator(String proprtyPrefix, String execPathDefault,
				String paramDefault, String workingDirDefault,
				String labelText, String[][] menuData) {

			this.propertyPrefix = proprtyPrefix;
			this.labelText = labelText;
			this.menuData = menuData;

			Properties d = new Properties();
			copy(d, AppPreferences.getToolCommandProperty(proprtyPrefix),
					execPathDefault);
			copy(d, AppPreferences.getToolParameterProperty(proprtyPrefix),
					paramDefault);
			copy(d, AppPreferences.getToolWorkingFolderProperty(proprtyPrefix),
					workingDirDefault);
			toolConfigProp = new Properties(d);

			createWidgets();
		}

		/**
		 * vpeBlRs[܂B
		 * 
		 * @param p Rs[vpeB
		 * @param key Rs[vpeB̃L[
		 * @param defaultValue ftHgl
		 */
		private void copy(Properties p, String key, String defaultValue) {
			p.setProperty(key, prop.getProperty(key, defaultValue));
		}

		/**
		 * EBWFbg𐶐܂B
		 */
		private void createWidgets() {

			Label label = new Label(parent, SWT.NONE);
			label.setText(labelText);

			Composite composite = new Composite(parent, SWT.NONE);
			GridData gridData = new GridData();
			gridData.grabExcessHorizontalSpace = true;
			gridData.horizontalAlignment = GridData.HORIZONTAL_ALIGN_FILL;
			composite.setLayoutData(gridData);

			GridLayout layout = new GridLayout(2, false);
			//layout.horizontalSpacing = 0;
			layout.verticalSpacing = 0;
			layout.marginTop = 0;
			layout.marginBottom = 0;
			layout.marginLeft = 0;
			layout.marginRight = 0;
			layout.marginHeight = 0;
			layout.marginWidth = 0;
			composite.setLayout(layout);

			button = new Button(composite, SWT.PUSH);
			button.setText(mm.get("SWTControlCreator.edit")); //$NON-NLS-1$

			button.addSelectionListener(this);
		}

		public void widgetSelected(SelectionEvent event) {
			SWTToolConfigurationDialog dialog = new SWTToolConfigurationDialog(
					parent.getShell(), labelText, toolConfigProp,
					propertyPrefix, menuData);
			dialog.open();
		}

		public void saveProperty() {
			saveValue(AppPreferences.getToolCommandProperty(propertyPrefix));
			saveValue(AppPreferences.getToolParameterProperty(propertyPrefix));
			saveValue(AppPreferences
					.getToolWorkingFolderProperty(propertyPrefix));
		}

		/**
		 * @param key
		 */
		private void saveValue(String key) {
			String v = toolConfigProp.getProperty(key);
			prop.setProperty(key, v);

		}

		public void setChecker(ControlChecker checker) {
			// mFȂ
		}

		public boolean checkValue() {
			// mFȂ
			return true;
		}

		public String getReason() {
			return null;
		}

		public void setFocus() {
			button.forceFocus();
		}

		public void setToolTipText(String text) {
			button.setToolTipText(text);
		}

	}

	/**
	 * `FbN{bNX
	 */
	public void createCheckBox(String property, String label,
			boolean defaultValue) {
		//
		CheckBox cb = new CheckBox(property, label, defaultValue);
		controls.add(cb);
	}

	/**
	 * R{{bNX
	 */
	public void createComboBox(String property, String label, String[] values,
			String[] propertyValues, String defaultValue, boolean compact) {
		//
		ComboBox cb = new ComboBox(property, label, values, propertyValues,
				defaultValue, compact);
		controls.add(cb);
	}

	/**
	 * fBNgI
	 */
	public void createDirectorySelector(String property, String label,
			String defaultValue, String initialPath, boolean editable,
			boolean useTextBoxPath) {
		//
		FileDirectorySelector ds = new FileDirectorySelector(property, label,
				defaultValue, initialPath, editable, false, null, null);
		controls.add(ds);
	}

	/**
	 * t@CI
	 */
	public void createFileSelector(String property, String label,
			String defaultValue, String initialPath, String[] filterNames,
			String[] filterExtentions, boolean editable) {
		//
		FileDirectorySelector fs = new FileDirectorySelector(property, label,
				defaultValue, initialPath, editable, true, filterNames,
				filterExtentions);
		controls.add(fs);
	}

	public void createAssistedTextBox(String property, String label,
			String defaultValue, String[][] menuData) {

		AssistedTextBox textBox = new AssistedTextBox(property, label,
				defaultValue, menuData);
		controls.add(textBox);
	}

	/**
	 * x
	 */
	public void createLabel(String text) {
		new LabelText(text);
	}

	/**
	 * WI{^
	 */
	public void createRadioButton(String property, String label,
			String[] values, String[] propertyValues, String defaultValue) {
		//
		Radio radio = new Radio(property, label, values, propertyValues,
				defaultValue);
		controls.add(radio);
	}

	/**
	 * Zp[^
	 */
	public void createSeparator() {
		new Separator();
	}

	/**
	 * eLXg{bNX
	 */
	public void createText(String property, String label, String defaultText,
			boolean compact, ControlChecker checker) {
		//
		TextBox tb = new TextBox(property, label, defaultText, compact);
		tb.setChecker(checker);
		controls.add(tb);
	}

	/**
	 * pX[h{bNX
	 */
	public void createPasswordBox(String property, String buttonLabel,
			String dialogTitle) {
		PasswordBox pb = new PasswordBox(property, buttonLabel, dialogTitle);
		controls.add(pb);
	}

	/**
	 * Spinner
	 * @param property
	 * @param label
	 * @param defaultValue
	 * @param compact
	 * @param min
	 * @param max
	 * @param increment 
	 */
	public void createSpinner(String property, String label, int defaultValue,
			boolean compact, int min, int max, int increment) {
		SpinnerBox spinner = new SpinnerBox(property, label, defaultValue,
				compact, min, max, increment);
		controls.add(spinner);
	}

	/**
	 * u[hLXgO[v(AvP[Vݒp)
	 * @param listProperty Xg{bNX̃vpeB
	 * @param limitedBrProperty limited broadcast̃vpeB
	 * @param directedBrProperty directed broadcast̃vpeB
	 */
	public void createBroadcastGroup(String listProperty,
			String limitedBrProperty, String directedBrProperty) {
		BroadcastGroup bg = new BroadcastGroup(listProperty, limitedBrProperty,
				directedBrProperty);
		controls.add(bg);
	}

	/**
	 * u[hLXgO[v(Nݒp)
	 * @param radioProperty WI{^̃vpeB
	 * @param listProperty Xg{bNX̃vpeB
	 * @param limitedBrProperty limited broadcast̃vpeB
	 * @param directedBrProperty directed broadcast̃vpeB
	 */
	public void createBroadcastGroup(String radioProperty, String listProperty,
			String limitedBrProperty, String directedBrProperty) {
		BroadcastGroup bg = new BroadcastGroup(radioProperty, listProperty,
				true, limitedBrProperty, directedBrProperty);
		controls.add(bg);
	}

	/**
	 * ƍ͂Rg[
	 * @param widthProperty ̃vpeB
	 * @param widthDefault ̏l
	 * @param heightProperty ̃vpeB
	 * @param heightDefault ̏l
	 * @param label x
	 */
	public void createSquare(String widthProperty, int widthDefault,
			String heightProperty, int heightDefault, String label) {
		Square s = new Square(widthProperty, widthDefault, heightProperty,
				heightDefault, label);
		controls.add(s);
	}

	/**
	 * tHg_CAOJ߂̃{^\܂B
	 * @param propertyPrefix vpeB̃vtBbNX
	 * @param label x
	 */
	public void createFontDialogButton(String propertyPrefix, String label) {
		FontSelector selector = new FontSelector(propertyPrefix, label);
		controls.add(selector);
	}

	/**
	 * L[Rrl[Vݒ肷邽߂̃Rg[
	 * 
	 * @param property vpeB
	 * @param defaultValue ftHgl
	 * @param label x
	 */
	public void createKeyCombinationSelector(String property,
			String defaultValue, String label) {
		KeyCombinationSelector selector = new KeyCombinationSelector(property,
				defaultValue, label);
		controls.add(selector);
	}

	/**
	 * t@C}l[WOc[ݒ肷邽߂̃Rg[
	 * 
	 * @param propertyPrefix vpeB̃vtBbNX
	 * @param execPathDefault 
	 * @param paramDefault 
	 * @param workingDirDefault 
	 * @param label 
	 * @param menuData 
	 */
	public void createToolConfigurator(String propertyPrefix,
			String execPathDefault, String paramDefault,
			String workingDirDefault, String label, String[][] menuData) {
		ToolConfigurator toolConf = new ToolConfigurator(propertyPrefix,
				execPathDefault, paramDefault, workingDirDefault, label,
				menuData);
		controls.add(toolConf);
	}
}
