package petaclone.swt;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.widgets.Shell;

import petaclone.Message;
import petaclone.MessageFoundListener;

/**
 * <p>bZ[WEBhẼXgǗ܂B</p>
 * <p>̃CX^X͊OœK؂ɓKv܂B</p>
 * 
 * @author Takayuki Shoji
 */
public class SWTMessageWindowManagerImpl implements SWTMessageWindowManager {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(SWTMessageWindowManagerImpl.class);

	/**
	 * EBhẼXg
	 * <br>l: SWTMessageWindow
	 */
	private List list = new ArrayList();

	/**
	 * bZ[WEBhEXgɒǉ܂B
	 * @param mw ǉ郁bZ[WEBhE
	 */
	public void add(SWTMessageWindow mw) {
		list.add(mw);
	}

	/**
	 * bZ[WEBhEXg폜܂B
	 * @param mw 폜郁bZ[WEBhE
	 */
	public void remove(SWTMessageWindow mw) {
		list.remove(mw);
	}

	/**
	 * ǗĂ郁bZ[WEBhE̐擾܂B
	 * @return TCY
	 */
	public int size() {
		return list.size();
	}

	/**
	 * CfbNXw肵ăbZ[WEBhE擾܂B
	 * @param index CfbNX(0ȏ)
	 * @return SWTMessageWindow
	 */
	public SWTMessageWindow get(int index) {
		return (SWTMessageWindow) list.get(index);
	}

	/**
	 * w肵bZ[WbZ[WEBhE擾܂B
	 * @param msg bZ[W
	 * @return SWTMessageWindowBvȂꍇnullB
	 */
	public SWTMessageWindow get(Message msg) {
		for (int i = 0; i < this.list.size(); i++) {
			SWTMessageWindow mw = (SWTMessageWindow) this.list.get(i);
			if (mw.getMessage() == msg) {
				return mw;
			}
		}
		for (int i = 0; i < this.list.size(); i++) {
			SWTMessageWindow mw = (SWTMessageWindow) this.list.get(i);
			if (mw.hasMessage(msg)) {
				return mw;
			}
		}
		return null;

	}

	/**
	 * w肵ShellbZ[WEBhE擾܂B
	 * @param msgShell Shell
	 * @return SWTMessageWindowBvȂꍇnullB
	 */
	public SWTMessageWindow get(Shell msgShell) {
		for (int i = 0; i < this.list.size(); i++) {
			SWTMessageWindow mw = (SWTMessageWindow) this.list.get(i);
			if (mw.hasShell(msgShell)) {
				return mw;
			}
		}
		return null;
	}

	/**
	 * ŌɒǉbZ[WEBhE擾܂B
	 * @param visible \Ă郁bZ[WEBhE擾ꍇtrue
	 * @return SWTMessageWindowB݂ȂꍇnullB
	 */
	public SWTMessageWindow getLast(boolean visible) {
		int size = list.size();
		if (size == 0) {
			return null;
		}
		if (!visible) {
			return (SWTMessageWindow) list.get(size - 1);
		}

		for (int i = list.size() - 1; i >= 0; i--) {
			SWTMessageWindow mw = (SWTMessageWindow) list.get(i);
			if (mw.isDisposed()) {
				/*
				 * [U[ɕ邱ƂĂ郁bZ[WEBhE
				 * shell#close()ŕȂlistɎc܂܂ɂȂAɗ(bug)B
				 * Ôߌlist菜B
				 */
				logger.warn("Message window was unexpectedly disposed."); //$NON-NLS-1$
				list.remove(mw);
				return null;
			}
			if (!mw.getMinimized()) {
				return mw;
			}
		}
		return null;
	}

	public void find(String search, Matcher m, MessageFoundListener listener) {
		int size = list.size();
		for (int i = 0; i < size; i++) {
			SWTMessageWindow mw = (SWTMessageWindow) list.get(i);
			if (mw.getMessage().match(search, m) >= 0) {
				listener.found(mw.getMessage());
			}
		}
	}

	public void synchAll() {
		int size = list.size();
		for (int i = 0; i < size; i++) {
			SWTMessageWindow msg = (SWTMessageWindow) list.get(i);
			if (msg.isDisposed()) {
				logger.warn("Message window was unexpectedly disposed."); //$NON-NLS-1$
			} else {
				msg.synchMessage();
			}
		}
	}
}
