package petaclone.swt;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Display;

import petaclone.EventBroker;
import petaclone.Events;

/**
 * }EẌʒuĎăv[XRg[܂B
 * @author Takayuki Shoji
 */
public class SWTPresenceWatcher implements Runnable {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(SWTPresenceWatcher.class);

	/**
	 * ĎԊu
	 */
	private static final int MONITORING_INTERVAL = 10 * 1000;

	/**
	 * Display
	 */
	private Display display;

	/**
	 * s݂ɂȂ܂ł̎
	 */
	private int millis;

	/**
	 * Ď̏ꍇtrue
	 */
	private boolean alive;

	/**
	 * Õ}EẌʒu
	 */
	private Point prev;

	/**
	 * }EXŌɓ
	 */
	private long prevTime;

	/**
	 * Ď[h(true: s)
	 */
	private boolean absence;

	/**
	 * EventBroker
	 */
	private EventBroker broker;

	/**
	 * RXgN^
	 * @param display Display
	 * @param broker EventBroker
	 * @param millis s݂ɂȂ܂ł̎
	 */
	public SWTPresenceWatcher(Display display, EventBroker broker, int millis) {
		this.display = display;
		this.broker = broker;
		this.millis = millis;
	}

	/**
	 * s݂ɂȂ܂ł̎ԂύX܂B
	 * @param millis s݂ɂȂ܂ł̎
	 */
	public void setMillis(int millis) {
		logger.debug("Auto absence time is changed from " + this.millis //$NON-NLS-1$
				+ " to " + millis + "."); //$NON-NLS-1$//$NON-NLS-2$
		this.millis = millis;
	}

	/**
	 * ĎJn܂B
	 */
	public void startWatching() {
		logger.debug("Watching for auto absence started."); //$NON-NLS-1$
		alive = true;
		display.asyncExec(this);
	}

	/**
	 * ĎI܂B
	 */
	public void endWatching() {
		alive = false;
		logger.debug("Cancel of watching for auto absence reserved."); //$NON-NLS-1$
	}

	/**
	 * Ď^C}[Zbg܂B
	 */
	public void resetTimer() {
		prevTime = System.currentTimeMillis();
	}

	/**
	 * Ď̎s
	 */
	public void run() {
		if (!alive || display.isDisposed()) {
			logger.debug("Watching for auto absence is cancelled."); //$NON-NLS-1$
			return;
		}
		Point location = display.getCursorLocation();

		if (location.equals(prev)) {
			if (!absence && prevTime + millis <= System.currentTimeMillis()) {
				absence = true;
				// s݃[hJnCxg
				logger.debug("Start auto absence mode event"); //$NON-NLS-1$
				broker.notifyEvent(Events.StartAutoAbsence, null);
			}
		} else {
			if (absence && prevTime + millis <= System.currentTimeMillis()) {
				absence = false;
				// s݃[hCxg
				logger.debug("End auto absence mode event"); //$NON-NLS-1$
				broker.notifyEvent(Events.EndAutoAbsence, null);
			}
			prev = location;
			prevTime = System.currentTimeMillis();
		}

		display.timerExec(MONITORING_INTERVAL, this);
	}
}
