package petaclone.swt;

import jp.takayuki.logging.Logger;

import org.eclipse.swt.widgets.Display;

import petaclone.RuntimeProperties;

/**
 * AvP[VĨtbN
 * @author Takayuki Shoji
 */
public class SWTShutdown implements Runnable {

	/**
	 * logger
	 */
	private static final Logger logger = Logger.getLogger(SWTShutdown.class);

	/** I[h̔p */
	private RuntimeProperties rp;

	/** CEBhE */
	private SWTMainWindow main;

	/**
	 * RXgN^
	 * @param main CEBhE
	 * @param rp s
	 */
	SWTShutdown(SWTMainWindow main, RuntimeProperties rp) {
		this.main = main;
		this.rp = rp;
	}

	/**
	 * I
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		logger.info("Shutdown hook start."); //$NON-NLS-1$

		if (rp.isQuit()) {
			while (!SWTMainWindow.exit) {
				try {
					logger.debug("waiting..."); //$NON-NLS-1$
					Thread.yield();
					Thread.sleep(400);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			logger.info("Shutdown hook has been cancelled."); //$NON-NLS-1$
			return;
		}

		if (main == null || main.getShell() == null) {
			logger.error("main == null || main.getShell() == null"); //$NON-NLS-1$
			return;
		}

		if (main.getShell().isDisposed()) {
			logger.error("Shutdown process quit because " //$NON-NLS-1$
					+ "main.getShell().isDisposed() returned true."); //$NON-NLS-1$
			return;
		}

		logger.info("Shutdown hook will dispose main shell."); //$NON-NLS-1$

		SWTCloseMainWindowAction sdMain = new SWTCloseMainWindowAction(main);
		Display.getDefault().syncExec(sdMain);

		logger.info("Shutdown hook end."); //$NON-NLS-1$
	}

	/**
	 * CEBhE鏈B
	 * Ctrl + CŏIۂɎgpB
	 */
	private static class SWTCloseMainWindowAction implements Runnable {
		/** CEBhE */
		private SWTMainWindow main;

		/**
		 * RXgN^
		 * @param main CEBhE
		 */
		SWTCloseMainWindowAction(SWTMainWindow main) {
			this.main = main;
		}

		/**
		 * @see java.lang.Runnable#run()
		 */
		public void run() {
			main.getShell().close();
		}
	}
}
