package petaclone.swt;

import java.io.IOException;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.swt.widgets.CountdownLabel;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Os;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

/**
 * Vbg_EEX[vEnCol[g܂ł̃JEg_Es_CAO
 * @author Takayuki Shoji
 */
public class SWTShutdownDialog extends SelectionAdapter {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(SWTShutdownDialog.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** EBhE */
	Shell shell = null;

	/** JEg_Ex */
	private CountdownLabel countdownLabel = null;

	/** s */
	private Button okButton = null;

	/** LZ */
	private Button cancelButton = null;

	/** Vbg_EEX[vEnCol[g̎ */
	private final int shutdownType;

	/** ^Cg */
	private String text;

	/** bZ[W */
	private String message;

	/**
	 * RXgN^
	 * @param shutdownType Vbg_EEX[vEnCol[g̎
	 */
	public SWTShutdownDialog(int shutdownType) {
		this.shutdownType = shutdownType;
	}

	/**
	 * @param message bZ[W
	 */
	public void setMessage(String message) {
		this.message = message;
	}

	/**
	 * @param text ^Cg
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * _CAOJ܂B
	 * @param targetTime JEg_E0ɂȂ鎞
	 */
	public void open(long targetTime) {
		initialize();
		shell.pack();
		SWTUtils.moveToCenter(shell);
		countdownLabel.setTargetTime(targetTime);
		countdownLabel.start();
		shell.open();
	}

	/**
	 * EBWFbg܂B
	 */
	private void initialize() {

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		gridLayout.horizontalSpacing = 10;
		gridLayout.verticalSpacing = 3;
		gridLayout.marginWidth = 50;
		gridLayout.marginHeight = 10;
		gridLayout.makeColumnsEqualWidth = true;
		shell = new Shell(Display.getDefault(), SWT.ON_TOP | SWT.DIALOG_TRIM);
		shell.setText(text);
		shell.setLayout(gridLayout);
		shell.setSize(new Point(270, 196));
		Label label = new Label(shell, SWT.NONE);
		label.setText(message);
		label.setLayoutData(createColSpan2(GridData.BEGINNING));

		countdownLabel = new CountdownLabel(shell, SWT.NONE);
		FontData[] fontData = Display.getDefault().getSystemFont()
				.getFontData();
		Font font = new Font(Display.getDefault(), fontData[0].getName(), 48,
				SWT.NORMAL);
		countdownLabel.setLabelFont(font, true);
		countdownLabel.setLayoutData(createColSpan2(GridData.CENTER));
		countdownLabel.setCountdownListener(this);

		okButton = new Button(shell, SWT.NONE);
		okButton.setText(mm.get("SWTShutdownDialog.exec")); //$NON-NLS-1$
		okButton.setLayoutData(createGrabSpace(GridData.END));
		okButton.addSelectionListener(this);

		cancelButton = new Button(shell, SWT.NONE);
		cancelButton.setText(mm.get("SWTShutdownDialog.cancel")); //$NON-NLS-1$
		cancelButton.setLayoutData(createGrabSpace(GridData.BEGINNING));
		cancelButton.addSelectionListener(this);
	}

	/**
	 * @param align ̈ʒu
	 * @return GridData
	 */
	private GridData createColSpan2(int align) {
		GridData data = new GridData();
		data.horizontalAlignment = align;
		data.horizontalSpan = 2;
		return data;
	}

	/**
	 * @param align ̈ʒu
	 * @return GridData
	 */
	private GridData createGrabSpace(int align) {
		GridData data = new GridData();
		data.horizontalAlignment = align;
		data.grabExcessHorizontalSpace = true;
		return data;
	}

	public void widgetSelected(SelectionEvent ev) {
		if (ev.widget == okButton) {
			countdownLabel.stop();
			doShutdown();
		} else if (ev.widget == cancelButton) {
			shell.close();
		} else if (ev.widget == countdownLabel) {
			doShutdown();
		}
	}

	/**
	 * Vbg_Es܂B
	 */
	private void doShutdown() {
		try {
			Os.shutdown(this.shutdownType);
		} catch (IOException e) {
			logger.error("Exception occurred while shutdown command.", e); //$NON-NLS-1$
		} catch (InterruptedException e) {
			logger.error("Exception occurred while shutdown command.", e); //$NON-NLS-1$
		} finally {
			if (shell != null && !shell.isDisposed())
				shell.close();
		}
	}
}
