package petaclone.swt;

import java.util.Iterator;
import java.util.Map.Entry;
import java.util.Properties;

import jp.takayuki.swt.util.ListenerDelegate;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Os;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import petaclone.AppPreferences;

/**
 * c[ݒ_CAO
 * 
 * @author Takayuki Shoji
 */
public class SWTToolConfigurationDialog {

	/** bZ[W\[X */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** _CAOShell */
	private Shell shell;

	/** ĂяoShell */
	private final Shell parent;

	/** _CAÕ^Cg̃L[ */
	private final String dialogTitle;

	/** |bvAbvj[̒`f[^ */
	private String[][] menuData;

	/**  */
	private final Properties prop;

	/**  */
	private final String propPrefix;

	/**  */
	private SWTControlCreator creator;

	/**
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		Display display = Display.getDefault();
		Shell sh = new Shell(display);
		sh.setLayout(new FillLayout());
		String[][] data = { { "test1", "value1" }, { "test2", "value2" } }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$

		Properties d = new Properties();
		d.setProperty("prefix" + AppPreferences.TOOL_EXEC_FILE, "explorer"); //$NON-NLS-1$ //$NON-NLS-2$
		d.setProperty("prefix" + AppPreferences.TOOL_PARAM, "/select,"); //$NON-NLS-1$ //$NON-NLS-2$
		d.setProperty("prefix" + AppPreferences.TOOL_WORKING_DIR, ""); //$NON-NLS-1$ //$NON-NLS-2$
		final Properties prop = new Properties(d);
		final SWTToolConfigurationDialog dialog = new SWTToolConfigurationDialog(
				sh, "Dialog Title", prop, "prefix", data); //$NON-NLS-1$ //$NON-NLS-2$
		Button b = new Button(sh, SWT.PUSH);
		b.setText("open"); //$NON-NLS-1$
		b.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				dialog.open();
			}
		});
		Button b2 = new Button(sh, SWT.PUSH);
		b2.setText("print"); //$NON-NLS-1$
		b2.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Iterator entries = prop.entrySet().iterator();
				while (entries.hasNext()) {
					Entry entry = (Entry) entries.next();
					System.out.println(entry.getKey() + "=" //$NON-NLS-1$
							+ entry.getValue());
				}
			}
		});
		sh.pack();
		sh.open();
		while (!sh.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		display.dispose();
	}

	/**
	 * RXgN^
	 * @param parent eEBWFbg
	 * @param dialogTitle _CAÕ^Cg
	 * @param prop l̎󂯓nɎgProperties
	 * @param propPrefix vpeB̃L[̃vtBbNX
	 * @param menuData j[
	 */
	public SWTToolConfigurationDialog(Shell parent, String dialogTitle,
			Properties prop, String propPrefix, String[][] menuData) {
		this.parent = parent;
		this.dialogTitle = dialogTitle;
		this.prop = prop;
		this.propPrefix = propPrefix;
		this.menuData = menuData;
	}

	/**
	 * EBhEJ܂B
	 */
	public void open() {
		this.shell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL
				| SWT.RESIZE);
		shell.setImage(parent.getImage());
		shell.setText(dialogTitle);

		GridLayout layout = new GridLayout();
		layout.numColumns = 2;

		shell.setLayout(layout);

		Actions actions = new Actions();

		creator = new SWTControlCreator(prop);
		creator.setParent(shell);

		final String[] filterNames = mm
				.getArray("SWTToolConfigurationDialog.filterNames." //$NON-NLS-1$
						+ Os.getName());
		final String[] filterExtentions = mm
				.getArray("SWTToolConfigurationDialog.filterExtentions." //$NON-NLS-1$
						+ Os.getName());

		// st@C: pX͎w肵Ȃ
		creator.createFileSelector(
				AppPreferences.getToolCommandProperty(propPrefix),
				mm.get("SWTToolConfigurationDialog.executableFile"), //$NON-NLS-1$
				"", //ftHgl //$NON-NLS-1$
				null, // pX
				filterNames, filterExtentions, true);

		creator.createAssistedTextBox(
				AppPreferences.getToolParameterProperty(propPrefix),
				mm.get("SWTToolConfigurationDialog.commandlineArgs"), //$NON-NLS-1$
				null, menuData);

		creator.createDirectorySelector(
				AppPreferences.getToolWorkingFolderProperty(propPrefix),
				mm.get("SWTToolConfigurationDialog.workingFolder"), //$NON-NLS-1$
				"", // ftHgl //$NON-NLS-1$
				null, //  pX
				true, true);

		// TODO OK, Cancel̃CAEgʉ
		// OK, Cancel{^
		Composite composite = new Composite(shell, SWT.NONE);
		GridData gd = new GridData();
		gd.horizontalSpan = 2;
		gd.horizontalAlignment = SWT.END;
		gd.verticalAlignment = SWT.BOTTOM;
		gd.grabExcessVerticalSpace = true;
		composite.setLayoutData(gd);

		GridLayout buttonGridLayout = new GridLayout(2, true);
		buttonGridLayout.marginRight = 0;
		buttonGridLayout.marginLeft = 0;
		buttonGridLayout.marginTop = 0;
		buttonGridLayout.marginBottom = 0;
		composite.setLayout(buttonGridLayout);

		if (Display.getDefault().getDismissalAlignment() == SWT.LEFT) {
			// OK,Cancel̏
			createButton(actions, composite, "doButtonOK", //$NON-NLS-1$
					"SWTToolConfigurationDialog.ok", true); //$NON-NLS-1$
			createButton(actions, composite, "doButtonCancel", //$NON-NLS-1$
					"SWTToolConfigurationDialog.cancel", false); //$NON-NLS-1$
		} else {
			createButton(actions, composite, "doButtonCancel", //$NON-NLS-1$
					"SWTToolConfigurationDialog.cancel", false); //$NON-NLS-1$
			createButton(actions, composite, "doButtonOK", //$NON-NLS-1$
					"SWTToolConfigurationDialog.ok", true); //$NON-NLS-1$

		}

		shell.pack();

		Point shellSize = shell.getSize();
		shell.setMinimumSize(-1, shellSize.y);
		shell.setSize(400, -1);

		SWTUtils.moveToCenter(shell);
		shell.open();
	}

	/**
	 * 
	 * @param actions
	 * @param composite
	 * @param methodName
	 * @param key
	 * @param defaultButton ftHg{^
	 */
	private void createButton(Actions actions, Composite composite,
			String methodName, String key, boolean defaultButton) {
		Button button = new Button(composite, SWT.PUSH);
		button.setText(mm.get(key));
		actions.register(button, methodName);
		button.addSelectionListener(actions);
		GridData gd = new GridData();
		gd.horizontalAlignment = SWT.FILL;
		button.setLayoutData(gd);
		if (defaultButton) {
			shell.setDefaultButton(button);
		}
	}

	/**
	 * CxgXi[
	 */
	public class Actions extends ListenerDelegate {

		protected void handleException(Exception e) {
			// G[͋NȂ
		}

		/**
		 * OK{^
		 * @param ev
		 */
		public void doButtonOK(SelectionEvent ev) {
			creator.saveProperties();
			shell.close();
		}

		/**
		 * LZ{^
		 * @param ev
		 */
		public void doButtonCancel(SelectionEvent ev) {
			shell.close();
		}

	}
}
