package petaclone.swt;

import java.util.Random;

import jp.takayuki.swt.util.SWTUtils;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Display;

/**
 * ォȂׂdȂȂ悤ɃEBhËʒu肵܂B
 * 
 * @author Takayuki Shoji
 */
public class SWTTopLeftWindowLocator implements SWTWindowLocator {

	/**
	 * @see petaclone.swt.SWTWindowLocator#getLocation(int, int, int, int)
	 */
	public Rectangle getLocation(int windowWidth, int windowHeight, int padding,
			int spacing) {

		Rectangle displaySize = SWTUtils.getPointedMonitorClient(Display
				.getDefault());
		if (windowWidth > displaySize.width - (padding * 2)) {
			windowWidth = displaySize.width - (padding * 2);
		}
		if (windowHeight > displaySize.height - (padding * 2)) {
			windowHeight = displaySize.height - (padding * 2);
		}
		
		Rectangle[] rects = SWTUtils.getVisibleShellRects();

		Point pt = getSimpleLocationRetry(windowWidth, windowHeight, padding,
				spacing, displaySize, rects);
		if (pt == null) {
			return null;
		}
		return new Rectangle(pt.x, pt.y, windowWidth, windowHeight);
	}

	/**
	 * dȂEBhẺEɔzu\Ȉʒu܂B
	 * Ƀ_ɂ炵܂B
	 * 
	 * @param windowWidth VzuEBhẺ
	 * @param windowHeight VzuEBhE̍
	 * @param padding fBXvC̒[̗]
	 * @param spacing EBhEƃEBhE̊Ԋu
	 * @param displaySize fBXvC̗L͈
	 * @param rects ݂EBhË̗
	 * @return ʒuB擾łȂꍇnullB
	 */
	private Point getSimpleLocation(int windowWidth, int windowHeight,
			int padding, int spacing, Rectangle displaySize, Rectangle[] rects) {
		// ʒu
		Rectangle windowRect = new Rectangle(padding + displaySize.x, padding
				+ displaySize.y, windowWidth, windowHeight);

		while (true) {
			Rectangle rect = SWTUtils.getIntersectRect(windowRect, rects);
			if (rect == null) {
				//ɔzuł
				Random r = new Random();
				int rx = spacing == 0 ? 0 : -r.nextInt(spacing);
				int ry = spacing == 0 ? 0 : -r.nextInt(spacing);
				return new Point(windowRect.x + rx, windowRect.y + ry);
			}

			// ËʒuvZ
			windowRect.x = spacing + rect.x + rect.width;
			if (SWTUtils.withinDisplay(displaySize, windowWidth, windowHeight,
					padding, windowRect.x, windowRect.y)) {
				continue;
			}

			// ̈ʒuvZ
			windowRect.y += spacing + (windowRect.height / 8) + displaySize.y;
			windowRect.x = padding + displaySize.x;
			if (SWTUtils.withinDisplay(displaySize, windowWidth, windowHeight,
					padding, windowRect.x, windowRect.y)) {
				continue;
			}

			// fBXvC͈̔͊O
			return null;
		}
	}

	/**
	 * EBhETCY̔{
	 */
	private static final double x[] = { 1d, 0.8d, 0.5d, 0.25d };

	/**
	 * dȂEBhẺEɔzu\Ȉʒu܂B
	 * ꏊƂ͑dȂʒugp܂B
	 * 
	 * @param windowWidth VzuEBhẺ
	 * @param windowHeight VzuEBhE̍
	 * @param padding fBXvC̒[̗]
	 * @param spacing EBhEƃEBhE̊Ԋu
	 * @param displaySize fBXvC̗L͈
	 * @param rects ݂EBhË̗
	 * @return ʒuB擾łȂꍇnullB
	 */
	private Point getSimpleLocationRetry(int windowWidth, int windowHeight,
			int padding, int spacing, Rectangle displaySize, Rectangle[] rects) {

		for (int i = 0; i < x.length; i++) {
			Point p = getSimpleLocation((int) (windowWidth * x[i]),
					(int) (windowHeight * x[i]), padding, spacing, displaySize,
					rects);
			if (p != null) {
				return p;
			}
		}
		return null;
	}

}
