package petaclone.swt;

import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;

/**
 * tH[JXۂɃEBhE̓xFocusListenerB
 * 
 * @author Takayuki Shoji
 */
public class SWTTransparencyCanceller extends ShellAdapter {

	/**
	 * EBhE}l[W
	 */
	private final SWTMessageWindowManager desktopMessages;

	/**
	 * RXgN^
	 * 
	 * @param desktopMessages EBhE}l[W
	 */
	public SWTTransparencyCanceller(SWTMessageWindowManager desktopMessages) {
		this.desktopMessages = desktopMessages;
	}

	public void shellActivated(ShellEvent e) {
		Shell sh = getShell(e.widget);
		if (sh == null) {
			return;
		}
		// sh.getAlpha()255Ԃꍇ邽ߘ_IȒlŔ肷
		//https://bugs.eclipse.org/bugs/show_bug.cgi?id=230121
		SWTMessageWindow mw = desktopMessages.get(sh);
		if (mw != null && mw.getMessage().alpha < 255) {
			sh.setAlpha(255);
		}
	}

	public void shellDeactivated(ShellEvent e) {
		Shell sh = getShell(e.widget);
		if (sh == null) {
			return;
		}
		SWTMessageWindow mw = desktopMessages.get(sh);
		if (mw != null && mw.getMessage().alpha < 255) {
			sh.setAlpha(mw.getMessage().alpha);
		}
	}

	/**
	 * tH[JXCxgShell擾܂B
	 * @param widget Ώۂ̃EBWFbg
	 * @return ShellB擾łȂꍇnullB
	 */
	private Shell getShell(Widget widget) {
		Shell sh = null;
		if (widget instanceof Text) {
			Text text = (Text) widget;
			if (text.isDisposed()) {
				return null;
			}
			sh = text.getShell();
		} else if (widget instanceof Shell) {
			sh = (Shell) widget;
		}
		if (sh == null || sh.isDisposed()) {
			return null;
		}
		return sh;
	}
}
