package petaclone.swt.logic;

import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.widgets.Shell;

import petaclone.AppPreferences;
import petaclone.Events;
import petaclone.Message;
import petaclone.MessageLogger;
import petaclone.MessageStorage;
import petaclone.MessengerFacade;
import petaclone.swt.SWTMainWindow;
import petaclone.swt.SWTMessageWindow;
import petaclone.swt.SWTTaskTray;

/**
 * V̎MbZ[W\܂B
 * @author Takayuki Shoji
 */
public class SWTDisplayWindow extends AbstractSWTEventListener {

	/**
	 * CEBhE
	 */
	private SWTMainWindow main;

	/**
	 * ݒ
	 */
	private AppPreferences pref;

	/**
	 * MessengerFacade
	 */
	private MessengerFacade facade;

	/**
	 * ۊǔ
	 */
	private MessageStorage storage;

	/**
	 * ^XNgC
	 */
	private SWTTaskTray tray;

	/**
	 * MessageLogger
	 */
	private MessageLogger msgLogger;

	/**
	 * RXgN^
	 * @param display 
	 * @param main 
	 * @param pref 
	 * @param facade 
	 * @param storage 
	 * @param tray 
	 * @param msgLogger 
	 */
	public SWTDisplayWindow(SWTMainWindow main, AppPreferences pref,
			MessengerFacade facade, MessageStorage storage, SWTTaskTray tray,
			MessageLogger msgLogger) {
		this.main = main;
		this.pref = pref;
		this.facade = facade;
		this.storage = storage;
		this.tray = tray;
		this.msgLogger = msgLogger;
	}

	/**
	 * Cxg
	 * @param eventName CxgBEvents.ShowInIndependentWindow, Events.DisplayWindow
	 * @param event Boolean.TRUE ̂Ƃo[̏sȂ
	 */
	protected void handleEvent(String eventName, Object event) {

		boolean showInIndependent = eventName
				.equals(Events.ShowInIndependentWindow);

		// ʏACRɂ
		tray.setNormalImage();

		// ToolTip
		if (event == null || Boolean.FALSE.equals(event)) {
			tray.clearBalloon();
		}

		// V̎MbZ[W擾
		List messages = storage.getPending();
		if (messages == null || messages.isEmpty()) {

			/*
			 * tH[JX̃[
			 * 1.AvP[VobNOEĥƂ
			 * 2.CEBhE\Eŏ̂Ƃ
			 * 3.CEBhEobNOEĥƂ(ƗEBhEtHAOEh)
			 * 
			 * ^XNo[̃y^N[NbNōŏ
			 * ActiveShell != null̂܂ܔ\ɂȂ錻ۂNB(Win32)
			 */
			if (!showInIndependent) {
				Shell active = getDisplay().getActiveShell();
				if (active == null || !main.getVisible()
						|| active.getParent() == null) {
					// gCNbN̓tH[JXD
					main.show(true);
				}
			}
			return;
		}

		// CEBhE\
		if (!showInIndependent && !pref.getUseIndependentMessageWindow()
				&& !main.getVisible())
			main.show(true);

		boolean save = pref.getSaveReceivedMessage();

		Iterator itr = messages.iterator();
		while (itr.hasNext()) {
			Message message = (Message) itr.next();
			message.messageClass = Message.RECEIVED;

			// ۑ
			if (save) {
				storage.add(message);
			}

			SWTMessageWindow mw = new SWTMessageWindow(main, message, pref,
					facade, msgLogger);
			// ƗIvV𔽉f
			if (showInIndependent || pref.getUseIndependentMessageWindow()) {
				message.windowMode = Message.WINDOW_INDEPENDENT;
			}
			mw.open();
			mw.activate();
		}
	}
}
