package petaclone.swt.logic;

import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import petaclone.AppPreferences;
import petaclone.Message;
import petaclone.swt.SWTTaskTray;

/**
 * Jʒm̎MCxg
 * @author Takayuki Shoji
 */
public class SWTOpenNoticeReceived extends AbstractSWTEventListener {

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * AvP[Vݒ
	 */
	private AppPreferences pref;

	/**
	 * SWTTaskTray
	 */
	private SWTTaskTray tray;

	/**
	 * RXgN^
	 * @param display
	 * @param pref 
	 * @param tray 
	 */
	public SWTOpenNoticeReceived(AppPreferences pref, SWTTaskTray tray) {
		this.pref = pref;
		this.tray = tray;
	}

	/**
	 * Cxg
	 */
	protected void handleEvent(String eventName, Object event) {
		Message message = (Message) event;
		//
		switch (pref.getOpenNoticeDisplay()) {
		case AppPreferences.OPEN_NOTICE_DISPLAY_BALLOON:
			showBalloon(message);
			break;
		case AppPreferences.OPEN_NOTICE_DISPLAY_ALERT:
			showAlert(message);
			break;
		case AppPreferences.OPEN_NOTICE_DISPLAY_NONE:
			// Ȃ
			break;
		default:
			break;
		}
	}

	/**
	 * o[\B
	 * @param message Jʒm
	 */
	private void showBalloon(Message message) {
		//		TrayItem item = tray.getTrayItem();
		//		if (item == null) {
		//			tip.setLocation(20, 20);
		//		} else {
		//			tray.clearBalloon();
		//			item.setToolTip(tip);
		//		}
		//
		//		// o[
		//		tip.setText("bZ[WJ܂");
		//		tip.setMessage(message.userName + "  " + message.getLocalTime());
		//
		//		// c[`bv\
		//		getDisplay().asyncExec(action);

		tray.showBalloon(
				mm.get("SWTOpenNoticeReceived.messageWasOpened"), //$NON-NLS-1$
				mm.get("SWTOpenNoticeReceived.senderAndTime", //$NON-NLS-1$
						new Object[] { message.userName, message.getDate() }),
				false);
	}

	/**
	 * A[g\B
	 * @param message Jʒm
	 */
	private void showAlert(Message message) {

		final Shell sh = new Shell(getDisplay(), SWT.CLOSE);
		GridLayout gridLayout = new GridLayout();
		sh.setLayout(gridLayout);

		sh.setText(mm.get("SWTOpenNoticeReceived.openNotice")); //$NON-NLS-1$

		Label label = new Label(sh, SWT.NONE);
		label.setText(mm.get("SWTOpenNoticeReceived.messageWasOpened") //$NON-NLS-1$
				+ mm.get("SWTOpenNoticeReceived.senderAndTime", //$NON-NLS-1$
						new Object[] { message.userName, message.getDate() }));
		GridData data = new GridData();
		data.horizontalAlignment = SWT.CENTER;
		label.setLayoutData(data);

		Button button = new Button(sh, SWT.PUSH);
		button.setText(mm.get("SWTOpenNoticeReceived.ok")); //$NON-NLS-1$
		data = new GridData();
		data.horizontalAlignment = SWT.CENTER;
		data.widthHint = 80;
		button.setLayoutData(data);
		button.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				sh.close();
			}
		});

		sh.setDefaultButton(button);

		sh.pack();

		// tH[JXȂŊJ
		sh.setVisible(true);
	}
}
