package petaclone.swt.logic;

import java.io.IOException;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.MessageMap;

import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import petaclone.swt.SWTQualityFeedback;

/**
 * M{^
 * @author Takayuki Shoji
 */
public class SWTQualityFeedbackSendAction extends SelectionAdapter {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(SWTQualityFeedbackSendAction.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * itB[hobN
	 */
	private SWTQualityFeedback feedback;

	/**
	 * tB[hobN𑗐MURL
	 */
	private static final String FEEDBACK_URL = "http://petaclone.sakura.ne.jp/qualityfeedback/feedback.cgi"; //$NON-NLS-1$

	/**
	 * Ix
	 */
	private boolean warnQuit;

	/**
	 * RXgN^
	 * @param feedback itB[hobN
	 * @param warnQuit Ǐxsꍇtrue
	 */
	public SWTQualityFeedbackSendAction(SWTQualityFeedback feedback,
			boolean warnQuit) {
		this.feedback = feedback;
		this.warnQuit = warnQuit;
	}

	/**
	 * Cxg
	 */
	public void widgetSelected(SelectionEvent event) {
		send(false);
	}

	/**
	 * M
	 * @param autoSend M̏ꍇtrue
	 */
	public void send(boolean autoSend) {
		try {
			feedback.setSendButtonEnabled(false);
			feedback.send(FEEDBACK_URL);

			logger.info(feedback.getSendResponse());

			if (!autoSend) {
				String msg = mm.get("SWTQualityFeedbackSendAction.thankYou"); //$NON-NLS-1$
				if (warnQuit) {
					msg += mm
							.get("SWTQualityFeedbackSendAction.applicationWillQuitAfterClose"); //$NON-NLS-1$
				}

				SWTUtils.showInformation(
						feedback.getShell(),
						mm.get("SWTQualityFeedbackSendAction.transferComplete"), //$NON-NLS-1$
						msg);
			}

		} catch (IOException e) {
			logger.error("Failed to send quality feedback.", e); //$NON-NLS-1$

			if (!autoSend) {
				String msg = mm.get("SWTQualityFeedbackSendAction.sorry"); //$NON-NLS-1$
				if (warnQuit) {
					msg += mm
							.get("SWTQualityFeedbackSendAction.applicationWillQuitAfterClose"); //$NON-NLS-1$
				}

				SWTUtils.showInformation(
						feedback.getShell(),
						mm.get("SWTQualityFeedbackSendAction.failedToSend.title"), //$NON-NLS-1$
						msg);
			}

			feedback.setSendButtonEnabled(true);
		}
	}
}