package petaclone.swt.logic;

import jp.takayuki.logging.Logger;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.tools.InetAddressUtils;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Tool;
import jp.takayuki.tools.Version;

import org.eclipse.swt.SWT;

import petaclone.swt.SWTQualityFeedback;

/**
 * <p>\ȂOEG[ɂُIɕitB[hobNN܂B</p>
 * @author Takayuki Shoji
 */
public class UnexpectedErrorOccured extends AbstractSWTEventListener {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(UnexpectedErrorOccured.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/**
	 * Cxg܂B
	 */
	protected void handleEvent(String eventName, Object event) {
		Throwable th = (Throwable) event;

		logger.fatal("Unexpected error occured.", th); //$NON-NLS-1$

		String stackTrace = Tool.getStackTraceString(th);

		SWTQualityFeedback feedback = new SWTQualityFeedback();
		feedback.initialize(true);

		feedback.getShell().setText(
				mm.get("UnexpectedErrorOccured.qualityFeedback")); //$NON-NLS-1$
		feedback.setButtonText(mm.get("UnexpectedErrorOccured.send"), //$NON-NLS-1$
				mm.get("UnexpectedErrorOccured.cancel")); //$NON-NLS-1$
		feedback.setExplanation(mm.get("UnexpectedErrorOccured.explanation")); //$NON-NLS-1$

		// Rg
		feedback.addElement(mm.get("UnexpectedErrorOccured.comment"), //$NON-NLS-1$
				mm.get("UnexpectedErrorOccured.pleaseWriteIn"), false); //$NON-NLS-1$

		// AvP[V
		feedback.addElement("Application", mm.get("BaseMain.appName")); //$NON-NLS-1$ //$NON-NLS-2$
		Version v = Version.loadFromResource();
		feedback.addElement("Build number", v.getBuildNumberStr()); //$NON-NLS-1$
		feedback.addElement("Version", v.getVersionText()); //$NON-NLS-1$
		feedback.addElement("Stage", v.getStage()); //$NON-NLS-1$

		// G[e
		feedback.addElement("Stack trace", stackTrace); //$NON-NLS-1$

		// SWT
		feedback.addElement("SWT Version", Integer.toString(SWT.getVersion())); //$NON-NLS-1$
		feedback.addElement("SWT Platform", SWT.getPlatform()); //$NON-NLS-1$

		// Locale
		feedback.addSystemPropertyElement("user.language"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("user.country"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("user.variant"); //$NON-NLS-1$

		// Memory
		long totalMemory = Runtime.getRuntime().totalMemory();
		long freeMemory = Runtime.getRuntime().freeMemory();
		long committedMemory = totalMemory - freeMemory;
		feedback.addElement("Total Memory", Long.toString(totalMemory)); //$NON-NLS-1$
		feedback.addElement("Free Memory", Long.toString(freeMemory)); //$NON-NLS-1$
		feedback.addElement("Committed Memory", Long.toString(committedMemory)); //$NON-NLS-1$

		// System
		feedback.addSystemPropertyElement("os.name"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("os.version"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("os.arch"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("sun.os.patch.level"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("sun.arch.data.model"); //$NON-NLS-1$

		// IP Version
		feedback.addElement("ip version", //$NON-NLS-1$
				Integer.toString(InetAddressUtils.getIpVersion()));

		//Java
		feedback.addSystemPropertyElement("java.version"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.runtime.name"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.runtime.version"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.vm.vendor"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.vm.name"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.vm.info"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.home"); //$NON-NLS-1$
		feedback.addSystemPropertyElement("java.library.path"); //$NON-NLS-1$

		SWTQualityFeedbackSendAction action = new SWTQualityFeedbackSendAction(
				feedback, true);
		feedback.addSendButtonListener(action);

		// ׂĂShell̃bN
		SWTUtils.enableAllShells();
		feedback.open();

		if (v.isDevelopmentStage()) {
			// Jł͎M
			action.send(true);
		}
		feedback.doEventLoop();
	}
}
