package petaclone.swt;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.nio.charset.UnsupportedCharsetException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;

import jp.takayuki.graphics.DibImage;
import jp.takayuki.graphics.WindowsMetafile;
import jp.takayuki.logging.Logger;
import jp.takayuki.rtf.RTFParser;
import jp.takayuki.rtf.RTFParser.RTFPicture;
import jp.takayuki.swt.dnd.DibTransfer;
import jp.takayuki.swt.dnd.PNGTransfer;
import jp.takayuki.swt.dnd.PrivateDataTransfer;
import jp.takayuki.swt.undo.TextUndoCommand;
import jp.takayuki.swt.undo.UndoStack;
import jp.takayuki.swt.util.ClipboardMenuItemEnabler;
import jp.takayuki.swt.util.CocoaMenuDetectSuppressor;
import jp.takayuki.swt.util.ListenerDelegate;
import jp.takayuki.swt.util.SWTMenuUtils;
import jp.takayuki.swt.util.SWTUtils;
import jp.takayuki.swt.util.TextSelectionMenuItemEnabler;
import jp.takayuki.swt.widgets.LabeledIconItem;
import jp.takayuki.swt.widgets.LabeledIconTray;
import jp.takayuki.swt.widgets.SWTWindowTransition;
import jp.takayuki.tools.CharCode;
import jp.takayuki.tools.MessageMap;
import jp.takayuki.tools.Os;
import jp.takayuki.tools.Password;
import jp.takayuki.tools.Tool;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.custom.MovementEvent;
import org.eclipse.swt.custom.MovementListener;
import org.eclipse.swt.custom.PaintObjectEvent;
import org.eclipse.swt.custom.PaintObjectListener;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.custom.TextChangeListener;
import org.eclipse.swt.custom.TextChangedEvent;
import org.eclipse.swt.custom.TextChangingEvent;
import org.eclipse.swt.custom.VerifyKeyListener;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSource;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.DragSourceListener;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.ImageTransfer;
import org.eclipse.swt.dnd.RTFTransfer;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.ArmEvent;
import org.eclipse.swt.events.ArmListener;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MenuAdapter;
import org.eclipse.swt.events.MenuDetectEvent;
import org.eclipse.swt.events.MenuDetectListener;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.MenuListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.GlyphMetrics;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import org.eclipse.swt.graphics.PaletteData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.ColorDialog;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolTip;

import petaclone.AppPreferences;
import petaclone.Attachment;
import petaclone.Destination;
import petaclone.DownloadListener;
import petaclone.Events;
import petaclone.Message;
import petaclone.MessageColorScheme;
import petaclone.MessageLogger;
import petaclone.Messenger;
import petaclone.MessengerFacade;
import petaclone.Protocol;
import petaclone.SendingResultListener;
import petaclone.ToolExecutor;
import petaclone.UniqueMember;
import petaclone.swt.logic.UnexpectedErrorOccured;

import com.swetake.util.Qrcode;

/**
 * bZ[WEBhEBRXgN^ŐAopen()Kv܂B
 * @author Takayuki Shoji
 */
public class SWTMessageWindow implements SendingResultListener,
		DownloadListener, TransparencySetter {

	/**
	 * logger
	 */
	private static final Logger logger = Logger
			.getLogger(SWTMessageWindow.class);

	/**
	 * bZ[W\[X
	 */
	private static final MessageMap mm = MessageMap.getMessageMap();

	/** fobOtO */
	private static final boolean DEBUG = logger.isDebugEnabled();

	/** ׂĂ̌` */
	static final int PASTE_TYPE_ALL = 0;

	/** eLXg` */
	static final int PASTE_TYPE_TEXT = 1;

	/** 摜 */
	static final int PASTE_TYPE_IMAGE = 2;

	/** t@C */
	static final int PASTE_TYPE_FILE = 3;

	/** eLXgp`ɕϊăy[Xg */
	static final int PASTE_TYPE_QUOTED_TEXT = 4;

	/**
	 * Nbv{[h
	 */
	private static TextUndoCommand internalClipboard;

	/** MessengerFacade */
	private MessengerFacade facade;

	/** CEBhEւ̎Q */
	private SWTMainWindow main;

	/**
	 * bZ[WEBhEǗ
	 */
	private SWTMessageWindowManager desktopMessages;

	/** CEBhEShell */
	private Shell parentShell;

	/** 񓯊spDisplay */
	private Display display;

	/** ݒ */
	private AppPreferences pref;

	/** ACRLbV */
	private ImageProvider img;

	/** bZ[Wf[^ */
	private Message message;

	/**
	 * ݂̃X^C
	 */
	private Style currentStyle;

	/** windowStyle؂ւ郊Xi[ */
	private WindowStyleShortcutAction wsListener;

	/**
	 * bZ[WL^
	 */
	private MessageLogger msgLogger;

	/**
	 * CxgXi[
	 */
	private Actions actions = new Actions();

	/**
	 * ׂĕ\ɐ؂ւMouseListener
	 */
	private MouseListener changeToFrontAction;

	/**
	 * xLZ
	 */
	private SWTTransparencyCanceller transparencyCanceller;

	/**
	 * VKMbZ[WpRXgN^B
	 * open()͌ŌĂяoȂ΂ȂȂB
	 * @param main CEBhE
	 * @param msg bZ[W
	 * @param pref AvP[Vݒ
	 * @param facade bZW[t@T[h
	 * @param msgLogger bZ[WL^
	 */
	public SWTMessageWindow(SWTMainWindow main, Message msg,
			AppPreferences pref, MessengerFacade facade, MessageLogger msgLogger) {

		this.main = main;
		this.desktopMessages = main.getSWTMessageWindowManager();
		this.transparencyCanceller = main.getTransparencyCanceller();
		this.message = msg;
		this.parentShell = main.getShell();
		this.display = main.getShell().getDisplay();
		this.pref = pref;
		this.img = main;
		this.facade = facade;
		this.msgLogger = msgLogger;
	}

	/**
	 * currentStyleLXgOpenStyle擾܂B
	 * 
	 * @return OpenStylełȂnullB
	 */
	private OpenStyle getOpenStyle() {
		if (currentStyle != null && (currentStyle instanceof OpenStyle)) {
			return (OpenStyle) currentStyle;
		}
		return null;
	}

	/**
	 * EBWFbgăEBhEJ܂B
	 * TODO visible𐧌ł悤ɂ
	 */
	public void open() {

		// o^
		desktopMessages.add(this);
		// desktop畜ꂽbZ[W͒ʏɖ߂Ă
		message.desktop = false;

		// \̐؂ւ
		setWindowStyle(this.message.windowStyle);
	}

	/**
	 * EBhE̐萔𒴂x܂B
	 * @param main CEBhE
	 * @param pref AvP[Vݒ
	 * @param shell Shell
	 */
	private static void warnExcessiveWindows(SWTMainWindow main,
			AppPreferences pref, Shell shell) {
		if (Os.isWindows() && pref.warnExcessiveWindows()) {
			SWTMessageWindowManager windowManager = main
					.getSWTMessageWindowManager();
			int count = windowManager.size() + 1;
			if (count >= 60) {
				ToolTip tip = new ToolTip(shell, SWT.ICON_WARNING);
				tip.setText(mm.get("SWTMessageWindow.windowCount.title")); //$NON-NLS-1$
				tip.setMessage(mm.get("SWTMessageWindow.windowCount.message", //$NON-NLS-1$
						new Object[] { new Integer(count) }));
				Rectangle clientRect = shell.getMonitor().getClientArea();
				Rectangle rect = shell.getBounds();
				tip.setLocation(SWTUtils.getVertexForBalloon(clientRect, rect));
				tip.setAutoHide(true);
				tip.setVisible(true);
			}
		}
	}

	/**
	 * VbZ[WEBhE\܂B
	 * <p>
	 * `FbN{bNX̏ԂAEBhẼANeBx[gs܂B
	 * <p>
	 * msgnull̏ꍇ͓ƗIvV𔽉f܂B
	 * 
	 * @param main C
	 * @param pref AvP[Vݒ
	 * @param facade MessengerFacade
	 * @param msgLogger bZ[WL^
	 * @param msg nullB
	 * @param moveCursorToLast J[\ŌɈړꍇtrue(p̏ꍇɎgp)
	 * @param forceIndependent IɓƗEBhEŊJꍇtrue
	 * @return bZ[WEBhE
	 */
	public static SWTMessageWindow openNewMessageWindow(SWTMainWindow main,
			AppPreferences pref, MessengerFacade facade,
			MessageLogger msgLogger, Message msg, boolean moveCursorToLast,
			boolean forceIndependent) {

		if (msg == null) {
			msg = new Message();
			msg.initialNewMessage();
			if (forceIndependent || pref.getUseIndependentMessageWindow()) {
				msg.windowMode = Message.WINDOW_INDEPENDENT;
			}
		}
		msg.setPrivacyLevel(pref.getPrivacyProtectionLevel());

		SWTMessageWindow result = new SWTMessageWindow(main, msg, pref, facade,
				msgLogger);
		result.open();

		if (moveCursorToLast) {
			OpenStyle s = (OpenStyle) result.currentStyle;
			s.moveCursorToLast();
		}
		// tH[JXړ
		result.activate();

		warnExcessiveWindows(main, pref, result.currentStyle.getShell());

		return result;
	}

	/**  */
	private static Random random;

	/**
	 * VtⳎZbg\܂B
	 * 
	 * @param main C
	 * @param pref AvP[Vݒ
	 * @param facade MessengerFacade
	 * @param msgLogger bZ[WL^
	 */
	public static void openNewStickiesSet(SWTMainWindow main,
			AppPreferences pref, MessengerFacade facade, MessageLogger msgLogger) {

		warnExcessiveWindows(main, pref, main.getShell());

		final int c = 3;
		if (random == null)
			random = new Random();

		final Display display = Display.getDefault();
		Rectangle rect = SWTUtils.getPointedMonitorClient(display);
		int centerX = rect.x + (rect.width / 2);
		int centerY = rect.y + (rect.height / 2);

		int h = pref.getMessageHeight();
		int w = pref.getMessageWidth();

		// a
		double r = Math.min(h, w) * 0.4d;

		// px
		double radian = random.nextDouble() * (2d * Math.PI);
		// W
		final int[] x = new int[c];
		final int[] y = new int[c];
		for (int i = 0; i < c; i++) {
			double radianN = (radian + (i * ((2d * Math.PI) / c)))
					% (2d * Math.PI);
			x[i] = (int) (Math.cos(radianN) * r);
			y[i] = (int) (Math.sin(radianN) * r);
			x[i] += centerX - (w / 2);
			y[i] += centerY - (h / 2);
		}

		Point initial = display.getCursorLocation();
		SWTWindowTransition[] wts = new SWTWindowTransition[c];
		MessageMap colorSchemes = MessageMap
				.getMessageMap("stickies_colorscheme"); //$NON-NLS-1$
		String numStr = colorSchemes.get("0"); //$NON-NLS-1$
		int colorSchemeCount = Integer.parseInt(numStr);
		boolean showStickyOperationGuide = pref.showStickyOperationGuide();
		String msg = showStickyOperationGuide ? mm
				.get("SWTMessageWindow.doubleClickToEdit") + '\n' : null; //$NON-NLS-1$
		int[] keys = new int[c];
		for (int i = 0; i < c; i++) {
			Message message = new Message();
			message.initialNewMessage();
			message.windowLeft = initial.x;
			message.windowTop = initial.y;
			message.windowStyle = Message.STICKY;
			message.setPrivacyLevel(pref.getPrivacyProtectionLevel());

			String[] colorSchemeStrArr;
			// J[XL[
			while (true) {
				int key = 1 + random.nextInt(colorSchemeCount);

				// dmF
				if (Tool.indexOf(keys, key, i) >= 0) {
					continue;
				}
				keys[i] = key;

				String colorSchemeStr = colorSchemes.get(Integer.toString(key));
				colorSchemeStrArr = Tool.split(colorSchemeStr, ',', 5);
				MessageColorScheme colorScheme = new MessageColorScheme(
						colorSchemeStrArr);
				message.colorScheme = colorScheme;
				break;
			}

			// {
			if (showStickyOperationGuide && i == c - 1) {
				message.message = msg + colorSchemeStrArr[4];
			} else {
				message.message = colorSchemeStrArr[4];
			}
			message.selectionStart = 0;
			message.selectionEnd = message.message.length();

			SWTMessageWindow mw = new SWTMessageWindow(main, message, pref,
					facade, msgLogger);
			message.alpha = 51;
			mw.open();

			// x
			int alpha = Integer.parseInt(colorSchemeStrArr[3]);
			message.alpha = alpha;

			if (i == c - 1)
				mw.activate();
			Shell sh = mw.currentStyle.getShell();
			wts[i] = new SWTWindowTransition(sh, x[i], y[i], 300, message.alpha);
			display.timerExec(i * 130, wts[i]);
		}
	}

	/**
	 * WindowStyleShortcutAction擾܂B
	 * 
	 * @return WindowStyleShortcutAction
	 */
	private WindowStyleShortcutAction getWsListener() {
		if (wsListener == null) {
			this.wsListener = new WindowStyleShortcutAction();
		}
		return wsListener;
	}

	/**
	 * @return M\ȏꍇtrue
	 * @see OpenStyle#isSendableMessage()
	 */
	boolean isSendableMessage() {
		OpenStyle s = getOpenStyle();
		return s != null && s.isSendableMessage();
	}

	/**
	 * bZ[WEBhE܂B
	 * <p>
	 * ̃\bh̓bZ[WEBhEjړIŌĂяo邽߁A
	 * ͍sȂA炩ߓς݂łB
	 * <p>
	 * ShellAdaptořĂяo: ÖٓIɗL
	 */
	public void close() {
		currentStyle.dispose(false);
	}

	/**
	 * ̃bZ[W擾܂B
	 * ݂̃EBhȄԂfĂƂ͂܂B
	 * 擾L邽߁AtB[hύX܂B
	 * @return bZ[W
	 */
	Message getMessage() {
		return message;
	}

	/**
	 * bZ[WEBhEőOʂɈړ܂B
	 */
	public void activate() {
		currentStyle.activate();
	}

	/**
	 * windowStyle̕ύX(EBhE`Ȃǂ̕ύX)ƃEBWFbg܂B
	 * JőOʂ1s\ɂƂ͊Jʒm𑗂܂B
	 * @param wStyle FRONTAICONABACKAONE_LINEB
	 */
	private void setWindowStyle(int wStyle) {
		if (DEBUG)
			logger.debug("setWindowStyle:" + message.windowStyle //$NON-NLS-1$
					+ "->" + wStyle); //$NON-NLS-1$

		boolean glueRight;
		boolean glueBottom;
		Rectangle client;
		Monitor[] monitors = display.getMonitors();

		Style old = currentStyle;
		if (old != null) {
			old.synchMessage();

			// ӂƉEӂfBXvC̒[ɐڂĂ邩
			Rectangle rect = old.getShell().getBounds();
			Monitor monitor = SWTUtils.getMonitorByCoordinate(monitors, rect.x,
					rect.y, display);
			client = monitor.getClientArea();

			glueRight = SWTUtils.isSharedBorderRight(client, rect);
			glueBottom = SWTUtils.isSharedBorderBottom(client, rect);
		} else {
			Monitor monitor = SWTUtils.getPointedMonitor(display, monitors);
			client = monitor.getClientArea();
			glueRight = false;
			glueBottom = false;
		}
		switch (wStyle) {
		case Message.FRONT:
			currentStyle = new OpenStyle();
			break;
		case Message.BACK:
			currentStyle = new BackStyle();
			break;
		case Message.ICON:
			currentStyle = new IconStyle();
			break;
		case Message.ONE_LINE:
			currentStyle = new OneLineStyle();
			break;
		case Message.QR_CODE:
			currentStyle = new QRCodeStyle();
			break;
		case Message.STICKY:
			currentStyle = new StickyStyle();
			break;
		default:
			logger.warn("Undefined style:" + wStyle); //$NON-NLS-1$
			currentStyle = new OpenStyle();
			break;
		}
		currentStyle.create(client);
		// ڂێ邽߂Ɉړ
		glueBorder(glueRight, glueBottom, client);

		currentStyle.setVisible(true);

		if (old != null) {
			// open()̂Ƃ͊OIactivate()
			currentStyle.activate();

			old.setVisible(false);
			old.dispose(true);
		}

		// JJʒm𑗂
		// (sendOpenNotice()ׂƂ`FbN)
		if (this.message.windowStyle == Message.FRONT) {
			this.facade.sendOpenNotice(message);
		}
	}

	/**
	 * fBXvC̃NCAg̈ւ̓ڂێ邽߂
	 * currentStyleshellړ܂B
	 * 
	 * @param glueRight Eӂڂ
	 * @param glueBottom ӂڂ
	 * @param client fBXvC̃NCAg̈
	 */
	private void glueBorder(boolean glueRight, boolean glueBottom,
			Rectangle client) {
		if (glueRight || glueBottom) {
			Rectangle curRect = currentStyle.getShell().getBounds();
			if (glueRight) {
				SWTUtils.glueBorderRight(client, curRect);
			}
			if (glueBottom) {
				SWTUtils.glueBorderBotom(client, curRect);
			}
			currentStyle.getShell().setLocation(curRect.x, curRect.y);
		}
	}

	/**
	 * Messageɓ܂B
	 */
	public void synchMessage() {
		currentStyle.synchMessage();
		logger.debug("synchMessage() called."); //$NON-NLS-1$
	}

	/**
	 * ׂĕ\ɐ؂ւMouseListener𐶐Ď擾܂B
	 * @return MouseListener
	 */
	private MouseListener getChangeToFrontAction() {
		if (changeToFrontAction == null) {
			changeToFrontAction = new MouseAdapter() {
				public void mouseDoubleClick(MouseEvent event) {
					setWindowStyle(Message.FRONT);
				}
			};
		}
		return changeToFrontAction;
	}

	/**
	 * |bvAbvj[\z܂B
	 * @param parent eShell
	 * @param currentStyle ݂̕\X^CBMessage.FRONT, Message.ONE_LINE, Message.BACK, Message.ICON
	 * @param canChangeStyle X^CύX鍀ڂǉȂtrue
	 * @return j[
	 */
	private Menu getViewPopupMenu(Shell parent, int currentStyle,
			boolean canChangeStyle) {
		Menu popup = new Menu(parent, SWT.POP_UP);

		switch (currentStyle) {
		case Message.ONE_LINE:
			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.copy"), //$NON-NLS-1$
					"Ctrl+C", 0, null, actions, //$NON-NLS-1$
					"doPopupCopyOneLineText"); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(popup);
			break;

		case Message.ICON:
			SWTMenuUtils.addMenuItemCheckbox(popup, //
					mm.get("SWTMessageWindow.popup.sameMagnification"), //$NON-NLS-1$
					"", 0, null, actions, //$NON-NLS-1$
					"doPopupSameMagnification", message.magnification); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(popup);
			break;

		case Message.QR_CODE:
			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.saveQRCodeImage"), //$NON-NLS-1$
					"", 0, null, actions, //$NON-NLS-1$
					"doPopupSaveQRCodeImage"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.copyQRCodeImage"), //$NON-NLS-1$
					"", 0, null, actions,  //$NON-NLS-1$
					"doPopupCopyQRCodeImage"); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(popup);
			break;

		case Message.STICKY:
			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.font"), "", 0, null, //$NON-NLS-1$ //$NON-NLS-2$
					actions, "doPopupStickyFont"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.fontColor"), "", 0, null, //$NON-NLS-1$ //$NON-NLS-2$
					actions, "doPopupStickyForegroundColor"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.bgcolor1"), "", 0, null, //$NON-NLS-1$ //$NON-NLS-2$
					actions, "doPopupStickyBackgroundColor1"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.bgcolor2"), "", 0, null, //$NON-NLS-1$ //$NON-NLS-2$
					actions, "doPopupStickyBackgroundColor2"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, //
					mm.get("SWTMessageWindow.popup.duplicate"), "Ctrl+D", 0, //$NON-NLS-1$ //$NON-NLS-2$
					null, actions, "doPopupStickyDuplicate"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, mm
					.get("SWTMessageWindow.popup.copyColorScheme"), "", 0, //$NON-NLS-1$ //$NON-NLS-2$
					null, actions, "doPopupStickyCopyColorScheme"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(popup, mm
					.get("SWTMessageWindow.popup.pasteColorScheme"), "", 0, //$NON-NLS-1$ //$NON-NLS-2$
					null, actions, "doPopupStickyPasteColorScheme"); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(popup);
			break;

		default:
			// Ȃ
			break;
		}

		if (canChangeStyle) {
			// vpX[ĥƂ̓X^CύXȂ
			createMenuViewChangeStyle(popup, currentStyle);

			SWTMenuUtils.addSeparator(popup);
		}

		createMenuViewTransparency(popup, false);

		SWTMenuUtils.addSeparator(popup);

		createMenuFileMessageWindowClose(null, popup, false);

		return popup;
	}

	/**
	 * ݂̃bZ[W_CAOȂŒڑM܂B
	 * ̃\bȟĂяoOcheckSendable()őM\ǂmFKv܂B
	 * @param um o[
	 */
	private void send(UniqueMember um) {
		synchMessage();

		facade.sendMessage(message, new UniqueMember[] { um }, this);
	}

	/**
	 * M\ǂmF܂B
	 * MłȂꍇ̓bZ[W_CAO\܂B
	 * @return M\ȏꍇtrue
	 */
	private boolean checkSendable() {
		if (facade.isSendable()) {
			return true;
		}

		SWTUtils.showError(currentStyle.getShell(),//
				mm.get("SWTMessageWindow.messengerIsNotLaunched")); //$NON-NLS-1$

		return false;
	}

	/**
	 * Mʂ󂯎܂B<br>
	 * u悭vƁuԐMv1ʂB
	 * @see petaclone.SendingResultListener#onSendResult(Destination, Exception)
	 */
	public void onSendResult(Destination dest, Exception e) {
		message.addDestination(dest);
		display.asyncExec(new OnSendResult(dest, e));
	}

	/** Mʂ󂯎܂B */
	private final class OnSendResult implements Runnable {
		/** M */
		boolean isSuccess;

		/**
		 * sꍇɔO
		 */
		Exception e;

		/**
		 * RXgN^
		 * @param dest ML^
		 * @param e O
		 */
		OnSendResult(Destination dest, Exception e) {
			this.isSuccess = dest.getResult();
			this.e = e;
		}

		public void run() {
			boolean disposed = currentStyle.isDisposed();
			if (isSuccess) {
				// : ۑA

				// OɗLɂȂƕȂB
				if (!disposed) {
					currentStyle.setEnabled(true);
					close();
				}

				// IP MessengerO
				if (pref.getLogEnabled()) {
					msgLogger.writeMessageLog(getMessage());
				}

				// ۊǔ
				if (!disposed && pref.getSaveSentMessage()) {
					main.savedMessageWindow.add(getMessage());
				}

			} else {
				if (!disposed) {
					//TODO 킩₷bZ[W
					SWTUtils.showError(currentStyle.getShell(), e.getMessage());

					// bN
					currentStyle.setEnabled(true);
				}
			}
		}
	}

	/**
	 * bZ[WꍇɌĂяo܂B
	 */
	public void onTooLongMessage(Protocol protocol, UniqueMember member,
			int length) {
		Shell sh = currentStyle.getShell();
		display.asyncExec(new OnTooLongMessage(sh, protocol, member, length));
	}

	/**
	 * ShellAdapter
	 */
	private final class ShellClosed extends ShellAdapter {
		public void shellClosed(ShellEvent event) {

			/*
			 * Mac OS Xł́AM_CAOJĂƂƗEBhEɃANZXłB
			 * M_CAOJĂƂɃEBhEƁAM_CAO
			 * ^C~OŖ肪N邽߁AȂ悤ɐ䂷B
			 */
			if (main.sendDialog.isShown(SWTMessageWindow.this)) {
				event.doit = false;
				return;
			}

			Shell sh = currentStyle.getShell();
			if (message.messageClass == Message.RECEIVED && !message.isSaved
					&& pref.warnClosingUnsavedReceivedMessage()) {

				// MbZ[WŖۑ̂Ƃx
				if (!SWTUtils
						.showConfirm(
								sh,
								mm
										.get("SWTMessageWindow.discardReceivedMessage"), //$NON-NLS-1$
								mm
										.get("SWTMessageWindow.doYouReallyWantToDiscardThisReceivedMessageWithoutSaving"))) { //$NON-NLS-1$
					event.doit = false;
					return;
				}
				if (message.hasAttachment()) {
					disposeAttachment();
				}
			} else if (message.messageClass == Message.RECEIVED
					&& message.hasUnsavedAttachment()) {

				// MbZ[WœYtt@CAۑ̂Ƃ
				if (!SWTUtils
						.showConfirm(sh,
								mm.get("SWTMessageWindow.discardAttachment"), //$NON-NLS-1$
								mm
										.get("SWTMessageWindow.doYouReallyWantToDiscardTheUnsavedAttachment"))) { //$NON-NLS-1$
					event.doit = false;
					return;
				}
				// Ytt@C̔jbZW[ɒʒm
				disposeAttachment();
			}

			desktopMessages.remove(SWTMessageWindow.this);

			SWTMessageWindow nextFocus;
			if (message.messageClass == Message.REPLY
					&& message.replyFrom != null) {
				nextFocus = desktopMessages.get(message.replyFrom);
			} else {
				nextFocus = desktopMessages.getLast(true);
			}
			if (nextFocus != null)
				nextFocus.activate();
		}

		/**
		 * Ytt@Cj
		 */
		private void disposeAttachment() {
			// Ytt@C̔jbZW[ɒʒm
			Messenger messenger = facade.findMessenger(message.launchId);
			if (messenger != null) {
				messenger.releaseAttachments(message);

				// _E[h̓Ytt@Cꍇ͐ؒf
				List progress = message.getAttachmentInProgress();
				if (progress != null) {
					Iterator itr = progress.iterator();
					while (itr.hasNext()) {
						Attachment att = (Attachment) itr.next();
						messenger.cancelSavingAttachment(att);
					}
				}
			}
		}
	}

	/**
	 * DownloadListener: VK_E[hǉ
	 */
	public void onAdd(Messenger messenger, Attachment attachment) {

		if (DEBUG)
			logger.debug("New download item added:" + attachment); //$NON-NLS-1$

		OpenStyle s = getOpenStyle();
		if (s != null)
			s.onAdd(messenger, attachment);

	}

	/**
	 * DownloadListener: _E[ḧُI
	 */
	public void onAbort(Attachment attachment, String reason) {
		attachment.setToolTipCache(reason);

		if (DEBUG)
			logger.debug("Download aborted:" + attachment //$NON-NLS-1$
					+ ", reason=" + reason); //$NON-NLS-1$

		// o^
		OpenStyle s = getOpenStyle();
		if (s != null)
			s.onAbort(attachment, reason);
	}

	/**
	 * DownloadListener: T[oւ̐ڑ
	 */
	public void onConnect(Attachment attachment) {
		if (DEBUG)
			logger.debug("Connected:" + attachment); //$NON-NLS-1$

		OpenStyle s = getOpenStyle();
		if (s != null)
			s.onConnect(attachment);
	}

	/**
	 * DownloadListener: _E[h̐튮
	 */
	public void onFinished(Attachment attachment) {
		if (DEBUG)
			logger.debug("Download completed:" + attachment); //$NON-NLS-1$

		// o^
		OpenStyle s = getOpenStyle();
		if (s != null)
			s.onFinished(attachment);
	}

	/**
	 * DownloadListener: _E[ḧꎞ~(LZ̒ʒm󂯂)
	 */
	public void onSuspend(Attachment attachment) {
		if (DEBUG)
			logger.debug("Download suspended:" + attachment); //$NON-NLS-1$

		// o^
		OpenStyle s = getOpenStyle();
		if (s != null)
			s.onSuspend(attachment);
	}

	/**
	 * ŌɕۑtH_DirectoryDialogɐݒ肵܂B
	 * @param dialog _CAO
	 */
	private void setFolder(DirectoryDialog dialog) {
		String lastFolder = pref.getLastDownloadFolder();
		if (lastFolder != null) {
			dialog.setFilterPath(lastFolder);
		}
	}

	/**
	 * EBhEX^CύXV[gJbg̃Xi[
	 */
	private final class WindowStyleShortcutAction implements Listener {
		public void handleEvent(Event event) {

			if (event.type != SWT.KeyDown) {
				return;
			}

			if (DEBUG) {
				logger.debug(getClass().getName() + ":src=" //$NON-NLS-1$
						+ event.widget);
				logger.debug("wsListener keyCode: " + event.keyCode //$NON-NLS-1$
						+ ", stateMask: " + event.stateMask + ", character: " //$NON-NLS-1$ //$NON-NLS-2$
						+ event.character + ";"); //$NON-NLS-1$
			}

			if (event.stateMask != SWT.MOD1) {
				return;
			}

			// X^CύXV[gJbg
			switch (event.keyCode) {
			case 'o':
				setWindowStyle(Message.FRONT);
				activate();
				break;
			case 'i':
				setWindowStyle(Message.ICON);
				activate();
				break;
			case 'k':
				setWindowStyle(Message.BACK);
				activate();
				break;
			case 'l':
				setWindowStyle(Message.ONE_LINE);
				activate();
				break;
			case '9':
				setWindowStyle(Message.QR_CODE);
				activate();
				break;
			case '0':
				setWindowStyle(Message.STICKY);
				activate();
				break;
			case 'c':
				// Rs[
				if (currentStyle instanceof OneLineStyle) {
					actions.doPopupCopyOneLineText(null);
				}
				break;
			case 'd':
				// tⳎ̕
				if (currentStyle instanceof StickyStyle) {
					actions.doPopupStickyDuplicate(null);
				}
				break;
			default:
				return;
			}
		}
	}

	/**
	 * ESCL[ɂN[Y̗}
	 */
	private static final PreventEscClosing preventEscClosingAction = new PreventEscClosing();

	/**
	 * bZ[WEBhEESCL[ŕ
	 * 삪NȂ悤ɂ܂B
	 */
	private static final class PreventEscClosing implements TraverseListener {
		public void keyTraversed(TraverseEvent e) {
			if (e.keyCode == SWT.ESC) {
				e.doit = false;
			}
		}
	}

	/**
	 * (GTK)Alt+F4EBhEj[ɂN[Y̗}
	 */
	private static final PreventWindowMenuClosing preventWindowMenuClosingAction = new PreventWindowMenuClosing();

	/**
	 * bZ[WEBhEAlt+F4EBhEj[ɂ
	 * 铮}܂B
	 */
	private static final class PreventWindowMenuClosing extends ShellAdapter {
		public void shellClosed(ShellEvent e) {
			e.doit = false;
		}
	}

	/**
	 * MovementListener
	 */
	private static final MovementListener blockMovementListener = new BlockMovementListener();

	/**
	 * ̋EŎ~܂MovementListenerłB
	 */
	private static final class BlockMovementListener implements
			MovementListener {

		public void getNextOffset(MovementEvent event) {
			event.newOffset = CharCode.getMovementOffsetForward(event.lineText,
					event.offset, event.lineOffset);
		}

		public void getPreviousOffset(MovementEvent event) {
			event.newOffset = CharCode.getMovementOffsetBackward(
					event.lineText, event.offset, event.lineOffset);
		}

	}

	/**
	 * w肵ShellĂ邩肵܂B
	 * @param sh Shell
	 * @return w肵ShellĂꍇtrue
	 */
	public boolean hasShell(Shell sh) {
		return currentStyle.hasShell(sh);
	}

	/**
	 * w肵MessageĂ邩肵܂B
	 * @param msg Message
	 * @return w肵MessageĂꍇtrue
	 */
	public boolean hasMessage(Message msg) {
		return this.message.equals(msg);
	}

	/**
	 * EBhE\v񕶂擾܂B
	 * @return v
	 */
	public String getWindowDescription() {
		// 
		if (message.messageClass != Message.RECEIVED) {
			synchMessage();
		}
		return message.getWindowDescription();
	}

	/**
	 * EBhẼACRݒ肵܂B
	 * @param shell Shell
	 */
	private void setWindowIcon(Shell shell) {
		if (Os.isMacOSX())
			return;
		String iconName;
		switch (message.messageClass) {
		case Message.REPLY:
			iconName = "reply.gif"; //$NON-NLS-1$
			break;
		case Message.SEND:
		case Message.RECEIVED:
		default:
			iconName = "message.gif"; //$NON-NLS-1$
			break;
		}
		// ^Cgo[̃ACR
		shell.setImage(img.getImage(iconName));
	}

	/**
	 * EBhẼ^Cgݒ肵܂B
	 * 
	 * @param shell Shell
	 * @param title ^Cg̉ϕ
	 */
	private void setWindowTitle(Shell shell, String title) {
		switch (message.messageClass) {
		case Message.SEND:
			shell.setText(mm.get("SWTMessageWindow.title.new", //$NON-NLS-1$
					new Object[] { title }));
			break;
		case Message.REPLY:
			shell.setText(mm.get("SWTMessageWindow.title.reply", //$NON-NLS-1$
					new Object[] { message.replyFrom.userName, title }));
			break;
		case Message.RECEIVED:
			String multicast = message.isMulticast ? mm
					.get("SWTMessageWindow.title.received.multicast") : ""; //$NON-NLS-1$ //$NON-NLS-2$
			String title2 = mm.get("SWTMessageWindow.title.received", //$NON-NLS-1$
					new Object[] { message.userName, message.getLocalTime(),
							multicast, title });
			shell.setText(title2);
			break;
		default:
			shell.setText(mm.get("SWTMessageWindow.title.unknownClass", //$NON-NLS-1$
					new Object[] { title }));
			break;
		}
	}

	/**
	 * EBhËʒuݒ肵܂B
	 * @param shell Shell
	 */
	private void setWindowLocation(Shell shell) {
		if (message.windowLeft != Message.IMPOSSIBLE
				&& message.windowTop != Message.IMPOSSIBLE) {
			shell.setLocation(message.windowLeft, message.windowTop);
		} else {
			SWTWindowLocator locator;
			if (pref.getMessageArrangement().equals(
					AppPreferences.MESSAGE_ARRANGEMENT_TOP_LEFT)) {
				locator = new SWTTopLeftWindowLocator();
			} else if (pref.getMessageArrangement().equals(
					AppPreferences.MESSAGE_ARRANGEMENT_MOUSE)) {
				locator = new SWTMousePositionWindowLocator();
			} else {
				locator = new SWTStackWindowLocator();
			}
			Rectangle r = locator.getLocation(pref.getMessageWidth(),
					pref.getMessageHeight(), 10, 5);
			if (r != null) {
				message.width = r.width;
				message.height = r.height;
				shell.setLocation(r.x, r.y);
			}
		}
	}

	/**
	 * EBhETCYݒ肵܂B
	 * @param shell Shell
	 * @param client fBXvC̃NCAg̈
	 */
	private void setWindowSize(Shell shell, Rectangle client) {
		if (message.width != Message.IMPOSSIBLE
				&& message.height != Message.IMPOSSIBLE) {
			shell.setSize(message.width, message.height);
		} else {
			int width = pref.getMessageWidth();
			int height = pref.getMessageHeight();
			if (width < 100 || width > client.width)
				width = 150;
			if (height < 100 || height > client.height)
				height = 150;

			shell.setSize(width, height);
		}
	}

	/**
	 * EBhËʒuƃTCYۑ܂B
	 * @param shell Shell
	 * @param saveSize TCYۑ
	 */
	private void saveWindowLocationAndSize(Shell shell, boolean saveSize) {
		if (shell.getMaximized()) {
			/*
			 * ő剻ĂƉ̈ʒu擾łȂB
			 * ŏĂꍇ͒ʏTCY擾łB
			 */
			shell.setMaximized(false);
		}
		// ʒu 
		Point location = shell.getLocation();
		message.windowLeft = location.x;
		message.windowTop = location.y;

		if (!saveSize)
			return;

		// TCY
		Point size = shell.getSize();
		message.width = size.x;
		message.height = size.y;
	}

	/**
	 * Shell̋`̈Ԃ܂B
	 * 
	 * @return Shell̋`̈
	 */
	public Rectangle getCurrentShellRectangle() {
		return currentStyle.getShell().getBounds();
	}

	/**
	 * ŏĂ邩ǂԂ܂B
	 * 
	 * @return ŏĂƂtrue
	 */
	public boolean getMinimized() {
		return currentStyle.getShell().getMinimized();
	}

	/**
	 * jĂ邩ǂԂ܂B 
	 * <p>
	 * ̃\bh͗\\[XjĂȂmF邽߂ɗpӂĂ܂B
	 * @return jĂꍇtrue
	 */
	public boolean isDisposed() {
		return currentStyle.isDisposed();
	}

	/**
	 * x
	 * @param force alpha255̂ƂAIɐݒ肷ƂtrueBEBhEfalseŌĂяoB
	 */
	private void setAlpha(boolean force) {
		if (message.alpha >= 255) {
			message.alpha = 255;
			if (!force)
				return;
		}
		if (message.alpha < 51) {
			message.alpha = 51;
		}
		Shell sh = currentStyle.getShell();
		sh.setAlpha(message.alpha);
	}

	/**
	 * xݒ肵܂B
	 * 
	 * @param alpha x(0(transparent)-255(opaque))
	 */
	public void setAlpha(int alpha) {
		message.alpha = alpha;
		setAlpha(true);
	}

	/**
	 * EBhẼCxg͂𐧌䂵܂B
	 * @param enabled [U[̓͂󂯕tꍇtrue
	 */
	public void setEnabled(boolean enabled) {
		currentStyle.setEnabled(enabled);
	}

	/**
	 * [hɉShell𐶐܂B
	 * 
	 * @param shellTrim true: Open, BackpAfalse: Icon, OneLinep
	 * @return Shell
	 */
	private Shell createModeAwaredShell(boolean shellTrim) {
		Shell shell;
		int style;
		if (message.windowStyle == Message.STICKY) {
			if (SWT.getPlatform().equals("gtk")) { //$NON-NLS-1$
				/*
				 * NO_TRIMȊOł̓^Cgo[\邽߁B
				 * ATCY͂łȂB
				 */
				style = SWT.NO_TRIM;
			} else {
				style = SWT.RESIZE | SWT.MODELESS;
			}
		} else if (shellTrim) {
			style = SWT.CLOSE | SWT.RESIZE;
		} else {
			style = SWT.MODELESS | SWT.BORDER;
		}
		switch (message.windowMode) {
		case Message.WINDOW_INDEPENDENT_ONTOP:
			style |= SWT.ON_TOP;
			// breakȂ
		case Message.WINDOW_INDEPENDENT:
			if (shellTrim) {
				style |= SWT.MIN | SWT.MAX;
			}
			shell = new Shell(display, style);
			break;
		case Message.WINDOW_DEFAULT:
		default:
			shell = new Shell(parentShell, style);
			break;
		}
		return shell;
	}

	/**
	 * X^CύX̃j[ڂ𐶐܂B
	 * @param menuView ẽj[
	 * @param style IX^CBMessage.FRONT, Message.ONE_LINE, Message.BACK, Message.ICON.
	 */
	private void createMenuViewChangeStyle(Menu menuView, int style) {
		SWTMenuUtils.addMenuItemRadio(menuView,//
				mm.get("SWTMessageWindow.menu.view.openStyle"), //$NON-NLS-1$
				"Ctrl+O", SWT.MOD1 | 'O', null, actions, //$NON-NLS-1$
				"doMenuViewFront", style == Message.FRONT); //$NON-NLS-1$

		SWTMenuUtils.addMenuItemRadio(menuView, //
				mm.get("SWTMessageWindow.menu.view.oneLineStyle"), //$NON-NLS-1$
				"Ctrl+L", SWT.MOD1 | 'L', null, actions, //$NON-NLS-1$
				"doMenuViewOneLine", style == Message.ONE_LINE); //$NON-NLS-1$

		SWTMenuUtils.addMenuItemRadio(menuView, //
				mm.get("SWTMessageWindow.menu.view.backStyle"), //$NON-NLS-1$
				"Ctrl+K", SWT.MOD1 | 'K', null, actions, //$NON-NLS-1$
				"doMenuViewReverse", style == Message.BACK); //$NON-NLS-1$

		SWTMenuUtils.addMenuItemRadio(menuView,//
				mm.get("SWTMessageWindow.menu.view.iconStyle"), //$NON-NLS-1$
				"Ctrl+I", SWT.MOD1 | 'I', null, actions, //$NON-NLS-1$
				"doMenuViewIcon", style == Message.ICON); //$NON-NLS-1$

		SWTMenuUtils.addMenuItemRadio(menuView,//
				mm.get("SWTMessageWindow.menu.view.qrCodeStyle"), //$NON-NLS-1$
				"Ctrl+9", SWT.MOD1 | '9', null, actions, //$NON-NLS-1$
				"doMenuViewQRCode", style == Message.QR_CODE); //$NON-NLS-1$

		SWTMenuUtils.addMenuItemRadio(menuView,//
				mm.get("SWTMessageWindow.menu.view.stickyStyle"), //$NON-NLS-1$
				"Ctrl+0", SWT.MOD1 | '0', null, actions, //$NON-NLS-1$
				"doMenuViewSticky", style == Message.STICKY); //$NON-NLS-1$
	}

	/**
	 * x...̃j[ڂ𐶐܂B
	 * 
	 * @param menuView ẽj[
	 * @param showKeyLabel V[gJbgL[̃x\ꍇtrue
	 */
	private void createMenuViewTransparency(Menu menuView, boolean showKeyLabel) {
		SWTMenuUtils.addMenuItem(menuView, //
				mm.get("SWTMessageWindow.menu.view.transparency"), //$NON-NLS-1$
				"Ctrl+Shift+Y", SWT.MOD1 | SWT.MOD2 | 'Y', null, actions, //$NON-NLS-1$
				"doMenuViewTransparency", showKeyLabel); //$NON-NLS-1$
	}

	/**
	 * ɍőOʂ̂ƂEBhE\ɂ܂B
	 * <p>
	 * M_CAOŎgp܂B
	 * 
	 * @param visible \̏ꍇtrueA\̏ꍇfalseB
	 */
	public void setVisibleIfOnTop(boolean visible) {
		Shell shell = currentStyle.getShell();
		if (!shell.isDisposed() && Tool.hasFlag(shell.getStyle(), SWT.ON_TOP)) {
			shell.setVisible(visible);
		}
	}

	/**
	 * IĂYtt@C̃pXԂ܂B
	 * 
	 * @return Ytt@C̃pX܂nullB
	 */
	private String getSelectedAttachmentPath() {

		if (!message.hasAttachment()) {
			return null;
		}

		OpenStyle s = getOpenStyle();
		int index = s.iconTray.getSelectionIndex();
		if (index == -1) {
			return null;
		}

		LabeledIconItem item = s.iconTray.getItem(index);
		if (item.getStatus() != LabeledIconItem.ICON) {
			return null;
		}

		Attachment att = (Attachment) message.attachments.get(index);
		if (att.type != Attachment.TYPE_FILE
				&& att.type != Attachment.TYPE_INLINE) {
			return null;
		}
		if (att.localPath == null || att.localPath.length() == 0
				|| att.isProgress()) {
			return null;
		}
		return att.localPath;
	}

	/**
	 * IĂYtt@CEtH_̃pX()Ԃ܂B
	 * 
	 * @return Ytt@C̃pX̃Xg(String)B
	 */
	private List getSelectedAttachmentPaths() {
		if (!message.hasAttachment()) {
			return Collections.EMPTY_LIST;
		}

		OpenStyle s = getOpenStyle();
		int[] indices = s.iconTray.getSelectionIndices();
		if (indices == null || indices.length == 0) {
			return Collections.EMPTY_LIST;
		}

		Set set = new HashSet();
		List result = new ArrayList();
		for (int i = 0; i < indices.length; i++) {
			LabeledIconItem item = s.iconTray.getItem(indices[i]);
			if (item.getStatus() != LabeledIconItem.ICON) {
				continue;
			}
			Attachment att = (Attachment) message.attachments.get(indices[i]);
			if (att.type != Attachment.TYPE_FILE
					&& att.type != Attachment.TYPE_INLINE
					&& att.type != Attachment.TYPE_DIR) {
				continue;
			}
			if (att.localPath == null || att.localPath.length() == 0
					|| att.isProgress()) {
				continue;
			}
			if (!set.contains(att.localPath)) {
				set.add(att.localPath);
				result.add(att.localPath);
			}
		}
		return result;
	}

	/**
	 * Vvȃj[o[\z܂B
	 * 
	 * @param shell EBhE
	 * @param windowStyle Message.FRONT, BACK, ICON, ONE_LINE, QR_CODE, STICKY
	 * @param enableClose ûĂv쐬ꍇtrue
	 */
	private void createMenuBarForMac(Shell shell, int windowStyle,
			boolean enableClose) {
		Menu menuBar = SWTMenuUtils.addMenuBar(shell);
		Menu menuFile = SWTMenuUtils.addCascade(menuBar, //
				mm.get("SWTMessageWindow.menu.file")); //$NON-NLS-1$
		createMenuFileMessageWindowClose(null, menuFile, enableClose);

		Menu menuView = SWTMenuUtils.addCascade(menuBar, //
				mm.get("SWTMessageWindow.menu.view")); //$NON-NLS-1$

		createMenuViewChangeStyle(menuView, windowStyle);

		SWTMenuUtils.addSeparator(menuView);

		createMenuViewTransparency(menuView, true);
	}

	/**
	 * j[ɃbZ[WAEBhEA؂Aǉ܂B
	 * <p>
	 *  shell  menuFile ͂ǂ炩n܂B
	 * 
	 * @param shell j[o[VKɒǉꍇɓn܂B(Mac̗Ԃp)
	 * @param menuFile t@Cj[ڂ݂ꍇɓnB
	 * @param enableClose uv쐬ꍇtrue
	 */
	private void createMenuFileMessageWindowClose(Shell shell, Menu menuFile,
			boolean enableClose) {
		if (shell != null) {
			Menu menuBar = SWTMenuUtils.addMenuBar(shell);
			menuFile = SWTMenuUtils.addCascade(menuBar,//
					mm.get("SWTMessageWindow.menu.file")); //$NON-NLS-1$
		}

		// bZ[W
		main.createMenuFileMessage(menuFile, true, false, true);

		// EBhE
		main.createMenuWindow(menuFile, true, false, false);

		if (enableClose) {
			SWTMenuUtils.addSeparator(menuFile);

			SWTMenuUtils.addMenuItem(menuFile,//
					mm.get("SWTMessageWindow.menu.file.close"), //$NON-NLS-1$
					"Ctrl+W", SWT.MOD1 | 'W', null, actions, //$NON-NLS-1$
					"doMenuFileDispose"); //$NON-NLS-1$
		}
	}

	/**
	 * SWTWindowDragMoveActioñCX^X
	 */
	private static SWTWindowDragMoveAction dragMoveAction = new SWTWindowDragMoveAction();

	/**
	 * SWTArrowKeyWindowMoveActioñCX^X
	 */
	private static SWTArrowKeyWindowMoveAction arrowKeyWindowMoveAction = new SWTArrowKeyWindowMoveAction();

	/**
	 * CC摜`悷
	 */
	private InlineImagePainter inlineImagePainter;

	/**
	 * InlineImagePainter̃VOgCX^X擾܂B
	 * @return CX^X
	 */
	InlineImagePainter getInlineImagePainter() {
		if (inlineImagePainter == null) {
			inlineImagePainter = new InlineImagePainter();
		}
		return inlineImagePainter;
	}

	/**
	 * CC摜`悷
	 */
	private final class InlineImagePainter implements PaintObjectListener {
		public void paintObject(PaintObjectEvent event) {
			if (DEBUG) {
				logger.debug("paintObject event."); //$NON-NLS-1$
			}
			StyleRange style = event.style;
			if (style.data instanceof Attachment) {
				Attachment att = (Attachment) style.data;
				Image image = (Image) att.data;
				if (image != null && !image.isDisposed()) {
					int x = event.x;
					int y = event.y + event.ascent - style.metrics.ascent;
					event.gc.drawImage(image, x, y);
				}
			}
		}
	}

	/**
	 * SelectionListener̃Zbg
	 */
	public class Actions extends ListenerDelegate {
		/**
		 * O
		 * @see jp.takayuki.swt.util.ListenerDelegate#handleException(java.lang.Exception)
		 */
		protected void handleException(Exception e) {
			/*
			 * ł́Abrokerƈˑ֌WGɂȂ邽߁A
			 * UnexpectedErrorOccured𒼐ڌĂяoB
			 */
			UnexpectedErrorOccured fb = new UnexpectedErrorOccured();
			fb.listen(Events.UnexpectedErrorOccured, e);
		}

		/**
		 * ɑM
		 * @param event Cxg
		 */
		public void doMenuFileSendTo(SelectionEvent event) {
			synchMessage();
			main.sendDialog.show(SWTMessageWindow.this);
		}

		/**
		 * j[t@CׂđI
		 * <p>
		 * eLXg܂͓Ytt@CׂđI܂B
		 * @param event Cxg
		 */
		public void doMenuFileSelectAll(SelectionEvent event) {
			OpenStyle s = getOpenStyle();
			if (s.iconTray != null && !s.iconTray.isDisposed()
					&& s.iconTray.isFocusControl()) {
				s.iconTray.selectAll();
			} else {
				s.textBox.selectAll();
				s.registerSelection(true, 0, s.textBox.getCharCount());
			}
		}

		/**
		 * j[t@C...
		 * g\܂B
		 * @param event Cxg
		 */
		public void doMenuFileDetail(SelectionEvent event) {
			synchMessage();
			String msg = message.getDetailString();
			if (msg == null) {
				msg = mm.get("SWTMessageWindow.messageInfo.nothing"); //$NON-NLS-1$
			}

			SWTUtils.showInformation(currentStyle.getShell(), mm
					.get("SWTMessageWindow.messageInfo.title"), msg); //$NON-NLS-1$
		}

		/**
		 * j[t@ĈĂ
		 * EBhE܂B
		 * @param event Cxg
		 */
		public void doMenuFileDispose(SelectionEvent event) {
			close();
		}

		/**
		 * j[t@CɑM
		 * M܂B
		 * @param event Cxg
		 */
		public void doMenuFileSendReply(SelectionEvent event) {
			OpenStyle s = getOpenStyle();
			if (!s.isSendableMessage() || !checkSendable()) {
				return;
			}

			// Đ
			String id = message.replyFrom.getIdentifier();
			if (!main.members.exists(id)) {
				SWTUtils.showError(s.getShell(), mm
						.get("SWTMessageWindow.destinationMayBeNotStarted")); //$NON-NLS-1$
				return;
			}
			// bN
			s.setEnabled(false);

			// M
			send(main.members.get(id));
		}

		/**
		 * j[t@CɕԐM
		 * <p>
		 * ԐMp̃bZ[WEBhE\܂B
		 * 
		 * @param event Cxg
		 */
		public void doMenuFileReplyWindow(SelectionEvent event) {
			getOpenStyle().getReplyWindow(false);
		}

		/**
		 * j[t@CɈpĕԐM
		 * <p>
		 * ԐMp̃bZ[WEBhE\܂B
		 * @param event Cxg
		 */
		public void doMenuFileReplyWindowWithQuote(SelectionEvent event) {
			getOpenStyle().getReplyWindow(true);
		}

		/**
		 * SelectionAdapter: j[t@Cۑ
		 * <p>
		 * bZ[WEBhEۑ܂B(MbZ[Ŵ)
		 * @param event Cxg
		 */
		public void doMenuFileSave(SelectionEvent event) {
			// Isɂ
			MenuItem item = (MenuItem) event.widget;
			item.setEnabled(false);
			// ۑ
			main.savedMessageWindow.add(getMessage());
		}

		/**
		 * SelectionAdapter: j[t@CQuick Look
		 * 
		 * @param event
		 */
		public void doMenuFileQuickLook(SelectionEvent event) {

			List paths = getSelectedAttachmentPaths();
			if (paths.size() == 0) {
				return;
			}

			// Quick LookN
			String[] command = new String[paths.size() + 2];
			command[0] = "qlmanage"; //$NON-NLS-1$
			command[1] = "-p"; //$NON-NLS-1$
			for (int i = 2; i < command.length; i++) {
				command[i] = (String) paths.get(i - 2);
			}

			try {
				Runtime.getRuntime().exec(command);
			} catch (IOException e) {
				logger.error("Could not launch Quick Look. path=" //$NON-NLS-1$
						+ paths.toString(), e);
			}
		}

		/**
		 * SelectionAdapter: j[t@CpXƂĊJ
		 * 
		 * @param event Cxg
		 */
		public void doMenuFileOpenSelectionAsPath(SelectionEvent event) {
			OpenStyle s = getOpenStyle();
			String path = s.textBox.getSelectionText();
			if (path == null || path.length() == 0) {
				return;
			}
			File file = new File(path);
			if (file.isFile()) {
				Program.launch(path);
				return;
			} else if (file.isDirectory()) {
				ToolExecutor exec = new ToolExecutor(pref);
				exec.openFile(AppPreferences.FILE_MANAGER_FOLDER, file);
			}
		}

		/**
		 * `FbN{bNX̃Xi[
		 * @param event Cxg
		 */
		public void doCheckBoxSealed(SelectionEvent event) {
			OpenStyle s = (OpenStyle) currentStyle;

			if (s.checkBoxSealed.getSelection()) {
				s.checkBoxPassword.setEnabled(true);
			} else {
				s.checkBoxPassword.setEnabled(false);
			}
		}

		/**
		 * j[\eɂ킹
		 * @param event Cxg
		 */
		public void doMenuViewFitContent(SelectionEvent event) {
			getOpenStyle().resizeWindow(0);
		}

		/**
		 * j[\߂
		 * @param event Cxg
		 */
		public void doMenuViewFitContentHeight(SelectionEvent event) {
			getOpenStyle().resizeWindow(2);
		}

		/**
		 * EBhE
		 * @param event Cxg
		 */
		public void doMenuViewReduceWindowSize(SelectionEvent event) {
			getOpenStyle().resizeWindow(-1);
		}

		/**
		 * EBhE傫
		 * @param event Cxg
		 */
		public void doMenuViewExpandWindowSize(SelectionEvent event) {
			getOpenStyle().resizeWindow(1);
		}

		/**
		 * EBhEcɑ傫
		 * @param event Cxg
		 */
		public void doMenuViewExpandVertical(SelectionEvent event) {
			getOpenStyle().resizeWindow(3);
		}

		/**
		 * ׂĕ\
		 * @param event Cxg
		 */
		public void doMenuViewFront(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.FRONT);
		}

		/**
		 * ACR\
		 * @param event Cxg
		 */
		public void doMenuViewIcon(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.ICON);
		}

		/**
		 * Ԃ
		 * @param event Cxg
		 */
		public void doMenuViewReverse(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.BACK);
		}

		/**
		 * 1s\
		 * @param event Cxg
		 */
		public void doMenuViewOneLine(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.ONE_LINE);
		}

		/**
		 * QRR[h\
		 * @param event Cxg
		 */
		public void doMenuViewQRCode(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.QR_CODE);
		}

		/**
		 * tⳎ\
		 * @param event Cxg
		 */
		public void doMenuViewSticky(SelectionEvent event) {
			doMenuViewChangeStyle(event, Message.STICKY);
		}

		/**
		 * X^CύX܂B
		 * @param event SelectionEvent nullsB
		 * @param windowStyle Message.FRONT, Message.ONE_LINE, Message.ICON, Message.BACK
		 */
		private void doMenuViewChangeStyle(SelectionEvent event, int windowStyle) {
			if (message.windowStyle == windowStyle) {
				return;
			}
			MenuItem item = (MenuItem) event.widget;
			if (!item.getSelection()) {
				return;
			}
			setWindowStyle(windowStyle);
			activate();
		}

		/**
		 * x_CAO\
		 * @param event Cxg
		 */
		public void doMenuViewTransparency(SelectionEvent event) {
			Shell sh = currentStyle.getShell();
			new SWTTransparencySettingDialog(sh, SWTMessageWindow.this,
					message.alpha);
		}

		/**
		 * ʏEBhE[hɐ؂ւB
		 * @param event Cxg
		 */
		public void doMenuViewModeDefault(SelectionEvent event) {
			doMenuViewChangeMode(event, Message.WINDOW_DEFAULT, true);
		}

		/**
		 * ƗEBhE[hɐ؂ւB
		 * @param event Cxg
		 */
		public void doMenuViewModeIndependent(SelectionEvent event) {
			doMenuViewChangeMode(event, Message.WINDOW_INDEPENDENT, false);
		}

		/**
		 * ɍőOʂɕ\B
		 * @param event Cxg
		 */
		public void doMenuViewModeOnTop(SelectionEvent event) {
			doMenuViewChangeMode(event, Message.WINDOW_INDEPENDENT_ONTOP, false);
		}

		/**
		 * EBhE[hύX܂B
		 * 
		 * @param event
		 * @param mode EBhE[hBMessage.WINDOW_DEFAULT, Message.WINDOW_INDEPENDENT, Message.WINDOW_INDEPENDENT_ONTOP.
		 * @param showMainIfNeeded CEBhE\\ꍇtrueB
		 */
		private void doMenuViewChangeMode(SelectionEvent event, int mode,
				boolean showMainIfNeeded) {
			if (message.windowMode == mode) {
				return;
			}
			MenuItem item = (MenuItem) event.widget;
			if (!item.getSelection()) {
				return;
			}
			message.windowMode = mode;

			if (showMainIfNeeded && !main.getVisible()) {
				main.show(false);
			}

			// ݂̃X^Cōč\z
			setWindowStyle(message.windowStyle);
			activate();
		}

		/**
		 * BB
		 * <p>
		 * ʏEBhE[h̏ꍇ͓ƗEBhE[hɕύX܂B
		 * <p>
		 * őOʃEBhE[h̏ꍇ͕ύX܂B
		 * 
		 * @param event Cxg
		 */
		public void doMenuViewHideOthers(SelectionEvent event) {
			if (message.windowMode == Message.WINDOW_DEFAULT) {
				message.windowMode = Message.WINDOW_INDEPENDENT;
				setWindowStyle(Message.FRONT);
			}
			minimizeOthers();
		}

		/**
		 * BčőOʂɕ\B
		 * <p>
		 * ƗEBhE[hȊȌꍇ͓ƗEBhE[hɕύX܂B
		 * 
		 * @param event Cxg
		 */
		public void doMenuViewHideOthersAndOnTop(SelectionEvent event) {
			if (message.windowMode != Message.WINDOW_INDEPENDENT_ONTOP) {
				message.windowMode = Message.WINDOW_INDEPENDENT_ONTOP;
				setWindowStyle(Message.FRONT);
			}
			minimizeOthers();
		}

		/**
		 * ̃EBhEB܂B
		 */
		private void minimizeOthers() {
			main.minimize();
			Shell[] shells = SWTUtils.getVisibleShells(currentStyle.getShell(),
					true, false);
			if (shells == null) {
				return;
			}
			// ̃gbvxEBhE
			for (int i = 0; i < shells.length; i++) {
				if (Tool.hasFlag(shells[i].getStyle(), SWT.MIN)) {
					shells[i].setMinimized(true);
				}
			}
		}

		/**
		 * Nbv{[h̉摜Yt
		 * @param event Cxg
		 */
		public void doMenuFileAttachClipboardImage(SelectionEvent event) {
			getOpenStyle().paste(true, PASTE_TYPE_IMAGE);
		}

		/**
		 * Nbv{[h̃eLXgYt
		 * @param event Cxg
		 */
		public void doMenuFileAttachClipboardText(SelectionEvent event) {
			getOpenStyle().paste(true, PASTE_TYPE_TEXT);
		}

		/**
		 * Nbv{[h̃t@CYt
		 * @param event Cxg
		 */
		public void doMenuFileAttachClipboardFile(SelectionEvent event) {
			getOpenStyle().paste(true, PASTE_TYPE_FILE);
		}

		/**
		 * Nbv{[hp
		 * @param event Cxg
		 */
		public void doMenuFileQuoteClipboard(SelectionEvent event) {
			getOpenStyle().paste(false, PASTE_TYPE_QUOTED_TEXT);
		}

		/**
		 * tH_Yt
		 * @param event Cxg
		 */
		public void doMenuFileAttachFolder(SelectionEvent event) {
			getOpenStyle().addDirectory();
		}

		/**
		 * t@CYt
		 * @param event Cxg
		 */
		public void doMenuFileAttachFile(SelectionEvent event) {
			getOpenStyle().addFiles();
		}

		/**
		 * ׂĂ̓Ytt@Cۑ
		 * @param event Cxg
		 */
		public void doMenuFileSaveAllAttachments(SelectionEvent event) {
			getOpenStyle().saveAllAttachments();
		}

		/**
		 * Undo
		 * @param ev Cxg
		 */
		public void doMenuEditUndo(SelectionEvent ev) {
			getOpenStyle().undoRedo(false);
		}

		/**
		 * Redo
		 * @param ev Cxg
		 */
		public void doMenuEditRedo(SelectionEvent ev) {
			getOpenStyle().undoRedo(true);
		}

		/**
		 * Undo/Redoobt@̃NA
		 * @param ev Cxg
		 */
		public void doMenuEditClearUndoBuffer(SelectionEvent ev) {
			getOpenStyle().clearUndoBuffer();
		}

		/**
		 * Jbg
		 * @param ev Cxg
		 */
		public void doMenuEditCut(SelectionEvent ev) {
			getOpenStyle().doClipboard(true);
		}

		/**
		 * Rs[
		 * @param ev Cxg
		 */
		public void doMenuEditCopy(SelectionEvent ev) {
			getOpenStyle().doClipboard(false);
		}

		/**
		 * y[Xg
		 * @param event Cxg
		 */
		public void doMenuEditPaste(SelectionEvent event) {
			getOpenStyle().paste(false, PASTE_TYPE_ALL);
		}

		/**
		 * Yt
		 * @param event Cxg
		 */
		public void doMenuEditPasteAsAttachment(SelectionEvent event) {
			getOpenStyle().paste(true, PASTE_TYPE_ALL);
		}

		/**
		 * eLXgƂăy[Xg
		 * @param event Cxg
		 */
		public void doMenuEditPasteAsText(SelectionEvent event) {
			getOpenStyle().paste(false, PASTE_TYPE_TEXT);
		}

		/**
		 * 摜Ƃăy[Xg
		 * @param event Cxg
		 */
		public void doMenuEditPasteImage(SelectionEvent event) {
			getOpenStyle().paste(false, PASTE_TYPE_IMAGE);
		}

		/**
		 * 폜
		 * @param event Cxg
		 */
		public void doMenuEditDelete(SelectionEvent event) {
			getOpenStyle().deleteSelectedItem();
		}

		/**
		 * (Mp)Ytt@CgC̃{^ACẽNbN̏
		 * @param event Cxg
		 */
		public void doTrayButtonItemClicked(SelectionEvent event) {
			LabeledIconItem item = (LabeledIconItem) event.item;
			int number = getOpenStyle().iconTray.indexOf(item);
			Attachment att = (Attachment) message.attachments.get(number);
			if (att.status >= Attachment.STATUS_WAIT) {
				// ~
				suspend(item, att);
			} else {
				// VKEĊJ
				download(item, att);
			}
		}

		/**
		 * ꎞ~
		 * @param item ACe
		 * @param att Ytt@C
		 */
		private void suspend(LabeledIconItem item, Attachment att) {
			item.setEnabled(false);
			facade.cancelDownload(message.launchId, att);
		}

		/**
		 * _E[hJnEĊJ
		 * @param item ACe
		 * @param att Ytt@C
		 */
		private void download(LabeledIconItem item, Attachment att) {
			String path = null;

			File parent = null;

			Shell sh = currentStyle.getShell();
			if (att.localPath == null) {
				if (att.type == Attachment.TYPE_FILE
						|| att.type == Attachment.TYPE_INLINE) {
					File f = SWTUtils.openSaveFileDialog(sh, mm
							.get("SWTMessageWindow.saveAttachment.file.title"), //$NON-NLS-1$
							att.name, null, false);
					if (f == null) {
						return;
					}
					parent = f.getParentFile();
					att.name = f.getName();
				} else if (att.type == Attachment.TYPE_DIR) {
					// fBNg_CAO(efBNg̎w)
					DirectoryDialog dialog = new DirectoryDialog(sh,
							SWT.APPLICATION_MODAL | SWT.SHEET);
					dialog
							.setText(mm
									.get("SWTMessageWindow.saveAttachment.folder.title")); //$NON-NLS-1$
					dialog.setMessage(mm
							.get("SWTMessageWindow.saveAttachment.folder.msg")); //$NON-NLS-1$
					setFolder(dialog);
					path = dialog.open();
					if (path == null) {
						return;
					}
					parent = new File(path);
					if (!SWTUtils.isExistingDirectory(sh, parent)) {
						return;
					}
					pref.setLastDownloadFolder(path);
				}
			} else {
				//path = att.localPath;
				File f = new File(att.localPath);
				parent = f.getParentFile();
				if (!SWTUtils.isExistingDirectory(sh, parent)) {
					return;
				}
			}

			// ǉ܂őIsɂ
			item.setEnabled(false);
			// ۑ...
			//File file = new File(path);
			//if (att.type == Attachment.TYPE_FILE) {
			//	att.name = file.getName();
			//	// efBNg擾
			//	file = file.getParentFile();
			//}
			// _E[h
			//facade.saveAttachment(message, att, file, SWTMessageWindow.this);
			facade.saveAttachment(message, att, parent);
		}

		/**
		 * (Mp)Ytt@CgC̃ACR̃_uNbN,EnterL[
		 * @param event Cxg
		 */
		public void doTrayIconOpen(SelectionEvent event) {
			LabeledIconItem item = (LabeledIconItem) event.item;
			OpenStyle s = getOpenStyle();
			int number = s.iconTray.indexOf(item);
			Attachment att = (Attachment) message.attachments.get(number);
			if (event.stateMask == SWT.NONE) {
				// J
				s.openIconItem(att);
			} else if (event.stateMask == SWT.MOD2/* SHIFT */) {
				s.openIconItemParent(att);
			}
		}

		/**
		 * Ytt@Cl[܂B
		 * @param event Cxg
		 */
		public void doMenuFileRename(SelectionEvent event) {
			if (!message.hasAttachment()) {
				return;
			}
			int index = getOpenStyle().iconTray.getSelectionIndex();
			if (index == -1) {
				return;
			}
			Attachment att = (Attachment) message.attachments.get(index);
			File file = new File(att.localPath);
			if (!file.exists()) {
				SWTUtils.showError(currentStyle.getShell(), mm
						.get("SWTMessageWindow.fileNotFound")); //$NON-NLS-1$
				return;
			}
			SWTRenameDialog dialog = new SWTRenameDialog(currentStyle
					.getShell(), getOpenStyle(), att.getFile());
			dialog.open();
		}

		/**
		 * vpX[hbZ[W̊JpOK{^̏
		 * @param event Cxg
		 */
		public void doPasswordOkButton(SelectionEvent event) {
			BackStyle s = (BackStyle) currentStyle;
			Password stored = new Password();
			stored.setStoredPassword(pref.getOpenPassword());
			String in = s.passwordBox.getText();

			try {
				if (stored.equals(in)) {
					setWindowStyle(Message.FRONT);
					// TODO vpX[hbZ[W̏ꍇ̓OɋL^AJɍsB
				} else {
					SWTUtils.showWarning(s.getShell(), mm
							.get("SWTMessageWindow.incorrectPassword")); //$NON-NLS-1$
					s.passwordBox.setFocus();
				}
			} catch (NoSuchAlgorithmException e1) {
				SWTUtils
						.showError(
								s.getShell(),
								mm
										.get("SWTMessageWindow.passwordEncryptionIsIncompatible")); //$NON-NLS-1$
			}
		}

		/**
		 * 1s\̃eLXgRs[܂B
		 * @param event Cxg
		 */
		public void doPopupCopyOneLineText(SelectionEvent event) {
			OneLineStyle s = (OneLineStyle) currentStyle;
			String str = s.textOneLine.getText();
			SWTUtils.setTextToClipboard(str);
		}

		/**
		 * Yt摜̃ACR\𓙔{\ɂ܂B
		 * @param event Cxg
		 */
		public void doPopupSameMagnification(SelectionEvent event) {
			message.magnification = !message.magnification;
			setWindowStyle(Message.ICON);
		}

		/**
		 * QRR[h摜Nbv{[hɃRs[܂B
		 * @param event Cxg
		 */
		public void doPopupCopyQRCodeImage(SelectionEvent event) {
			QRCodeStyle s = (QRCodeStyle) currentStyle;
			Image image = s.icon.getImage();
			List transfers=new ArrayList();
			List dataList=new ArrayList();
			ImageData data = image.getImageData();
			transfers.add(PNGTransfer.getInstance());
			dataList.add(data);
			transfers.add(ImageTransfer.getInstance());
			dataList.add(data);
			if (!SWTUtils.setClipboard(transfers, dataList)) {
				SWTUtils.showError(s.getShell(),
						mm.get("SWTMessageWindow.couldNotCopyToClipboard")); //$NON-NLS-1$
			}
		}

		/**
		 * QRR[h摜ۑ܂B
		 * @param event Cxg
		 */
		public void doPopupSaveQRCodeImage(SelectionEvent event) {
			QRCodeStyle s = (QRCodeStyle) currentStyle;
			File file = SWTUtils.openSaveFileDialog(s.getShell(), //
					mm.get("SWTMessageWindow.saveQRCodeImage"), //$NON-NLS-1$
					"qrcode.png", //$NON-NLS-1$
					new String[] { "*.png", "*.jpg", "*.bmp" }, //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					true);
			if (file == null) {
				return;
			}
			try {
				Image image = s.icon.getImage();
				SWTUtils.saveImageAs(file, image.getImageData());
			} catch (IOException e) {
				logger.error("I/O error occurred while saving QR code image.", //$NON-NLS-1$
						e);
				SWTUtils.showError(currentStyle.getShell(), //
						mm.get("SWTMessageWindow.failedToSaveQRCodeImage")); //$NON-NLS-1$
			}
		}

		/**
		 * tⳎ̃tHgI܂B
		 * @param event Cxg
		 */
		public void doPopupStickyFont(SelectionEvent event) {
			if (!(currentStyle instanceof StickyStyle)) {
				return;
			}
			StickyStyle s = (StickyStyle) currentStyle;

			FontDialog dialog = new FontDialog(currentStyle.getShell());
			if (s.font != null) {
				dialog.setFontList(s.font.getFontData());
			}
			FontData selected = dialog.open();
			if (selected == null) {
				return;
			}
			FontData filtered = new FontData(selected.getName(), selected
					.getHeight(), selected.getStyle());
			filtered.setLocale(selected.getLocale());

			final Font font = new Font(Display.getDefault(), filtered);

			s.label.setFont(font);
			if (s.font != null) {
				s.font.dispose();
			}
			s.font = font;
		}

		/**
		 * tⳎ̕FI܂B
		 * @param event Cxg
		 */
		public void doPopupStickyForegroundColor(SelectionEvent event) {
			StickyStyle s = (StickyStyle) currentStyle;
			Color selected = selectColor(s.fontColor);
			if (selected == null) {
				return;
			}
			Color old = s.fontColor;
			s.fontColor = selected;
			s.label.setForeground(s.fontColor);
			if (old != null) {
				old.dispose();
			}
		}

		/**
		 * tⳎ̔wiFI܂B
		 * @param event Cxg
		 */
		public void doPopupStickyBackgroundColor1(SelectionEvent event) {
			selectStickyBackgroundColor(true);
		}

		/**
		 * tⳎ̔wiFI܂B
		 * @param event Cxg
		 */
		public void doPopupStickyBackgroundColor2(SelectionEvent event) {
			selectStickyBackgroundColor(false);
		}

		/**
		 * tⳎ̔wiFI܂B
		 * @param color1 wiF1̏ꍇtrue
		 */
		private void selectStickyBackgroundColor(boolean color1) {
			StickyStyle s = (StickyStyle) currentStyle;
			Color old = color1 ? s.color1 : s.color2;
			Color selected = selectColor(old);
			if (selected == null) {
				return;
			}
			if (color1) {
				s.color1 = selected;
			} else {
				s.color2 = selected;
			}
			s.drawGradient();
			if (old != null) {
				old.dispose();
			}
		}

		/**
		 * J[_CAOŐFI܂B
		 * 
		 * @param current ݂̐F
		 * @return IFBLZꍇnullB
		 */
		private Color selectColor(Color current) {
			ColorDialog dialog = new ColorDialog(currentStyle.getShell());

			if (current != null) {
				dialog.setRGB(current.getRGB());
			}

			RGB rgb = dialog.open();
			if (rgb == null) {
				return null;
			}
			return new Color(Display.getDefault(), rgb);
		}

		/**
		 * tⳎ𕡐܂B
		 * @param event Cxg
		 */
		public void doPopupStickyDuplicate(SelectionEvent event) {
			synchMessage();
			Message msg = message.duplicateForSticky();

			Rectangle client = SWTUtils.getMonitorClientByCoordinate(
					msg.windowLeft, msg.windowTop, Display.getDefault());
			if (!SWTUtils.withinDisplay(client, msg.width, msg.height, 0,
					msg.windowLeft, msg.windowTop)) {
				msg.windowLeft = Message.IMPOSSIBLE;
				msg.windowTop = Message.IMPOSSIBLE;
			}
			SWTMessageWindow.openNewMessageWindow(main, pref, facade,
					msgLogger, msg, false, false);
		}

		/**
		 * J[XL[Rs[܂B
		 * @param event Cxg
		 */
		public void doPopupStickyCopyColorScheme(SelectionEvent event) {
			synchMessage();
			SWTUtils.setTextToClipboard(message.toColorSchemeString());
		}

		/**
		 * J[XL[y[Xg܂B
		 * @param event Cxg
		 */
		public void doPopupStickyPasteColorScheme(SelectionEvent event) {
			Clipboard clip = new Clipboard(Display.getDefault());
			try {
				String colorSchemeStr = SWTUtils.getClipboardText(clip);
				if (colorSchemeStr != null) {
					StickyStyle sticky = (StickyStyle) currentStyle;
					sticky.applyColorSchemeString(colorSchemeStr);
				}
			} finally {
				clip.dispose();
			}
		}

		/**
		 * Ytt@CgC̃|bvAbvj[́uJv̏B
		 * @param event Cxg
		 */
		public void doPopupTrayOpenIconItem(SelectionEvent event) {
			openItem(false);
		}

		/**
		 * Ytt@CgC̃|bvAbvj[́u̃tH_Jv̏B
		 * @param event Cxg
		 */
		public void doPopupTrayOpenParentFolder(SelectionEvent event) {
			openItem(true);
		}

		/**
		 * ACeJ܂B
		 * @param parent ̃tH_Jꍇtrue
		 */
		private void openItem(boolean parent) {
			if (!message.hasAttachment()) {
				return;
			}
			OpenStyle s = getOpenStyle();
			// 1J
			int index = s.iconTray.getSelectionIndex();
			if (index == -1) {
				return;
			}
			// {^͊JȂ
			LabeledIconItem item = s.iconTray.getItem(index);
			if (item.getStatus() != LabeledIconItem.ICON) {
				return;
			}
			Attachment att = (Attachment) message.attachments.get(index);
			if (parent) {
				s.openIconItemParent(att);
			} else {
				s.openIconItem(att);
			}
		}

		/**
		 * Ytt@CgC̃|bvAbvj[́unbVlvZăRs[v̏B
		 * @param event Cxg
		 */
		public void doPopupTrayCalculateAndCopyHashValue(SelectionEvent event) {
			OpenStyle s = getOpenStyle();
			try {
				s.getShell().setEnabled(false);

				int[] indices = s.iconTray.getSelectionIndices();
				List files = new ArrayList(indices.length);
				for (int i = 0; i < indices.length; i++) {
					LabeledIconItem item = s.iconTray.getItem(indices[i]);
					if (item.getStatus() != LabeledIconItem.ICON) {
						continue;
					}
					Attachment att = (Attachment) message.attachments
							.get(indices[i]);
					File file = att.getFile();
					if (file.isFile()) {
						if (file.length() > 1024 * 1024 * 20) {
							// 傫t@C̏smF
							String msg = mm.get(
									"SWTMessageWindow.confirmLongProcess.msg", //$NON-NLS-1$
									new Object[] { file.getName(),
											new Long(file.length()) });
							int answer = SWTUtils
									.showCancellableConfirm(
											s.getShell(),
											mm.get("SWTMessageWindow.confirmLongProcess.title"), //$NON-NLS-1$
											msg);
							if (answer == SWT.CANCEL) {
								return;
							} else if (answer == SWT.YES) {
								files.add(file);
							}
						} else {
							files.add(file);
						}
					}
				}
				if (files.isEmpty()) {
					return;
				}
				// TODO 񓯊
				try {
					MessageDigest md5 = MessageDigest.getInstance("MD5"); //$NON-NLS-1$
					MessageDigest sha1 = MessageDigest.getInstance("SHA1"); //$NON-NLS-1$

					MessageDigest[] mds = new MessageDigest[] { md5, sha1 };

					final String EOL = System.getProperty("line.separator"); //$NON-NLS-1$
					StringBuffer sb = new StringBuffer(96 * files.size());
					for (int i = 0; i < files.size(); i++) {
						File file = (File) files.get(i);
						Tool.getDigest(file, mds);

						sb.append(file.getAbsolutePath());
						sb.append(EOL);
						for (int j = 0; j < mds.length; j++) {
							sb.append('{').append(mds[j].getAlgorithm())
									.append('}');
							sb.append(Tool.bytesToHexString(mds[j].digest()));
							sb.append(EOL);
						}
					}

					if (!SWTUtils.setTextToClipboard(sb.toString())) {
						logger.error("Failed to copy text:" + sb.toString()); //$NON-NLS-1$
					}

				} catch (NoSuchAlgorithmException e) {
					logger.error("Failed to create MessageDigest.", e); //$NON-NLS-1$
				} catch (IOException e) {
					logger.error("Failed to calculate hash value.", e); //$NON-NLS-1$
				}
			} finally {
				s.getShell().setEnabled(true);
			}

		}

		/**
		 * Ytt@CgC̃|bvAbvj[́u摜ҏWv̏B
		 * @param event Cxg
		 */
		public void doPopupTrayEditImageIconItem(SelectionEvent event) {

			String path = getSelectedAttachmentPath();
			if (path == null) {
				return;
			}

			String editor = pref.getGraphicEditor();
			if (editor == null || editor.length() == 0) {
				return;
			}

			try {
				Runtime.getRuntime().exec(new String[] { editor, path });
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		/**
		 * Ytt@CgC̃|bvAbvj[́u폜v̏B
		 * @param event Cxg
		 */
		public void doPopupTrayDeleteItem(SelectionEvent event) {
			getOpenStyle().deleteSelectedItem();
		}

		/**
		 * Ytt@CgC̃|bvAbvj[́uׂĕۑv̏B
		 * @param event Cxg
		 */
		public void doPopupTraySaveAllAttachments(SelectionEvent event) {
			getOpenStyle().saveAllAttachments();
		}

		/**
		 * j[t@C悭遨eo[
		 * @param event Cxg
		 */
		public void doMenuFileSendToClosestMember(SelectionEvent event) {

			if (!checkSendable()) {
				return;
			}

			// bN
			currentStyle.setEnabled(false);

			// M
			UniqueMember um = (UniqueMember) event.widget.getData();
			send(um);
		}
	}

	/**
	 * 
	 */
	interface Style {
		/**
		 * ĕ\܂B
		 * @param client fBXvC̃NCAg̈
		 */
		void create(Rectangle client);

		/**
		 * j܂B
		 * @param toChangeStyle X^CύX̂߂ɔjꍇtrue
		 */
		void dispose(boolean toChangeStyle);

		/**
		 * jĂ邩ǂԂ܂B
		 * <p>
		 * ̃\bh͗\\[XjĂȂmF邽߂ɗpӂĂ܂B
		 * @return jĂꍇtrue
		 */
		boolean isDisposed();

		/**
		 * EBWFbg̏ԂMessageɓ܂B
		 */
		void synchMessage();

		/**
		 * \E\𐧌䂵܂B
		 * 
		 * @param visible \ꍇtrue
		 */
		void setVisible(boolean visible);

		/**
		 * ShellĂ邩𒲂ׂ܂B
		 * 
		 * @param sh rΏۂShell
		 * @return ShellĂꍇtrue
		 */
		boolean hasShell(Shell sh);

		/**
		 * Shell#setEnable(false)
		 * [U[̑̃ubN𐧌䂵܂B
		 * @param enabled ubNꍇfalseBubN̉trueB
		 */
		void setEnabled(boolean enabled);

		/**
		 * MessageBox̐eWidgetɎgShell擾܂B
		 * @return Shell
		 */
		Shell getShell();

		/**
		 * EBhEɃtH[JX܂B
		 */
		void activate();
	}

	/**
	 * ׂĕ\
	 */
	class OpenStyle implements Style, DownloadListener, Renamable, Listener {
		/** CC摜̃v[Xz_ */
		private static final String FFFC = "\uFFFC"; //$NON-NLS-1$

		/**
		 * Shell
		 */
		Shell shell;

		/** ׂĕ\p:j[o[ */
		private Menu menuBar;

		/** ׂĕ\p:TbVtH[(Mp͏ɐ) */
		private SashForm sashForm;

		/** ׂĕ\p:eLXg{bNX */
		private StyledText textBox;

		/** ׂĕ\p:`FbN{bNX */
		private Button checkBoxSealed;

		/** ׂĕ\p:pX[h`FbN{bNX */
		private Button checkBoxPassword;

		/** ׂĕ\p:Ytt@Cp */
		private LabeledIconTray iconTray;

		/** u悭vA[ */
		private Menu menuFileSendToRegisteredArm;

		/** u悭vj[ACe */
		private MenuItem menuFileSendToRegistered;

		/** ԐḾuMvj[ACe */
		private MenuItem menuFileSend;

		/** F */
		private Color color;

		/**
		 * _E[h̐is󋵂\
		 */
		private DownloadObserver observer;

		/**
		 * ShellCxgXi[
		 */
		private ShellClosed shellClosedAction = new ShellClosed();

		/** tHg */
		private Font font;

		/**
		 * I͈͂̃X^C
		 */
		private StyleRange[] selectedStyles;

		/**
		 * I𒆂ȂtrueBIMEɂĕ폜ꍇɔB
		 */
		private boolean selected;

		public void create(Rectangle client) {
			message.windowStyle = Message.FRONT;

			shell = createModeAwaredShell(true);
			setAlpha(false);

			shell.addShellListener(shellClosedAction);
			shell.addTraverseListener(preventEscClosingAction);

			// EBhẼ^Cgݒ
			setWindowIcon(shell);
			setWindowTitle(shell, Tool.head(message.message, 30));

			// EBhËʒu
			setWindowLocation(shell);

			// EBhETCY
			setWindowSize(shell, client);

			// _E[hXi[̐ݒ
			setDownloadListener();

			shell.setLayout(new FillLayout());

			// j[o[
			this.menuBar = SWTMenuUtils.addMenuBar(shell);
			shell.setMenuBar(this.menuBar);

			// j[ȊÕEBWFbg̐
			if (message.messageClass == Message.RECEIVED
					&& !message.hasAttachment()) {
				createReceiveWindowWithoutAttachment();
			} else if (message.messageClass == Message.RECEIVED
					&& message.hasAttachment()) {
				createReceiveWindowWithAttachment();
			} else {
				createSendWindow();
			}

			// j[o[̒g
			createMenuBar();

			// _E[h̊Ď
			List progress = message.getAttachmentInProgress();
			if (progress != null) {
				if (observer == null) {
					observer = new DownloadObserver();
				}
				observer.addAttachments(progress);
			}

			// ̓[h
			if (message.messageClass != Message.RECEIVED
					&& pref.useImInMessageWindow()) {
				int mode = SWT.DBCS | SWT.NATIVE;
				if (pref.getImModeIsRoman()) {
					mode |= SWT.ROMAN;
				}
				shell.setImeInputMode(mode);
			}

			// tH[JX
			textBox.setFocus();
			if (pref.getCancelTransParencyOnFocus()) {
				shell.addShellListener(transparencyCanceller);
			}

			// JJʒm𑗂
			if (!message.isOpened && message.messageClass == Message.RECEIVED) {
				facade.sendOpenNotice(message);
			}

			shell.setVisible(true);
		}

		public void dispose(boolean toChangeStyle) {
			// DownloadObserver炷ׂĉ
			if (observer != null) {
				observer.removeAllAttachments();
			}
			if (toChangeStyle)
				shell.removeShellListener(shellClosedAction);
			shell.close();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void synchMessage() {

			if (message.messageClass == Message.SEND
					|| message.messageClass == Message.REPLY) {
				// bZ[W{(VKEԐM̏ꍇ)
				if (textBox.getEditable()) {
					message.message = textBox.getText();
					// CC摜ۑ
					StyleRange[] styles = textBox.getStyleRanges();
					File attDir = getAttachmentDirectory();
					if (attDir != null)
						attDir.mkdirs();
					String eol = textBox.getLineDelimiter();
					for (int i = 0; i < styles.length; i++) {
						if (styles[i].length == 1
								&& styles[i].data instanceof Attachment) {
							Attachment att = (Attachment) styles[i].data;

							// }ʒu̍ČvZ
							att.position = Tool.getStorableIndex(
									styles[i].start, message.message, eol);
							if (att.localPath == null
									&& att.data instanceof Image) {

								Image image = (Image) att.data;
								try {
									File file = SWTUtils.saveImageAs(attDir,
											image.getImageData());
									att.localPath = file.getAbsolutePath();
									att.name = file.getName();
									addAttachment(att);
									logger.info("Saved inline image:" //$NON-NLS-1$
											+ att.localPath);
								} catch (IOException e) {
									logger.error(
											"Failed to save inline image.", e); //$NON-NLS-1$
								}
							}
						}
					}
				}

				// `FbN{bNX̏
				message.isOpened = !checkBoxSealed.getSelection();
				message.isPasswordRequired = checkBoxPassword.getSelection();
			}

			// I͈
			Point selection = textBox.getSelection();
			message.selectionStart = selection.x;
			message.selectionEnd = selection.y;
			message.topIndex = textBox.getTopIndex();

			// SashForm̃EFCg
			if (sashForm != null) {
				message.trayRatio = sashForm.getWeights();
			}

			saveWindowLocationAndSize(shell, true);
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.forceActive();
		}

		/**
		 * ̃\bh̓eLXg{bNXjƂɌĂяo܂B
		 * <p>
		 * {@inheritDoc}
		 */
		public void handleEvent(Event event) {
			if (event.type == SWT.Dispose) {
				// CC摜̔j
				if (event.widget instanceof StyledText) {
					StyleRange[] styles = ((StyledText) event.widget)
							.getStyleRanges();
					for (int i = 0; i < styles.length; i++) {
						disposeAttachedImage(styles[i], false);
					}
				}

				// tHgJ[
				if (color != null) {
					color.dispose();
				}

				// tHg
				if (font != null) {
					font.dispose();
				}
			}
		}

		/**
		 * Ytt@CȂƂ̎MbZ[W̑OʃEBWFbg𐶐܂B<br>
		 * j[ƃeLXg{bNX݂̂𐶐܂B
		 */
		private void createReceiveWindowWithoutAttachment() {
			// eLXg{bNX
			createTextBox(shell, true);
		}

		/**
		 * Ytt@CƂ̎MbZ[W̑OʃEBWFbg𐶐܂B<br>
		 * j[SashForm̒ɃeLXgƃgC
		 */
		private void createReceiveWindowWithAttachment() {
			// SashForm
			sashForm = createSashForm();
			// eLXg
			createTextBox(sashForm, true);
			// gC
			createIconTray(sashForm);
			// {^̃NbN
			iconTray.addButtonSelectionListener(new ButtonItemClicked());
			//iconTray.addButtonSelectionListener(actions);
			//actions.register("TrayButtonItemClicked", "doTrayButtonItemClicked");
			// ACR̃_uNbN
			iconTray.addIconOpenListener(new IconOpener());
			// FIXME ACR̃_uNbN܂@\Ȃ
			/*
			 * ButtonSelectionListenerIconOpenListener
			 * EBWFbg瓯ނ̃Cxĝ
			 * ܂ȂB
			 * NCAgR[hŃACȅԂ𔻒肷KvB
			 */
			//iconTray.addIconOpenListener(actions);
			//iconTray.setData(ListenerDelegate.DATA_KEY, "TrayIcon");
			//actions.register("TrayIcon", "doTrayIconOpen");
			// ENbN
			// ACẻENbN
			createPopupMenuForTray(false);
			// hbO\[X
			setDragSource();
			// V[gJbg
			iconTray.getComposite()
					.addKeyListener(new IconTrayShortcutAction());
			// sashForm̃EFCg
			setSashFormWeight();
		}

		/**
		 * ԐMAMEBhȆOʃEBWFbg𐶐܂B
		 */
		private void createSendWindow() {

			sashForm = createSashForm();

			Composite bodyComposite = new Composite(sashForm, SWT.NONE);
			GridLayout bodyCompositeLayout = new GridLayout(2, false);
			bodyCompositeLayout.marginHeight = 0;
			bodyCompositeLayout.marginWidth = 0;
			bodyCompositeLayout.horizontalSpacing = 3;
			bodyCompositeLayout.verticalSpacing = 3;
			bodyComposite.setLayout(bodyCompositeLayout);

			// eLXg
			createTextBox(bodyComposite, false);
			GridData textBoxData = new GridData(GridData.FILL_BOTH);
			textBoxData.horizontalSpan = 2;
			textBox.setLayoutData(textBoxData);
			// MpeLXg{bNXɃhbv^[Qbg
			AttachmentReceiver drop = new AttachmentReceiver();
			setDropTarget(drop, textBox);

			// `FbN{bNX
			createCheckBoxes(bodyComposite);

			// ACRgC
			if (message.hasAttachment()) {
				createIconTray(sashForm);

				// hbv^[Qbg
				setDropTarget(drop, iconTray);
				// hbO\[X
				setDragSource();

				// I[v
				iconTray.addIconOpenListener(new IconOpener());
				// FIXME ACR̃_uNbN܂@\Ȃ
				//			iconTray.addIconOpenListener(actions);
				//			actions.register("TrayIconOpen", "doTrayIconOpen");
				// ENbN
				createPopupMenuForTray(true);
				// V[gJbgL[
				setIconTrayShortcutForSend();

				// sashForm̃EFCg
				setSashFormWeight();
			}
		}

		/**
		 * Vj[:
		 * j[o[\z܂B
		 */
		private void createMenuBar() {

			// File
			createMenuFile();

			// Edit
			createMenuEdit();

			// View
			createMenuView();
		}

		/**
		 * j[t@C 𐶐܂B
		 */
		private void createMenuFile() {
			Menu menuFile = SWTMenuUtils.addCascade(menuBar, //
					mm.get("SWTMessageWindow.menu.file")); //$NON-NLS-1$

			// j[t@C ̍
			if (message.messageClass == Message.RECEIVED) {
				// MbZ[Wp

				SWTMenuUtils.addMenuItem(menuFile, mm.get(
						"SWTMessageWindow.menu.file.replyTo", //$NON-NLS-1$
						new Object[] { Tool
								.escapeSWTToolTipText(message.userName) }),
						"Ctrl+R", SWT.MOD1 | 'R', //$NON-NLS-1$
						img.getImage("reply.gif"), actions, //$NON-NLS-1$
						"doMenuFileReplyWindow"); //$NON-NLS-1$

				SWTMenuUtils.addMenuItem(menuFile, mm.get(
						"SWTMessageWindow.menu.file.replyWithQuote", //$NON-NLS-1$
						new Object[] { Tool
								.escapeSWTToolTipText(message.userName) }),
						"Ctrl+Shift+R", SWT.MOD1 | SWT.MOD2 | 'R', //$NON-NLS-1$
						img.getImage("reply.gif"), actions, //$NON-NLS-1$
						"doMenuFileReplyWindowWithQuote"); //$NON-NLS-1$

				SWTMenuUtils.addSeparator(menuFile);

				MenuItem menuFileSave = SWTMenuUtils.addMenuItem(menuFile, mm
						.get("SWTMessageWindow.menu.file.save"), //$NON-NLS-1$
						"Ctrl+S", SWT.MOD1 | 'S', //$NON-NLS-1$
						img.getImage("save.gif"), actions, //$NON-NLS-1$
						"doMenuFileSave"); //$NON-NLS-1$
				if (message.isSaved) {
					// ۑς(Ăꍇ)ȂIs
					menuFileSave.setEnabled(false);
				}
			} else if (message.messageClass == Message.REPLY) {
				// ԐMbZ[Wp

				menuFileSend = SWTMenuUtils
						.addMenuItem(
								menuFile,
								mm
										.get(
												"SWTMessageWindow.menu.file.sendTo", //$NON-NLS-1$
												new Object[] { Tool
														.escapeSWTToolTipText(message.replyFrom.userName) }),
								"Ctrl+R", SWT.MOD1 | 'R', img //$NON-NLS-1$
										.getImage("send.gif"), actions, //$NON-NLS-1$
								"doMenuFileSendReply"); //$NON-NLS-1$

				menuFile.addMenuListener(new MenuListener() {
					public void menuShown(MenuEvent event) {
						menuFileSend.setEnabled(isSendableMessage());
					}

					public void menuHidden(MenuEvent e) {
						menuFileSend.setEnabled(true);
					}
				});
			} else if (message.messageClass == Message.SEND) {
				// VKMbZ[Wp

				SWTMenuUtils.addMenuItem(menuFile, mm
						.get("SWTMessageWindow.menu.file.send"), //$NON-NLS-1$
						"Ctrl+R", SWT.MOD1 | 'R', //$NON-NLS-1$
						img.getImage("sendto.gif"), //$NON-NLS-1$
						actions, "doMenuFileSendTo"); //$NON-NLS-1$

				// 悭
				menuFileSendToRegistered = new MenuItem(menuFile, SWT.CASCADE);
				menuFileSendToRegistered.setText(mm
						.get("SWTMessageWindow.menu.file.frequentlySend")); //$NON-NLS-1$
				menuFileSendToRegisteredArm = new Menu(menuFileSendToRegistered);
				menuFileSendToRegistered.setMenu(menuFileSendToRegisteredArm);
				menuFileSendToRegistered
						.addArmListener(new MenuFileFrequentlyArmed());
				menuFile.addMenuListener(new MenuListener() {
					public void menuShown(MenuEvent event) {
						menuFileSendToRegistered
								.setEnabled(isSendableMessage());
					}

					public void menuHidden(MenuEvent e) {
						menuFileSendToRegistered.setEnabled(true);
					}
				});
			}

			boolean send = message.messageClass == Message.SEND
					|| message.messageClass == Message.REPLY;

			// Yt֘A
			createMenuItemsForAttachment(menuFile, true, send);

			// TrayItem֘A
			createMenuItemsForTrayItem(menuFile, true, send);

			// AbZ[WAEBhEA
			SWTMenuUtils.addSeparator(menuFile);

			SWTMenuUtils.addMenuItem(menuFile, //
					mm.get("SWTMessageWindow.menu.file.showInfo"), //$NON-NLS-1$
					"Ctrl+D", SWT.MOD1 | 'D', null, //$NON-NLS-1$
					actions, "doMenuFileDetail"); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(menuFile);

			createMenuFileMessageWindowClose(null, menuFile, true);
		}

		/**
		 * ҏWj[쐬܂B
		 */
		private void createMenuEdit() {
			Menu menu = SWTMenuUtils.addCascade(menuBar, //
					mm.get("SWTMessageWindow.menu.edit")); //$NON-NLS-1$

			// ҏW֘A
			createMenuItemsForEdit(menu, !textBox.getEditable());
		}

		/**
		 * j[\ 𐶐܂B
		 */
		private void createMenuView() {
			// \
			Menu menuView = SWTMenuUtils.addCascade(menuBar, //
					mm.get("SWTMessageWindow.menu.view")); //$NON-NLS-1$

			createMenuViewChangeStyle(menuView, Message.FRONT);

			SWTMenuUtils.addSeparator(menuView);

			createMenuViewTransparency(menuView, true);

			SWTMenuUtils.addSeparator(menuView);

			SWTMenuUtils.addMenuItem(menuView, //
					mm.get("SWTMessageWindow.menu.view.expandWindowSize"), //$NON-NLS-1$
					"Ctrl+;", SWT.MOD1 | ';', null, //$NON-NLS-1$
					actions, "doMenuViewExpandWindowSize"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(menuView,//
					mm.get("SWTMessageWindow.menu.view.reduceWindowSize"), //$NON-NLS-1$
					"Ctrl+-", SWT.MOD1 | '-', null, //$NON-NLS-1$
					actions, "doMenuViewReduceWindowSize"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(menuView, //
					mm.get("SWTMessageWindow.menu.view.expandVertically"), //$NON-NLS-1$
					"Ctrl+:", SWT.MOD1 | ':', null, //$NON-NLS-1$
					actions, "doMenuViewExpandVertical"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(menuView, mm
					.get("SWTMessageWindow.menu.view.fitContent"), //$NON-NLS-1$
					"Ctrl+@", SWT.MOD1 | '@', null, //$NON-NLS-1$
					actions, "doMenuViewFitContent"); //$NON-NLS-1$

			SWTMenuUtils.addMenuItem(menuView,//
					mm.get("SWTMessageWindow.menu.view.fitVertically"), //$NON-NLS-1$
					"Ctrl+Shift+@", SWT.MOD1 | SWT.MOD2 | '@', null, //$NON-NLS-1$
					actions, "doMenuViewFitContentHeight"); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(menuView);

			// EBhE[h
			SWTMenuUtils.addMenuItemRadio(menuView,//
					mm.get("SWTMessageWindow.menu.view.normalWindowMode"), //$NON-NLS-1$
					"Ctrl+Shift+L", SWT.MOD1 | SWT.MOD2 | 'L', null, //$NON-NLS-1$
					actions, "doMenuViewModeDefault", //$NON-NLS-1$
					message.windowMode == Message.WINDOW_DEFAULT);

			SWTMenuUtils.addMenuItemRadio(menuView,//
					mm.get("SWTMessageWindow.menu.view.independentWindowMode"), //$NON-NLS-1$
					"Ctrl+Shift+O", SWT.MOD1 | SWT.MOD2 | 'O', null, //$NON-NLS-1$
					actions, "doMenuViewModeIndependent", //$NON-NLS-1$
					message.windowMode == Message.WINDOW_INDEPENDENT);

			if (!SWT.getPlatform().equals("gtk")) //$NON-NLS-1$
				SWTMenuUtils.addMenuItemRadio(menuView,//
						mm.get("SWTMessageWindow.menu.view.alwaysOnTop"), //$NON-NLS-1$
						"Ctrl+Shift+K", SWT.MOD1 | SWT.MOD2 | 'K', null, //$NON-NLS-1$
						actions, "doMenuViewModeOnTop", //$NON-NLS-1$
						message.windowMode == Message.WINDOW_INDEPENDENT_ONTOP);

			SWTMenuUtils.addSeparator(menuView);

			SWTMenuUtils.addMenuItem(menuView,//
					mm.get("SWTMessageWindow.menu.view.hideOther"), //$NON-NLS-1$
					"Ctrl+Alt+H", SWT.MOD1 | SWT.MOD3 | 'H', null, //$NON-NLS-1$
					actions, "doMenuViewHideOthers"); //$NON-NLS-1$

			if (!SWT.getPlatform().equals("gtk")) //$NON-NLS-1$
				SWTMenuUtils
						.addMenuItem(
								menuView,
								mm
										.get("SWTMessageWindow.menu.view.hideOtherAndAlwaysOnTop"), //$NON-NLS-1$
								"Shift+Alt+H", SWT.MOD2 | SWT.MOD3 | 'H', null, //$NON-NLS-1$
								actions, "doMenuViewHideOthersAndOnTop"); //$NON-NLS-1$
		}

		/**
		 * Vj[:
		 * ҏW֘Ãj[ڂǉ܂B
		 * @param menu ẽj[
		 * @param readOnly ǂݍݐp̂Ƃtrue
		 */
		private void createMenuItemsForEdit(Menu menu, boolean readOnly) {

			MenuItem tmp;

			// Redo
			int redoShortcut;
			if (Os.isMacOSX()) {
				redoShortcut = SWT.MOD1 | SWT.MOD2 | 'Z';
			} else {
				redoShortcut = SWT.MOD1 | 'Y';
			}

			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.undo"), "Ctrl+Z", //$NON-NLS-1$ //$NON-NLS-2$
					SWT.MOD1 | 'Z', null, actions, "doMenuEditUndo"); //$NON-NLS-1$
			tmp.setEnabled(!readOnly);

			// Redo
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.redo"), "Ctrl+Y", //$NON-NLS-1$ //$NON-NLS-2$
					redoShortcut, null, actions, "doMenuEditRedo"); //$NON-NLS-1$
			tmp.setEnabled(!readOnly);

			SWTMenuUtils.addSeparator(menu);

			// Cut
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.cut"), "Ctrl+X", //$NON-NLS-1$ //$NON-NLS-2$
					SWT.MOD1 | 'X', null, actions, "doMenuEditCut"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly, null);

			// Copy
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.copy"), "Ctrl+C", //$NON-NLS-1$ //$NON-NLS-2$
					SWT.MOD1 | 'C', null, actions, "doMenuEditCopy"); //$NON-NLS-1$
			TextSelectionMenuItemEnabler.register(textBox, tmp);

			// Paste
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.paste"), "Ctrl+V", //$NON-NLS-1$ //$NON-NLS-2$
					SWT.MOD1 | 'V', null, actions, "doMenuEditPaste"); //$NON-NLS-1$
			tmp.setEnabled(!readOnly);

			// Nbv{[hp
			tmp = SWTMenuUtils.addMenuItem(menu,//
					mm.get("SWTMessageWindow.menu.file.quoteClipboard"), //$NON-NLS-1$
					"Ctrl+Shift+B", SWT.MOD1 | SWT.MOD2 | 'B', //$NON-NLS-1$
					null, actions, "doMenuFileQuoteClipboard"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly,
					ClipboardMenuItemEnabler.PURE_TEXT);

			// 摜\t
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.pasteImage"), //$NON-NLS-1$
					"Ctrl+Alt+I", SWT.MOD1 | SWT.MOD3 | 'I', //$NON-NLS-1$
					null, actions, "doMenuEditPasteImage"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly,
					ClipboardMenuItemEnabler.IMAGE);

			// eLXg\t
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.pasteText"), //$NON-NLS-1$
					"Ctrl+Alt+T", SWT.MOD1 | SWT.MOD3 | 'T', //$NON-NLS-1$
					null, actions, "doMenuEditPasteAsText"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly, ClipboardMenuItemEnabler.TEXT);

			// Ytt@CƂē\t
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.pasteAsAttachment"), //$NON-NLS-1$
					"Ctrl+Shift+V", SWT.MOD1 | SWT.MOD2 | 'V', null, //$NON-NLS-1$
					actions, "doMenuEditPasteAsAttachment"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly,
					ClipboardMenuItemEnabler.ATTACHMENT);

			// GfB^̃eLXg̍폜
			tmp = SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.edit.delete"), //$NON-NLS-1$
					"Delete", 0, null, //$NON-NLS-1$
					actions, "doMenuEditDelete"); //$NON-NLS-1$
			setEditMenuItemEnabled(tmp, readOnly, null);

			createMenuItemsForEditEtc(menu, true);
		}

		/**
		 * ҏWj[ڂenabledw肵܂B
		 * 
		 * @param item j[
		 * @param readOnly eLXg{bNXǂݍݐp̂Ƃtrue
		 * @param trs ClipboardMenuItemEnablergɎw肷
		 */
		private void setEditMenuItemEnabled(MenuItem item, boolean readOnly,
				Transfer[] trs) {
			if (readOnly) {
				item.setEnabled(false);
			} else {
				if (trs == null) {
					TextSelectionMenuItemEnabler.register(textBox, item);
				} else {
					ClipboardMenuItemEnabler.register(item, trs);
				}
			}
		}

		/**
		 * upXƂĊJvuׂđIṽj[ڂ𐶐܂B
		 * @param menu ẽj[
		 * @param addOpenSelectionAsPath upXƂĊJvǉꍇtrue
		 */
		private void createMenuItemsForEditEtc(Menu menu,
				boolean addOpenSelectionAsPath) {
			SWTMenuUtils.addSeparator(menu);

			if (addOpenSelectionAsPath) {

				// pXƂĊJ
				MenuItem pathMenuItem = SWTMenuUtils.addMenuItem(menu, //
						mm.get("SWTMessageWindow.menu.file.openAsPath"), //$NON-NLS-1$
						"Ctrl+E", SWT.MOD1 | 'E', null, //$NON-NLS-1$
						actions, "doMenuFileOpenSelectionAsPath"); //$NON-NLS-1$
				TextSelectionMenuItemEnabler.register(textBox, pathMenuItem);
			}

			// ׂđI
			SWTMenuUtils.addMenuItem(menu,//
					mm.get("SWTMessageWindow.menu.file.selectAll"), //$NON-NLS-1$
					"Ctrl+A", SWT.MOD1 | 'A', null, actions, //$NON-NLS-1$
					"doMenuFileSelectAll"); //$NON-NLS-1$
		}

		/**
		 * Ytt@CgCɃ|bvAbvj[\z܂B
		 * 
		 * @param send Mp̏ꍇtrueAMp̏ꍇfalse
		 */
		private void createPopupMenuForTray(boolean send) {
			// TrayItem
			Menu popup = new Menu(shell, SWT.POP_UP);
			createMenuItemsForTrayItem(popup, false, send);
			iconTray.setItemMenu(popup);

			// Tray
			iconTray.getComposite().setMenu(createMenuItemsForTray(send));
			CocoaMenuDetectSuppressor.install(iconTray.getComposite());
		}

		/**
		 * Vj[:
		 * gCACe֘Ãj[𐶐܂B
		 * @param menu ẽj[
		 * @param addSeparator Zp[^ǉꍇtrue
		 * @param send MpȂtrueAMpȂfalse
		 */
		private void createMenuItemsForTrayItem(Menu menu,
				boolean addSeparator, boolean send) {
			if (addSeparator) {
				SWTMenuUtils.addSeparator(menu);
			}

			final List items = new ArrayList();
			// Ytt@CEtH_J
			items.add(SWTMenuUtils.addMenuItem(menu, mm
					.get("SWTMessageWindow.menu.file.open"), //$NON-NLS-1$
					"Enter", 0, null, //$NON-NLS-1$
					actions, "doPopupTrayOpenIconItem")); //$NON-NLS-1$

			// QuickLook
			if (Os.isMacOSX()) {
				int[] vers = Os.getOsVersion();
				if (vers.length >= 2 && vers[0] >= 10 && vers[1] >= 5) {
					// QuickLookpłLeopard 10.5ȍ~
					items.add(SWTMenuUtils.addMenuItem(menu, mm
							.get("SWTMessageWindow.menu.file.quickLook"), //$NON-NLS-1$
							"", SWT.MOD1 | 'Y', null, actions, //$NON-NLS-1$
							"doMenuFileQuickLook", false)); //$NON-NLS-1$
				}
			}

			// Yt摜ҏW
			final MenuItem editImage = SWTMenuUtils.addMenuItem(menu,//
					mm.get("SWTMessageWindow.menu.file.editImage"), //$NON-NLS-1$
					"", 0, null, //$NON-NLS-1$
					actions, "doPopupTrayEditImageIconItem"); //$NON-NLS-1$
			menu.addMenuListener(new MenuListener() {
				public void menuShown(MenuEvent e) {
					String editor = pref.getGraphicEditor();
					if (editor == null || editor.length() == 0) {
						// ݒ̏ꍇ
						editImage.setEnabled(false);
						return;
					}

					String path = getSelectedAttachmentPath();
					editImage.setEnabled(Tool.isImageFile(path));
				}

				public void menuHidden(MenuEvent e) {
					editImage.setEnabled(true);
				}
			});

			// ̃tH_J
			items.add(SWTMenuUtils.addMenuItem(menu,//
					mm.get("SWTMessageWindow.menu.file.openParentFolder"), //$NON-NLS-1$
					"Shift+Enter", 0, null, //$NON-NLS-1$
					actions, "doPopupTrayOpenParentFolder")); //$NON-NLS-1$

			// nbVlvZ
			items.add(SWTMenuUtils.addMenuItem(
					menu,
					mm.get("SWTMessageWindow.menu.file.calculateAndCopyHashValue"), //$NON-NLS-1$
					"", 0, null, actions, //$NON-NLS-1$
					"doPopupTrayCalculateAndCopyHashValue")); //$NON-NLS-1$

			SWTMenuUtils.addSeparator(menu);

			if (send) {
				// Yt
				items.add(SWTMenuUtils.addMenuItem(menu,//
						mm.get("SWTMessageWindow.menu.file.releaseAttachment"), //$NON-NLS-1$
						"Delete", 0, null, actions, "doPopupTrayDeleteItem")); //$NON-NLS-1$ //$NON-NLS-2$

			} else {
				// 폜
				items.add(SWTMenuUtils.addMenuItem(menu,//
						mm.get("SWTMessageWindow.popup.deleteAttachment"), //$NON-NLS-1$
						"Delete", 0, null, //$NON-NLS-1$
						actions, "doPopupTrayDeleteItem")); //$NON-NLS-1$

			}

			SWTMenuUtils.addSeparator(menu);

			// Ytt@C̖OύX
			items.add(SWTMenuUtils.addMenuItem(menu, //
					mm.get("SWTMessageWindow.menu.file.renameAttachment"), //$NON-NLS-1$
					"F2", SWT.F2, null, actions, "doMenuFileRename")); //$NON-NLS-1$ //$NON-NLS-2$

			// Ytt@CIĂƂ̂enabled
			menu.addMenuListener(new MenuAdapter() {
				public void menuShown(MenuEvent e) {
					boolean enabled = message.hasAttachment()
							&& iconTray.getSelectionIndex() != -1;
					SWTMenuUtils.setEnabled(items, enabled);
				}

				public void menuHidden(MenuEvent e) {
					SWTMenuUtils.setEnabled(items, true);
				}
			});
		}

		/**
		 * Vj[:
		 * gCp̃|bvAbvj[𐶐܂B
		 * @param send Mp̎true, Mp̎false
		 * @return |bvAbvj[
		 */
		private Menu createMenuItemsForTray(boolean send) {
			Menu popup = new Menu(shell, SWT.POP_UP);

			// u...Ytv܂́uׂĂ̓Ytt@Cۑv
			createMenuItemsForAttachment(popup, false, send);

			// ؂ApXƂĊJAׂđI
			createMenuItemsForEditEtc(popup, false);

			return popup;
		}

		/**
		 * Vj[:
		 * Ytt@C֘Ãj[ڂ𐶐܂B
		 * @param menu ẽj[
		 * @param addSeparator 擪ɃZp[^ǉꍇtrue
		 * @param send VKEMp̏ꍇtrue, Mp̏ꍇfalse
		 */
		private void createMenuItemsForAttachment(Menu menu,
				boolean addSeparator, boolean send) {

			if (addSeparator) {
				SWTMenuUtils.addSeparator(menu);
			}

			MenuItem tmp;
			if (send) {
				// t@C̓Yt
				SWTMenuUtils.addMenuItem(menu, //
						mm.get("SWTMessageWindow.menu.file.attachFile"), //$NON-NLS-1$
						"Ctrl+T", SWT.MOD1 | 'T', //$NON-NLS-1$
						img.getImage("white.gif"), //$NON-NLS-1$
						actions, "doMenuFileAttachFile"); //$NON-NLS-1$

				// tH_̓Yt
				SWTMenuUtils.addMenuItem(menu, //
						mm.get("SWTMessageWindow.menu.file.attachFolder"), //$NON-NLS-1$
						"Ctrl+Shift+T", SWT.MOD1 | SWT.MOD2 | 'T', //$NON-NLS-1$
						img.getImage("folder.gif"), //$NON-NLS-1$
						actions, "doMenuFileAttachFolder"); //$NON-NLS-1$

				//Nbv{[h̉摜Yt
				tmp = SWTMenuUtils
						.addMenuItem(
								menu,
								mm
										.get("SWTMessageWindow.menu.file.attachImageInClipboard"), //$NON-NLS-1$
								"Shift+Alt+I", SWT.MOD2 | SWT.MOD3 | 'I', //$NON-NLS-1$
								img.getImage("white.gif"), //$NON-NLS-1$
								actions, "doMenuFileAttachClipboardImage"); //$NON-NLS-1$
				ClipboardMenuItemEnabler.register(tmp,
						ClipboardMenuItemEnabler.IMAGE);

				//Nbv{[h̃eLXgYt
				tmp = SWTMenuUtils
						.addMenuItem(
								menu,
								mm
										.get("SWTMessageWindow.menu.file.attachTextInClipboard"), //$NON-NLS-1$
								"Shift+Alt+T", SWT.MOD2 | SWT.MOD3 | 'T', //$NON-NLS-1$
								img.getImage("white.gif"), //$NON-NLS-1$
								actions, "doMenuFileAttachClipboardText"); //$NON-NLS-1$
				ClipboardMenuItemEnabler.register(tmp,
						ClipboardMenuItemEnabler.PURE_TEXT);

				// Nbv{[h̃t@CYt
				tmp = SWTMenuUtils
						.addMenuItem(
								menu,
								mm
										.get("SWTMessageWindow.menu.file.attachFileInClipboard"), //$NON-NLS-1$
								"Shift+Alt+F", SWT.MOD2 | SWT.MOD3 | 'F', //$NON-NLS-1$
								img.getImage("white.gif"), //$NON-NLS-1$
								actions, "doMenuFileAttachClipboardFile"); //$NON-NLS-1$
				ClipboardMenuItemEnabler.register(tmp,
						ClipboardMenuItemEnabler.FILE);

			} else {
				// ׂĂ̓Ytۑ
				final MenuItem saveAll = SWTMenuUtils.addMenuItem(menu, //
						mm.get("SWTMessageWindow.popup.saveAllAttachments"), //$NON-NLS-1$
						"Ctrl+Shift+S", SWT.MOD1 | SWT.MOD2 | 'S', //$NON-NLS-1$
						null, actions, "doPopupTraySaveAllAttachments"); //$NON-NLS-1$
				menu.addMenuListener(new MenuListener() {
					public void menuShown(MenuEvent e) {
						saveAll.setEnabled(message.hasAttachment());
					}

					public void menuHidden(MenuEvent e) {
						saveAll.setEnabled(true);
					}
				});
			}
		}

		/**
		 * Ytt@Cꍇ̓_E[hXi[ݒ肵܂B
		 */
		private void setDownloadListener() {
			if (!message.hasAttachment()) {
				return;
			}
			Iterator itr = message.attachments.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				att.listener = this;
			}
		}

		/**
		 * bZ[ŴƂɑMł邩ǂlđMł邩Ԃ܂B
		 * <p>
		 * ĂȂ\MessageIuWFNgł͂ȂAeLXg{bNXɂ܂B
		 * @return M\ȏꍇ true
		 */
		boolean isSendableMessage() {
			if (!pref.getNeverSendEmptyMessage()) {
				return true;
			}
			String str = textBox.getText();
			if (str == null || str.length() == 0) {
				return false;
			}
			return true;
		}

		/**
		 * ԐMpSWTMessageWindow擾܂B
		 * Đ͐ݒ肳Ă܂B
		 * @param quote ԐM̃bZ[Wpꍇtrue
		 * @return ԐMpSWTMessageWindowBopen()ς݁B
		 */
		private SWTMessageWindow getReplyWindow(boolean quote) {
			String quotation;
			if (quote) {
				quotation = pref.getQuoteString();
			} else {
				quotation = null;
			}

			boolean moveCursorToLast = pref.getMoveCursorToLast();

			Message replyMessage = message.createReplyMessage(quotation,
					!moveCursorToLast);

			return SWTMessageWindow.openNewMessageWindow(main, pref, facade,
					msgLogger, replyMessage, quote && moveCursorToLast, false);
		}

		/**
		 * J[\Ō̈ʒuɈړ܂B
		 */
		private void moveCursorToLast() {
			int last = textBox.getText().length() + 1;
			textBox.setSelection(last);
			textBox.showSelection();
		}

		/**
		 * SashForm𐶐܂B
		 * @return SashForm
		 */
		private SashForm createSashForm() {
			SashForm sash = new SashForm(shell, SWT.VERTICAL);
			sash.setLayout(new FillLayout());
			return sash;
		}

		/**
		 * hbO\[Xݒ肵܂B
		 */
		private void setDragSource() {
			DragSource src = new DragSource(iconTray, DND.DROP_MOVE);
			src.setTransfer(new Transfer[] { FileTransfer.getInstance() });
			src.addDragListener(new AttachmentServer());
		}

		/**
		 * hbv^[Qbgݒ肵܂B
		 * @param drop hbv^[QbgXi[
		 * @param control ^[QbgɂȂRg[
		 */
		private void setDropTarget(AttachmentReceiver drop, Control control) {
			DropTarget target = new DropTarget(control, DND.DROP_DEFAULT
					| DND.DROP_MOVE);
			target.setTransfer(new Transfer[] { FileTransfer.getInstance() });
			target.addDropListener(drop);
		}

		/**
		 * (Mp)iconTrayɃV[gJbgݒ肵܂B
		 */
		private void setIconTrayShortcutForSend() {
			iconTray.getComposite()
					.addKeyListener(new IconTrayShortcutAction());
		}

		/** sashForm̃EFCgݒ */
		private void setSashFormWeight() {
			if (message.trayRatio != null && message.trayRatio.length == 2) {
				sashForm.setWeights(message.trayRatio);
			} else {
				// 
				int height = shell.getSize().y;
				int trayHeight = 45;
				if (height <= trayHeight) {
					trayHeight = height / 2;
				}
				sashForm
						.setWeights(new int[] { height - trayHeight, trayHeight });
			}
		}

		/**
		 * sR[h̓AUndo̎Ws܂B
		 */
		private final class TextBoxVerifyListener extends SelectionAdapter
				implements VerifyListener, TextChangeListener,
				VerifyKeyListener {

			public void verifyKey(VerifyEvent ev) {
				/*
				 * IME͒Alt+Enter ܂ Shift+Ctrl+Enter ܂ Cmd+Return 
				 * IllegalArgumentException: Index out of bounds at TextLayout.java:2377
				 * ɂȂ
				 */
				if ((ev.stateMask & SWT.MODIFIER_MASK) != 0
						&& SWTUtils.isIMEEditing(ev.widget)) {
					ev.doit = false;
					return;
				} else if (ev.character == '\u200B' || ev.character == '\uFEFF') {
					// ZERO WIDTH SPACE' (U+200B), 'ZERO WIDTH NO-BREAK SPACE' (U+FEFF)͂łȂ悤ɂB
					ev.doit = false;
					return;
				}
			}

			public void verifyText(VerifyEvent ev) {
				if (ev.widget instanceof StyledText) {
					StyledText widget = (StyledText) ev.widget;
					// ݂sR[h𓝈
					if (ev.text.length() > 1
							|| (ev.text.equals("\r") || ev.text.equals("\n"))) { //$NON-NLS-1$ //$NON-NLS-2$
						ev.text = Tool.convertLineDelimiter(ev.text, widget
								.getLineDelimiter());
					}

					UndoStack stack = getUndoStack(false, false);
					if (stack.underOperation) {
						return;
					}
					// UndoW
					TextUndoCommand undo = new TextUndoCommand();
					undo.offset = ev.start;
					if (ev.start == ev.end) {
						undo.replaced = ""; //$NON-NLS-1$
					} else {
						undo.replaced = widget.getText(ev.start, ev.end - 1);

						int index = undo.replaced.indexOf('\uFFFC');
						while (index != -1) {
							StyleRange style = widget
									.getStyleRangeAtOffset(ev.start + index);
							Attachment att = disposeAttachedImage(style, true);
							if (att != null) {
								att.setPlatformIndex(ev.start + index);
								undo.addReplacedObject(att);
							}
							index = undo.replaced.indexOf('\uFFFC', index + 1);
						}
					}
					undo.inserted = ev.text;
					// ύX̉摜́AĂяostackɓo^
					stack.push(undo, false);
				}
			}

			public void widgetSelected(SelectionEvent ev) {
				/*
				 * IԂIMELɂē͂
				 * ueLXgtextChanging()ł킩ȂB
				 * textChanging()ł̓X^CɃANZXłȂ߁A
				 * Ń[Nƍ郊\[XW߂B
				 */
				registerSelection(ev.x != ev.y, ev.x, ev.y - ev.x);
			}

			public void textChanging(TextChangingEvent ev) {
				/*
				 * IԂIMELɂē͂
				 * mOɑIeLXg폜B
				 * 폜eLXgtextChangingł킩ȂB
				 * ł͍폜̑̂UndoX^bNɋL^B
				 */
				if (textBox.getIME().getCompositionOffset() >= 0 && selected
						&& ev.newCharCount > 0 && ev.replaceCharCount > 0) {
					UndoStack stack = getUndoStack(false, false);
					if (stack.underOperation) {
						return;
					}
					TextUndoCommand undo = new TextUndoCommand();
					undo.offset = ev.start;
					undo.replaced = textBox.getTextRange(ev.start,
							ev.replaceCharCount);
					undo.inserted = ""; //$NON-NLS-1$
					if (selectedStyles != null && selectedStyles.length > 0) {
						for (int i = 0; i < selectedStyles.length; i++) {
							Attachment att = disposeAttachedImage(
									selectedStyles[i], true);
							if (att != null) {
								undo.addReplacedObject(att);
							}
						}
					}
					stack.push(undo, false);
					// ێĂI͈͂NA
					registerSelection(false, 0, 0);
				}
			}

			public void textChanged(TextChangedEvent ev) {
				// ignore
			}

			public void textSet(TextChangedEvent ev) {
				// ignore
			}
		}

		/**
		 * (Mp){^̃NbN
		 */
		private final class ButtonItemClicked extends SelectionAdapter {
			public void widgetSelected(SelectionEvent event) {
				LabeledIconItem item = (LabeledIconItem) event.item;
				OpenStyle s = (OpenStyle) currentStyle;
				int number = s.iconTray.indexOf(item);
				Attachment att = (Attachment) message.attachments.get(number);
				if (att.status >= Attachment.STATUS_WAIT) {
					// ~
					suspend(item, att);
				} else {
					// VKEĊJ
					actions.download(item, att);
				}
			}

			/**
			 * ꎞ~
			 * @param item ACe
			 * @param att Ytt@C
			 */
			private void suspend(LabeledIconItem item, Attachment att) {
				item.setEnabled(false);
				facade.cancelDownload(message.launchId, att);
			}
		}

		/**
		 * (Mp)ACR̃_uNbN,EnterL[
		 */
		private final class IconOpener extends SelectionAdapter {
			public void widgetSelected(SelectionEvent event) {

				LabeledIconItem item = (LabeledIconItem) event.item;
				int number = iconTray.indexOf(item);
				Attachment att = (Attachment) message.attachments.get(number);
				if (event.stateMask == SWT.NONE) {
					// J
					openIconItem(att);
				} else if (event.stateMask == SWT.MOD2/* SHIFT */) {
					openIconItemParent(att);
				}
			}
		}

		/**
		 * (Mp)hbO\[X
		 */
		private final class AttachmentServer implements DragSourceListener {
			public void dragStart(DragSourceEvent event) {
				event.doit = true;
			}

			public void dragSetData(DragSourceEvent event) {
				int[] items = iconTray.getSelectionIndices();
				HashSet set = new HashSet(items.length);
				for (int i = 0; i < items.length; i++) {
					Attachment att = (Attachment) message.attachments
							.get(items[i]);
					set.add(att.localPath);
				}
				if (set.isEmpty()) {
					event.doit = false;
				} else {
					event.data = set.toArray(new String[set.size()]);
				}
			}

			public void dragFinished(DragSourceEvent event) {
				// t@C̈ړ悪킩ȂUndosɂ
				UndoStack stack = getUndoStack(false, true);
				try {
					if (event.detail == DND.DROP_TARGET_MOVE) {
						// ACeAttachment̍폜
						int[] indices = iconTray.getSelectionIndices();
						iconTray.remove(indices);
						for (int i = indices.length - 1; i >= 0; i--) {
							Attachment att = message
									.removeAttachment(indices[i]);
							deleteInlineAttachment(att, false);
						}
						iconTray.layout();
					} else {
						logger.debug("dragFinished:event.detail=" //$NON-NLS-1$
								+ event.detail);
					}
				} finally {
					if (stack != null && event.detail != DND.DROP_NONE) {
						stack.clear();
					}
				}
			}
		}

		/**
		 * (Mp)hbv^[Qbg
		 */
		private final class AttachmentReceiver extends DropTargetAdapter {
			public void drop(DropTargetEvent event) {
				//System.out.println("hbv" + event.data);
				if (event.data == null) {
					event.detail = DND.DROP_NONE;
					return;
				}
				if (event.data instanceof String[]) {
					String[] paths = (String[]) event.data;
					// ŏ̃hbvŃCC摜ɂ邩ǂq˂
					boolean inline = true;
					if (iconTray == null) {
						for (int i = 0; i < paths.length; i++) {
							if (isSupportedExtention(paths[i])
									&& new File(paths[i]).isFile()) {
								inline = SWTUtils
										.showConfirm(
												shell,
												mm.get("SWTMessageWindow.droppedImage.title"), //$NON-NLS-1$
												mm.get("SWTMessageWindow.droppedImage.msg")); //$NON-NLS-1$
								break;
							}
						}
					}
					for (int i = 0; i < paths.length; i++) {

						// PNGeLXg{bNXɃhbvCC摜ɂ
						try {
							if (inline && isSupportedExtention(paths[i])) {
								File f = new File(paths[i]);
								if (f.isFile()) {
									if (event.widget instanceof DropTarget) {
										DropTarget target = (DropTarget) event.widget;
										if (target.getControl() instanceof StyledText) {
											StyledText text = (StyledText) target
													.getControl();
											Point selection = text
													.getSelection();
											setInlineImageWithUndo(null,
													selection.x, null, f
															.getAbsolutePath(),
													true, selection.x + 1);
											continue;
										}
									}
								}
							}
						} catch (IOException e) {
							logger.warn("Failed to load an image:" + paths[i], //$NON-NLS-1$
									e);
						}

						// ǉ
						addAttachment(paths[i]);
						// ăCAEg̗}
						if (iconTray == null) {
							/*
							 * Ytt@C̒ǉs
							 * iconTraynull̂܂܂ɂȂANPEɂȂB
							 * ͕R[hɂ́Aǂ߂Ȃt@CB
							 */
							StringBuffer sb = new StringBuffer(
									"iconTray was not generated. path="); //$NON-NLS-1$
							Tool.dumpCharCode(sb, paths[i]);
							logger.warn(sb);
						} else {
							iconTray.setSuppressLayout(true);
						}
					}
					if (iconTray != null) {
						iconTray.setSuppressLayout(false);
					}
				}
			}
		}

		/**
		 * CC摜ƂăT|[gĂgqǂԂ܂B
		 * @param path t@CpX
		 * @return T|[gĂꍇtrue
		 */
		private boolean isSupportedExtention(String path) {
			return path.endsWith(".png"); //$NON-NLS-1$
		}

		/**
		 * EBhETCY܂B
		 * 
		 * @param command 0: eɂ킹, -1: k
		 * @category window_size
		 */
		private void resizeWindow(int command) {
			Rectangle shellRect = shell.getBounds();
			Rectangle client = SWTUtils.getMonitorClientByCoordinate(
					shellRect.x, shellRect.y, display);
			boolean glueRight = SWTUtils.isSharedBorderRight(client, shellRect);
			boolean glueBottom = SWTUtils.isSharedBorderBottom(client,
					shellRect);

			switch (command) {
			case -1:
				// k
				shellRect.width = Math.max(shellRect.width - 32, 100);
				shellRect.height = Math.max(shellRect.height - 32, 100);
				break;
			case 0:
				// eɂ킹
				// eLXg{bNX̉ɂ
				String text = textBox.getText();
				Point textSize;
				if (text != null && text.length() > 0) {
					textSize = textBox.computeSize(SWT.DEFAULT, SWT.DEFAULT,
							true);
					// ɒꍇz肵čČvZ
					textSize.x = Math.min(textSize.x, client.width - 20);
					textSize = textBox.computeSize(textSize.x, SWT.DEFAULT,
							true);
				} else {
					textSize = textBox.getSize();
				}

				Point size = shell.computeSize(textSize.x, SWT.DEFAULT);
				shellRect.width = size.x;
				shellRect.height = size.y;
				SWTUtils.moveAndPack(client, shellRect);
				break;
			case 2:
				// Œ肵ēeɂ킹(𒲐߂)
				textSize = textBox.getSize();
				size = shell.computeSize(textSize.x, SWT.DEFAULT);
				shellRect.width = size.x;
				shellRect.height = size.y;
				SWTUtils.moveAndPack(client, shellRect);
				break;
			case 1:
				// g
				shellRect.width += 32;
				shellRect.height += 32;
				shellRect.width = Math.min(shellRect.width, client.width);
				shellRect.height = Math.min(shellRect.height, client.height);
				if (shellRect.x + shellRect.width > client.x + client.width) {
					shellRect.x = client.x + client.width - shellRect.width;
				}
				if (shellRect.y + shellRect.height > client.y + client.height) {
					shellRect.y = client.y + client.height - shellRect.height;
				}
				break;
			case 3:
				// cɑ傫
				shellRect.height += 32;
				if (shellRect.y + shellRect.height > client.y + client.height) {
					shellRect.y = client.y + client.height - shellRect.height;
				}
				break;
			}

			if (glueRight || glueBottom) {
				if (glueRight) {
					shellRect.x = client.x + client.width - shellRect.width;
				}
				if (glueBottom) {
					shellRect.y = client.y + client.height - shellRect.height;
				}
			}
			shell.setBounds(shellRect);
		}

		/**
		 * StyleRangeImage擾Ĕj܂B
		 * <p>
		 * t@CɕۑĂꍇ͓Yt܂B
		 * 
		 * @param style X^C
		 * @param release YtꍇtrueBPɃEBWFbgjƂfalseB
		 * @return jImageێĂAttachmentBstylenull̂ƂnullAstyle.dataAttachmentȊÔƂnullԂ܂B
		 */
		private Attachment disposeAttachedImage(StyleRange style,
				boolean release) {
			if (style != null && style.data instanceof Attachment) {
				Attachment att = (Attachment) style.data;
				if (att.data == null) {
					return att;
				}
				Image image = (Image) att.data;
				if (release) {
					// Undop
					att.setPlatformIndex(style.start);
					att.data = image.getImageData();
				} else {
					att.data = null;
				}
				image.dispose();
				logger.info("Inline image was disposed."); //$NON-NLS-1$
				// ۑς݃CC摜̓Yt
				if (release && att.localPath != null) {
					removeAttachment(att);
				}
				return att;
			}
			return null;
		}

		/**
		 * messageƓYtt@CgCw肳ꂽAttachmentYt܂B
		 * @param att 폜Ytt@C
		 */
		private void removeAttachment(Attachment att) {
			for (int i = message.attachments.size() - 1; i >= 0; i--) {
				if (att.equals(message.attachments.get(i))) {
					message.removeAttachment(i);
					if (iconTray != null && !iconTray.isDisposed()
							&& i < iconTray.getItemCount()) {
						iconTray.remove(i);
					}
					break;
				}
			}
		}

		/**
		 * (Mp)ACeǉ܂B
		 * @param path t@CEtH_̃pX
		 */
		private void addAttachment(String path) {
			Attachment att = message.addAttachment(path);
			if (att == null) {
				return;
			}
			addAttachmentToTray(att);
		}

		/**
		 * CC摜̕ۑɃACeǉ܂B
		 * @param att Yt
		 */
		private void addAttachment(Attachment att) {
			if (att == null) {
				return;
			}
			if (!att.getFileInfo()) {
				return;
			}
			message.addAttachment(att);
			addAttachmentToTray(att);
		}

		/**
		 * ACeǉ܂B
		 * @param att Ytt@C
		 */
		private void addAttachmentToTray(Attachment att) {
			//System.out.println("ǉ܂B");
			if (iconTray == null) {
				// gC̐message.attachments̔f
				createIconTray(sashForm);
				setSashFormWeight();

				// hbv^[Qbg
				AttachmentReceiver drop = new AttachmentReceiver();
				setDropTarget(drop, iconTray);
				// hbO\[X
				setDragSource();

				// I[vAENbN,V[gJbg
				iconTray.addIconOpenListener(actions);
				actions.register(iconTray, "doTrayIconOpen"); //$NON-NLS-1$
				createPopupMenuForTray(true);
				setIconTrayShortcutForSend();
			} else {
				// gCɒǉ
				int style = att.localPath == null ? SWT.PUSH : SWT.NONE;
				LabeledIconItem item = new LabeledIconItem(iconTray, style);
				setTrayItemIcon(att, item);
				item.setText(att.name);
				item.setToolTipText(att.getToolTipText(true));
			}
		}

		/**
		 * TrayItemɃACRݒ肵܂B
		 * @param att Ytt@C
		 * @param item TrayItem
		 */
		private void setTrayItemIcon(Attachment att, LabeledIconItem item) {
			if (att.type == Attachment.TYPE_DIR) {
				item.setImage(img.getImage("folder.gif")); //$NON-NLS-1$
			} else {
				item.setImage(img.getImage(Tool.getExtention(att.name)));
			}
		}

		/**
		 * Undo/Redo
		 * @param redo Redȍꍇtrue
		 */
		void undoRedo(boolean redo) {
			UndoStack stack = getUndoStack(false, true);
			try {
				TextUndoCommand undo = redo ? stack.getRedo() : stack.getUndo();
				if (undo == null) {
					logger.debug("Undo/Redo: n/a"); //$NON-NLS-1$
					return;
				}
				String inserted = redo ? undo.replaced : undo.inserted;
				List insertedObjects = redo ? undo.replacedObjects
						: undo.insertedObjects;
				String replaced = redo ? undo.inserted : undo.replaced;
				List replacedObjects = redo ? undo.insertedObjects
						: undo.replacedObjects;

				if (insertedObjects != null && !insertedObjects.isEmpty()) {
					for (int i = 0; i < insertedObjects.size(); i++) {
						Attachment att = (Attachment) insertedObjects.get(i);
						if (att.data instanceof Image) {
							att.data = ((Image) att.data).getImageData();
						}
						if (att.localPath != null) {
							// Yt
							removeAttachment(att);
						}
					}
				}
				textBox.replaceTextRange(undo.offset, inserted.length(),
						replaced);
				// CC摜̕
				if (replacedObjects != null && !replacedObjects.isEmpty()) {
					for (int i = 0; i < replacedObjects.size(); i++) {
						Attachment att = (Attachment) replacedObjects.get(i);
						att = att.duplicate(true);
						try {
							loadAttachmentImage(att);
						} catch (IOException e) {
							// Ԃ񖳂
							logger.error("Could not load image.", e); //$NON-NLS-1$
						}
						setInlineImage(att, textBox.getText(), att
								.getPlatformIndex(), false);
						if (att.localPath != null) {
							// messageƓYtgCɒǉ
							addAttachment(att);
						}
					}
				}

				if (redo) {
					textBox.setCaretOffset(undo.offset + replaced.length());
				}

			} finally {
				stack.underOperation = false;
			}
		}

		/**
		 * Undoobt@NA܂B
		 * underOperation tO false ɐݒ肵܂B
		 */
		private void clearUndoBuffer() {
			UndoStack stack = getUndoStack(false, false);
			if (stack != null)
				stack.clear();
		}

		/**
		 * UndoStack擾܂B
		 * @param setUnmergeable ŌUndoR}hmergeabletOfalseɐݒ肷ꍇtrue
		 * @param startOperation underOperationtOtrueɐݒ肷ꍇtrue
		 * @return UndoStack
		 */
		private UndoStack getUndoStack(boolean setUnmergeable,
				boolean startOperation) {
			UndoStack stack = (UndoStack) textBox
					.getData(UndoStack.KEY_UNDO_STACK);
			if (stack != null) {
				if (setUnmergeable) {
					stack.setUnmergeable();
				}
				if (startOperation) {
					stack.underOperation = true;
				}
			}
			return stack;
		}

		/**
		 * IɌĂяođI͈͂̃X^Cێ܂B
		 * <p>
		 * X^CIMEoRŏ㏑ꍇ textChanging() Ŏgp܂B
		 * @param select Iꍇtrue, Iꍇfalse
		 * @param start IJn
		 * @param length I钷
		 */
		void registerSelection(boolean select, int start, int length) {
			selected = select;
			if (select) {
				selectedStyles = textBox.getStyleRanges(start, length);
			} else {
				selectedStyles = null;
			}
		}

		/**
		 * eLXg{bNX𐶐܂B
		 * @param parent eEBWFbg
		 * @param readOnly truêƂҏWsɂ܂B
		 */
		private void createTextBox(Composite parent, boolean readOnly) {
			this.textBox = new StyledText(parent, SWT.MULTI | SWT.BORDER
					| SWT.V_SCROLL | SWT.WRAP);
			setFont();
			setTabWidth();

			textBox.setText(message.message);
			textBox.addWordMovementListener(blockMovementListener);

			Menu menu = new Menu(textBox);
			createMenuItemsForEdit(menu, readOnly);
			textBox.setMenu(menu);

			// _E[hς݂̃CC摜ݒ肷
			setInlineImages();

			// I
			int s = message.selectionStart;
			int e = message.selectionEnd;
			boolean select = true;

			if (s < 0 || s > message.message.length() || s > e) {
				select = false;
				message.selectionStart = 0;
				message.selectionEnd = 0;
			}
			if (e < 0 || e > message.message.length()) {
				select = false;
				message.selectionStart = 0;
				message.selectionEnd = 0;
			}
			if (select) {
				// I͈
				textBox.setSelection(s, e);
				if (e - s > 0) {
					registerSelection(true, s, e - s);
				}

				// \ʒu
				if (message.topIndex >= 0
						&& message.topIndex < textBox.getLineCount()) {
					textBox.setTopIndex(message.topIndex);
				}
			}

			// ҏWs
			if (readOnly) {
				this.textBox.setEditable(false);
				this.textBox.setBackground(shell.getDisplay().getSystemColor(
						SWT.COLOR_LIST_BACKGROUND));
			} else {
				textBox.setData(UndoStack.KEY_UNDO_STACK, new UndoStack());
				TextBoxVerifyListener verifyListener = new TextBoxVerifyListener();
				textBox.addVerifyKeyListener(verifyListener);
				textBox.addVerifyListener(verifyListener);
				textBox.addSelectionListener(verifyListener);
				textBox.getContent().addTextChangeListener(verifyListener);
			}

			// F
			if (message.color != null) {
				color = new Color(shell.getDisplay(), message.color[0],
						message.color[1], message.color[2]);
				textBox.setForeground(color);
			}

			// \[X̔j
			textBox.addListener(SWT.Dispose, this);

			// CC摜̕`
			textBox.addPaintObjectListener(getInlineImagePainter());
		}

		/**
		 * CC摜ݒ肵܂B
		 */
		private void setInlineImages() {
			Collection atts = message.getInlineAttachments(true);
			if (atts == null || atts.isEmpty()) {
				return;
			}
			Iterator itr = atts.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				if ((att.status == Attachment.STATUS_FINISHED || att.status == Attachment.STATUS_NONE)
						&& att.localPath != null) {
					try {
						loadAttachmentImage(att);
						setInlineImage(att, message.message, -1, false);
					} catch (IOException e) {
						logger.error("Could not load image.", e); //$NON-NLS-1$
					}
				}
			}
		}

		/**
		 * localPathɐݒ肳ꂽpX摜[h܂B
		 * <p>
		 * data ImageData ݒ肳Ăꍇ͂gp܂B
		 * 
		 * @param att Ytt@C
		 * @throws IOException 摜t@C[hłȂꍇ
		 */
		private void loadAttachmentImage(Attachment att) throws IOException {
			// TODO obNOEhŏ
			if (att.data instanceof Image) {
				Image image = (Image) att.data;
				if (!image.isDisposed()) {
					image.dispose();
				}
				att.data = null;
			} else if (att.data instanceof ImageData) {
				att.data = new Image(display, (ImageData) att.data);
				return;
			}
			try {
				ImageLoader loader = new ImageLoader();
				ImageData[] data = loader.load(att.localPath);
				att.data = new Image(display, data[0]);
			} catch (SWTException e) {
				throw Tool.newIOException("Could not load image:" //$NON-NLS-1$
						+ att.localPath, e);
			}
		}

		/**
		 * CC摜ݒ肵܂B
		 * 
		 * @param att Ytt@CBdataImageݒ肳ĂKv܂B
		 * @param messageText bZ[W{Bmessage.message܂textBox.getText()BplatformIndexgpꍇnullB
		 * @param platformIndex J[\̃ItZbgB̒l̎Aatt.positionvZ܂
		 * @param insertPlaceholder v[Xz_}ꍇtrue
		 */
		private void setInlineImage(Attachment att, String messageText,
				int platformIndex, boolean insertPlaceholder) {

			StyleRange style = new StyleRange();
			style.length = 1;
			style.data = att;

			if (platformIndex >= 0) {
				style.start = platformIndex;
			} else {
				if (att.position < 0) {
					style.start = (att.position * -1) - 2;
				} else {
					style.start = Tool.getPlatformIndex(att.position,
							messageText, textBox.getLineDelimiter());
				}
			}

			if (insertPlaceholder) {
				textBox.replaceTextRange(style.start, 0, FFFC);
			} else {
				// 
				if (!textBox.getTextRange(style.start, style.length).equals(
						FFFC)) {
					logger.warn("Placeholder not found at " + style.start //$NON-NLS-1$
							+ ". The image was moved to last."); //$NON-NLS-1$
					textBox.append(FFFC);
					style.start = textBox.getText().length() - 1;
				}
			}

			Rectangle rect = ((Image) att.data).getBounds();
			style.metrics = new GlyphMetrics(rect.height, 0, rect.width);
			textBox.setStyleRange(style);
		}

		/**
		 * ^uw肵܂B
		 */
		private void setTabWidth() {
			/*
			 * Text#setTabs(int)̓Xy[X1̃sNZw肷B
			 * ^u̓Xy[X4B
			 * 0̏ꍇTextEBWFbg̃ftHggp܂B
			 */
			int tabWidth = pref.getTabWidthPx();
			if (tabWidth > 0) {
				this.textBox.setTabs(tabWidth / 4);
			}
		}

		/**
		 * eLXg{bNXɃtHgw肵܂B
		 */
		private void setFont() {
			if (!pref.useCustomFontInSimpleMessage()) {
				return;
			}

			String fontName = pref.getFontNameInSimpleMessage();
			int fontSize = pref.getFontSizeInSimpleMessage();
			String locale = pref.getFontLocaleInSimpleMessage();
			if (fontName == null || fontName.length() <= 0 || fontSize <= 0) {
				return;
			}

			FontData data = new FontData(fontName, fontSize, pref
					.getFontStyleInSimpleMessage());
			if (locale != null && locale.length() > 0) {
				data.setLocale(locale);
			}
			font = new Font(display, data);

			textBox.setFont(font);
		}

		/**
		 * ƃpX[h̃`FbN{bNX𐶐܂B
		 * @param parent eEBWFbg
		 */
		private void createCheckBoxes(Composite parent) {
			// `FbN{bNX
			// 
			checkBoxSealed = new Button(parent, SWT.CHECK);
			checkBoxSealed.setText(mm.get("SWTMessageWindow.sealed")); //$NON-NLS-1$

			// pX[h
			checkBoxPassword = new Button(parent, SWT.CHECK);
			checkBoxPassword.setText(mm.get("SWTMessageWindow.password")); //$NON-NLS-1$

			// `FbN{bNX̏
			if (message.isPasswordRequired) {
				checkBoxPassword.setSelection(true);
			}
			if (!message.isOpened) {
				checkBoxSealed.setSelection(true);
			} else {
				checkBoxPassword.setEnabled(false);
			}
			// Enable؂ւpXi[
			actions.registerAndAddListener(checkBoxSealed, "doCheckBoxSealed"); //$NON-NLS-1$
		}

		/**
		 * ACRgC𐶐܂B
		 * (EBhEX^CύXɂ镜p)<br>
		 * Xi[ނ͕ʓrB
		 * @param parent eEBWFbg
		 */
		private void createIconTray(Composite parent) {
			this.iconTray = new LabeledIconTray(parent, SWT.BORDER
					| SWT.V_SCROLL);
			this.iconTray.setSuppressLayout(true);
			// ACe̐
			Iterator itr = message.attachments.iterator();
			while (itr.hasNext()) {
				Attachment att = (Attachment) itr.next();
				int style;
				if (att.status == Attachment.STATUS_WAIT
						|| att.status == Attachment.STATUS_CONNECTED
						|| att.status == Attachment.STATUS_SUSPENDED
						|| att.status > 0) {
					style = SWT.PUSH;
				} else if (att.status == Attachment.STATUS_NONE
						&& att.localPath == null) {
					style = SWT.PUSH;
				} else {
					style = SWT.NONE;
				}

				LabeledIconItem item = new LabeledIconItem(iconTray, style);
				applyAttachment(att, item);
			}
			this.iconTray.setSuppressLayout(false);
		}

		/**
		 * Attachment̃f[^Itemɔf܂B
		 * @param att Ytt@C
		 * @param item ACe
		 */
		private void applyAttachment(Attachment att, LabeledIconItem item) {

			item.setRedraw(false);
			item.setText(att.name);
			item.setToolTipText(att.getToolTipText(true));

			if (att.status != Attachment.STATUS_ABORTED) {
				setTrayItemIcon(att, item);
				// I\
				item.setEnabled(true);
			}

			if (att.status >= Attachment.STATUS_CONNECTED) {
				// ڑEis
				item.setProgress(att.size, att.status);

			} else if (att.status == Attachment.STATUS_NONE) {
				// Xe[^XȂ
				item.clearProgress();
				// {^ACR͎

			} else if (att.status == Attachment.STATUS_SUSPENDED) {
				// f
				item.clearProgress();

			} else if (att.status == Attachment.STATUS_FINISHED) {
				// 
				item.clearProgress();
				// ACR
				item.setStatus(LabeledIconItem.ICON);
				if (att.type == Attachment.TYPE_INLINE) {
					try {
						loadAttachmentImage(att);
						setInlineImage(att, textBox.getText(), -1, false);
					} catch (IOException e) {
						logger.error("Could not load image.", e); //$NON-NLS-1$
						//FIXME [U[ɃG[ʒm
					}
				}

			} else if (att.status == Attachment.STATUS_WAIT) {
				// ڑ҂
				item.setProgress(att.size, 0);

			} else if (att.status == Attachment.STATUS_ABORTED) {
				// ُI
				// G[ACR
				item.setImage(img.getImage("aborted.gif")); //$NON-NLS-1$
				// I\ɂăc[`bv\ł悤ɂ
				item.setEnabled(true);
				item.setStatus(LabeledIconItem.BUTTON);

			} else {
				assert false;
			}
			item.setRedraw(true);
		}

		/**
		 * Ytt@CpfBNg擾܂B
		 * ݂Ȃ΍쐬݂܂B
		 * 
		 * @return Ytt@CpfBNgB쐬łȂꍇnullB
		 */
		private File getAttachmentDirectory() {
			File dir = new File(pref.getAttachmentStorage());
			if (!Tool.makeDirectory(dir)) {
				// e|ɕۑ
				dir = null;
			}
			return dir;
		}

		/**
		 * eLXgt@Cɕۑ܂B
		 * ZbgUTF-8łB
		 * 
		 * @param savePath ۑ
		 * @param text 
		 * @return ۑt@C
		 * @throws IOException
		 */
		private File saveTextAs(File savePath, String text) throws IOException {
			File tmp;
			if (savePath == null || savePath.isDirectory()) {
				tmp = File.createTempFile(//
						mm.get("SWTMessageWindow.clipboard"), //$NON-NLS-1$
						".txt", savePath); //$NON-NLS-1$
			} else {
				tmp = savePath;
			}
			FileOutputStream fo = null;
			OutputStreamWriter w = null;
			try {
				fo = new FileOutputStream(tmp);
				w = new OutputStreamWriter(fo, "UTF-8"); //$NON-NLS-1$
				w.write(text);
			} finally {
				try {
					if (w != null) {
						w.close();
					}
				} catch (IOException e) {
					logger.error("Exception occurred while " //$NON-NLS-1$
							+ "saving text in clipboard.", e); //$NON-NLS-1$
				}
				try {
					if (fo != null) {
						fo.close();
					}
				} catch (IOException e) {
					logger.error("Exception occurred while " //$NON-NLS-1$
							+ "saving text in clipboard.", e); //$NON-NLS-1$
				}
			}
			return tmp;
		}

		/**
		 * Jbg܂̓Rs[̏s܂B
		 * 
		 * @param cut I͈͂폜ꍇtrue
		 */
		public void doClipboard(boolean cut) {
			if (textBox.isFocusControl()) {
				String text = textBox.getSelectionText();
				if (text.length() == 0) {
					return;
				}
				internalClipboard = null;
				if (text.indexOf(FFFC) == -1) {
					if (cut) {
						textBox.cut();
					} else {
						textBox.copy();
					}
					return;
				}

				// Transfer
				List transfers = new ArrayList();
				// Object
				List dataList = new ArrayList();

				Point range = textBox.getSelectionRange();

				// `
				addTransferForPrivateData(textBox, range, text, transfers,
						dataList);

				// 1摜Ȃ摜Ƃ
				addTransferForImage(textBox, range, text, transfers, dataList);

				// 摜܂ޕRTFƂ
				addTransferForRTF(textBox, range, text, transfers, dataList);

				// 1̉摜ȊOȂeLXgƂ
				addTransferForText(textBox, range, text, transfers, dataList);

				if (cut) {
					// Undo͎ōs
					textBox.replaceTextRange(range.x, range.y, ""); //$NON-NLS-1$
				}

				if (!SWTUtils.setClipboard(transfers, dataList)) {
					SWTUtils.showError(getShell(), mm
							.get("SWTMessageWindow.couldNotCopyToClipboard")); //$NON-NLS-1$
				}
			} else if (iconTray != null && iconTray.isFocusControl()) {
				internalClipboard = null;
				if (cut) {
					// Jbgɂ͑ΉĂ܂
					String msg = mm
							.get("SWTMessageWindow.cutOfFileFolderIsNotSupported"); //$NON-NLS-1$
					SWTUtils.showInformation(getShell(), mm
							.get("SWTMessageWindow.info"), msg); //$NON-NLS-1$
					return;
				}
				List paths = getSelectedAttachmentPaths();
				if (!paths.isEmpty()) {

					StringBuffer textData = new StringBuffer();
					for (int i = 0; i < paths.size(); i++) {
						textData.append(paths.get(i)).append(
								System.getProperty("line.separator")); //$NON-NLS-1$
					}

					List dataList = new ArrayList();
					dataList.add(paths.toArray(new String[dataList.size()]));
					dataList.add(textData.toString());

					List transferList = new ArrayList();
					transferList.add(FileTransfer.getInstance());
					transferList.add(TextTransfer.getInstance());

					if (!SWTUtils.setClipboard(transferList, dataList)) {
						String str = mm
								.get("SWTMessageWindow.couldNotCopyToClipboard"); //$NON-NLS-1$
						SWTUtils.showError(getShell(), str);
					}
				}
			}
		}

		/**
		 * 1̉摜ȊOȂeLXgƂĈ̃Xgɒǉ܂B
		 * 
		 * @param field eLXg{bNX
		 * @param range I͈
		 * @param text I͈͂̃eLXg
		 * @param transfers Transfer̃Xg(o͐)
		 * @param dataList f[^̃Xg(o͐)
		 */
		private void addTransferForText(StyledText field, Point range,
				String text, List transfers, List dataList) {
			if (text.equals(FFFC)) {
				return;
			}
			transfers.add(TextTransfer.getInstance());
			dataList.add(text);
		}

		/**
		 * 摜܂ޕRTFƂĈ̃Xgɒǉ܂B
		 * 
		 * @param field eLXg{bNX
		 * @param range I͈
		 * @param text I͈͂̃eLXg
		 * @param transfers Transfer̃Xg(o͐)
		 * @param dataList f[^̃Xg(o͐)
		 */
		private void addTransferForRTF(StyledText field, Point range,
				String text, List transfers, List dataList) {

			if (text.equals(FFFC)) {
				return;
			}

			StringBuffer rtf = new StringBuffer("{\\rtf1\\ansi "); //$NON-NLS-1$
			for (int i = 0; i < text.length(); i++) {
				char c = text.charAt(i);
				if (c == '\uFFFC') {
					Attachment att = findAttachmentInTextUndoCommand(
							internalClipboard, i);
					if (att == null) {
						rtf.append(c);
					} else {
						// PNG
						rtf.append('{');
						rtf.append("{\\*\\shppict"); //$NON-NLS-1$

						ImageData img = (ImageData) att.data;
						{
							// Word͂D悵ēǂ
							byte[] pngBytes = getImageBytes(SWT.IMAGE_PNG, img);
							writeRTFPicture(rtf, i, "\\pngblip", //$NON-NLS-1$
									img, pngBytes);
						}
						rtf.append('}');

						// WMF(DIB)
						rtf.append("{\\nonshppict"); //$NON-NLS-1$
						{
							// Wordpad͂ǂ
							byte[] dibBytes = getImageBytes(SWT.IMAGE_BMP, img);
							DibImage dib = new DibImage(dibBytes);
							// WMFɖߍ
							byte[] wmfBytes = WindowsMetafile.wrapDibImage(dib);

							writeRTFPicture(rtf, i, "\\wmetafile8", //$NON-NLS-1$
									img, wmfBytes);
						}
						rtf.append('}');
						rtf.append('}');
					}

				} else if (c == '\r' || c == '\n') {
					if (c == '\r' && i + 1 < text.length()
							&& text.charAt(i + 1) == '\n') {
						i++;
					}
					rtf.append("\\par "); //$NON-NLS-1$
				} else {
					rtf.append("\\u").append((int) c).append("  "); //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
			rtf.append('}');

			transfers.add(RTFTransfer.getInstance());
			dataList.add(rtf.toString());
		}

		/**
		 * ImageDataw肵摜tH[}bg̃oCgz擾܂B
		 * @param imgType 摜tH[}bg
		 * @param img 摜f[^
		 * @return 摜̃oCgz
		 */
		private byte[] getImageBytes(int imgType, ImageData img) {
			ImageLoader loader = new ImageLoader();
			loader.data = new ImageData[] { img };
			ByteArrayOutputStream os = new ByteArrayOutputStream();
			loader.save(os, imgType);
			byte[] pngBytes = os.toByteArray();
			return pngBytes;
		}

		/**
		 * \pict O[v݂܂B
		 * 
		 * @param rtf o͐
		 * @param i bliptagɎg摜ID
		 * @param pictType \pngblip ܂ \wmetafile8
		 * @param imageData ImageData
		 * @param imageBytes 摜̃oCgz
		 */
		private void writeRTFPicture(StringBuffer rtf, int i, String pictType,
				ImageData imageData, byte[] imageBytes) {
			rtf.append("{\\pict"); //$NON-NLS-1$
			rtf.append("\\picw"); //$NON-NLS-1$
			rtf.append(Tool.pixelToLogicalUnit(imageData.width));
			rtf.append("\\pich"); //$NON-NLS-1$
			rtf.append(Tool.pixelToLogicalUnit(imageData.height));
			rtf.append("\\picwgoal"); //$NON-NLS-1$
			rtf.append(Tool.pixelToTwip(imageData.width));
			rtf.append("\\pichgoal"); //$NON-NLS-1$
			rtf.append(Tool.pixelToTwip(imageData.height));
			rtf.append(pictType);
			rtf.append("\\bliptag-").append(i).append(' '); //$NON-NLS-1$
			rtf.append(Tool.bytesToHexString(imageBytes));
			rtf.append('}');
		}

		/**
		 * I͈͂1ŉ摜ꍇɉ摜Ƃăf[^̃Xgɒǉ܂B
		 * 
		 * @param field eLXg{bNX
		 * @param range I͈
		 * @param text I͈͂̃eLXg
		 * @param transfers Transfer̃Xg(o͐)
		 * @param dataList f[^̃Xg(o͐)
		 */
		private void addTransferForImage(StyledText field, Point range,
				String text, List transfers, List dataList) {
			if (text.equals(FFFC)) {
				// 1ŉ摜ꍇ́A摜Ƃ
				StyleRange style = field.getStyleRangeAtOffset(range.x);
				if (style != null && style.data instanceof Attachment) {
					Attachment att = (Attachment) style.data;
					if (att.data instanceof Image) {
						ImageData data = ((Image) att.data).getImageData();
						transfers.add(PNGTransfer.getInstance());
						dataList.add(data);
						transfers.add(ImageTransfer.getInstance());
						dataList.add(data);
					}
				}
			}
		}

		/**
		 * Nbv{[hf[^̃Xgɒǉ܂B
		 * 
		 * @param field eLXg{bNX
		 * @param range I͈
		 * @param text I͈͂̃eLXg
		 * @param transfers Transfer̃Xg(o͐)
		 * @param dataList f[^̃Xg(o͐)
		 */
		private void addTransferForPrivateData(StyledText field, Point range,
				String text, List transfers, List dataList) {
			internalClipboard = new TextUndoCommand();
			internalClipboard.inserted = text;
			StyleRange[] styles = field.getStyleRanges(range.x, range.y);
			for (int i = 0; i < styles.length; i++) {
				if (styles[i].data instanceof Attachment) {
					Attachment attachment = (Attachment) styles[i].data;
					Attachment att = attachment.duplicate(false);
					att.data = ((Image) att.data).getImageData();
					att.setPlatformIndex(styles[i].start - range.x);
					internalClipboard.addInsertedObject(att);
				}
			}
			transfers.add(PrivateDataTransfer.getInstance());
			dataList.add(internalClipboard.hashCodeAsInteger());
		}

		/**
		 * TextUndoCommandw肵ItZbg(vbgtH[ˑʒu)ɂAttachment擾܂B
		 * @param undo UndoR}h(ɓNbv{[h)
		 * @param platformIndex vbgtH[ˑʒu
		 * @return Ȃꍇnull
		 */
		private Attachment findAttachmentInTextUndoCommand(
				TextUndoCommand undo, int platformIndex) {
			for (int i = 0; i < undo.insertedObjects.size(); i++) {
				Attachment att = (Attachment) undo.insertedObjects.get(i);
				if (att.getPlatformIndex() == platformIndex) {
					return att;
				}
			}
			return null;
		}

		/**
		 * CC摜wʒuɐݒ肵AUndoStackɉ摜ݒ肵܂B
		 * 
		 * @param copied AttachmentBdataImageData\Ă܂B
		 * @param platformIndex vbgtH[ˑ̐ݒʒuBK{B
		 * @param imageData 摜f[^BlocalPathݒ肷ꍇnullB
		 * @param localPath 摜̃pXBimageDataݒ肷ꍇnullB
		 * @param insertPlaceholder v[Xz_}ꍇtrue
		 * @param caretOffset caret̃ItZbgBړȂꍇ͕̒lB
		 * @throws IOException 摜t@C[hłȂꍇ
		 */
		private void setInlineImageWithUndo(Attachment copied,
				int platformIndex, ImageData imageData, String localPath,
				boolean insertPlaceholder, int caretOffset) throws IOException {
			Attachment att;
			if (copied == null) {
				att = new Attachment();
			} else {
				att = copied;
			}
			att.type = Attachment.TYPE_INLINE;
			att.setPlatformIndex(platformIndex);

			if (localPath != null)
				att.localPath = localPath;

			if (imageData != null)
				att.data = imageData;

			loadAttachmentImage(att);
			setInlineImage(att, null, platformIndex, insertPlaceholder);

			if (att.localPath != null)
				addAttachment(att);

			// Undo
			UndoStack stack = getUndoStack(true, false);
			stack.addInsertedObjectToLast(att, true);

			if (caretOffset >= 0)
				textBox.setCaretOffset(caretOffset);
		}

		/**
		 * y[Xg
		 * @param asAttachment Ytt@CƂăy[Xgꍇtrue
		 * @param pasteType y[Xg̎
		 */
		public void paste(boolean asAttachment, int pasteType) {
			if (!textBox.getEditable()) {
				return;
			}

			Clipboard clip = null;
			try {
				clip = new Clipboard(Display.getDefault());

				switch (pasteType) {
				case PASTE_TYPE_ALL:
					if (pastePrivateData(clip, asAttachment)) {
						return;
					} else if (pasteFile(clip, asAttachment)) {
						return;
					} else if (pasteImage(clip, asAttachment)) {
						return;
					} else if (pasteRTF(clip, asAttachment)) {
						return;
					} else if (pasteText(clip, asAttachment)) {
						return;
					}
					break;
				case PASTE_TYPE_TEXT:
					if (pasteText(clip, asAttachment)) {
						return;
					} else if (!asAttachment && pasteFilePath(clip, false)) {
						// t@CpX̓Yt͂܂Ӗ̂łȂ
						return;
					}
					break;
				case PASTE_TYPE_IMAGE:
					if (pasteImage(clip, asAttachment)) {
						return;
					}
					break;
				case PASTE_TYPE_FILE:
					if (pasteFile(clip, asAttachment)) {
						return;
					}
					break;
				case PASTE_TYPE_QUOTED_TEXT:
					pasteQuotedText(clip);
					break;
				default:
					logger.warn("Invalid pasteType: " + pasteType); //$NON-NLS-1$
					break;
				}

			} finally {
				if (clip != null) {
					clip.dispose();
				}
			}
		}

		/**
		 * Nbv{[hp܂B
		 * @param clip Nbv{[h
		 */
		private void pasteQuotedText(Clipboard clip) {
			// Nbv{[h擾
			String text = SWTUtils.getClipboardText(clip);
			if (text == null) {
				text = ""; //$NON-NLS-1$
			}

			// pꂽ擾
			String quoted = Tool.getQuotedText(text, pref.getQuoteString(), false);

			// J[\ʒuɓ\t
			textBox.insert(quoted);
			int max = textBox.getCharCount();
			int offset = Math.min(max,
					textBox.getCaretOffset() + quoted.length());
			textBox.setCaretOffset(offset);
		}

		/**
		 * Nbv{[h̓f[^y[Xg܂B
		 * @param clip Nbv{[h
		 * @param asAttachment ܂
		 * @return y[XgꍇtrueAf[^Rs[ĂȂꍇfalse
		 */
		private boolean pastePrivateData(Clipboard clip, boolean asAttachment) {
			Integer hashCode = (Integer) clip.getContents(PrivateDataTransfer
					.getInstance());
			if (hashCode == null || internalClipboard == null
					|| hashCode.intValue() != internalClipboard.hashCode()) {
				return false;
			}
			getUndoStack(true, false);

			TextUndoCommand content = internalClipboard;
			Point r = textBox.getSelectionRange();
			textBox.replaceTextRange(r.x, r.y, content.inserted);
			if (content.insertedObjects != null) {
				for (int i = 0; i < content.insertedObjects.size(); i++) {
					Attachment attachment = (Attachment) content.insertedObjects
							.get(i);
					Attachment att = attachment.duplicate(false);
					int platformIndex = r.x + att.getPlatformIndex();
					try {
						setInlineImageWithUndo(att, platformIndex, null, null,
								false, -1);
					} catch (IOException e) {
						// Ԃ񖳂
						logger.error("Could not load image.", e); //$NON-NLS-1$
					}
				}
			}
			textBox.setCaretOffset(r.x + content.inserted.length());
			return true;
		}

		/**
		 * Nbv{[h̃t@CXgy[Xg܂B
		 * @param clip Nbv{[h
		 * @param asAttachment Yt݂̂̏ꍇtrueACC摜ɂꍇfalse
		 * @return y[XgꍇtrueAt@CXgRs[ĂȂꍇfalse
		 */
		private boolean pasteFile(Clipboard clip, boolean asAttachment) {
			String[] files = (String[]) clip.getContents(FileTransfer
					.getInstance());
			if (files == null) {
				return false;
			}
			for (int i = 0; i < files.length; i++) {
				if (!asAttachment && isSupportedExtention(files[i])) {
					getUndoStack(true, false);
					Point range = textBox.getSelectionRange();
					textBox.replaceTextRange(range.x, range.y, FFFC);

					try {
						setInlineImageWithUndo(null, range.x, null, files[i],
								false, range.x + 1);
					} catch (IOException e) {
						String msg = mm
								.get(
										"SWTMessageWindow.menu.edit.paste.failedToLoadImage", //$NON-NLS-1$
										new Object[] { files[i] });
						SWTUtils.showError(getShell(), msg);
						continue;
					}
				} else {
					addAttachment(files[i]);
				}
			}
			return true;
		}

		/**
		 * Nbv{[hRTFy[Xg܂B
		 * <p>
		 * RTFɉ摜܂܂ĂȂꍇ͉falseԂ܂B
		 * asAttachment  true ̏ꍇfalseԂ܂B
		 * 
		 * @param clip Nbv{[h
		 * @param asAttachment truȅꍇ͉߂lfalseԂ܂B
		 * @return y[XgꍇtrueARTFRs[ĂȂꍇfalse
		 */
		private boolean pasteRTF(Clipboard clip, boolean asAttachment) {
			if (asAttachment) {
				return false;
			}
			String rtf = (String) clip.getContents(RTFTransfer.getInstance());
			if (rtf == null) {
				return false;
			}
			try {
				ByteArrayInputStream in = new ByteArrayInputStream(rtf
						.getBytes());
				RTFParser parser = new RTFParser(in, textBox.getLineDelimiter());
				parser.parse();

				List pictureList = parser.getPictureList();
				if (pictureList.isEmpty()) {
					return false;
				}

				// eLXg
				Point range = textBox.getSelectionRange();
				String replaceTo = parser.getText();
				textBox.replaceTextRange(range.x, range.y, replaceTo);

				// 摜
				int bliptag = 0;
				for (int i = 0; i < pictureList.size(); i++) {
					RTFPicture pict = (RTFPicture) pictureList.get(i);
					if (pict.shppict != 0 && bliptag == pict.bliptag) {
						// ς
						continue;
					}

					ImageData imageData = null;
					switch (pict.pictType) {
					case RTFParser.PICT_TYPE_JPEG:
					case RTFParser.PICT_TYPE_PNG:
						ByteArrayInputStream bi = new ByteArrayInputStream(
								pict.data.toArray());
						imageData = new ImageData(bi);
						bliptag = pict.bliptag;
						break;
					case (RTFParser.PICT_TYPE_WMF + 1):
					case (RTFParser.PICT_TYPE_WMF + 2):
					case (RTFParser.PICT_TYPE_WMF + 3):
					case (RTFParser.PICT_TYPE_WMF + 4):
					case (RTFParser.PICT_TYPE_WMF + 5):
					case (RTFParser.PICT_TYPE_WMF + 6):
					case (RTFParser.PICT_TYPE_WMF + 7):
					case (RTFParser.PICT_TYPE_WMF + 8):
						int mm = pict.pictType - RTFParser.PICT_TYPE_WMF;
						WindowsMetafile wmf = new WindowsMetafile(pict.data
								.toArray(), mm);
						List dibs = wmf.getDibImages();
						if (!dibs.isEmpty()) {
							DibImage dib = (DibImage) dibs.get(0);
							imageData = DibTransfer.convertDibToImageData(dib);
							bliptag = pict.bliptag;
						}
						break;
					case RTFParser.PICT_TYPE_EMF:
					case RTFParser.PICT_TYPE_MAC:
						// Ή
						break;
					}

					if (imageData != null) {
						setInlineImageWithUndo(null, range.x + pict.position,
								imageData, null, false, -1);
					}
				}
				textBox.setCaretOffset(range.x + replaceTo.length());

			} catch (IOException e) {
				logger.warn("Failed to parse RTF data.", e); //$NON-NLS-1$
			}
			return true;
		}

		/**
		 * Nbv{[h̃eLXgy[Xg܂B
		 * @param clip Nbv{[h
		 * @param asAttachment Yt݂̂̏ꍇtrueACC摜ɂꍇfalse
		 * @return y[XgꍇtrueAeLXgRs[ĂȂꍇfalse
		 */
		private boolean pasteText(Clipboard clip, boolean asAttachment) {
			String text = (String) clip.getContents(TextTransfer.getInstance());
			if (text == null) {
				return false;
			}
			if (!asAttachment && textBox.isFocusControl()) {
				getUndoStack(true, false);
				textBox.paste();

			} else {
				try {
					File saved;
					if (pref.getAttachClipboardContentWithDialog()) {

						File savePath = SWTUtils.openSaveFileDialog(shell,//
								mm.get("SWTMessageWindow.pathToClipboardText"), //$NON-NLS-1$
								mm.get("SWTMessageWindow.clipboard"), //$NON-NLS-1$
								new String[] { "*.txt" }, true); //$NON-NLS-1$
						if (savePath == null) {
							return true;
						}

						// ۑ
						saved = saveTextAs(savePath, text);

					} else {
						File dir = getAttachmentDirectory();

						saved = saveTextAs(dir, text);
						if (saved == null) {
							return true;
						}
					}

					// Yt
					addAttachment(saved.getAbsolutePath());
				} catch (IOException e) {
					logger.error("Exception occurred while " //$NON-NLS-1$
							+ "saving text in clipboard.", e); //$NON-NLS-1$
				}
			}
			return true;
		}

		/**
		 * Nbv{[h̃t@CXgeLXgƂăy[Xg܂B
		 * @param clip Nbv{[h
		 * @param asAttachment falsêݗLBfalsȅꍇAfalseŖ߂܂B
		 * @return y[XgꍇtrueAt@CRs[ĂȂꍇfalse
		 */
		private boolean pasteFilePath(Clipboard clip, boolean asAttachment) {
			if (asAttachment) {
				return false;
			}
			String[] paths = (String[]) clip.getContents(FileTransfer
					.getInstance());
			if (paths == null) {
				return false;
			}
			getUndoStack(true, false);

			StringBuffer textData = new StringBuffer();
			for (int i = 0; i < paths.length; i++) {
				textData.append(paths[i]).append(
						System.getProperty("line.separator")); //$NON-NLS-1$
			}
			String text = textData.toString();

			Point range = textBox.getSelectionRange();
			textBox.replaceTextRange(range.x, range.y, text);
			textBox.setCaretOffset(range.x + text.length());

			return true;
		}

		/**
		 * Nbv{[h̉摜y[Xg܂B
		 * @param clip Nbv{[h
		 * @param asAttachment Yt݂̂̏ꍇtrueACC摜ɂꍇfalse
		 * @return y[XgꍇtrueA摜Rs[ĂȂꍇfalse
		 */
		private boolean pasteImage(Clipboard clip, boolean asAttachment) {
			try {
				Transfer[] trs = ClipboardMenuItemEnabler.IMAGE;
				ImageData imageData = null;
				for (int i = 0; i < trs.length; i++) {
					Object obj = clip.getContents(trs[i]);
					if (obj instanceof ImageData) {
						imageData = (ImageData) obj;
					} else if (obj instanceof DibImage) {
						imageData = DibTransfer
								.convertDibToImageData((DibImage) obj);
					}

					if (imageData != null) {
						break;
					}
				}
				if (imageData == null) {
					return false;
				}
				if (asAttachment) {
					pasteImageAsAttachment(imageData);
				} else {
					getUndoStack(true, false);

					Point range = textBox.getSelectionRange();
					textBox.replaceTextRange(range.x, range.y, FFFC);

					setInlineImageWithUndo(null, range.x, imageData, null,
							false, range.x + 1);
				}

			} catch (IOException e) {
				// Ȃ摜tH[}bgȂ
				String msg = mm
						.get("SWTMessageWindow.menu.edit.paste.failedToLoadClipboardImage"); //$NON-NLS-1$
				SWTUtils.showError(getShell(), msg);
			}
			return true;
		}

		/**
		 * Nbv{[h̉摜Yt܂B
		 * @param imgData null̏ꍇANbv{[h擾܂B
		 */
		private void pasteImageAsAttachment(ImageData imgData) {

			// TODO ۑobNOEhōs
			// TODO 摜ۑ̓J[\WAITɕς
			try {
				File saved;
				if (pref.getAttachClipboardContentWithDialog()) {

					File savePath = SWTUtils.openSaveFileDialog(shell,//
							mm.get("SWTMessageWindow.pathToClipboardImage"), //$NON-NLS-1$
							mm.get("SWTMessageWindow.clipboard"), //$NON-NLS-1$
							new String[] { "*.png", "*.jpg", "*.bmp" }, true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					if (savePath == null) {
						return;
					}

					// ۑ
					saved = SWTUtils.saveImageAs(savePath, imgData);

				} else {
					File dir = getAttachmentDirectory();

					saved = SWTUtils.saveImageAs(dir, imgData);
					if (saved == null) {
						return;
					}
				}

				// Yt
				addAttachment(saved.getAbsolutePath());

			} catch (IOException e) {
				logger.error("Exception occurred while " //$NON-NLS-1$
						+ "saving image in clipboard.", e); //$NON-NLS-1$
			}
		}

		/**
		 * u悭vA[Xi[
		 */
		private final class MenuFileFrequentlyArmed implements ArmListener {
			public void widgetArmed(ArmEvent event) {
				/*
				 * dispose()ŏɂ
				 * 1. Zp[^쐬Ƃ̃ACe
				 *    -Zp[^̏ꍇ͍ėp
				 *    -ʏ̃ACȅꍇ̓Zp[^}
				 * 2. ʏ̃ACe쐬Ƃ̃ACe
				 *    -Zp[^̏ꍇ͔j
				 *    -ʏ̃ACȅꍇ͍ėp
				 * 3. ]EBWFbg͔j
				 * 4. ȂEBWFbg͐
				 */

				// TODO eXgp
				//System.out.println();
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH, 0);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.SEPARATOR, 0);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH, 0);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH);
				//new MenuItem(menuFileSendToRegisteredArm, SWT.PUSH);
				List list = main.members.getLivingRegisteredMembers();
				List sameGroup = main.members.getLivingGroupMembers(50);
				if (!sameGroup.isEmpty()) {
					if (!list.isEmpty()) {
						// ؂
						//System.out.println("؂肪");
						list.add(null);
					}
					list.addAll(sameGroup);
				}

				// TODO eXgpf[^
				//System.out.println();
				//UniqueMember dummy = new UniqueMember(null);
				//dummy.setUserName("test");
				//
				//for (int x = 0; x < 47; x++) {
				//	list.add(dummy);
				//}

				MenuItem[] items = menuFileSendToRegisteredArm.getItems();
				Iterator itr = list.iterator();
				int place = 0;
				UniqueMember member = null;
				for (int i = 0; i < items.length; i++) {
					MenuItem item = items[i];

					// MenuItem̕ꍇ͔j
					if (member == null && !itr.hasNext()) {
						// ̂Ŕj
						item.dispose();
						continue;
					}

					// 
					if (member == null)
						member = (UniqueMember) itr.next();

					if (member == null) {
						// ؂ɂ
						if ((item.getStyle() & SWT.SEPARATOR) != 0) {
							// s悭؂
							place++;
							continue;
						}
						// ؂}
						new MenuItem(menuFileSendToRegisteredArm,
								SWT.SEPARATOR, place);
						// MenuItemɂ̂i--
						i--;
						place++;
						continue;
					}

					// ؂͔j
					if ((item.getStyle() & SWT.SEPARATOR) != 0) {
						// ėpǋ؂Ȃ̂Ŕj
						item.dispose();
						continue;
					}

					// MenuItemėpBVUniqueMember𐶐B

					// j[ɐݒ
					// j[̃ANZXL[GXP[v
					StringBuffer userName = new StringBuffer();
					userName.append(member.getUserName());
					Tool.replaceAll(userName, "&", "&&"); //$NON-NLS-1$ //$NON-NLS-2$
					item.setText(userName.toString());
					item.setData(member);

					// t@CYtl
					if (message.hasAttachment()) {
						if (member.getFileReceivableMessengerCount() == 0) {
							item.setEnabled(false);
						} else {
							item.setEnabled(true);
						}
					} else {
						item.setEnabled(true);
					}

					member = null;
					place++;
					// Xi[͒ǉς
				}
				if (member != null) {
					// Ȃ̂Ő
					createMenuItem(member);
					place++;
				}
				// ȂMenuItem𐶐
				while (itr.hasNext()) {
					member = (UniqueMember) itr.next();
					if (member == null) {
						// ؂}
						SWTMenuUtils.addSeparator(menuFileSendToRegisteredArm);
						place++;
						continue;
					}
					// Ȃ̂Ő
					createMenuItem(member);
					place++;
				}

				/////////////////////////////////////////////////
				//// Ôݑ|
				//MenuItem[] items = menuFileSendToRegisteredArm.getItems();
				//for (int i = 0; i < items.length; i++) {
				//	items[i].dispose();
				//}
				//// o^Ă郁o[
				//List list = main.members.getLivingRegisteredMembers();
				//Iterator itr = list.iterator();
				//while (itr.hasNext()) {
				//	UniqueMember um = (UniqueMember) itr.next();
				//	createMenuItem(um);
				//}
				//// O[ṽo[
				//list = main.members.getLivingGroupMembers();
				//if (list.isEmpty()) {
				//	return;
				//}
				//new MenuItem(menuFileSendToRegisteredArm, SWT.SEPARATOR);
				//
				//itr = list.iterator();
				//int count = 0;
				//while (itr.hasNext()) {
				//	UniqueMember um = (UniqueMember) itr.next();
				//	createMenuItem(um);
				//
				//	// Yƃt[Y
				//	count++;
				//	if (count > 30) {
				//		break;
				//	}
				//}
			}

			/**
			 * j[ACe쐬܂B
			 * @param um o[
			 */
			private void createMenuItem(UniqueMember um) {
				// j[̃ANZXL[GXP[v
				StringBuffer userName = new StringBuffer();
				userName.append(um.getUserName());
				Tool.replaceAll(userName, "&", "&&"); //$NON-NLS-1$ //$NON-NLS-2$

				MenuItem item = SWTMenuUtils.addMenuItem(
						menuFileSendToRegisteredArm, userName.toString(), null,
						0, null, actions, "doMenuFileSendToClosestMember"); //$NON-NLS-1$
				item.setData(um);
				// t@CYtl
				if (message.hasAttachment()) {
					if (um.getFileReceivableMessengerCount() == 0) {
						item.setEnabled(false);
					}
				}

			}
		}

		/**
		 * Ytt@C̃_E[hĎA
		 * \XV܂B
		 */
		private final class DownloadObserver implements Runnable {
			/**
			 * ĎΏۂ̃Xg
			 * <p>
			 * l: Attachment
			 */
			private List list = new ArrayList();

			/**
			 * XV
			 */
			public void run() {
				//System.out.println("DownloadObserver#run()");
				if (update()) {
					display.timerExec(1000, this);
				}
			}

			/**
			 * \XV܂B
			 * @return XVpƂtrue
			 */
			private boolean update() {
				synchronized (list) {
					Iterator itr = list.iterator();
					while (itr.hasNext()) {
						Attachment att = (Attachment) itr.next();

						List atts = message.attachments;
						if (atts == null || atts.isEmpty()) {
							/*
							 * _E[hɓYtt@C
							 * 폜ꍇnulllB
							 */
							removeAllAttachments();
							break;
						}
						int num = atts.indexOf(att);
						if (num == -1) {
							continue;
						}
						if (iconTray == null || iconTray.isDisposed()) {
							return false;
						}
						LabeledIconItem item = iconTray.getItem(num);
						applyAttachment(att, item);
						if (!att.isProgress()) {
							/*
							 * _E[h̏ꍇ
							 * _E[hIołȂ
							 * ꍇ̂ŊĎŌB
							 */
							itr.remove();
						}
					}
					return (list.size() > 0);
				}
			}

			/**
			 * ĎΏۂ̓Ytt@Cǉ܂B
			 * @param att Ytt@C
			 */
			void addAttachment(Attachment att) {
				synchronized (list) {
					list.add(att);
					if (list.size() == 1) {
						display.asyncExec(this);
					}
				}
			}

			/**
			 * ĎΏۂ̓Ytt@Cǉ܂B
			 * @param attachments Ytt@C̃Xg(l: Attachment)
			 */
			void addAttachments(List attachments) {
				synchronized (list) {
					boolean first = (list.size() == 0);
					list.addAll(attachments);
					if (first) {
						display.asyncExec(this);
					}
				}
			}

			/**
			 * Ytt@CĎΏۂO܂B
			 * @param att Ytt@C
			 */
			void removeAttachment(Attachment att) {
				synchronized (list) {
					list.remove(att);
				}
			}

			/**
			 * ׂĂ̓Ytt@CĎΏۂO܂B
			 */
			void removeAllAttachments() {
				synchronized (list) {
					list.clear();
				}
			}
		}

		public void onAbort(Attachment attachment, String reason) {
			if (observer != null) {
				observer.removeAttachment(attachment);
			}
			display.asyncExec(new ItemPainter(attachment));
		}

		public void onAdd(Messenger messenger, Attachment attachment) {
			display.asyncExec(new ItemPainter(attachment));
		}

		public void onConnect(Attachment attachment) {
			if (observer == null) {
				observer = new DownloadObserver();
			}
			observer.addAttachment(attachment);
		}

		public void onFinished(Attachment attachment) {
			if (observer == null) {
				return;
			}
			observer.removeAttachment(attachment);
			display.asyncExec(new ItemPainter(attachment));
		}

		public void onSuspend(Attachment attachment) {
			if (observer == null) {
				return;
			}
			observer.removeAttachment(attachment);
			display.asyncExec(new ItemPainter(attachment));
		}

		/**
		 * _E[hXi[̃ACe̕`s܂B
		 */
		private final class ItemPainter implements Runnable {
			/** Ytt@C */
			private Attachment attachment;

			/**
			 * RXgN^
			 * @param attachment Ytt@C
			 */
			ItemPainter(Attachment attachment) {
				this.attachment = attachment;
			}

			public void run() {
				int num = message.attachments.indexOf(attachment);
				if (num == -1) {
					return;
				}
				if (iconTray == null || iconTray.isDisposed()) {
					return;
				}
				LabeledIconItem item = iconTray.getItem(num);
				applyAttachment(attachment, item);
			}
		}

		/**
		 * Ytt@C܂̓tH_J܂B
		 * @param att Ytt@C
		 */
		private void openIconItem(Attachment att) {
			if (att.localPath == null) {
				return;
			}

			if (att.type == Attachment.TYPE_FILE
					|| att.type == Attachment.TYPE_INLINE) {
				Program.launch(att.localPath);
			} else if (att.type == Attachment.TYPE_DIR) {
				File f = new File(att.localPath);
				ToolExecutor exec = new ToolExecutor(pref);
				exec.openFile(AppPreferences.FILE_MANAGER_FOLDER, f);
			}
		}

		/**
		 * Ytt@C܂̓tH_̐etH_J܂B
		 * @param att Ytt@C
		 */
		private void openIconItemParent(Attachment att) {
			if (att.localPath == null) {
				return;
			}

			File f = new File(att.localPath);
			ToolExecutor exec = new ToolExecutor(pref);
			exec.openFile(AppPreferences.FILE_MANAGER_CONTAINING_FOLDER, f);
		}

		/**
		 * tH[JXĂEBWFbgɉāA
		 * IACe܂͑IeLXg폜܂B
		 * <p>
		 * MbZ[W̏ꍇ̓ACȅA
		 * MbZ[W̏ꍇ̓t@C̍폜([Uւ̊mF)s܂B
		 */
		private void deleteSelectedItem() {

			// eLXg{bNX
			if (textBox.isFocusControl()) {
				if (message.messageClass == Message.RECEIVED) {
					return;
				}
				// IeLXg
				Point selection = textBox.getSelectionRange();
				if (selection.y == 0) {
					return;
				}
				textBox.replaceTextRange(selection.x, selection.y, ""); //$NON-NLS-1$
				return;
			}

			// YtgC
			if (iconTray == null || iconTray.getItemCount() == 0) {
				return;
			}
			// IACe̎擾
			int[] indices = iconTray.getSelectionIndices();
			if (indices.length == 0) {
				return;
			}
			boolean deletable = false;
			if (message.messageClass == Message.RECEIVED) {

				int result = SWTUtils
						.showCancellableConfirm(
								shell,//
								mm.get("SWTMessageWindow.confirmToDeleteFile"), //$NON-NLS-1$
								mm
										.get("SWTMessageWindow.doYouReallyWantToDeleteSavedAttachment")); //$NON-NLS-1$

				if (result == SWT.YES) {
					deletable = true;
				} else if (result == SWT.NO) {
					deletable = false;
				} else {
					iconTray.setFocus();
					return;
				}
			}
			// \폜
			iconTray.remove(indices);
			// f[^폜
			for (int i = indices.length - 1; i >= 0; i--) {
				if (message.messageClass == Message.RECEIVED && deletable) {
					message.deleteAttachment(indices[i]);
				} else {
					Attachment att = message.removeAttachment(indices[i]);
					if (att != null && att.type == Attachment.TYPE_INLINE) {
						deleteInlineAttachment(att, true);
					}
				}
			}
		}

		/**
		 * CC摜eLXg{bNX폜܂B
		 * <p>
		 * ̃\bȟĂяoɂAeLXg{bNXɕύX
		 * 邽߁AUndoStackɕύX쐬܂B
		 * <p>
		 * 폜Attachment́Aŏ̈łB
		 * localPathłĂ2ڈȍ~͍폜Ȃ߁A
		 * ĂяoŐ䂷Kv܂B
		 * 
		 * @param att 폜Ytt@C
		 * @param preserveImage Undopɉ摜ImageDataƂĕێĂꍇtrue
		 */
		private void deleteInlineAttachment(Attachment att,
				boolean preserveImage) {
			StyleRange[] styles = textBox.getStyleRanges();
			for (int i = 0; i < styles.length; i++) {
				StyleRange style = styles[i];
				if (att.equals(style.data)) {
					textBox.replaceTextRange(style.start, style.length, ""); //$NON-NLS-1$
					if (att.data instanceof Image) {
						Image image = (Image) att.data;
						if (preserveImage) {
							att.data = image.getImageData();
						} else {
							att.data = null;
						}
						image.dispose();
					}
					break;
				}
			}
		}

		/**
		 * (Mp)iconTrayV[gJbgL[
		 */
		private final class IconTrayShortcutAction extends KeyAdapter {
			public void keyPressed(KeyEvent event) {
				if (event.keyCode == 8 || event.keyCode == 127) {
					// Delete, BackSpace = IACe̍폜
					deleteSelectedItem();
				}
			}
		}

		/**
		 * ׂĂ̓Ytt@Cۑ܂B(Shift + Ctrl + S)
		 * @return LZꂽꍇfalse
		 */
		private boolean saveAllAttachments() {
			if (!message.hasAttachment()) {
				return false;
			}
			// ۑ𕷂
			DirectoryDialog dialog = new DirectoryDialog(shell,
					SWT.APPLICATION_MODAL | SWT.SHEET);
			dialog.setMessage(mm.get("SWTMessageWindow.selectFolderToSave")); //$NON-NLS-1$
			setFolder(dialog);
			String path = dialog.open();
			if (path == null) {
				return false;
			}
			File destDir = new File(path);
			if (!SWTUtils.isExistingDirectory(shell, destDir)) {
				return false;
			}
			pref.setLastDownloadFolder(path);

			for (int i = 0; i < message.attachments.size(); i++) {
				Attachment att = (Attachment) message.attachments.get(i);
				facade.saveAttachment(message, att, destDir);
				if (att.localPath != null) {
					// ړt@C̕\XV
					att.setToolTipCache(null);
					applyAttachment(att, iconTray.getItem(i));
				}
			}
			return true;
		}

		/**
		 * Ytt@Cǉ܂B
		 */
		private void addFiles() {
			//
			FileDialog dialog = new FileDialog(shell, SWT.OPEN | SWT.MULTI
					| SWT.APPLICATION_MODAL | SWT.SHEET);
			dialog.setText(mm.get("SWTMessageWindow.attachFile")); //$NON-NLS-1$
			dialog.open();
			String parent = dialog.getFilterPath();
			String[] files = dialog.getFileNames();
			if (files == null) {
				return;
			}
			for (int i = 0; i < files.length; i++) {
				File path = new File(parent, files[i]);
				addAttachment(path.getAbsolutePath());
			}
		}

		/**
		 * YttH_ǉ܂B
		 */
		private void addDirectory() {
			DirectoryDialog dialog = new DirectoryDialog(shell,
					SWT.APPLICATION_MODAL | SWT.SHEET);
			dialog.setText(mm.get("SWTMessageWindow.attachFolder")); //$NON-NLS-1$
			dialog.setMessage(mm.get("SWTMessageWindow.selectFolderToAttach")); //$NON-NLS-1$
			String path = dialog.open();
			if (path == null) {
				return;
			}
			File dir = new File(path);
			if (!SWTUtils.isExistingDirectory(shell, dir)) {
				return;
			}
			addAttachment(path);
		}

		public void setChangedFile(File oldFile, File newFile) {
			if (!message.hasAttachment()) {
				return;
			}
			int size = message.attachments.size();
			for (int i = 0; i < size; i++) {
				Attachment att = (Attachment) message.attachments.get(i);
				File file = att.getFile();
				if (file != null && file.equals(oldFile)) {
					att.localPath = newFile.getAbsolutePath();
					att.name = newFile.getName();
					att.getToolTipText(false);
					display.asyncExec(new ItemPainter(att));
				}
			}
			/*
			 * CC摜̏ꍇA
			 * UndosƕύXfĂȂ
			 * Attachment߂邽߃NA
			 */
			clearUndoBuffer();
		}
	}

	/**
	 * Ԃ
	 */
	class BackStyle implements Style, MenuDetectListener {
		/**
		 * Shell
		 */
		private Shell shell;

		/** Ԃ\p */
		private Composite back;

		/** Ԃ\p */
		private Text passwordBox;

		/**
		 * ShellCxgXi[
		 */
		private ShellClosed shellClosedAction = new ShellClosed();

		public void create(Rectangle client) {
			message.windowStyle = Message.BACK;
			shell = createModeAwaredShell(true);
			setAlpha(false);
			shell.addShellListener(shellClosedAction);

			// EBhẼ^Cgݒ
			setWindowIcon(shell);
			String title;
			if (message.isPasswordRequired) {
				title = ""; //$NON-NLS-1$
			} else {
				title = Tool.head(message.message, 30);
			}
			setWindowTitle(shell, title);

			// EBhËʒu
			setWindowLocation(shell);

			// EBhETCY
			setWindowSize(shell, client);

			if (message.isPasswordRequired
					&& message.messageClass == Message.RECEIVED) {
				// vpX[hbZ[W

				shell.setLayout(new FillLayout());
				back = new Composite(shell, SWT.NULL);

				GridLayout layout = new GridLayout();
				layout.numColumns = 2;
				back.setLayout(layout);

				Label label = new Label(back, SWT.HORIZONTAL);
				label.setText(mm.get("SWTMessageWindow.openPassword")); //$NON-NLS-1$
				GridData labelData = new GridData();
				labelData.grabExcessHorizontalSpace = true;
				labelData.horizontalAlignment = SWT.FILL;
				labelData.horizontalSpan = 2;
				label.setLayoutData(labelData);

				passwordBox = new Text(back, SWT.PASSWORD | SWT.BORDER);

				GridData data = new GridData();
				data.grabExcessHorizontalSpace = true;
				data.horizontalAlignment = SWT.FILL;

				passwordBox.setLayoutData(data);

				Button openButton = new Button(back, SWT.PUSH);
				openButton.setText(mm.get("SWTMessageWindow.ok")); //$NON-NLS-1$
				actions
						.registerAndAddListener(openButton,
								"doPasswordOkButton"); //$NON-NLS-1$

				shell.setDefaultButton(openButton);

				// |bvAbvj[
				Menu popup = getViewPopupMenu(shell, Message.BACK, false);
				back.setMenu(popup);
				openButton.setMenu(popup);
				label.setMenu(popup);
				shell.addMenuDetectListener(this);

				// hbO
				back.addMouseListener(dragMoveAction);
				back.addMouseMoveListener(dragMoveAction);
				label.addMouseListener(dragMoveAction);
				label.addMouseMoveListener(dragMoveAction);

				String platform = SWT.getPlatform();

				// L[
				if (platform.equals("win32")) { //$NON-NLS-1$
					openButton.addListener(SWT.Traverse,
							arrowKeyWindowMoveAction);//win32œOK

				} else if (platform.equals("gtk")) { //$NON-NLS-1$
					openButton.addListener(SWT.Traverse,
							arrowKeyWindowMoveAction);//gtkœOK

				} else if (platform.equals("cocoa") //$NON-NLS-1$
						|| platform.equals("carbon")) { //$NON-NLS-1$
					/*
					 * Macł̓{^ɃtH[JXȂ̂
					 * vpX[ĥƂ͖L[T|[gȂ
					 */
				}

				shell.addTraverseListener(preventEscClosingAction);
				back.addTraverseListener(preventEscClosingAction);
				label.addTraverseListener(preventEscClosingAction);
				openButton.addTraverseListener(preventEscClosingAction);

				// X^CύXV[gJbgȂ
				//passwordBox.addListener(SWT.KeyDown, getWsListener());
				//openButton.addListener(SWT.KeyDown, getWsListener());

				// AvP[VO[oV[gJbg
				// EBhE֘AV[gJbg
				if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
					/*
					 * Macł̓j[\z
					 */
					createMenuFileMessageWindowClose(shell, null, true);

				} else {
					passwordBox.addListener(SWT.KeyDown, main
							.getAppGlobalShortcut());
					openButton.addListener(SWT.KeyDown, main
							.getAppGlobalShortcut());

					passwordBox.addListener(SWT.KeyDown, main
							.getWindowSwitcher());
					openButton.addListener(SWT.KeyDown, main
							.getWindowSwitcher());
				}

				// FIXME gtkŏtH[JXȂ
				passwordBox.setFocus();

			} else {

				// VRg[𐶐
				shell.setLayout(new FillLayout());
				back = new Composite(shell, SWT.NULL);
				back.addMouseListener(getChangeToFrontAction());

				// |bvAbvj[
				back.setMenu(getViewPopupMenu(shell, Message.BACK, true));
				shell.addMenuDetectListener(this);

				// hbO
				back.addMouseListener(dragMoveAction);
				back.addMouseMoveListener(dragMoveAction);

				String platform = SWT.getPlatform();

				// L[
				shell.addListener(SWT.Traverse, arrowKeyWindowMoveAction);
				back.addListener(SWT.Traverse, arrowKeyWindowMoveAction);

				shell.addTraverseListener(preventEscClosingAction);
				back.addTraverseListener(preventEscClosingAction);

				// X^CύXV[gJbg
				// AvP[VO[oV[gJbg
				// EBhE֘AV[gJbg
				if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
					/*
					 * Macł̓j[\z
					 */
					createMenuBarForMac(shell, Message.BACK, true);

				} else {
					/*
					 * ʏShellŃCxg邪ACompositeNbN
					 * CompositeCxg悤ɂȂB
					 */
					shell.addListener(SWT.KeyDown, getWsListener());
					back.addListener(SWT.KeyDown, getWsListener());

					shell.addListener(SWT.KeyDown, main.getAppGlobalShortcut());
					back.addListener(SWT.KeyDown, main.getAppGlobalShortcut());

					shell.addListener(SWT.KeyDown, main.getWindowSwitcher());
					back.addListener(SWT.KeyDown, main.getWindowSwitcher());
				}

				back.setFocus();
			}

			// Oʕ\ƃEBhȆ傫Ȃ̂ŋIɃCAEg
			shell.layout();

			shell.setVisible(true);
		}

		public void menuDetected(MenuDetectEvent e) {
			back.getMenu().setVisible(true);
		}

		public void dispose(boolean toChangeStyle) {
			if (toChangeStyle)
				shell.removeShellListener(shellClosedAction);
			shell.close();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public void synchMessage() {
			saveWindowLocationAndSize(shell, true);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.forceActive();
		}
	}

	/**
	 * ACR\
	 */
	class IconStyle implements Style, MenuDetectListener, DisposeListener {
		/**
		 * Shell
		 */
		Shell shell;

		/** ACRp */
		private Label icon;

		/** ACR */
		private Image iconImage;

		public void create(Rectangle client) {
			message.windowStyle = Message.ICON;
			shell = createModeAwaredShell(false);
			shell.addShellListener(preventWindowMenuClosingAction);
			setAlpha(false);
			FillLayout fixedShellLayout = new FillLayout();
			shell.setLayout(fixedShellLayout);
			shell.setVisible(false);

			// EBhẼ^Cgݒ
			setWindowIcon(shell);
			setWindowTitle(shell, Tool.head(message.message, 30));

			// EBhËʒu
			setWindowLocation(shell);

			icon = new Label(shell, SWT.NULL);
			setIconImage();

			icon.addMouseListener(getChangeToFrontAction());

			// ENbNj[
			Menu popup = getViewPopupMenu(shell, Message.ICON, true);
			icon.setMenu(popup);
			shell.setMenu(popup);
			shell.addMenuDetectListener(this);

			// hbO
			icon.addMouseListener(dragMoveAction);
			icon.addMouseMoveListener(dragMoveAction);

			// L[
			shell.addListener(SWT.Traverse, arrowKeyWindowMoveAction);
			icon.addListener(SWT.Traverse, arrowKeyWindowMoveAction);

			shell.addTraverseListener(preventEscClosingAction);
			icon.addTraverseListener(preventEscClosingAction);

			String platform = SWT.getPlatform();
			// X^CύXV[gJbg
			// AvP[VO[oV[gJbg
			// EBhE֘AV[gJbg
			if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
				/*
				 * Macł̓j[\z
				 */
				createMenuBarForMac(shell, Message.ICON, false);
			} else {
				/*
				 * gtkł͂܂L[CxgȂ悤Ȃ̂
				 * V[gJbgL[̓T|[gȂ
				 */
				shell.addListener(SWT.KeyDown, getWsListener());
				shell.addListener(SWT.KeyDown, main.getAppGlobalShortcut());
				shell.addListener(SWT.KeyDown, main.getWindowSwitcher());
			}

			// pack
			shell.pack();
		}

		public void menuDetected(MenuDetectEvent e) {
			shell.getMenu().setVisible(true);
		}

		/**
		 * ACR̉摜shell̃^Cgݒ肵܂B
		 * <p>
		 * 摜YtĂꍇ͍Ō̉摜gp܂B
		 * <p>
		 * 摜̑傫̓ACȐꍇ̓IWiTCYA
		 * ȊO̓EBhE̒Zӂ̒ɂ킹
		 * TCY܂B
		 * <p>
		 * ܂{\w肳ĂƂIWiTCY
		 * \܂B
		 */
		private void setIconImage() {
			String path = message.getLastImageAttachment();
			if (path != null) {
				shell.setText(path);
				try {

					ImageData imgData = new ImageData(path);
					if (!message.magnification && !path.endsWith(".ico") //$NON-NLS-1$
							&& (imgData.width > 128 || imgData.height > 128)) {
						// TCY
						if (message.width < message.height) {
							double d = (double) imgData.height
									/ (double) imgData.width;
							imgData = imgData.scaledTo(message.width,
									(int) (message.width * d));
						} else {
							double d = (double) imgData.width
									/ (double) imgData.height;
							imgData = imgData.scaledTo(
									(int) (message.height * d), message.height);
						}
					}
					iconImage = new Image(display, imgData);
					icon.setImage(iconImage);
					icon.addDisposeListener(this);
					return;

				} catch (SWTException e) {
					logger.error("Cannot load image:" + path, e); //$NON-NLS-1$
				}
			}
			icon.setImage(img.getImage("appl.png")); //$NON-NLS-1$
		}

		public void widgetDisposed(DisposeEvent e) {
			if (iconImage != null) {
				iconImage.dispose();
				iconImage = null;
			}
		}

		public void dispose(boolean toChangeStyle) {
			shell.dispose();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void synchMessage() {
			saveWindowLocationAndSize(shell, false);
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.setActive();
		}
	}

	/**
	 * 1s\
	 */
	class OneLineStyle implements Style, MenuDetectListener {
		/**
		 * Shell
		 */
		Shell shell;

		/** 1s\px */
		private Label textOneLine;

		public void create(Rectangle client) {
			message.windowStyle = Message.ONE_LINE;
			shell = createModeAwaredShell(false);
			shell.addShellListener(preventWindowMenuClosingAction);
			setAlpha(false);
			FillLayout fixedShellLayout = new FillLayout();
			shell.setLayout(fixedShellLayout);
			shell.setVisible(false);
			// tH[JXJ[
			shell.addShellListener(new ShellAdapter() {
				public void shellActivated(ShellEvent e) {
					textOneLine.setBackground(display
							.getSystemColor(SWT.COLOR_WIDGET_NORMAL_SHADOW));
				}

				public void shellDeactivated(ShellEvent e) {
					textOneLine.setBackground(display
							.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
				}
			});
			setWindowLocation(shell);
			// VRg[𐶐
			// 1s\
			textOneLine = new Label(shell, SWT.NONE);
			// 1s؂o
			String oneLine = message.getOneLineText(pref
					.getUseFirstLineOfSelection());
			String escapedOneLine = Tool.replaceAll(oneLine, "&", "&&"); //$NON-NLS-1$ //$NON-NLS-2$

			setWindowIcon(shell);

			if (escapedOneLine.length() == 0) {
				textOneLine.setText("                 "); //$NON-NLS-1$
				shell.setText(mm.get("SWTMessageWindow.title.empty")); //$NON-NLS-1$
			} else {
				textOneLine.setText(escapedOneLine);
				shell.setText(oneLine);
			}

			// _uNbN
			textOneLine.addMouseListener(getChangeToFrontAction());

			// |bvAbvj[
			textOneLine
					.setMenu(getViewPopupMenu(shell, Message.ONE_LINE, true));
			shell.addMenuDetectListener(this);

			// c[`bv
			if (pref.getUseTooltipAtOneline()) {
				textOneLine.setToolTipText(Tool
						.escapeSWTToolTipText(message.message));
			}

			// hbO
			textOneLine.addMouseListener(dragMoveAction);
			textOneLine.addMouseMoveListener(dragMoveAction);

			// L[
			shell.addListener(SWT.Traverse, arrowKeyWindowMoveAction);
			textOneLine.addListener(SWT.Traverse, arrowKeyWindowMoveAction);

			shell.addTraverseListener(preventEscClosingAction);
			textOneLine.addTraverseListener(preventEscClosingAction);

			String platform = SWT.getPlatform();
			// X^CύXV[gJbg
			// AvP[VO[oV[gJbg
			// EBhE֘AV[gJbg
			if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
				/*
				 * Macł̓j[\z
				 */
				createMenuBarForMac(shell, Message.ONE_LINE, false);
			} else {
				/*
				 * gtkł͂܂L[CxgȂ悤Ȃ̂
				 * V[gJbgL[̓T|[gȂ
				 */
				shell.addListener(SWT.KeyDown, getWsListener());
				shell.addListener(SWT.KeyDown, main.getAppGlobalShortcut());
				shell.addListener(SWT.KeyDown, main.getWindowSwitcher());
			}

			// TCYłXV邽߂ɕKv
			shell.layout();
			// pack
			shell.pack();
		}

		public void menuDetected(MenuDetectEvent e) {
			textOneLine.getMenu().setVisible(true);
		}

		public void dispose(boolean toChangeStyle) {
			shell.dispose();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void synchMessage() {
			saveWindowLocationAndSize(shell, false);
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.setActive();
		}
	}

	/**
	 * QRR[h\
	 */
	class QRCodeStyle implements Style, MenuDetectListener, DisposeListener {
		/**
		 * Shell
		 */
		Shell shell;

		/** ACRp */
		private Label icon;

		/** ACR */
		private Image qrImage;

		public void create(Rectangle client) {
			message.windowStyle = Message.QR_CODE;
			shell = createModeAwaredShell(false);
			shell.addShellListener(preventWindowMenuClosingAction);
			FillLayout fixedShellLayout = new FillLayout();
			shell.setLayout(fixedShellLayout);
			shell.setVisible(false);

			// EBhẼ^Cgݒ
			setWindowIcon(shell);
			setWindowTitle(shell, Tool.head(message.message, 30));

			// EBhËʒu
			setWindowLocation(shell);

			icon = new Label(shell, SWT.NULL);
			setQRImage();

			icon.addMouseListener(getChangeToFrontAction());

			// ENbNj[
			Menu popup = getViewPopupMenu(shell, Message.QR_CODE, true);
			icon.setMenu(popup);
			shell.setMenu(popup);
			shell.addMenuDetectListener(this);

			// hbO
			icon.addMouseListener(dragMoveAction);
			icon.addMouseMoveListener(dragMoveAction);

			// L[
			shell.addListener(SWT.Traverse, arrowKeyWindowMoveAction);
			icon.addListener(SWT.Traverse, arrowKeyWindowMoveAction);

			shell.addTraverseListener(preventEscClosingAction);
			icon.addTraverseListener(preventEscClosingAction);

			String platform = SWT.getPlatform();
			// X^CύXV[gJbg
			// AvP[VO[oV[gJbg
			// EBhE֘AV[gJbg
			if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
				/*
				 * Macł̓j[\z
				 */
				createMenuBarForMac(shell, Message.QR_CODE, false);
			} else {
				/*
				 * gtkł͂܂L[CxgȂ悤Ȃ̂
				 * V[gJbgL[̓T|[gȂ
				 */
				shell.addListener(SWT.KeyDown, getWsListener());
				shell.addListener(SWT.KeyDown, main.getAppGlobalShortcut());
				shell.addListener(SWT.KeyDown, main.getWindowSwitcher());
			}

			// pack
			shell.pack();
		}

		public void menuDetected(MenuDetectEvent e) {
			shell.getMenu().setVisible(true);
		}

		/**
		 * QRR[h摜𐶐ăACRɂ܂B
		 */
		private void setQRImage() {
			// I͈͂܂͑S
			String text = message.getSelectedText();
			if (text == null) {
				text = message.message;
			}

			Qrcode qr = new Qrcode();
			qr.setQrcodeErrorCorrect(pref.getQRCodeErrorCorrectionLevel());
			qr.setQrcodeEncodeMode('B');

			// GR[fBǑ
			Charset encoding = null;
			try {
				String encodingStr = mm
						.get("ViewConfigContent.qrDefaultEncoding"); //$NON-NLS-1$
				String custom = pref.getQREncoding();
				if (custom != null && custom.length() > 0) {
					encoding = Charset.forName(custom);
				} else if (!encodingStr.equals("default")) { //$NON-NLS-1$
					encoding = Charset.forName(encodingStr);
				}
			} catch (UnsupportedCharsetException e) {
				logger.warn("Specified character encoding for QR code " //$NON-NLS-1$
						+ "is not supported on this environment.", e); //$NON-NLS-1$
			}

			if (encoding == null) {
				encoding = Tool.defaultCharset();
			}

			byte[] textBytes;
			try {
				textBytes = text.getBytes(encoding.name());
			} catch (UnsupportedEncodingException e) {
				// 肦Ȃ
				return;
			}

			int quality;
			switch (qr.getQrcodeErrorCorrect()) {
			case 'L':
				quality = 1;
				break;
			case 'M':
				quality = 0;
				break;
			case 'Q':
				quality = 4;
				break;
			case 'H':
				quality = 3;
				break;
			default:
				return;
			}

			// ő̃o[W
			int maxVersion = pref.getQRDivision();
			// Io[W̗e
			int maxByte = Qrcode.MAX_DATA_BITS_ARRAY[quality][maxVersion] / 8;
			// (ő16܂)
			int division = (int) Math.ceil(textBytes.length / (double) maxByte);
			// ̃TCY
			int maxPartSize = (int) Math.ceil(textBytes.length
					/ (double) division);
			// AppeB
			int parity = qr.calStructureappendParity(textBytes);
			List matrixes = new ArrayList();
			for (int c = 0; c < division; c++) {
				int start = c * maxPartSize;
				int length = Math.min(maxPartSize, textBytes.length - start);
				qr.setStructureappend(c + 1, division, parity);
				boolean[][] matrix = qr.calQrcode(textBytes, start, length);
				matrixes.add(matrix);
			}
			int sqrt = (int) Math.ceil(Math.sqrt(matrixes.size()));
			int sidePx1 = ((boolean[][]) matrixes.get(0)).length;
			final int MARGIN = 4;
			final int SPACE = 4;
			int widthPx = (sidePx1 * sqrt) + SPACE * (sqrt - 1) + (MARGIN * 2);

			int height = (int) Math.ceil(matrixes.size() / (double) sqrt);
			int heightPx = (sidePx1 * height) + SPACE * (height - 1)
					+ (MARGIN * 2);

			RGB[] rgb = new RGB[2];
			rgb[0] = new RGB(0, 0, 0);
			rgb[1] = new RGB(255, 255, 255);
			PaletteData palette = new PaletteData(rgb);
			ImageData data = new ImageData(widthPx, heightPx, 1, palette);
			for (int i = 0; i < data.data.length; i++) {
				data.data[i] = (byte) 0xFF;
			}
			for (int z = 0; z < matrixes.size(); z++) {
				boolean[][] matrix = (boolean[][]) matrixes.get(z);
				int baseX = MARGIN + ((z % sqrt) * (sidePx1 + SPACE));
				int baseY = MARGIN + ((z / sqrt) * (sidePx1 + SPACE));
				for (int y = 0; y < matrix.length; y++) {
					for (int x = 0; x < matrix.length; x++) {
						if (matrix[x][y]) {
							data.setPixel(baseX + x, baseY + y, 0);
						}
					}
				}

			}

			// NCAgGÃTCYzȂ傫ɂ
			Point location = shell.getLocation();
			Rectangle clientArea = SWTUtils.getMonitorClientByCoordinate(
					location.x, location.y, shell.getDisplay());
			int moduleSize = pref.getQRCodeModuleSize();
			while (moduleSize > 1) {
				if (clientArea.width >= widthPx * moduleSize
						&& clientArea.height >= heightPx * moduleSize) {
					break;
				}
				moduleSize--;
			}

			data = data.scaledTo((widthPx) * moduleSize, (heightPx)
					* moduleSize);
			qrImage = new Image(shell.getDisplay(), data);
			icon.setImage(qrImage);
			shell.addDisposeListener(this);
		}

		public void widgetDisposed(DisposeEvent e) {
			if (qrImage != null) {
				qrImage.dispose();
			}
		}

		public void dispose(boolean toChangeStyle) {
			shell.dispose();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void synchMessage() {
			saveWindowLocationAndSize(shell, false);
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.setActive();
		}

	}

	/**
	 * tⳎ\
	 */
	class StickyStyle implements Style, MenuDetectListener, DisposeListener,
			Listener {
		/** shell */
		private Shell shell;

		/** text */
		private Label label;

		/** selected font */
		private Font font;

		/** font color */
		private Color fontColor;

		/** background image */
		private Image image;

		/** start color of gradation */
		private Color color1;

		/** end color of gradation */
		private Color color2;

		public void create(Rectangle client) {
			message.windowStyle = Message.STICKY;
			shell = createModeAwaredShell(false);
			shell.addShellListener(preventWindowMenuClosingAction);
			shell.setBackgroundMode(SWT.INHERIT_FORCE);
			FillLayout layout = new FillLayout();
			layout.marginHeight = 5;
			layout.marginWidth = 5;
			shell.setLayout(layout);

			// EBhẼ^Cgݒ
			setWindowIcon(shell);
			setWindowTitle(shell, Tool.head(message.message, 30));

			// EBhËʒu
			setWindowLocation(shell);

			// EBhETCY
			setWindowSize(shell, client);
			setWindowLocation(shell);

			label = new Label(shell, SWT.WRAP);
			label.setText(Tool.escapeSWTLabelText(message.message));

			// _uNbN
			label.addMouseListener(getChangeToFrontAction());
			shell.addMouseListener(getChangeToFrontAction());

			// |bvAbvj[
			label.setMenu(getViewPopupMenu(shell, Message.STICKY, true));
			shell.addMenuDetectListener(this);

			// hbO
			label.addMouseListener(dragMoveAction);
			label.addMouseMoveListener(dragMoveAction);
			shell.addMouseListener(dragMoveAction);
			shell.addMouseMoveListener(dragMoveAction);

			// L[
			shell.addListener(SWT.Traverse, arrowKeyWindowMoveAction);
			label.addListener(SWT.Traverse, arrowKeyWindowMoveAction);

			shell.addTraverseListener(preventEscClosingAction);
			label.addTraverseListener(preventEscClosingAction);

			// TODO OneLineStyleRs[
			String platform = SWT.getPlatform();
			// X^CύXV[gJbg
			// AvP[VO[oV[gJbg
			// EBhE֘AV[gJbg
			if (platform.equals("cocoa") || platform.equals("carbon")) { //$NON-NLS-1$ //$NON-NLS-2$
				/*
				 * Macł̓j[\z
				 */
				createMenuBarForMac(shell, Message.STICKY, false);
			} else {
				/*
				 * gtkł͂܂L[CxgȂ悤Ȃ̂
				 * V[gJbgL[̓T|[gȂ
				 */
				shell.addListener(SWT.KeyDown, getWsListener());
				shell.addListener(SWT.KeyDown, main.getAppGlobalShortcut());
				shell.addListener(SWT.KeyDown, main.getWindowSwitcher());
			}

			label.addDisposeListener(this);

			applyColorScheme(true);
			shell.addListener(SWT.Resize, this);
		}

		/**
		 * J[XL[͂Messageƕ\ɔf܂B
		 * @param colorSchemeString J[XL[
		 */
		public void applyColorSchemeString(String colorSchemeString) {

			String[] colorSchemeStrArr = Tool.split(colorSchemeString, ',', 5);
			if (colorSchemeStrArr == null || colorSchemeStrArr.length < 5) {
				return;
			}
			int alpha;
			try {
				alpha = Integer.parseInt(colorSchemeStrArr[3]);

				MessageColorScheme colorScheme = new MessageColorScheme(
						colorSchemeStrArr);
				MessageColorScheme cs = message.colorScheme;
				if (cs != null) {
					colorScheme.stickyFontFace = cs.stickyFontFace;
					colorScheme.stickyFontSize = cs.stickyFontSize;
					colorScheme.stickyFontStyle = cs.stickyFontStyle;
				}

				message.alpha = alpha;
				message.colorScheme = colorScheme;
			} catch (NumberFormatException e) {
				return;
			} catch (IllegalArgumentException e) {
				return;
			}

			applyColorScheme(false);
		}

		/**
		 * Messageɐݒ肳ꂽxƃJ[XL[Kp܂B
		 * @param applyFont tHgfꍇtrue
		 */
		public void applyColorScheme(boolean applyFont) {
			setAlpha(true);

			MessageColorScheme cs = message.colorScheme;
			if (cs != null) {
				// font
				if (applyFont && cs.stickyFontFace != null) {
					Font old = font;
					FontData f = new FontData(cs.stickyFontFace,
							cs.stickyFontSize, cs.stickyFontStyle);
					font = new Font(display, f);
					label.setFont(font);
					if (old != null) {
						old.dispose();
					}
				}

				Color col = getColor(cs.stickyForeground, display);
				if (col != null) {
					Color old = fontColor;
					fontColor = col;
					label.setForeground(fontColor);
					if (old != null) {
						old.dispose();
					}
				}
				col = getColor(cs.stickyBackground1, display);
				if (col != null) {
					Color old = color1;
					color1 = col;
					if (old != null) {
						old.dispose();
					}
				}
				col = getColor(cs.stickyBackground2, display);
				if (col != null) {
					Color old = color2;
					color2 = col;
					if (old != null) {
						old.dispose();
					}
				}
			}
			drawGradient();
		}

		/**
		 * Color𕜌܂B
		 * @param rgb red, green, blue̔z
		 * @param display Display
		 * @return Color ܂nullB
		 */
		private Color getColor(int[] rgb, Display display) {
			if (rgb != null && rgb.length == 3) {
				return new Color(display, rgb[0], rgb[1], rgb[2]);
			}
			return null;
		}

		public void menuDetected(MenuDetectEvent e) {
			label.getMenu().setVisible(true);
		}

		public void dispose(boolean toChangeStyle) {
			shell.dispose();
		}

		public boolean isDisposed() {
			return shell == null || shell.isDisposed();
		}

		public void synchMessage() {
			saveWindowLocationAndSize(shell, true);

			if (font == null && fontColor == null && color1 == null
					&& color2 == null) {
				// ftHg
				return;
			}
			if (message.colorScheme == null) {
				message.colorScheme = new MessageColorScheme();
			}
			MessageColorScheme cs = message.colorScheme;
			if (font != null) {
				FontData[] data = font.getFontData();
				cs.stickyFontFace = data[0].getName();
				cs.stickyFontSize = data[0].getHeight();
				cs.stickyFontStyle = data[0].getStyle();
			}
			if (fontColor != null)
				cs.stickyForeground = getRGB(fontColor);
			if (color1 != null)
				cs.stickyBackground1 = getRGB(color1);
			if (color2 != null)
				cs.stickyBackground2 = getRGB(color2);
		}

		/**
		 * @param color Color
		 * @return RGBintz
		 */
		private int[] getRGB(Color color) {
			return new int[] { color.getRed(), color.getGreen(),
					color.getBlue() };
		}

		public void setVisible(boolean visible) {
			shell.setVisible(visible);
		}

		public boolean hasShell(Shell sh) {
			return sh == shell;
		}

		public void setEnabled(boolean enabled) {
			shell.setEnabled(enabled);
		}

		public Shell getShell() {
			return shell;
		}

		public void activate() {
			shell.setActive();
		}

		public void widgetDisposed(DisposeEvent event) {
			if (font != null) {
				font.dispose();
			}
			if (fontColor != null) {
				fontColor.dispose();
			}
			if (image != null) {
				image.dispose();
			}
			if (color1 != null) {
				color1.dispose();
			}
			if (color2 != null) {
				color2.dispose();
			}
		}

		public void handleEvent(Event event) {
			if (event.type == SWT.Resize) {
				drawGradient();
			}
		}

		/**
		 * Of[V`悵܂B
		 * 
		 * @param label `Ώۂ̃x
		 * @param color1 F1
		 * @param color2 F2
		 */
		private void drawGradient() {
			Rectangle rect = shell.getClientArea();
			Display display = Display.getDefault();
			Image newImage = new Image(display, Math.max(1, rect.width), Math
					.max(1, rect.height));
			GC gc = new GC(newImage);
			if (color1 != null) {
				gc.setForeground(color1);
			} else {
				gc.setForeground(display.getSystemColor(SWT.COLOR_WHITE));
			}
			if (color2 != null) {
				gc.setBackground(color2);
			} else {
				gc.setBackground(display.getSystemColor(SWT.COLOR_YELLOW));
			}
			gc.fillGradientRectangle(rect.x, rect.y, rect.width, rect.height,
					true);
			gc.dispose();

			shell.setBackgroundImage(newImage);
			if (image != null) {
				image.dispose();
			}
			image = newImage;
		}
	}
}
